//------------------------------------------------------------
// $Id: HostComm.h,v 1.2.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	HostComm.h Host Command class
//	1999ǯ621()
//	Copyright (C) 1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _HostComm_h
#define _HostComm_h 1

// Host ȯ륳ޥɤμ
enum HostCommand_e {
    HOSTCOM_End_Radiosity_e,	       // radiosity stage λ
    HOSTCOM_End_PrepareShading_e,      // prepare shading stage λ
    HOSTCOM_End_Raytrace_e,	       // ray-tracing stage λ
    HOSTCOM_Issue_BarrierSync_e,       // synchronization
    HOSTCOM_Suspend_GenNewRays_e,      // ʬ: stop generate new rays
    HOSTCOM_Resume_GenNewRays_e,       // ʬ: resume generate new ray
    HOSTCOM_Send_Patch_Descriptions_e, // ѥå׵ : Host
				       // (ַ̤μΤᡤPE ->
				       //  Host ؤΥѥå׵)  
    HOSTCOM_ELSE_e    
};

class HostCommClass {
protected:
    enum HostCommand_e mHostComm;
    
public:
    HostCommClass(void)
    {
	this->mHostComm = HOSTCOM_ELSE_e;
    }
    HostCommClass(const HostCommClass& rhs)
    {
	this->mHostComm = rhs.mHostComm;
    }
    HostCommClass(const HostCommand_e & com)
    {
	this->mHostComm = com;
    }
    const HostCommClass &operator=(const HostCommClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mHostComm	= rhs.mHostComm;
	}
	return(*this);
    }

    // status 
    void setCommand(HostCommand_e hostcom) 	
    { 
	this->mHostComm = hostcom;
    }
    HostCommand_e getCommand(void) const { return(this->mHostComm);	}
    
    // misc
    const char * toString(void) const 
    {
	static const char *pHCom[] = { 
	    "End Radiosity stage",
	    "End PrepareShading stage",
	    "End RayTrace stage",
	    "Issue Barrier sync",
	    "Suspend Generate new rays",
	    "Resume  Generate new rays",
	    "Send Patch descriptions to host",
	    "Warning! : null host command",
	    NULL 
	};
	return(pHCom[this->mHostComm]);
    }
public:
    // ֤
    static communication_tags_e getTAG(void) { return(TAG_HOST_COM_e);	}
};

#endif				// _HostComm_h
