//------------------------------------------------------------
// $Id: NetIntUnit.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// Network Interface Unit 
//   network interface unit ¤ 
//	¿ PE ˤ롣
//	NI ¾ PE ̿ʤɤΥ饹Ǵ뤷ʤ¿äƤ
//	뤿ᡢ¿ PE ΥФȤ
//   1998ǯ2 1()
//   1999ǯ529() ľ
//	Copyright (C) 1998-1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _NetIntUnit_h
#define _NetIntUnit_h 1

#include "mySLQueue.h"
#include "ray.h"
#include "object.h"
#include "constants.h"
#include "req_handle_t.h"
#include "Intensity.h"
#include "spc2PE.h"
#include "SendBuffer.h"
#include "RecvBuffer.h"
#include "PEStat.h"
#include "HostComm.h"

//------------------------------------------------------------
// NetIntClass : Network Interface Unit μ
//------------------------------------------------------------
class NetIntClass {
private:
    NetIntClass(const NetIntClass& rhs);
    const NetIntClass& operator=(const NetIntClass& rhs);
    
protected:
    int mTotalPENum;		 //  PE 
    int mSendRayThreshold;	 // 塼Ĺۤ ray 
    int	mSendIntensityThreshold; // 塼ĹĹۤ
    int mThisRank;		 //  NetworkInterface μʬ rank (check)
    int mHostRank;		 // host  rank

public:
    // ֤ PE бμ
    spc2PEBaseClass    *mpSpc2PE;

public:
    // ray ѥХåե (塼󥰤): i ܤѥХåե 
    //  rank == i  
    SendBuffer < Ray > *mpSendRaysBuf; //  : ¹Ի˿ꤹ
    RecvBuffer < Ray > mRecvRaysBuf[MAX_RECV_BUFFNUM];    // :ϸ

    // ۥȤؤε buf (ѤĤΤߡ host Τ)
    SendBuffer < IntensityClass > mSendIntensitiesBuf;

    // ǥ󥰻ĺѥХåե
    SendBuffer < VertexIntensity > *mpSendVerIntBuf; // [i]  destrank == i 
    RecvBuffer < VertexIntensity >  mRecvVerIntBuf;

    // ۥȤؤξ֤ѥХåե
    SendBuffer < PEStatClass   > mSendPEStatBuf;
    // ۥȤ̿μХåե
    RecvBuffer < HostCommClass > mRecvHostCommBuf;
    
public:
    NetIntClass(void);
    ~NetIntClass(void);

public: 
    //------------------------------------------------------------
    // Ray
    //------------------------------
    // initialize ray buffer
    //------------------------------
    void initRayBuff(int totalPENum,	   //  PE 
		     int sendThreshold,    // ray  ray 
		     int sendInt2FBAtOnce, // ޤȤ
		     int thisRank,	   // NetIntݻ PE  rank 
		     int hostRank,	   // host  rank
		     mySLQueue < Ray * > *pProcRaysQueue); //PEΥ塼ؤλ
    //------------------------------
    // send
    //------------------------------
    // 塼졤Υ塼ʬĹˤ
    YorN sendRays(Ray *pRay, int destRank);
    // Ƥ򸫤ƤΥ塼ʬĹˤ
    YorN sendRaysIfExceedQueueLen();
    // 塼1ĤǤ⥪֥Ȥ¸ߤ硤׵᤬ȯԲǽʤȯ
    YorN flushSendRaysBuff(void);    
    // ׵̤ΤΤλΤå
    void completeSendRaysRequest(void);
    // ΤΤϤʤ
    YorN isNoSendRay(void);    
    // ƤХåե empty ʤ YES
    YorN isSendRayBufAllEmpty(void) const;

    //------------------------------
    // recv
    //------------------------------
    YorN recvRays(void);	// 
    YorN isNoRecvRay(void);	// ΤΤʤ YES
    int  getNRecvs(void);	// ΥХåե֤

public: 
    //------------------------------------------------------------
    // Intenisity : pixel Τ (host )
    //------------------------------
    // 塼ꤷͤۤݻ줿硤׵᤬ȯԲǽʤȯ
    void sendIntensity(IntensityClass *pIntensity);
    // flush queue
    void flushIntensitySendBuf(void);
    YorN isSendingIntensity(void);

public:
    //------------------------------------------------------------
    // VerInt : ĺ
    //------------------------------
    // initialize verInt buffer
    //------------------------------
    void initVerIntBuff(int verIntSendThreshold, // VInt ޤȤ
			mySLQueue < VertexIntensity * > *pVerIntRecvQueue);
    void sendVerInt(VertexIntensity *pIntensity, int destrank);
    void flushVerIntSendBuff(void);
    YorN isSendingVerInt(void);		// ΤΤ¸ߤ

    void recvVerInt(void);
    YorN isRecvingVerInt(void);		// ΤΤ¸ߤ

public:
    //------------------------------------------------------------
    // PE ۥȤ
    //------------------------------
    void initPEStatHostCommBuff(mySLQueue < HostCommClass * >
				*pHostCommRecvQueue);
    void sendPEStat(PEStatClass *pIntensity);
    void flushPEStatSendBuff(void);
    YorN isSendingPEStat(void);	// ΤΤ¸ߤ

    //------------------------------------------------------------
    // ۥȤ PE إޥɤ
    //------------------------------
    void recvHostComm(void);
    YorN isRecvingHostComm(void); // ΤΤ¸ߤ

public:
    //------------------------------------------------------------
    // ׾ν
    //------------------------------------------------------------
    void printStat(const char *pMes, const char *pStageName);
};

#endif				// _NetIntUnit_h
