//------------------------------------------------------------
// $Id: PERadiosity.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $ 
//------------------------------------------------------------
//	PERadiosity.cc : Processing Element Radiosity stage
//	1999ǯ125() PE.cc ʬΥ
//	Copyright (C) 1996--1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#include "PE.h"
#include "mpi2_funcs.h"
#include "volumeFuncs.h"
#include "Option.h"
#include "hemicube.h"
#include "ProfileMon.h"		// for profiling monitor

//------------------------------------------------------------
// sub functions for radisoity stage
//------------------------------------------------------------
// radiosity ν ʣܤ delta-radiosity ray 
//    Ƚꡢַ׻Ԥ ray  NetworkInterface 
//------------------------------
void PEClass::
processingRadiosities(void)
{
    // δؿƤФˤϰʲξƤ
    //     塼˰ܤϥ쥤¸ߤƤ
    assert(this->mRayPtrQueue.empty()  == Q_NOT_EMPTY);
    
    // ʲξλ˥쥤ܼФƤνԤʤ
    // ʲξϤδؿ˥ȥꤷˤƤΤ 
    // do{}while;Υ롼פȤʤ롣 
    // 	   쥤塼¸ߤ
    // 	   쥤 getProcRadioAtOnce ʲ
    // 	   ХåեƤ
    static Ray *pRay;
    int i = 0;
    do {
	assert(this->mRayPtrQueue.length() > 0);
	pRay = this->mRayPtrQueue.deq();
	this->processingOneRadiosity(pRay); 
	i++;
    }while((this->mRayPtrQueue.empty() == Q_NOT_EMPTY)  && 
	   (i < this->mSysInfo.getProcRadioAtOnce()));
    
    // FIXME Statistics.addRadioProcsAtOnce(i);
}

//------------------------------
// processing one radiosity packet
// 	 processingOneRayTrace() ȤۤƱ Hit  ray 
// 	ۤʤ  (Diff ιԤۤʤ)
//      ĤΥ쥤֤ʤ NI ؤϤ
//	Ray Processing Block κȤԤ
//------------------------------
void PEClass::
processingOneRadiosity(Ray *pRay)
{
    // ray ¸ߤְ֤ǤʤĴ٤롣ʤ exit
    assert(this->isRayInValidSpace(pRay, 1) == YES);

    objectsArrayClass *pObjArray = this->mObjectSet.get(pRay->getSpcPos());
    int objNumInThisSpc = pObjArray->getLength();
    int i;
    double distanceBetweenRayNObject = PlusInfty;

    // Ƚ
    static Vector3 hitPoint;
    objBaseClass *pHitObj = NULL; // ʪ
    for(i = 0; i < objNumInThisSpc; i++)
    {
	objBaseClass *pObj = pObjArray->get(i);
	if(pObj != pRay->getRadObj()) // ̤ͤȤϸȽꤷʤ
	{
	    double tmpDist = pObj->getDistance(pRay, &hitPoint);
	    assert(tmpDist >= 0.0);

	    // Τ褦ʪΤξˤϤʬ֤¸ߤʤʬ 
	    // hit ǽ롥ξ
	    switch(pObj->who())
	    {
	    case TRIANGLE_OBJ_E:	
		break;
	    case SPHERE_OBJ_E:
		if(this->checkHitPosIsInThisSpcPos(hitPoint, pRay->getSpcPos())
		   == NO)
		{
		    tmpDist = PlusInfty;
		}
		break;
	    case NULL_OBJ_E:		
	    default:
		cout << "Internal Error! : " << endl;
		commMpi2_exit(1);
		break;
	    }
	    
	    if(distanceBetweenRayNObject > tmpDist)
	    {
		// tmpDist ᤤΤǸ򺹤obj򹹿򥻥åȤ
		distanceBetweenRayNObject = tmpDist;
		pHitObj = pObj;
		pRay->setHitPos(hitPoint);
	    }
	}
    }
    
    // ѥåٷ׻󼡥쥤ȯõ
    if(pHitObj != NULL) // ̤
    {
	// ʪΤ ray 򺹤
	// objBaseClass *pObj = pRay->getIntObj();

	materialClass *pMat = this->mMaterialSet.get(pHitObj->getMaterialID());
	if(pHitObj->who() == TRIANGLE_OBJ_E) //triangleΤߤradiosity 
	{
	    // Diffѥåεٷ׻
	    // ٤ûray  deltaRadiosity 򤳤 patch 
	    // ѤǳꡤñѤ delta radiosity Ȥ
	    this->calcNsetIntensityRadio(pRay, pMat, pHitObj);
	}

	// ȿͶޤԤ
	// Ǥ ray tracing ˡΤ褦˵٤ Frame Buffer 
	// ɬפʤΤ ray ȯɤդ
	this->newSecondaryRadiosityRays(pRay, pMat, pHitObj);
	delete pRay;		// äƤ쥤Ͼ deleteRay!
	pRay = NULL;
    }else
    {
	YorN isSendRay = this->moveRayToNextSubspace(pRay);
	if(isSendRay == YES)	// ray 
	{
	    this->setRayToNI(pRay); // NIΥХåեؤᤳ & 
	}else
	{
	    // 쥤 deleteRay!
	    delete pRay;
	    pRay = NULL;
	}
    }	
}

//------------------------------------------------------------
// initialize for ForRadiosity 
//------------------------------------------------------------
void PEClass::
initForRadiosity(void)
{
    // patch ν
    this->initializePatches();	// calcRadioFRG.cc

    // initialize Network Interface unit
    this->mNIUnit.initRayBuff(this->mSysInfo.getTotalPENum(),
			      this->mSysInfo.getProcRadioAtOnce(), 
			      this->mSysInfo.getSendInt2FBAtOnce(),
			      this->getMyRank(),
			      SysStat::getInstance()->getHostRank(),
			      &(this->mRayPtrQueue));

    this->mNIUnit.initPEStatHostCommBuff(&(this->mHostCommRecvQueue));
    
    // volume νΤ volume ؤΥݥ󥿥ꥹȤϤ
    SLList < VolumeClass * > volumeList;
    this->mVolSet.getAllElementAsList(&volumeList);
    if(!(volumeList.empty()))
    {
	initializeVolumes(&volumeList);
    }

    // PE status init
    this->initBusyIdleStat();
    this->mIsStopGenNewRay = NO; 	 // hostrayȯ׵Ϥʤ
    this->mSendingRayStopComToHost = NO; // hostؤrayȯ׵̤
}


//------------------------------------------------------------
// do radisoity
//------------------------------------------------------------
void PEClass::
doRadiosity(void)
{
    ProfileMon *pPfm = ProfileMon::getInstance();
    pPfm->startStage(ProfileMon::ProfSt_radiosity);
    
    // ǽ̤ͤäͥ륮
    const double totalInitNonRadEnergy = 
    	getTotalUnshotRadiosityEnergy(&(this->mObjList));
    this->initForRadiosity();
    
    while(this->isMultiPassStageEnd() == NO)
    {
	// ޤ¾
	this->recvRays();		
	
	//  : ǰŪˤϤǤ뤬¤ Network
	// Interface 	enqueue 줿ǥ塼ĹӤԤʤ졤
	// ȯԤ٤ʤϤλȯԤƤ롥
	// this->sendRays();	
	
	// processing
	if(this->mRayPtrQueue.empty() == Q_NOT_EMPTY)
	{ 
	    // ٤ ray ͭ
	    assert(this->isIdle() == NO);
	    pPfm->occurEv(ProfileMon::ProfEv_ProcRadRays);

	    // this->toBusy();
	    this->processingRadiosities(); // buffer ˶ʬ
	    this->globalLoadBalance();     // ray ̤ ray ȯ¤Ԥ
	}
	else if(this->mRadPatchQueue.empty() == Q_NOT_EMPTY)
	{
	    // 塼˥쥤ʤ && ͥѥå -> ͥѥåͤ
	    // ͤ¸ߤΤ busy ˤ롣 toBusy פ
	    // ʤͤʤΤ overhead ˤʤʤ 
	    this->toBusy(); 
	    
	    // 쥤ȯ host  ray ȯ׵᤬
	    // Ĵ٤ 
	    this->probNgetHostCommand();
	    if(this->mIsStopGenNewRay == NO) // host Ϥʤ
	    {
		pPfm->occurEv(ProfileMon::ProfEv_genHemiCube);
		this->radiateRadFromMaxRadPatch(); // ray ȯ 
		// include ProfileMon::outHemiCubeInfo()
	    }
	}
	else if(this->mNIUnit.isSendRayBufAllEmpty() == NO)
	{
	    // 쥤̵ && ̵ && Хåե˥쥤ĤäƤ
	    assert(this->isIdle() == NO);
	    
	    this->flushSendRaysBuffer(); //  buf ˶ǽʤ
	    pPfm->occurEv(ProfileMon::ProfEv_SendingWait);
	    
 	}else if((this->mNIUnit.isNoSendRay() == YES) && // ǤϤʤ && 
 		 (this->mNIUnit.isNoRecvRay() == YES))   // ǤϤʤ
 	{
	    // ٤ PEStat  flush
	    this->mNIUnit.flushPEStatSendBuff();   // PEStat  flush
	    if(this->mNIUnit.isSendingPEStat() == NO)
	    {
		// 쥤ʤ && ٤ ray ̵ && λ
		// && λ (ray && PEStat)
		// == ƤλŻλ
		if(this->isIdle() == NO)
		{
		    this->toIdle();
		    pPfm->occurEv(ProfileMon::ProfEv_Idle);		    
		}else
		{
		    // idle ֤Τޤ
		    // host Υޥɤм
		    this->probNgetHostCommand(); 
		    if(this->isMultiPassStageEnd() == YES)
		    {	// λޥɤˤϥ塼϶
			assert(this->mRayPtrQueue.empty() != Q_NOT_EMPTY);
			assert(this->mRadPatchQueue.empty()!= Q_NOT_EMPTY);
		    }
		}
	    }
	    pollingSleep();
	}else
	{
	    this->toBusy();
	}
    }

    // Ͱʲ̤ͥͥ륮ν
    this->finalizeForRadiosity(totalInitNonRadEnergy);

    pPfm->endStage(ProfileMon::ProfSt_radiosity);
}

//------------------------------------------------------------
// finalize for radisity
//------------------------------------------------------------
void PEClass::
finalizeForRadiosity(double totalInitNonRadEnergy)
{
    // ͤͥ륮̤ͥͥ륮ν
    double unshotRadEnergy = getTotalUnshotRadiosityEnergy(&(this->mObjList));

    cout << genHd(NORMALHEAD, this->getID()) << "unshot radenergy (start "
    	    "end) = " << totalInitNonRadEnergy << " " << unshotRadEnergy 
	    << endl;

    // ̤ͥ饸ƥͤ flush 饸ƥͤ˲ä
    Pix pix;
    for(pix = this->mObjList.first(); pix != NULL; this->mObjList.next(pix))
    {
	objBaseClass *pObj = this->mObjList(pix);
	switch(pObj->who())
	{
	case TRIANGLE_OBJ_E:
	    pObj->flushUnshotRadiosityNInitVerInt();	    
	    break;	    
	case SPHERE_OBJ_E:
	case NULL_OBJ_E:
	default:
	    break;
	}
    }

    if(this->mSysInfo.isRadiosityCalc() == NO)
    {				// radiosity calculation is not executed
	if(Option::getInstance()->getVerboseMode() == YES)
	{
	    cout << genHd(VERBOSEHEAD, this->getMyRank()) << "flushed each "
	    	"patch emittion (skipping radiosity stage)." << endl;
	}
    }else
    {
	delete this->mpHemiCube;
	this->mpHemiCube = NULL;
	
	if(Option::getInstance()->getVerboseMode() == YES)
	{
	    cout << genHd(VERBOSEHEAD, this->getMyRank()) << 
	    "destroing hemicube. finalize radiosity stage." << endl;
	}
    }
}

