//------------------------------------------------------------
// $Id: SendBuffer.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// SendBuffer
//     (rank) ФХåե
//    Ȥ object (ray) ݤˤϰʲΤȤԤ
//	1. object pointer Υ塼 object Υݥ󥿤򤿤Ƥ
//	2. ٤ޤä object μΤѤΥХåե˥ԡ
//	   ƤΥХåե̿饤֥Ϥ롥
//	   ǼͤƼΤΥХåեΥϸȤ롥
//	   (Ǥ mRealBufSize ޤ) ˤϥХåե lock 롥 
//	3. ̿饤֥꤬ΤλΤΥХåե unlock 
//	   롥 
//    
//   1999ǯ413()
//	Copyright (C) 1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _SendBuffer_h
#define _SendBuffer_h 1

#include <assert.h>
#include "mpi2.h"
#include "req_handle_t.h"
#include "mySLQueue.h"
#include "Statistics.h"
#include "ProfileMon.h"

//------------------------------------------------------------
// SendBuffer : ĤѤΥХåե
//------------------------------------------------------------
template < class T >
class SendBuffer {
private:
    SendBuffer(const SendBuffer < T > & rhs);
    const SendBuffer < T > & operator=(const SendBuffer < T > & rhs);

protected:
    mySLQueue < T * > mQueue;	// ΤΥݥ󥿥塼
    
    YorN mIsLockRealBuffer;	// RealBuffer  lock ʤ YES = 
    int  mRealBufSize;		// ѥХåեΥ ()
    T   *mpRealBuff;		// ΤμΤХåե
    reqHandle_st mReqHandle;	// ꥯȥϥɥ

public:
    CommunBufStatistics mCBStat;
    
protected:
    //  lock 򤫤
    void lockRealbuffer(void)
    {  
	assert(this->mIsLockRealBuffer == NO);
	this->mIsLockRealBuffer = YES;	
    }

    // Ƥѹ unlock.
    //   λbuffer ϺѤΤ delete ɬפϤʤ
    void unLockRealbuffer(void)	
    {  
	assert(this->mIsLockRealBuffer == YES);
	this->mIsLockRealBuffer = NO;
    }    

    //------------------------------
    // ׵ȯԤ
    //   ݥ󥿥塼ˤĤʤǤΤμΤΥХåե˥ԡ 
    //   饤֥롥
    //   ˥Хåե lock Ƥˤϥ顼
    //     @param destRank 	 rank
    //	   @return		 object 
    //------------------------------
    int issueSendObjs(int destRank)
    {
	if(this->isLockRealBuffer() == YES)
	{
	    cout << "Error! : Now locking sendbuffer, abort." << endl;
	    cout << "         call unlock before call. desc = "
	    	 << destRank << ", SendBuffer::getRealBuffer." << endl;
	    exit(1);
	}

	// ԡ RealBufSize ʲ
	int copynum = -1;
	if(this->mQueue.length() < this->mRealBufSize) 
	{
	    copynum = mQueue.length();
	}
	else
	{
	    copynum = this->mRealBufSize;
	}

	// ԡǽʬԡ
	int i = 0;
	for(i = 0; i < copynum; i++)
	{
	    assert(!(this->mQueue.empty()));
	    T *pObj = this->mQueue.deq();
	    this->mpRealBuff[i] = *pObj;
	    delete pObj;	// ҡ׾μΤβ
	}
	
	// ˤ
	this->lockRealbuffer();

	// ׵ȯ 
	this->mReqHandle = 
		commMpi2_IsendObj(destRank, this->mpRealBuff, copynum);

	// object ĿϿ
	this->mCBStat.reportNSendRecvObjs(copynum);

	// Profile Monitor
	ProfileMon::getInstance()->send(destRank, copynum, T::getTAG());

	return(copynum);
    }

    //------------------------------
    // ׵ϴλλˤ lock 򳰤
    // 	@return ̤鴰λѲ YES ֤
    //------------------------------
    YorN isCompleteSend(void)
    {
	// åƤʤΤǡ׵δλϤʤ(֤ѲϤʤ)
	if(this->isLockRealBuffer() == NO)
	{
	    return(NO);
	}
	else
	{
	    // å -> λƥȤ
	    if(commMpi2_isSendComplete(this->mReqHandle) == YES)
	    {
		this->unLockRealbuffer();
		return(YES);	
	    }
	    else
	    {
		return(NO);	    
	    }
	}
    }

    //------------------------------
    // 塼¸ߤʪο threshold ۤߤ
    //------------------------------
    YorN tryToIssueSendObjsIfExceedQueueLen(int destRank)
    {
	if((this->isExceedQueueLen() == YES) && 
	   (this->isLockRealBuffer() == NO))
	{
	    this->issueSendObjs(destRank);
	    return(YES);
	}else
	{
	    return(NO);
	}
    }

    //------------------------------
    // 塼¸ߤǽʾˤߤ
    //   @return 
    //------------------------------
    YorN tryToIssueSendObjs(int destRank)
    {
	if((this->mQueue.length() > 0) && 
	   (this->isLockRealBuffer() == NO))
	{
	    this->issueSendObjs(destRank);
	    return(YES);
	}else
	{
	    return(NO);
	}
    }

    //------------------------------    
    // enqueue 
    //   real buffer 򸫤׵ȯԤƤɤ
    //  ϡ׵ȯԤŪ˹ԤȤˤ1999ǯ529()
    //	  @param  pObj : 塼κǸɲ
    //    @return ߤΥ塼Υ
    //------------------------------
    int enqueue(T * pObj)
    {
	this->mQueue.enq(pObj);
	this->mCBStat.reportQueLen(this->mQueue.length()); // 塼ĹεϿ
	return(this->getSizeOfQueue()); // ߤΥ塼Υ֤
    }

public:
    SendBuffer(void)
    {
	this->mIsLockRealBuffer	= NO;
	this->mRealBufSize	= -1;
	this->mpRealBuff	= NULL;
	// this->mReqHandle;

	this->mCBStat.init();
    }
    ~SendBuffer(void)
    {
	if(this->mIsLockRealBuffer == YES)
	{
	    cout << "Error! : SendBuffer::~SendBuffer() buffer is locked. "
	    	<< "Queue length = " << this->mQueue.length() << ", Tag " 
		<< T::getTAG() << endl;
	}
	if(this->mRealBufSize > 0)
	{
	    delete [] this->mpRealBuff;
	    this->mpRealBuff = NULL;
	}
    }

    //------------------------------
    // initialize
    // ٤ call ǽ
    //	@param sendBufferSize : 塼ν
    //------------------------------    
    void initBuff(int sendBufferSize) 
    {
	//  queue ˲ĤäƤˤϽǤʤ
	if(this->mQueue.length() != 0)
	{
	    cout << "Error! : queue has some elements, can not initialize." 
	    << endl;
	    exit(1);
	}

	if(this->mRealBufSize > 0)
	{
	    // re-initialize
	    if(this->mpRealBuff != NULL)
	    {
		delete [] this->mpRealBuff;
		this->mpRealBuff = NULL;
	    }
	}

	// arg check
	if(sendBufferSize < 1)
	{
	    cout << "Warning! : sendBufferSize must be > 0 at SendBuffer, "
	            "set sendBufferSize = 1." << endl;
	    sendBufferSize = 1;
	}

	this->mRealBufSize	= sendBufferSize;
	this->mIsLockRealBuffer	= NO; // ǤϤʤ
	this->mpRealBuff	= new T[this->mRealBufSize];

	// init statistics 
	this->mCBStat.init();
    }

    //------------------------------
    // queue Ĺ٤ͤۤ?
    // 	 @return ٤ͤۤˤ Yes
    //------------------------------
    YorN isExceedQueueLen(void) 
    {
	return((this->mQueue.length() >= this->mRealBufSize) ? YES : NO);
    }

    //------------------------------
    // ΤΥХåե lock 椫
    //   @return ߼ˤĤ lock 椫
    //------------------------------
    YorN isLockRealBuffer(void) const 	{ return(this->mIsLockRealBuffer); }

    //------------------------------
    // ΤΥХåեΥ : lock ʤ֤
    //   @return Υ 
    //------------------------------
    int  getSendBufSize(void) const 	{ return(this->mRealBufSize);	}

    //------------------------------
    //  queue äƤΤο
    // 	 @return 塼Υ
    //------------------------------
    int getSizeOfQueue(void) 		{ return(this->mQueue.length());}

    //------------------------------
    // queue κĹ : ޤǤκ祭塼Ĺ֤
    // 	 @return Υ塼Υ
    // DELETEME
    //------------------------------
    // int getMaxSizeOfQueue(void)		{ return(this->mMaxQueueLen);}
    
    //------------------------------
    //  sendbuffer ˤϻŻʤ (== (塼Ĺ == 0) && (unlocking))
    // 	@return ʾΤλŻʤ YES
    //------------------------------
    YorN isNoMoreWork(void)
    {
	return(((this->getSizeOfQueue()== 0) && 
		(this->isLockRealBuffer() == NO)) ? YES : NO);
    }

public:
    //------------------------------------------------------------
    // convenient functions : 褯ѤؿޤȤ᤿
    //------------------------------    
    // ʪΤ塼 enqueue 塼Ĺͤۤ
    //   @param pEnqueueAndSendObj : Ĥ object ؤΥݥ
    //				      new ƤʤƤϤʤʤ
    //   @param destrank	   :   rank
    //	 @return		   : ȯԻˤ YES ֤
    //------------------------------
    YorN enqNewedObjwithMaySend(T *pEnqueueAndSendObj, int destrank)
    {
	// enqueue
	this->enqueue(pEnqueueAndSendObj);

	// ׵δλƥ
	this->isCompleteSend();

	// try to send
	return(this->tryToIssueSendObjsIfExceedQueueLen(destrank));
    }

    //------------------------------
    // Хåե flush
    // 	 @destrank 	:   rank
    // 	 @return	: ʤ YES 
    //------------------------------
    YorN flushdone(int destrank)
    {
	// ׵δλƥ
	this->isCompleteSend();

	// try to send 
	return(this->tryToIssueSendObjs(destrank));
    }
};

#endif				// _SendBuffer_h
