//------------------------------------------------------------
// $Id: calcRadioSRG.cc,v 1.2.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	calcRadioSRG.cc 
//	calculation of Secondary Ray Generation unit for radiosity 
// 1996/8/8  calcRayTrSRG.cc 
// 1999/2/18 
//	(C) 1995-1999 Copyright YAMAUCHI Hitoshi  
//	
//	ray-tracing ˡ radiosity ˡǤȿͥ쥤˰㤤ꡥ
//	2 쥤ȯ for Radiosity
//------------------------------------------------------------
#include <assert.h>
#include "PE.h"

//------------------------------
// ȿͤˤ󼡥쥤ȯ
//	߿ΤѤ ray tracing ǤϤʤ
//------------------------------
static inline Ray *newReflectionRadiosityRays(const  Ray *const pRay,
					      const  materialClass*  pMat,
					      double minRayCoefNorm,
					      objBaseClass *pHitObj)
{
    assert(pHitObj != NULL);

    // ȿ͸그׻
    Vector3 afterReflectRadiosity = pRay->getColor() * (pMat->getSpecRef());

    // commented by tosho : ޤǤƼϤʤ ray Ƥ
    //   ȿ͸그ʲΥͥ륮 ray Ϥʾ¤ʤ
    //   ʬminRayCoefNorm  ray-tracing ƱǤΤϸ
    //   ⤷ʤ FIXHERE
    if(afterReflectRadiosity.dInn_prd(afterReflectRadiosity) < minRayCoefNorm)
    {
	return(NULL);
    }

    // ȿ
    Vector3 normal = pHitObj->getNormal(pRay->getHitPos());
    assert((normal.getNorm() - 1.0) < D_ERROR_RES);//ˡƤϤ
    Vector3 reflectedRayDir = 
	(-2.0 * ((pRay->getDir()).dInn_prd(normal)) * normal) + pRay->getDir();
    
    // ȿͥ쥤 newRay! for radiosity ⥻åȤ
    // Υ󥹥ȥ饯Ǻ쥤ϰäʪΤˤϸ򺹤ʤ 
    Ray *pNewRay = Ray::newForReflectionRadiosity(pRay, reflectedRayDir, 
						  afterReflectRadiosity, 
						  pHitObj);
    return(pNewRay);
}

//------------------------------
// ޤˤ󼡥쥤ȯ
//------------------------------
static inline Ray *newRefractionRadiosityRays(const  Ray *const pRay,
					      const  materialClass*  pMat,
					      double minRayCoefNorm,
					      objBaseClass *pHitObj)
{
    // ray  copy  pMat Ʃ᷸ݤ
    Vector3 afterRefractRadiosity = (pRay->getColor())* (pMat->getSpecTrans());

    if(afterRefractRadiosity.dInn_prd(afterRefractRadiosity) < minRayCoefNorm)
    {
	return(NULL);
    }
    
    // Ʃ׻
    Vector3 refractedRayDir;
    if(pMat->getIdxRefraction() != 1.0)	
    {
	// ޤ ޥ쥤
	assert(pHitObj != NULL);
	Vector3 normal = pHitObj->getNormal(pRay->getHitPos());
	//ˡƤϤ
	assert((normal.getNorm() - 1.0) < D_ERROR_RES);
	
	// Υ٥ȥ T (I ͥ٥ȥ, N ʪˡ٥
	// , n жΨ >= 1.0)  
	// T = (n (-N \dot I) - \sqrt(1 - n^2(1 - (N \dot I)^2)) N) + nI
	const double n   = pMat->getIdxRefraction(); // Ψ
	const double ndi = (pRay->getDir()).dInn_prd(normal); // (N \dot I)
	const double rt  =  sqrt(1.0 - (n * n) * (1.0 - (ndi * ndi)));
	refractedRayDir = 
	    (((n * (-ndi)) - rt) * normal) + (n * pRay->getDir());
    }else
    {
	// pMat->getIdxRefraction() == 1.0  : ƩΨ 1 ̵̣ʡ
	refractedRayDir = pRay->getDir();
    }

    // Ʃ쥤 newRay! for radiosity ⥻åȤ
    // Υ󥹥ȥ饯Ǻ쥤ϰäʪΤˤϸ򺹤ʤ 
    // Ū˽ refraction  refraction Ʊ
    Ray *pNewRay = 
    	Ray::newForReflectionRadiosity(pRay, refractedRayDir, 
				       afterRefractRadiosity, pHitObj);
    return(pNewRay);
}


//------------------------------------------------------------
// 2 radiosity ray 
//     	ٷ׻ IC ǺѤǤ
//	(ʸ˽񤤤Ƥ߷פȤϰ㤤ΤȤ IC->SRG ³򼨤
//	 Ƥ롥ʸǤȿ FrameBuffer ؤƤ뤬
//	 ˤ ray Ǥκݤˤ FrameBuffer ؤιʤ
//		(see mpi2doc_implementation)
//------------------------------------------------------------
YorN PEClass::
newSecondaryRadiosityRays(Ray *pRay, const materialClass *pMat, 
			  objBaseClass * pHitObj)
{
    YorN isGenerateRay = NO;	// 쥤ȯ? 

    //  ray ȿ͡޲ۤƤ뤫
    if(pRay->getReflectedNum() >= this->mViewData.getMaxRayRefNum())
    {				// ۤƤ롣ray ȯʤ
	assert(isGenerateRay == NO);
	return(isGenerateRay);
    }
    
    //------------------------------------------------------------
    // ȿ 2  radiosity ray  new PE ν塼Ͽ
    //------------------------------------------------------------
    Ray *pNewHanshaRay = 
    	newReflectionRadiosityRays(pRay, pMat, 
				   this->mViewData.getMinRayRefCoeffNorm(),
				   pHitObj);
    if(pNewHanshaRay != NULL)	// ray ȯ塼
    {
	this->setRayPtrToThisPE(pNewHanshaRay);		   
	isGenerateRay = YES;
	// ȿ radiosity ray ΤʤФ Hint TOKUNAGA
    }

    //------------------------------------------------------------
    // Ʃ 2 l radiosity ray  new PE ν塼Ͽ
    //------------------------------------------------------------
    Ray *pNewToukaRay = 
	newRefractionRadiosityRays(pRay, pMat, 
				   this->mViewData.getMinRayRefCoeffNorm(),
				   pHitObj);
    if(pNewToukaRay != NULL)
    {
 	this->setRayPtrToThisPE(pNewToukaRay);
	isGenerateRay = YES;
	// ޥ쥤ΤʤФ Hint TOKUNAGA
    }
    return(isGenerateRay);
}
