//------------------------------------------------------------
// $Id: calcRayTrIC.cc,v 1.3.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	calcRayTrIC.cc
//	calculation of Intensity Calculation unit for ray tracing 
//	1996/8/2, 1996/9/18 
//	(C) 1995-1998 Copyright YAMAUCHI Hitoshi
//
//	ٷ׻ 
//	(Mapping) Shading ʪΤǹԤ
//	mapping Ϥθ¤ 
//------------------------------------------------------------
#include <assert.h>
#include <stdlib.h>
#include <math.h>

#include "PE.h"
#include "mpi2exit.h"
#include "ray.h"
#include "triangleObject.h"


// NO_OUT_SHADE_ERROR Ƥʤˤ shading η׻˼
// ȥ顼åϤ 

//------------------------------------------------------------
// calculate Intensity 
// 	٤׻ ray ˲äƤ
//------------------------------------------------------------
void PEClass::
calcNsetIntensityRayTr(Ray *pRay, objBaseClass *pHitObj)
{
    // assert(pRay->getIntObj() != NULL);
    assert(pHitObj != NULL);

    // ٷ׻ ׻ѤߤʪΤγȻ٤ 
    // ȻȿͤϷ׻ƤȤǤʪΤγȻȿͷϳݤʤ
    Vector3 intensity = pRay->getColor();

    // swich in most deep location, can I improve? IMPROVEME
    switch(this->mSysInfo.getShadingScheme())
    {
    case FlatShading:
	intensity = intensity + (pRay->getRefCoeff()) * 
		(pHitObj->getFlatRadiosityColor(pRay->getHitPos()));
	break;
    case GouroudShading:
	intensity = intensity + (pRay->getRefCoeff()) * 
		(pHitObj->getShadedRadiosityColor(pRay->getHitPos()));
	break;
    default:
	cout << "Internal Error! : illegal shading scheme in " << 
	    "PEClass::calcNsetIntensityRayTr" << endl;
	commMpi2_exit(1);
    }

    pRay->setColor(intensity);
    pRay->incReflectedNum();	// ää

    // ̤ȿͤ˸그Ѳ뤬󼡸ȯ
    // ʬǹԤ 
}


//------------------------------
// hit point ΰ֤ε٤֤
// 	flat shading
//------------------------------
Vector3 triangleObjectClass::
getFlatRadiosityColor(const Vector3& hitPos)
{
    return(this->mRadiosity);	// radiosity ֤ͤƤ
    cout << hitPos << endl;	// for Wall
}

//------------------------------
// 顼ȯͤν
//------------------------------
void showvers(const Vector3& hitpos, const Vector3& hvec, const Vector3& evec,
	      const Vector3& top,    const Vector3& side, const Vector3& other,
	      int asX, int asY, double oeh, double t, double s)
{
    cout << "hitpos        " << hitpos<< endl;
    cout << "to hitpos vec " << hvec  << endl;
    cout << "edge vector   " << evec  << endl;
    cout << "vertex top    " << top   << endl;
    cout << "vertex side   " << side  << endl;
    cout << "vertex other  " << other << endl;
    cout << "asX           " << asX   << endl;
    cout << "asY           " << asY   << endl;
    cout << "oeh           " << oeh   << endl;
    cout << "t             " << t     << endl;
    cout << "s             " << s     << endl;
}

//------------------------------
// hit point ΰ֤ε٤֤
// 	Gouroud shading
//------------------------------
Vector3 triangleObjectClass::
getShadedRadiosityColor(const Vector3& hitPos)
{
    const double ERRTOL = 1.0e-20; // error tolerance 

    int topver   = -1;		// ʤʸ礬Ф
    int sidever  = -1;
    int otherver = -2;
    int asX	 = -3;
    int asY	 = -5;
    // find (asX, asY) plane
    for(topver = 0; topver < 3; topver++)
    {
	sidever  = (topver + 1) % 3;
	otherver = (topver + 2) % 3;
	asX = asY = -1;
	int i, j;
	for(i = 0; i < 3; i++)
	{
	    //// ۤʤ˸褦 X,Y 򤹤
	    if(fabs(this->mVertex[topver  ].get(i) - 
 		    this->mVertex[sidever ].get(i)) > 1e-6)
	    {			//// top, side ΰۤʤ뼴Ǥꡢ
 		for(j = 0; j < 3; j++)
 		{
		    if(i != j)	// i ϷꤷƤ
		    {
			if(fabs(this->mVertex[topver  ].get(j) -
				this->mVertex[otherver].get(j)) > 1e-6)
			{
			    asX = i;
			    asY = j;
			    i = 3; // 롼æ : goto ǽФ٤
			    break;
			}
		    }
 		}
	    }
	}
	if(asX >= 0)
	{
	    break;
	}
    }
    if(asX < 0)
    {
#ifndef NO_OUT_SHADE_ERROR
	cout << "Error! : can't solve this triangle. asX(" << 
	  asX << ") < 0) but ignored and average intensity." << endl;
#endif
	Vector3 aveInt = (this->mIntensity[0] + this->mIntensity[1] +
			  this->mIntensity[2]) / 3.0;  
	return(aveInt);
    }
    
    if((fabs(this->mVertex[topver].get(Vector3::X) - 
	                    hitPos.get(Vector3::X)) < ERRTOL) && 
       (fabs(this->mVertex[topver].get(Vector3::Y) - 
	                    hitPos.get(Vector3::Y)) < ERRTOL) && 
       (fabs(this->mVertex[topver].get(Vector3::Z) - 
	                    hitPos.get(Vector3::Z)) < ERRTOL))
    {
	return(this->mIntensity[topver]); // top ĺפλˤϤΤޤ
    }
    
    Vector3 hvec = hitPos - this->mVertex[topver];
    Vector3 evec = this->mVertex[otherver] - this->mVertex[sidever];
    double ex	 = evec.get(asX);
    double ey 	 = evec.get(asY);
    double hx	 = hvec.get(asX);
    double hy	 = hvec.get(asY);
    double Tx	 = this->mVertex[topver].get(asX); // P0x (top vertex)
    double Ty	 = this->mVertex[topver].get(asY); // P0y
    double Sx	 = this->mVertex[sidever].get(asX); // P1x (side vertex)
    double Sy	 = this->mVertex[sidever].get(asY); // P1y
    double oeh	 = ex * hy - ey * hx;		    // t ʬ

    if(fabs(oeh) < ERRTOL)		
    {				// ǤϤʤʤϤ
#ifndef NO_OUT_SHADE_ERROR
	cout << "Error! : can't solve this triangle. oeh near 0" << endl;
	cout << "ignored and average intensity (t, s is not calced)" << endl;
#endif
#ifndef NDEBUG
	showvers(hitPos, hvec, evec, this->mVertex[topver],
		 this->mVertex[sidever], this->mVertex[otherver], 
		 asX, asY, oeh, -1.0, -1.0);
#endif
	Vector3 aveInt = (this->mIntensity[0] + this->mIntensity[1] +
			  this->mIntensity[2]) / 3.0;  
	return(aveInt);
	// commMpi2_exit(1);
    }
    double t = (Tx * hy - Ty * hx - Sx * hy + Sy * hx) / oeh;
    double s;
    if(fabs(hx) > fabs(hy))
    {
	s = (Sx - Tx + t * ex) / hx;
    }else
    {
	s = (Sy - Ty + t * ey) / hy; // hx ˤ hy Ƿ׻
    }
    Vector3 intensityP = (1.0 - t) * this->mIntensity[sidever]
 	+ t * this->mIntensity[otherver];
    Vector3 intensityH =  (1.0 - (1.0 / s)) * this->mIntensity[topver]
 	+ (1.0 / s) * intensityP;

#ifndef NDEBUG
    if((t < -0.0001) || (s < -0.0001))
    {
	cout << "Error! : illegal t or s" << endl;
	showvers(hitPos, hvec, evec, this->mVertex[topver], 
		 this->mVertex[sidever], this->mVertex[otherver], 
		 asX, asY, oeh, t, s);
    }
#endif
    // ٷ׻˼Ԥˤϳĺʿͤ٤Ȥ롣
    if((intensityH.get(Vector3::X) < 0.0) || 
       (intensityH.get(Vector3::Y) < 0.0) || 
       (intensityH.get(Vector3::Z) < 0.0))
    {
#ifndef NO_OUT_SHADE_ERROR
	cout << "Warning! : calcRayTrIC::intensity " << intensityH << 
	    ": < 0.0" << endl;
#endif
	intensityH = (this->mIntensity[0] + this->mIntensity[1] +
		      this->mIntensity[2]) / 3.0;
#ifndef NDEBUG
	showvers(hitPos, hvec, evec, this->mVertex[topver],
		 this->mVertex[sidever],  this->mVertex[otherver], 
		 asX, asY, oeh, t, s);
#endif
    }
    return(intensityH);
}
