//------------------------------------------------------------
// $Id: calcRayTrSRG.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
//	calcRayTrSRG.cc
//	calculation of Secondary Ray Generation unit for ray tracing 
//	1996/8/8
//	(C) 1995-1998 Copyright YAMAUCHI Hitoshi  
//
//	ray-tracing ˡ radiosity ˡǤȿͥ쥤˰㤤ꡥ
//	󼡥쥤ȯ for RayTracing
//------------------------------------------------------------
#include "calcRayTrSRGgetdir.h"

//------------------------------------------------------------
// 2 ray-tracing ray 
//     	ٷ׻ IC ǺѤǤ
//	(ʸ˽񤤤Ƥ߷פȤϰ㤤ΤȤ IC->SRG ³򼨤
//	 Ƥ롥ʸǤȿ FrameBuffer ؤƤ뤬
//	 ˤ ray Ǥκݤˤ FrameBuffer ؤιʤ
//		(see mpi2doc_implementation)
//------------------------------------------------------------
// YorN PEClass::
// newSecondaryRayTracingRays(Ray *pRay, const materialClass *pMat, 
// 			   objBaseClass * pHitObj)
// {
//     YorN isGenerateRay = NO;	// 쥤ȯ? 
// 
//     //  ray ȿ͡޲ۤƤ뤫
//     if(pRay->getReflectedNum() >= this->mViewData.getMaxRayRefNum())
//     {				// ۤƤ롣ray ȯʤ
// 	assert(isGenerateRay == NO);
// 	return(isGenerateRay);
//     }
//     
//     //------------------------------------------------------------
//     // ȿ 2  ray-tracing ray  new PE ν塼Ͽ
//     //------------------------------------------------------------
//     Ray *pNewHanshaRay = 
// 	newReflectionRayTracingRays(pRay, pMat, 
// 				    this->mViewData.getMinRayRefCoeffNorm(),
// 				    pHitObj);
//     if(pNewHanshaRay != NULL)	// ray ȯ
//     {
// 	pNewHanshaRay->setColor(pRay->getColor()); // IC Ƿ׻٤
// 	this->setRayPtrToThisPE(pNewHanshaRay);		   
// 	isGenerateRay = YES;
// 	// ȿ ray-tracing 쥤ΤʤФ Hint TOKUNAGA
//     }
// 
//     //------------------------------------------------------------
//     // Ʃ 2  refraction 쥤 new PE ν塼Ͽ
//     //------------------------------------------------------------
//     Ray *pNewToukaRay = 
//     	newRefractionRayTracingRays(pRay, pMat, 
// 				    this->mViewData.getMinRayRefCoeffNorm(),
// 				    pHitObj);
//     if(pNewToukaRay != NULL)
//     {
// 	// ray ȯ˵٤ƤΤ?
// 	if(isGenerateRay == NO)
// 	{			// Ƥʤ٤
// 	    pNewToukaRay->setColor(pRay->getColor());	    
// 	}
// 	this->setRayPtrToThisPE(pNewToukaRay);
// 	isGenerateRay = YES;
// 	//  ray-tracing ray ΤʤФ Hint TOKUNAGA
//     }
//     return(isGenerateRay);
// }

//------------------------------------------------------------
// 2 ray-tracing ray 
//     	ٷ׻ IC ǺѤǤ
//	(ʸ˽񤤤Ƥ߷פȤϰ㤤ΤȤ IC->SRG ³򼨤
//	 Ƥ롥ʸǤȿ FrameBuffer ؤƤ뤬
//	 ˤ ray Ǥκݤˤ FrameBuffer ؤιʤ
//		(see mpi2doc_implementation)
//------------------------------------------------------------
// ʬ̵󼡸
//------------------------------
YorN PEClass::
secondRayGenWithoutDistribute(Ray *pRay, const materialClass *pMat, 
			      objBaseClass * pHitObj)
{
    YorN isGenerateRay = NO;	// 쥤ȯ? 

    //  ray ȿ͡޲ۤƤ뤫
    if(pRay->getReflectedNum() >= this->mViewData.getMaxRayRefNum())
    {				// ۤƤ롣ray ȯʤ
	assert(isGenerateRay == NO);
	return(isGenerateRay);
    }
    
    //------------------------------------------------------------
    // ȿ 2  ray-tracing ray  new PE ν塼Ͽ
    //------------------------------------------------------------
    Vector3 reflectedRayDir, reflectedRayCoeff;
    YorN isGenReflectRay = 
	getReflectionRayDirRayTrace(pRay, pMat, 
				    this->mViewData.getMinRayRefCoeffNorm(),
				    pHitObj, 
				    &reflectedRayDir,
				    &reflectedRayCoeff);
    if(isGenReflectRay == YES)	// ray ȯ
    {
	// ȿͥ쥤 newRay! 
	// Υ󥹥ȥ饯Ǻ쥤ϰäʪΤˤϸ򺹤ʤ 
	Ray *pNewHanshaRay = Ray::newForReflectionRayTracing(pRay, 
							     reflectedRayDir, 
							     reflectedRayCoeff,
							     pHitObj);
	
	pNewHanshaRay->setColor(pRay->getColor()); // IC Ƿ׻٤
	this->setRayPtrToThisPE(pNewHanshaRay);		   
	isGenerateRay = YES;
	// ȿ ray-tracing 쥤ΤʤФ Hint TOKUNAGA
    }

    //------------------------------------------------------------
    // Ʃ 2  refraction 쥤 new PE ν塼Ͽ
    //------------------------------------------------------------
    Vector3 refractedRayDir, refractedRayCoeff;    
    YorN isGenRefractedRay = 
	getRefractionRayDirRayTrace(pRay, pMat, 
				    this->mViewData.getMinRayRefCoeffNorm(),
				    pHitObj, 
				    &refractedRayDir,
				    &refractedRayCoeff);
    if(isGenRefractedRay == YES)
    {
	Ray *pNewToukaRay = Ray::newForReflectionRayTracing(pRay, 
							    refractedRayDir, 
							    refractedRayCoeff,
							    pHitObj);
	pNewToukaRay->changeSide(); // ޤξˤʪΤȳξ֤Ѵ
	
	// ray ȯ˵٤ƤΤ?
	if(isGenerateRay == NO)
	{			// Ƥʤ٤
	    pNewToukaRay->setColor(pRay->getColor());	    
	}
	this->setRayPtrToThisPE(pNewToukaRay);
	isGenerateRay = YES;
	//  ray-tracing ray ΤʤФ Hint TOKUNAGA
    }
    return(isGenerateRay);
}

// 󼡸ͤʬ뤫ʤ
YorN PEClass::
newSecondaryRayTracingRays(Ray *pRay, const materialClass *pMat, 
			   objBaseClass * pHitObj)
{
    if(pMat->getFrustumHalfTopRad() != 0.0)
    {
	// ʬ󼡸 
 	return(this->secondRayGenWithDistrbute(pRay, pMat, pHitObj));
    }
    else
    {
	// 󼡸ͤʬ̵
	return(this->secondRayGenWithoutDistribute(pRay, pMat, pHitObj));
    }
}
