//------------------------------------------------------------
// $Id: constants.h,v 1.2 2000/05/15 14:20:43 yamauchi Exp $
//------------------------------------------------------------
//	constants.h
//	constant values
//	1996/3/17 
//	(C) Copyright Hitoshi Yamauchi
//------------------------------------------------------------
#ifndef _constants_h
#define _constants_h 1

#include <math.h>
#include <limits.h>

#ifdef FLT_MAX
const double PlusInfty  	= FLT_MAX;
// use FLT_MAX in limits.h but not in SunOS 4.x include file
#else
const double PlusInfty  	= 3.4E+38;
#endif

#include "IntVec3.h"

// PE  ü ID 
static const IntVec3 HostID(     -1, -1, -1);
static const IntVec3 IllegalPEID(-2, -2, -2);

// ϤκݤΥإå
static const char * const NORMALHEAD  = "//";
static const char * const VERBOSEHEAD = "##";
static const char * const DEBUGHEAD   = "<<";
static const char * const OUTDATAHEAD = ";;";
static const char * const TRACE_STDOUT_HEAD = "TR: ";

// material ̾κĹ
const unsigned int MAX_MATERIAL_NAME_LEN = 64;

// image  save 뤿 tmp file name Υƥץ졼
#define pTEMP_SAVE_IMAGE_FILENAME "tempMpi2imageXXXXXX"

// material name ν(̾ material ̾ȤƻȤʤ)
#define NULLMaterialName "This is NULL material, can not use."

// ٤ϰ 0 餤ĤޤǤ
const double MAX_INTENSITY	= 1.0;

// ϰϤȤߤʤ
const double D_ERROR_RES	= 1e-5;

// 饸ƥͥ륮κǾ
const double	DEFAULT_MIN_RAD_ENERGY		= 0.01; 

// إߥ塼֤ξ̤ΰդβ
const int	DEFAULT_HEMRES			= 10; 

// 쥤κȿͲ
const int    	DEFAULT_MAX_REFLECTION_RAY_NUM	= 3; 

// 쥤ȿ͸ΨκǾ^2
const double 	DEFAULT_MIN_REFLECTION_COEFF_NORM2	= 0.00001; 

// ʬ쥤ȥ졼ˡΥ쥤ν(쥤Τ)
const int    	DEFAULT_DIST_RAY_NUM		= 1; 

// 쥤ȥ졼ˡˤ쥤ȯ (̤̿βܤ)
const int 	GEN_FRAYS_FACTOR_BY_COMMUN	= 2;

// ѿβ
const int 	DEFAULT_FRUSTUM_RES		= 2;

// Хåե
const int	MAX_RECV_BUFFNUM		= 8;

// ̿ٱθretry 롣βȥȥ饤ֳ()
// SP2  HPS γߤ 400 msec 餷 = 400*1e3 = 4e5 micro sec.
const int 	MAX_RETRY_NUM_WAIT_BARRIER	= 36;
const int 	MAX_RETRY_NUM_CALC		= 16;
#ifdef USE_MPI
const int 	RETRY_WAIT_TIME			= 100000;
#else
const int 	RETRY_WAIT_TIME			= 100;
#endif

// ƻεٻ߻(̿ٱθ:)()
// SP2  High Performance Switch γߤ 400 msec 餷ΤǤ
// θ ϥ顼Τδֳ֤ǼºݤϤäȾ
//const int 	POLLING_SLEEP_TIME		= 200000; 
const int 	POLLING_SLEEP_TIME		= 0; 

// پ礤ĤޤȤ뤫 FIXHERE
const int 	MAX_INTVER_NUM_AT_ONCE		= 64;

// ͥβܤΥΥХåեѰդ뤫
const int BUFSIZE_FACTOR_BY_THREASH = 3;

// time display precision for gettimeofday
const int TIMEOFDAYPREC = 16;

//------------------------------------------------------------
// compiling option
//------------------------------------------------------------
// ¹Իν(ɤ)
// #define REDUCE_VERBOSE_INFO


#endif				// #ifndef _constants_h
