//------------------------------------------------------------
// $Id: frustumSRG.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// distribute secondary ray generation	
//	ȯ˿ΤѤʬ쥤ȯ롥
//
//	Original file is prbDist.cc by TOKUNAGA Mayumi
//	Changed to frustumSRG.cc by YAMAUCHI Hitoshi
//
//	Copyright (C) 1998  TOKUNAGA Mayumi   ͳ
//	Copyright (C) 1998  YAMAUCHI Hitoshi  
//---------------------------------------------------------
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include "frustumSRG.h"

//------------------------------------------------------
// protected function
//------------------------------
// output message
//------------------------------
// void frustumSRGClass::
// outMessage(int messageType)
// {
//     static const char* pMes[] = {
// 	"Error! : illegal sample square resolution (must be > 0)"
// 	"Suggest : in view file. setnum frustum = 1 1 1.0 1.0"
// 		"frustumSRGClass::getMemory"
// }

//------------------------------------------------------
// public functions
//------------------------------
// constructor
//------------------------------
frustumSRGClass::
frustumSRGClass(void)
{
    this->mBaseSquareEdgeResol  = -1;
    this->mNumberOfTotalSamples = -1; // illegal value ǽ
    this->mpPixelBasePos   	= NULL;
    this->mpPixelSamplePos 	= NULL;
    this->mpWeight 		= NULL;
}

//------------------------------
// destructor
//------------------------------
frustumSRGClass::
~frustumSRGClass(void)
{
    if(this->mBaseSquareEdgeResol > 0)	// Ѥߤξ
    {
	// to tokunaga 
	// ǳݤΤ delete ʤȥ꡼ 
	// ˤΥ饹򸫤Ƥ getMemory ƤФ뤫
	// ʤΤǥåɬ  
	delete [] this->mpPixelBasePos;
	delete [] this->mpPixelSamplePos;
	delete [] this->mpWeight;
	this->mpPixelBasePos 	= NULL;
	this->mpPixelSamplePos 	= NULL;
	this->mpWeight 		= NULL;
	this->mBaseSquareEdgeResol  = -1;
	this->mNumberOfTotalSamples = -1;
    }
}


// [0, m) εȯYam 
inline static int rand_i(int max)
{
    return (int(drand48() * ((double)max)));
} 

//------------------------------------------------------------
// ʬ۴ؿ
// 	frustum ̤˽ŤߤĤ
//	cos^n §Ѥ
// Z Ͼ 1.0 ꤹ롥
//   @param x : frustum ̾ΰ x
//   @param y : frustum ̾ΰ y
//   @param pow_cos_n : Phone  cos  n §Υѥ᡼ n 
//------------------------------------------------------------
// inline 
static double genWeight(double x, double y, double pow_cos_n)
{
    assert(pow_cos_n >= 0.0);

    const double z_sqrt = 1.0;	// z = 1.0, z^2 = 1.0 * 1.0 = 1.0;

    // x^2 + y^2 + z^2 : 礭ʿξˤˤʤ뤬
    // (x^2 + y^2 + z^2 > MAX_DOUBLE && sqrt(x^2 + y^2 + z^2)
    // < MAX_DOUBLE ξˤȤȤhypot  3 
    // Ϥʤ)
    double distance_from_reflent_point = sqrt(x * x + y * y + z_sqrt);
    double cos_theta = 1.0 / distance_from_reflent_point;

    return(pow(cos_theta, pow_cos_n)); 
}

//    double distance = tan(sqrt(x[0] * x[0] + x[1] * x[1]));
//    double m = 0.8;
//    return(exp((-1)*pow((distance/m),2.0)));
//    return(exp((-1)*(distance*distance)/(m*m)));

//------------------------------
// initialize : memory allocation and 
//   @param resolBaseSquareEdge frustum դΰդβ 
//------------------------------
void frustumSRGClass::
init(int resolBaseSquareEdge)
{
    const char *pEmes = 
      "Error!  : frustumSRGClass::init : illegal sample square resolution.\n";

    if(resolBaseSquareEdge < 1)
    {
 	cout << pEmes << "Suggest : in viewfile, "
	"x value must be > 0 of line `setnum frustum = x y fov cos_n'" << endl;
	exit(1);
    }

    // ̤β٤ 2 ǳʤƤϤʤ
    if(resolBaseSquareEdge % 2 != 0)
    {
 	cout << pEmes << "Suggest : in viewfile, x value must be "
	"x % 2 == 0 of line `setnum frustum = x y fov cos_n'" << endl;
	exit(1);
    }

    // Ѥߤ?
    if(this->mBaseSquareEdgeResol < 0)
    {
	// Ѥ(Ѥ)ξˤϳ
	delete [] this->mpPixelBasePos;
	delete [] this->mpPixelSamplePos;
	delete [] this->mpWeight;
    }
    
    this->mBaseSquareEdgeResol  = resolBaseSquareEdge;
    // ̤ pixel  = (1 դ resol)^2
    this->mNumberOfTotalSamples = resolBaseSquareEdge * resolBaseSquareEdge;

    // allocation
    this->mpPixelBasePos   = new Vector3[this->mNumberOfTotalSamples];
    this->mpPixelSamplePos = new Vector3[this->mNumberOfTotalSamples];
    this->mpWeight 	   = new double [this->mNumberOfTotalSamples];

    // 
    srand48(time(NULL));
}

//------------------------------
// ž (0.0, 0.0, 1.0)  frustum հֽ
//   @param frustumTopHalfRad    : ĺ/2 (radian)
//   @param pow_cos_n		 : Phone  cos n § n 
//------------------------------
void frustumSRGClass::
setBaseSamplePosition(double halfFrustumTopRad, double pow_cos_n)
{
    // Υ֥ȤϽѤߤǤʤƤϤʤ
    assert(this->mBaseSquareEdgeResol > 0);  

    // ̤ȾʬĹ
    double halfEdge = sin(halfFrustumTopRad);

    // ץ󥰥ԥ
    double widthOfSamplePixel = 
    	2.0 * halfEdge / (double)(this->mBaseSquareEdgeResol);
    assert(widthOfSamplePixel > 0.0);
    
    // pixel 濴ؤ pixel ȾʬĹ׻Ƥ
    double halfWidthOfPixel = (widthOfSamplePixel / 2.0);
    
    int    pixelIdx = 0;
    double totalWeight = 0.0;	// ŤߤΤ˹פ׻
    double x = - halfEdge + halfWidthOfPixel;
    for(int xidx = 0; xidx < this->mBaseSquareEdgeResol; xidx++)
    {
	double y = - halfEdge + halfWidthOfPixel;
	for(int yidx = 0; yidx < this->mBaseSquareEdgeResol; yidx++)
	{
	    this->mpPixelBasePos[pixelIdx].set(x, y, 1.0);
	    this->mpWeight[pixelIdx] = genWeight(x, y, pow_cos_n);
	    totalWeight += this->mpWeight[pixelIdx];

	    y += widthOfSamplePixel;
	    pixelIdx++;
	    assert(pixelIdx <= this->mNumberOfTotalSamples);
	}
	x += widthOfSamplePixel;
    }

    // Ťߤ
    for(int i = 0; i < this->mNumberOfTotalSamples; i++)
    {
	this->mpWeight[i] /= totalWeight;
    }
}
    

// void frustumSRGClass::
// probablty(int precise, double *min, double *max) 
// {
//     // precise = n = ̤ pixel 
//     int i, j;
//     double h[2], x[2], val;
// 
//     // To Tokunaga 
//     // int n_sq = precise * precise;
//     // getMemory(n_sq) Ǥ礦ޤʬȤνǤʤΤ
//     // ʬΥФǽΤϴǤϤʤʡ noi  
//     // double ɬפϤ
//     this->noi =  pow((double) precise, 2.0); // n^2 (ʤ餫Ȥ)
//     this->getMemory(int(this->noi));	     // 
//     
//     for(i = 0; i < 2; i++)
//     {
// 	h[i] = (max[i] - min[i]) / precise; // h = sampling pixel 
//     }
//     val=0.0;
//     int k = 0;
// 
//     for(i = 0; i < precise; i++) 
//     {
// 	x[0] = h[0]*i + min[0] + h[0]/2; // ̤ X ΰ
// 	for(j = 0; j < precise; j++)
// 	{
// 	    x[1] = h[1]*j +  min[1] + h[1]/2; // ̤ Y ΰ
// 	    this->mpPixelBasePos[k].set(x[0], x[1], 1.0); // ֤Υå
// 	    this->distributeProb[k] = f(x);	   // ΰ֤νŤߤΥå
// 	    val += f(x);		   // 뤿Ʋû
// 	    k++;			   // Ťߡ֤ 1  index
// 	}
//     }
// 
//     for(i = 0; i < ((int) this->noi); i++)
//     {
// 	//	cout << this->mpPixelBasePos[i].get(0) << " " <<
// 	//	    this->mpPixelBasePos[i].get(1) << " " <<
// 	//			this->distributeProb[i]  << endl;
// 	this->distributeProb[i] /= val;	// 
//     }
// }

//------------------------------------------------------------
// rotate : HemiCube βžƱ롼 tokunaga changed 
//	@param rayDir : rayDir 濴˸äƳȻ쥤
//------------------------------------------------------------
void frustumSRGClass::
rotate(const Vector3& rayDir)
{
    const double D_NON_DEF = -2.0; // ꤨʤ
    double a[3][3];		   /* 顼Ѵޥȥꥯ  */
    double dCtheta = D_NON_DEF;	   /* (x' axis)     */
    double dStheta = D_NON_DEF;
    double dCkai   = D_NON_DEF;    /* (y' axis)     */
    double dSkai   = D_NON_DEF;
    double dCphi   = 1.0;	   /* (z' axis)=0.0 */
    double dSphi   = 0.0;
    
    double dNx = rayDir.get(Vector3::X);
    double dNy = rayDir.get(Vector3::Y);
    double dNz = rayDir.get(Vector3::Z);

    dCtheta = dNz;
    dStheta = sqrt( 1 - dNz * dNz ); /* Ȥꤢ˲ */
    if(0.0 == dStheta)
    {
	dSkai = 0.0;
	dCkai = 1.0;
    }else
    {
	dSkai   = dNx / dStheta;
	dCkai   = dNy / dStheta;
    }

    // žѴ
    a[0][0] =   dCkai   * dCphi - dSkai * dCtheta * dSphi;
    a[1][0] = - dSkai   * dCphi - dCkai * dCtheta * dSphi;
    a[2][0] =   dStheta * dSphi;

    a[0][1] =   dCkai   * dSphi + dSkai * dCtheta * dCphi;
    a[1][1] = - dSkai   * dSphi + dCkai * dCtheta * dCphi;
    a[2][1] = - dStheta * dCphi;

    a[0][2] =   dSkai * dStheta;
    a[1][2] =   dCkai * dStheta;
    a[2][2] =   dCtheta;
    
    for(int i = 0; i < this->mNumberOfTotalSamples; i++)
    {
	// double x = this->distributePoint[i].get(Vector3::X) * rad * route_2;
	// double y = this->distributePoint[i].get(Vector3::Y) * rad * route_2;
	// double z = this->distributePoint[i].get(Vector3::Z) * rad * route_2;
	// cout << x << " " << y << " " << this->distributeProb[i] << endl;

 	double x = this->mpPixelBasePos[i].get(Vector3::X);
 	double y = this->mpPixelBasePos[i].get(Vector3::Y);
 	double z = this->mpPixelBasePos[i].get(Vector3::Z);

	double x2 = a[0][0] * x + a[0][1] * y + a[0][2] * z; 
	double y2 = a[1][0] * x + a[1][1] * y + a[1][2] * z;
	double z2 = a[2][0] * x + a[2][1] * y + a[2][2] * z;
	
	this->mpPixelSamplePos[i].set(x2, y2, z2);
    }
}

/*
 ʤΥɤϲ򤷤ƤΤ

    int i;
    //tokunaga changed
    //ͳѿ̤ rad ϰ ץ
    double weight_all = 0.0;

    //    double route_2 = sqrt(2);
    for(i = 0; i <sampleNum; i++)
    {
	//double x = this->mpPixelBasePos[i].get(Vector3::X) * rad * route_2;
	//double y = this->mpPixelBasePos[i].get(Vector3::Y) * rad * route_2;
	//double z = this->mpPixelBasePos[i].get(Vector3::Z) * rad * route_2;
	
	int j = rand_i((int)this->noi);
	while(fabs(this->mpPixelBasePos[j].get(Vector3::X) * 
		   this->mpPixelBasePos[j].get(Vector3::Y)) > rad * rad) 
	{
	    j = rand_i((int)this->noi);
	}
	double x = this->mpPixelBasePos[j].get(Vector3::X); 
	double y = this->mpPixelBasePos[j].get(Vector3::Y);
	double z = this->mpPixelBasePos[j].get(Vector3::Z); 

	double x2 = a[0][0] * x + a[0][1] * y + a[0][2] * z; 
	double y2 = a[1][0] * x + a[1][1] * y + a[1][2] * z;
	double z2 = a[2][0] * x + a[2][1] * y + a[2][2] * z;
	
	this->mpPixelSamplePos[i].set(x2, y2, z2);
	this->Weight[i] = this->distributeProb[j];
	weight_all += this->distributeProb[i];
    }
    for(i = 0; i < sampleNum; i++)
    {
        this->Weight[i] /= weight_all;
    }
*/

//------------------------------------------------------------
// test
//------------------------------------------------------------
/*
void main()
{
    int n = 20;
    double a[2], b[2];
    Vector3 *point;
    
    double width = tan(M_PI/8);
    a[0] = -width;    a[1] = -width;
    b[0] = width;     b[1] = width;
    
    frustumSRGClass sPoint;
    sPoint.probablty(n, a, b);
    Vector3 x_axis(1/sqrt(2), 1/sqrt(2), 0.0);
    sPoint.rotate(x_axis);
    
    point = new Vector3 [n*n];
    point = sPoint.getmpPixelSamplePos();
    
    int i;
    int sample = sPoint.getSampleNum();
//    for(i = 0; i < sample; i++)
//	printf("%f %f %f \n", point[i].get(Vector3::X),
//	       point[i].get(Vector3::Y),point[i].get(Vector3::Z));
}
*/
