//------------------------------------------------------------
// $Id: mpi2communStandAlone.cc,v 1.2 2000/05/19 20:35:51 yamauchi Exp $
//------------------------------------------------------------
//	mpi2 communication implementation
//	1996/7/31
//	Copyright (C)  YAMAUCHI Hitoshi  
// 	̿ط  MPI (commMpi2 ؿ ǥץ벽)
// Stand Alone  ̿롼Ƥ֤Ƚλ롣PE 1 ĤǼ¹ԤΤ
// ray-tracing, radiosity code debug  
//------------------------------------------------------------
#ifndef FOR_STANDALONE
# error "This communication routines are for stand alone processing"
#endif

#include <assert.h>

#include "StandAloneModeObjects.h"
#include "mpi2communication.h"
#include "sphereObject.h"
#include "triangleObject.h"
#include "volume.h"
#include "Option.h"

//------------------------------------------------------------
// initialize commun (M\pi)^2
//------------------------------------------------------------
void commMpi2_Init(int *pArgc, char ***pArgv)
{
    SysStat::getInstance()->setCommSize(2);
    SysStat::getInstance()->setMyRank(0);	// PE's rank = 0
    return;
    // for Wall
    pArgc = pArgc;
    pArgv = pArgv;
    // for Wall
}

void commMpi2_Finalize(void)
{
    cout << DEBUGHEAD << " commMpi2_Finalize nothing done" << endl;
}

void commMpi2_Barrier(void)
{
    // nothing for barrier synchronization
}

void commMpi2_exit(int err_num)
{
    exit(err_num);
}

//------------------------------------------------------------
// sysinfo
//------------------------------------------------------------
// send (Broadcast)
//  PE ѤǤ object, material, sysinfo  receive Ϥʤ
//  send Ʊ receive 
//------------------------------
// ϤѤ object
void commMpi2_BroadSysinfo(SysInfoClass 	*pSys,
			   ViewDataClass	*pVw,
			   SpaceParam		*pSp)
{
    GpPE->receiveSysinfoNinitSpaceInfo(*pSys, *pVw, *pSp);
}

// ƶ֤ʪΤ¸ߤ뤫ɽ
void commMpi2_BroadObjInSpc(int bytes, OBJINSPC_IMPLEMENT_TYPE * pDatArray)
{
    GpPE->receiveObjInSpcMap(bytes, pDatArray);
}

// ʪΤεΥɽ
//tokunaga
void commMpi2_BroadPRCSkipMap(int bytes, OBJINSPC_IMPLEMENT_TYPE * pDatArray)
{
    GpPE->receivePRCSkipMap(bytes, pDatArray);
}


//------------------------------
// receive command
//------------------------------
// int commMpi2_recvBroadCommand(enum mpi2commun_command_e *pCommand)
// {
//     (*pCommand) = BroadCommand;
//     return(YES);
// }

//------------------------------------------------------------
// send, recv objects
//------------------------------------------------------------
// static IntVec3 		CommunSrcPEID;
// static IntVec3 		CommunDestPEID;
// static objBaseClass    *PCommunObj	= NULL;
void commMpi2_sendObject(int destRank, objBaseClass *pObj)
{
    if(destRank != 0)
    {
	cerr << "Error! : This is stand alone mode. There is only one PE."
	    << " You send to " << destRank << endl;
	exit(1);
    }
    
    // ¾ PE ξ뤿ᡢ¦ new ɬפ롣
    // ºݤ stand alone ǤϰĤΥ֤ưƤΤǤ
    // ˳ݤʤ褦˼ǽǤ뤬ΥɤǤ
    // ꥢǤƱ interface 󶡤ΤǤΤ褦ˤ¾ 
    // PE 줿褦˼ɬפ롣 
    // 
    // 󥭥㥹ȤƤޤä¾ˡͤ٤
    objBaseClass *pRecvObj = NULL;
    switch(pObj->who())
    {
    case TRIANGLE_OBJ_E:	// Wooo! downcasting ... It is not good.
	pRecvObj = new triangleObjectClass(*((triangleObjectClass*)pObj));
	break;
    case SPHERE_OBJ_E:		// Wooo! downcasting ... It is bad.
	pRecvObj = new sphereObjectClass(*((sphereObjectClass*)pObj));
	break;
    case NULL_OBJ_E:
	pRecvObj = new nullObjectClass;
	break;
    default:
	cerr << "Error! : send illegal obj "
	    "at mpi2communStandAlone.cc:commMpi2_sendObject" << endl;
	commMpi2_exit(1);
    }
    
    GpPE->receiveObjects(pRecvObj);
}

void commMpi2_recvObject(int srcRank, int dstRank, objBaseClass **ppObj)
{
    // nothing to do here
    ppObj = NULL; // for wall
    srcRank = dstRank;
}

//------------------------------------------------------------
// send, recv volume (䤬 object Ȥ줹٤?)
//	ĹΤΤ serialize ϤʤΤǸĹΤ
//	ϤΤޤޡserialize ٤Τ serialize Ū
//	褦  
//------------------------------------------------------------
// send subvolume
void commMpi2_sendVolume(int dstRank, VolumeClass *pVol)
{
    double *pBuf = pVol->newSerializedArray();
    VolumeClass recvVol;
    recvVol.deserialize(pBuf);
    delete [] pBuf;

    GpPE->receiveVolume(&recvVol);    
    dstRank = dstRank;		// for Wall
}

// recv subvolume
void commMpi2_recvVolume(int srcRank, int dstRank, VolumeClass **ppVol)
{
    // nothing to do here;
    ppVol = NULL;
    srcRank = dstRank;
}

//------------------------------------------------------------
// material
//------------------------------------------------------------
void commMpi2_BroadMaterial(materialClass *pMat)
{
    GpPE->receiveMaterials(*pMat);
}


//------------------------------------------------------------
// probe 
//------------------------------------------------------------
YorN commMpi2_canRecv(int *pSrcRank, 
		      enum communication_tags_e recvStaff,
		      int *pNumOdObjs)
{
    return(NO);
    recvStaff  = recvStaff;	// for -Wall
    pSrcRank   = pSrcRank;
    pNumOdObjs = pNumOdObjs;
}

YorN commMpi2_isSendComplete(reqHandle_st req_handle)
{
    return(YES);		// stand alone ǤϾǽ
    req_handle = req_handle;	// for -Wall
}

YorN commMpi2_isRecvComplete(reqHandle_st req_handle)
{
    return(YES);		// stand alone ǤϾ˼ǽ
    req_handle = req_handle;	// for -Wall
}

//------------------------------------------------------------
// ray
//------------------------------------------------------------
reqHandle_st commMpi2_sendRays(int destRank, Ray* pRay, int numOfRays)
{
    cerr << "Error! : at stand alone version, commMpi2_sendRay." << 
	"this function will be never called." << endl; // 椷ʤ
    exit(1);
    destRank = destRank;    pRay = pRay;    numOfRays = numOfRays;
    static reqHandle_st tmp;
    return(tmp);
}

reqHandle_st commMpi2_recvRays(int srcRank, Ray *pRay, int numOfRays)
{
    cerr << "Error! : at stand alone version, commMpi2_recvRay." << 
	"this function will never be called." << endl; // 椷ʤ
    exit(1);
    srcRank = srcRank;		// for wall
    pRay = pRay;
    numOfRays = numOfRays;
    static reqHandle_st tmp;
    return(tmp);
}


//------------------------------------------------------------
// send intensity to Frame Buffer
//------------------------------------------------------------
void commMpi2_sendIntensity2FB(IntensityClass *pIntensity, int numOfInt)
{
    int	i;
    for(i = 0; i < numOfInt; i++)
    {
	GpHost->setIntensity(pIntensity[i]);
    }
}

void commMpi2_recvIntensity2FB(IntensityClass *pIntensity, int numOfIntensity)
{
    // void but OK
    pIntensity = pIntensity; // for -Wall
    numOfIntensity = numOfIntensity;
}

// YorN commMpi2_canRecvIntensity(int *pSrcRank)
// {
//     // void but OK
// }

//------------------------------------------------------------
// send, recv PEStatus
//------------------------------------------------------------
void commMpi2_sendPEstat2Host(PEStatClass *pPEstat)
{
    // void but OK
    pPEstat = pPEstat; // for wall
}

void commMpi2_recvPEstat(PEStatClass *pPEstat)
{
    // void but OK
    pPEstat = pPEstat;// for wall
}

// YorN commMpi2_canRecvPEStatus(int *pSrcRank)
// {
//     // void but OK
// }

//------------------------------------------------------------
// send, recv HostCommand : HostCommand  Host -> PE
//------------------------------------------------------------
// void commMpi2_sendHostCommand(int destRank, enum hostCommand_e host_command)
// {
//     // void but OK
//     destRank = destRank; // for wall
//     host_command = host_command;
// }
// 
// enum hostCommand_e commMpi2_recvHostCommand(void)
// {
//     // void but OK
//     return(HOSTCOM_ELSE_e);
// }

// if return NO, *pSrcRank has no mean
// YorN commMpi2_canRecvHostCommand(void)
// {
//     // void but OK
//     return(NO);
// }

//------------------------------------------------------------
// send, recv Intensity value and vertex position
//------------------------------------------------------------
reqHandle_st commMpi2_sendIntVer(int destRank, intVerClass *pIntver)
{
    cerr << "This function will never use in stand alone mode." << endl;
    cerr << "commMpi2_sendIntVer" << endl;
    commMpi2_exit(1);
    destRank = destRank;	pIntver = pIntver; // for Wall
    static reqHandle_st dummy;
    return dummy;
}

void commMpi2_recvIntVer(int srcRank,  intVerClass *pIntver)
{
    cerr << "This function will never use in stand alone mode." << endl;
    cerr << "commMpi2_recvIntVer" << endl;
    commMpi2_exit(1);    
    srcRank	= srcRank;
    pIntver	= pIntver;
}


//------------------------------------------------------------
// send, recv object
//	1 PE ξ,ºݤˤ̿ʤΤǤδؿľܰ(̾ 
//	host)˽񤤤Ƥޤ  
//------------------------------------------------------------
void sendIntensityStandAlone(IntensityClass *pObj, int numOfObj)
{
    for(int i = 0; i < numOfObj; i++)
    {
	GpHost->setIntensity(pObj[i]);
    }
}
