//------------------------------------------------------------
// $Id: screenPointer.h,v 1.2 2000/06/14 13:29:37 yamauchi Exp $
//------------------------------------------------------------
//	screen pointer class 
//	    scan type : regular 	̤֤˥󤹤
//			scanline 	scanline  PE ˳Ƥ
//			distributed	distributed  PE سƤ
//	쥤ȯ screen  pixel 򥹥󤹤
//	
//	֥ȶʬ䷿׻ǥ˴Ť׻Ǥν
//	ʬιͤ 1997 δǷˤäƤ졢ǽδǷ
//	äƼ줿. Ϥ줷ư褦 rewrite 
//
//	Copyright (C) 1996--1998 MAEDA Takayuki   δǷ
//	Copyright (C) 1996--1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _screenPointer_h
#define _screenPointer_h 1

#include <assert.h>
#include "YorN.h"

//------------------------------------------------------------
// screen  pixel ֤ݻΰ֤ȯ
//	base class (interface)
//	virtual  next θΨ˿ۤ뤬
//------------------------------------------------------------
class scrPtrIF  {
private:
    scrPtrIF (const scrPtrIF & rhs);
    const scrPtrIF & operator=(const scrPtrIF & rhs);
 
protected:
    int mMaxX;			// screen max X
    int mMaxY;			// 	      Y
    int mX;			// ߤ screen  X
    int mY;			// 		      Y
 
public:
    scrPtrIF(void)
    {
	// Ȥ : mX(-1) Ȥ񤤤硤subclass  construct 
	// Τ狼ʤΤǽ񤤤Ƥޤ
	//  
	this->mX 	= -1;
	this->mY 	= -1;
	this->mMaxX	= -1;
	this->mMaxY 	= -1;
    }
    // virtual ~scrPtrIF(void);
    
    //------------------------------
    // ʬ scan type ֤
    //------------------------------
    virtual const char* getScreenPointerType(void)	= 0;

    //------------------------------
    //  screen ֤Ф
    //------------------------------
    virtual YorN next(void)		 		= 0;

    //------------------------------
    //  screen ֤Ф
    //------------------------------
    void getpos(int *pX, int *pY) const
    {
	(*pX) = this->mX;
	(*pY) = this->mY;
    }
};


//------------------------------------------------------------
// All scan on a screen 
//    screen  ֤ increment Ƥ
//   (ޤ X  scan 롥)
//------------------------------------------------------------
class scrPtrAllScan : public scrPtrIF {
private:
    scrPtrAllScan(const scrPtrAllScan& rhs);
    const scrPtrAllScan& operator=(const scrPtrAllScan& rhs);
    scrPtrAllScan(void)
    {
	// scrPtrIF::scrPtrIF(); AIX  super Ǥʤ餷
	this->mX 	= -1;
	this->mY 	= -1;
	this->mMaxX	= -1;
	this->mMaxY 	= -1;
    }

public:
    scrPtrAllScan(int maxX, int maxY)
    {
	this->initMax(maxX, maxY);
    }
    // ~scrPtrAllScan(void);
    
    // scan ֤̾
    virtual const char* getScreenPointerType(void)
    {
	return("ScanType : AllScan (not distributed ray generation)");
    }

    //------------------------------
    // ꡼κͤ򥻥åȤ
    //------------------------------
    void initMax(int maxX, int maxY)
    {
	assert(maxX >  0);
	assert(maxY >  0);
	this->mMaxX = maxX;
	this->mMaxY = maxY; 
	this->mX = -1;	// ǽ x = 0 ֤
	this->mY =  0;	
    }

    //------------------------------
    //  screen ֤Ф
    //------------------------------
    // ʲΥɤ 1 ƥåפŤļ¹Ԥ
    // for(int y = 0; y < maxY; y++)
    // {
    //    for(int x = 0; x < maxX; x++)
    //    {
    //    }
    // }
    virtual YorN next(void)
    {
	this->mX++;
	if(this->mX >= this->mMaxX)
	{
	    this->mX = 0;
	    this->mY++;
	    if(this->mY >= this->mMaxY)	    
	    {
		return(NO);	// ʾ ray ϤǤʤ
	    }
	}
	return(YES);
    }
};

//------------------------------------------------------------
// distributed with scanline
//	PE  scanline ʬƳƤ
//	scanline Ӥ screen ư
//------------------------------------------------------------
class scrPtrScanline : public scrPtrIF {
private:
    scrPtrScanline(const scrPtrScanline& rhs);
    const scrPtrScanline& operator=(const scrPtrScanline& rhs);
    scrPtrScanline(void) 
    {
	// scrPtrIF::scrPtrIF(); AIX  super Ǥʤ餷
	// ˸ƤФΤ⤷ʤ԰¤ʤΤǽ񤤤Ƥ
	// base class memeber
	this->mX 	= -1;
	this->mY 	= -1;
	this->mMaxX	= -1;
	this->mMaxY 	= -1;

	// members of this class 
	this->mSkipYLines = 10000000; // ʿǽ
    }

protected:
    int mSkipYLines;

public:
    scrPtrScanline(int maxX, int maxY, int skipYLines, int startY)
    {
	this->initMax(maxX, maxY, skipYLines, startY);
    }
    // ~scrPtrScanline(void);
    
    // scan ֤̾
    virtual const char* getScreenPointerType(void) 
    {
	return("ScanType : Scanline (distributed first ray generation)");
    }
    
    //------------------------------
    // initialize 
    //------------------------------
    void initMax(int maxX, int maxY, int skipYLines, int startY)
    {
	assert(maxX >  0);
	assert(maxY >  0);
	this->mMaxX = maxX;
	this->mMaxY = maxY; 
	this->mX = -1;	// ǽ x = 0 ֤
	
	assert(skipYLines > 0);
	this->mSkipYLines = skipYLines;

	assert(startY >= 0);
	this->mY = startY;	// ǽ scanline
    }

    //------------------------------
    //  screen ֤Ф
    //------------------------------
    // ʲΥɤ 1 ƥåפŤļ¹Ԥ
    // for(int y = startY; y < maxY; y+= skipYLines)
    // {
    //    for(int x = 0; x < maxX; x++)
    //    {
    //    }
    // }
    virtual YorN next(void)
    {
	this->mX++;
	if(this->mX >= this->mMaxX)
	{
	    this->mX = 0;
	    this->mY += this->mSkipYLines;
	    if(this->mY >= this->mMaxY)	    
	    {
		return(NO);	// ʾ ray ϤǤʤ
	    }
	}
	return(YES);
    }
};

//------------------------------------------------------------
// distributed pixel by pixel
//	Ĥ pixel ؤ
//------------------------------------------------------------
class scrPtrDistribute : public scrPtrIF {
private:
    scrPtrDistribute(const scrPtrDistribute& rhs);
    const scrPtrDistribute& operator=(const scrPtrDistribute& rhs);
    scrPtrDistribute(void) 
    {
	// scrPtrIF::scrPtrIF(); AIX  super Ǥʤ餷
	// ˸ƤФΤ⤷ʤ԰¤ʤΤǽ񤤤Ƥ
	// base class memeber
	this->mX 	= -1;
	this->mY 	= -1;
	this->mMaxX	= -1;
	this->mMaxY 	= -1;

	// members of this class 
	this->mDistributedSizeX = 100000; // 
	this->mDistributedSizeY = 100000;
	this->mStartX		= 100000;
    }

protected:
    int mDistributedSizeX;
    int mDistributedSizeY;
    int mStartX;

public:
    scrPtrDistribute(int maxX, 		int maxY,
		     int distributedX, 	int distributedY, 
		     int startX, 	int startY)
    {
	this->initMax(maxX, maxY, distributedX, distributedY, startX, startY);
    }
    scrPtrDistribute(int maxX, int maxY, int totalPEnum, int thisRank)
    {
	// screen 礭 total PE Num  myRank (PE id  
	// distributedX,Y  startX,Y ׻롥)
	cout << "scrPtrDistribute:: Not Implemented Now" << endl;
	abort();
	maxX = maxY = totalPEnum = thisRank; // for -Wall
    }
    // ~scrPtrDistribute(void);

    // scan ֤̾
    virtual const char* getScreenPointerType(void) 
    {
	return("ScanType : Distributed (distributed first ray generation)");
    }

    // initialize 
    void initMax(int maxX, int maxY,
		 int distributedX, int distributedY, int startX, int startY)
    {
	assert(maxX >  0);
	assert(maxY >  0);
	this->mMaxX = maxX;
	this->mMaxY = maxY; 

	assert(distributedX > 0);
	assert(distributedY > 0);
	this->mDistributedSizeX = distributedX;
	this->mDistributedSizeY = distributedY;

	assert(startX >= 0);
	assert(startY >= 0);
	this->mStartX	= startX;

	this->mX =  startX - distributedX; // ǽ increment 뤿
	this->mY =  startY;
    }

    //------------------------------
    //  screen ֤Ф
    //------------------------------
    // ʲΥɤ 1 ƥåפŤļ¹Ԥ
    // for(int y = startY; y < maxY; y+ distributedY)
    // {
    //    for(int x = startX; x < maxX; x += distributedX)
    //    {
    //    }
    // }
    virtual YorN next(void)
    {
	this->mX += this->mDistributedSizeX;
	if(this->mX >= this->mMaxX)
	{
	    this->mX  = this->mStartX;
	    this->mY += this->mDistributedSizeY;
	    if(this->mY >= this->mMaxY)	    
	    {
		return(NO);	// ʾ ray ϤǤʤ
	    }
	}
	return(YES);
    }
};

#endif				// #ifndef _screenPointer_h

