//------------------------------------------------------------
// $Id: searchNextSpcDDA.cc,v 1.4.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 
// 	õ
//	;ޤäǤƤߤФʤΤȤϤʤ
//	DDA ˥åȤΩι⤤ΤȤȤǤ롣
//	1998ǯ127()
//	Copyright (C) 1997--1998 YAMAUCHI Hitoshi  
//
//    YorN moveRayToNextCalcSubspace(RayClass *pRay);
//	pRay Ϥδؿλˤϼ˸ȽԤ֤ˤ롣
//	֤ : θȽֳ֤Ǥ NO
//		 Ǥ YES ֤
//------------------------------------------------------------
#include "mpi2.h"
#include "mpi2exit.h"
#include "searchNextSpcDDA.h"

//------------------------------------------------------------
// local functions
//------------------------------------------------------------
// 쥤οʹ XPLUS, XMINUS,.. η(sub. calcDDA)
// ˹Ԥ뤫ɤ(⤫ɤΥƥȤϹԤʤ)
//------------------------------
inline static DIR_3D getDirection(const DDAInfoClass *const pDInfo, 
				  int goingDirection)  
{
    DIR_3D dir = DIR_ILLEGAL;

    switch(goingDirection)
    {
    case Vector3::X:
	if(pDInfo->getDDAVec().get(Vector3::X) < 0.0)
	{
	    dir = DIR_XMINUS;
	}else
	{
	    dir = DIR_XPLUS;
	}
	break;
	
    case Vector3::Y:	
	if(pDInfo->getDDAVec().get(Vector3::Y) < 0.0)
	{
	    dir = DIR_YMINUS;
	}else
	{
	    dir = DIR_YPLUS;
	}
	break;
	
    case Vector3::Z:
	if(pDInfo->getDDAVec().get(Vector3::Z) < 0.0)
	{
	    dir = DIR_ZMINUS;
	}else
	{
	    dir = DIR_ZPLUS;
	}
	break;
	
    default:
	cerr << "Error!: at getOnlyDirection illegal goingdir( = "
	    << goingDirection << ")" << endl;
	commMpi2_exit(1);
	break;
    }
    return(dir);
}
    
// IntVec3 -> Vector3(using in calcRayTrDD.cc, prepareShading.cc)
static inline Vector3 iv2v(const IntVec3& iv)
{
    return(Vector3(double(iv.get(IntVec3::X)),
		   double(iv.get(IntVec3::Y)),	   
		   double(iv.get(IntVec3::Z))));
}

// next space 
inline IntVec3 getNextSpcPos(const IntVec3& nowSpcpos, DIR_3D nextDir)
{
    int x = nowSpcpos.get(IntVec3::X);
    int y = nowSpcpos.get(IntVec3::Y);
    int z = nowSpcpos.get(IntVec3::Z);
    switch(nextDir)
    {
    case DIR_XPLUS:	
	x++;	break;
    case DIR_XMINUS:	
	x--;	break;
    case DIR_YPLUS:
	y++;	break;
    case DIR_YMINUS:
	y--;	break;
    case DIR_ZPLUS:	
	z++;	break;
    case DIR_ZMINUS:	
	z--;	break;
    default:
	cerr << "Error! : at getNextSpcPos Illegal dir." << endl;
	commMpi2_exit(1);
	break;
    }
    return(IntVec3(x, y, z));
}

//------------------------------
// double double ֤ (sub. of calcDDA)
//------------------------------
inline static double dSignD(double x) 
{
    if(x < 0.0)
    {
	return(-1.0);
    }else if(x > 0.0)
    {
	return(1.0);
    }else 
    {
	return(0.0);
    }
}

//------------------------------------------------------------
// protected functions
//------------------------------------------------------------
// check initialize parameter
//------------------------------
void searchNextSpcDDA::
exitIfIllegalParam(double cellLength, 
		   const int *pSpcIdxMin, const int *pSpcIdxMax, 
		   int   rayPropSkipMethod, int networkType)
{
    const char *pMes = 
	"Error! : searchNextSpcDDA::exitIfIllegalParam : ";
    if(cellLength <= 0.0)
    {
	cerr << pMes << "illegal cellLength (" << cellLength << ")" << endl;
	commMpi2_exit(1);
    }
    if((pSpcIdxMin == NULL) || (pSpcIdxMax == NULL))
    {
	cerr << pMes << "spc index is (null)." << endl;
	commMpi2_exit(1);
    }else
    {
	for(int i = 0; i < 3; i++)
	{
	    // ʬ index Ͼ >= 0,  minidx = maxidx ξ礢
	    if((pSpcIdxMin[i] < 0) || (pSpcIdxMax[i] < 0) || 
	       (pSpcIdxMin[i] > pSpcIdxMax[i]))
	    {
		cerr << pMes << "illegal spc index. spcMin[" << i << "] = " 
		    << pSpcIdxMin[i] << ", spcMax[" << pSpcIdxMax[i] <<
			"]" << endl;
		commMpi2_exit(1);		
	    }
	}
    }
    if((rayPropSkipMethod == NoSkip_rayprop)	 ||
       (rayPropSkipMethod == SobokuSkip_rayprop) ||
       (rayPropSkipMethod == ProximityClouds_rayprop)) //tokunaga changed
    {
	// OK! : no skip  Ѥ skip ϥݡ
    }else
    {
	cerr << pMes << "illegal skip method.(" << rayPropSkipMethod <<
	    ")" << endl;
	commMpi2_exit(1);		
    }

    if(networkType == Torus_network)
    {
	cerr << pMes << "NIN : Not implemented for Torus net." << endl;
	commMpi2_exit(1);		
    }
    else if(networkType == MultiStage_network)
    {    
	// OK! : multistage ϥݡ
    }else
    {
	cerr << pMes << "illegal network type = " << networkType << endl;
	commMpi2_exit(1);		
    }
}


//------------------------------
// õԤ
//	õԤ֤֤
//	֤ޤɤ
//------------------------------
DIR_3D searchNextSpcDDA::
getDirByDDA(DDAInfoClass *pDInfo)
{
    // δؿƥȤ뤿 member ؤΥϤˤ
    // optimizer of compiler will be delete this code
    const double CellLen	= this->mCellLength;
    const double CellHalf 	= this->mCellHalf;

    // DDA info is already initialized
    assert(pDInfo->isDDAinited() == YES);

    int travAxis = pDInfo->getTravAxis(); // ȥС    
    
    int OtherAxis1 = (travAxis + 1) % 3; // ʹԼʳ 1
    int OtherAxis2 = (travAxis + 2) % 3; // ʹԼʳ 2
    
    // ʹԼʳμˤʤफ а֤ưƤߤ
    const Vector3 relaPos(pDInfo->getRelativePos());
    const Vector3 DDAVec(pDInfo->getDDAVec());
    
    // аַ׻
    double t1 = relaPos.get(OtherAxis1) + DDAVec.get(OtherAxis1); 
    double t2 = relaPos.get(OtherAxis2) + DDAVec.get(OtherAxis2); 
    
    // ưа֤
    const double absT1 = fabs(t1);
    const double absT2 = fabs(t2);
    
    if((absT1 <= CellHalf) && (absT2 <= CellHalf)) // ɤˤʤޤʤ
    {
	pDInfo->changeRelativePos(t1, OtherAxis1, t2, OtherAxis2);
	DIR_3D dir = getDirection(pDInfo, travAxis);
	pDInfo->setGoingDir(dir);
	return(dir);		//----- ʹԼ;
    }
    
    // ʹʳΥ٥ȥ
    const double axis1_sign = dSignD((pDInfo->getDDAVec()).get(OtherAxis1));
    const double axis2_sign = dSignD((pDInfo->getDDAVec()).get(OtherAxis2));
    
    if((absT1 > CellHalf) && (absT2 <= CellHalf)) // 1˿ʤ
    {
	double rpos = relaPos.get(OtherAxis1) - axis1_sign * CellLen;
	pDInfo->changeRelativePos(rpos,                    OtherAxis1, 
				relaPos.get(OtherAxis2), OtherAxis2);
	DIR_3D dir = getDirection(pDInfo, OtherAxis1);	
	pDInfo->setGoingDir(dir);
	return(dir);		//----- 1;
    }

    if((absT1 <= CellHalf) && (absT2 > CellHalf)) // 2˿ʤ
    {
	double rpos = relaPos.get(OtherAxis2) - axis2_sign * CellLen;
	pDInfo->changeRelativePos(relaPos.get(OtherAxis1), OtherAxis1,
				rpos,                    OtherAxis2);
	DIR_3D dir = getDirection(pDInfo, OtherAxis2);
	pDInfo->setGoingDir(dir);
	return(dir);		//----- 2;
    }
    
    //--------------------------------------------------
    // ʳ(1,21,2ɤ餫ؿʤ) 
    //--------------------------------------------------
    const double param_s1
        = (axis2_sign * (pDInfo->getDDAVec()).get(OtherAxis2))
            * (CellHalf - (axis1_sign * relaPos.get(OtherAxis1)));
    const double param_s2
        = (axis1_sign * (pDInfo->getDDAVec()).get(OtherAxis1))
            * (CellHalf - (axis2_sign * relaPos.get(OtherAxis2)));
    
    if(param_s1 < param_s2)
    {
        double rpos = relaPos.get(OtherAxis1) - axis1_sign * CellLen;
        pDInfo->changeRelativePos(rpos,                    OtherAxis1,
                                relaPos.get(OtherAxis2), OtherAxis2);
	DIR_3D dir = getDirection(pDInfo, OtherAxis1);
	pDInfo->setGoingDir(dir);
	return(dir);		//----- 1;
    }else
    {
        double rpos = relaPos.get(OtherAxis2) - axis2_sign * CellLen;
        pDInfo->changeRelativePos(relaPos.get(OtherAxis1), OtherAxis1,
				 rpos,                    OtherAxis2);
	DIR_3D dir = getDirection(pDInfo, OtherAxis2);
	pDInfo->setGoingDir(dir);
	return(dir);		//----- 2;
    }
}

//--------------------------------------------------------------
// ʹԼDDAVectorpDInfo˥å(sub. of initializeDDA)
//--------------------------------------------------------------
void searchNextSpcDDA::
setTraverseAxisNVector(DDAInfoClass* pDInfo, const Vector3& rayDir)
{
    // access to member variable at here only
    const double cellLen = this->mCellLength;

    double dAbsmax;		/* ٥ȥ礭(x) */
    double dy, dz;		/* ٥ȥ礭          */
    int SinkouJiku;		// ȥС
    
    // ٥ȥͺǤ
    dAbsmax = fabs(rayDir.get(Vector3::X));
    dy      = fabs(rayDir.get(Vector3::Y));
    dz      = fabs(rayDir.get(Vector3::Z));
    SinkouJiku = Vector3::X;

    if(dAbsmax < dy){
	dAbsmax = dy;
	SinkouJiku = Vector3::Y;
    }
    if(dAbsmax < dz){
	dAbsmax = dz;
	SinkouJiku = Vector3::Z;
    }
    pDInfo->setTravAxis(SinkouJiku); // ʹԼ򥻥åȤ

    //----- DDAѤΥ٥ȥ򥻥åȤ
    pDInfo->setDDAVec(rayDir * (cellLen / dAbsmax));
}


//------------------------------
// ֤ذưǤ뤫ƥȤ롣ʤ yes 
// 	IN : pSpcPos ˸ΰ֤ƤؿƤ֡
//	IN : dir ư
// ƥȤΤѤʤ
//------------------------------
YorN searchNextSpcDDA::
testCanGo(IntVec3* pSpcPos, DIR_3D dir) const
{
    switch(dir)
    {
    case DIR_XPLUS:
	if((pSpcPos->get(IntVec3::X) + 1) > this->mSpcIdxMax[0])
	{
	    return(NO);
	}
	break;
    case DIR_XMINUS:
	if((pSpcPos->get(IntVec3::X) - 1) <  this->mSpcIdxMin[0])
	{
	    return(NO);
	}
	break;
    case DIR_YPLUS:
	if((pSpcPos->get(IntVec3::Y) + 1) > this->mSpcIdxMax[1])
	{
	    return(NO);
	}
	break;
    case DIR_YMINUS:
	if((pSpcPos->get(IntVec3::Y) - 1) <  this->mSpcIdxMin[1])
	{
	    return(NO);
	}
	break;
    case DIR_ZPLUS:
	if((pSpcPos->get(IntVec3::Z) + 1) > this->mSpcIdxMax[2])
	{
	    return(NO);
	}
	break;
    case DIR_ZMINUS:
	if((pSpcPos->get(IntVec3::Z) - 1) <  this->mSpcIdxMin[2])
	{
	    return(NO);
	}
	break;
    default:
	cerr << "Error! : at testCanGo Illegal dir." << endl;
	commMpi2_exit(1);
	break;
    }
    return(YES);
}

//------------------------------
// ֤ذư롣
// 	IN OUT: pSpcPos ˸ΰ֤ƴؿƤ֡
//	IN    : dir ư
// ֤ư
//------------------------------
void searchNextSpcDDA::
goNextSpace(IntVec3* pSpcPos, DIR_3D dir) const
{
    // forceMove Ѥ礬ΤǤ assert ̵
    // assert(this->testCanGo(pSpcPos, dir) == YES);

    int x = pSpcPos->get(IntVec3::X);
    int y = pSpcPos->get(IntVec3::Y);
    int z = pSpcPos->get(IntVec3::Z);
    switch(dir)
    {
    case DIR_XPLUS:
	x++;
	break;
    case DIR_XMINUS:
	x--;
	break;
    case DIR_YPLUS:
	y++;
	break;
    case DIR_YMINUS:
	y--;
	break;
    case DIR_ZPLUS:
	z++;
	break;
    case DIR_ZMINUS:
	z--;
	break;
    default:
	cerr << "Error! : goNextSpace() : Illegal dir." << endl;
	commMpi2_exit(1);
	break;
    }
    pSpcPos->set(x, y, z);
}

//------------------------------
// ֤õ
// 	calculate next subspace and set the subspace to ray
//	pDinfo, pSpcPos ѹ
// protected ؿskip ̵
//------------------------------
YorN searchNextSpcDDA::
moveRayToNextSubspaceNoSkip(DDAInfoClass *pDinfo, 
			    const Vector3& rayPos,
			    const Vector3& rayDir,
			    IntVec3      *pSpcPos)
{
    // 1.쥤˹Ԥζ֤
    // δؿϸߤζְ֤ DDA ξ󤫤鿷ְ֤
    if(pDinfo->isDDAinited() == NO)
    {
	this->initializeDDA(pDinfo, rayPos, rayDir, (*pSpcPos));
    }

    DIR_3D nextDir = this->getDirByDDA(pDinfo);   
	
    // 2.ζ֤⤫Ĵ٤
    YorN isNextSpaceInDefspc = this->testAndGoIfItCan(pSpcPos, nextDir);
    return(isNextSpaceInDefspc);
}


//------------------------------------------------------------
// public functions
//------------------------------------------------------------
// constructor
//------------------------------
searchNextSpcDDA::
searchNextSpcDDA(void)
{
    this->mPartVolMin.set(-1.0, -2.0, -3.0);
    this->mCellLength	= -1.0;
    int i;
    for(i = 0; i < 3; i++)
    {
	this->mSpcIdxMin[i] = -1;
	this->mSpcIdxMax[i] = -1;
    }
    this->mRayPropSkipMethod	= ELSE_rayprop;
    this->mNetworkType		= ELSE_network;

    // derived variables
    this->mCellHalf	= -1.0;
}

//------------------------------
// destructor
//------------------------------
searchNextSpcDDA::
~searchNextSpcDDA(void)
{
    // void 
}


//------------------------------
// initialize
//	partVolMin  DDA ŬѤ֤κǾ֤Ǥ롥 
//	subspace κǾ֤ǤϤʤʬ䤵뤤 subvolume 
//	ʬ䤵 partvol min Ǥ롣 
//	Ȥ[minIdx, maxIdx] ϰϤʬ֤¸ߤ
//	(äʬ֤ʬ䤷κǾ֤Хʤʤľ
//	 ʤä1998ǯ4 3() ¿ĸβָǤä
//	 3/30 Ӹ󤬷뺧餷)
//------------------------------
void searchNextSpcDDA::
initWithoutObjInSpcMap(const Vector3& partVolMin,//DDAŬѤ֤κǾ
		       double  	    cellLength,	//DDAtraverse륻礭
		       const int   *pSpcIdxMin, //cellκǾindex
		       const int   *pSpcIdxMax, //index
		       int     	   rayPropSkipMetod,//skip ˡ
		       int     	   networkType)	//ͥåȥ
{
    exitIfIllegalParam(cellLength, pSpcIdxMin, pSpcIdxMax, 
		       rayPropSkipMetod, networkType);
    this->mPartVolMin	= partVolMin; 	 
    this->mCellLength	= cellLength;
    for(int i = 0; i < 3; i++)
    {
	this->mSpcIdxMin[i] 	= pSpcIdxMin[i];
	this->mSpcIdxMax[i]	= pSpcIdxMax[i];
    }
    this->mRayPropSkipMethod = rayPropSkipMetod;
    this->mNetworkType 	 = networkType;    
    // derived variables
    this->mCellHalf = this->mCellLength / 2.0;
}

// ʪΤ¸߾
void searchNextSpcDDA::
initObjInSpcMap(array3dClass < objectExistInASpaceClass >  *pObjInSpcMap) 
{
    const char *pMes = "Error! : searchNextSpcDDA::initObjInSpcMap : ";
    if((pObjInSpcMap == NULL) || (pObjInSpcMap->getTotalSize() <= 0))
    {
	cerr << pMes << "illegal object in space map." << endl;
	commMpi2_exit(1);		
    }
    this->mObjInSpcMap	= (*pObjInSpcMap);
}

//------------------------------------------------------------
// ֤õ
// 	calculate next subspace and set the subspace to ray
//	ray  (volume Ǥʤ)  ddainfo, space pos Ϲ
// skip ̵
//------------------------------------------------------------
YorN searchNextSpcDDA::
moveRayToNextSubspaceNoSkip(Ray *pRay)
{
    DDAInfoClass ddainfo = pRay->getSpcDDAInfo();
    IntVec3      spcpos  = pRay->getSpcPos();
    YorN isSendRay = this->moveRayToNextSubspaceNoSkip(&ddainfo,
						       pRay->getPos(),
						       pRay->getDir(),
						       &spcpos);

    pRay->setSpcDDAInfo(ddainfo);
    pRay->setSpcPos(spcpos);
    return(isSendRay);
}    

//------------------------------------------------------------
// ֤õ
// 	Ѥ skip (⤦ pRay->getSpcPos() ѤϤʤɬ٤ذư
// 	ߤ)
//------------------------------------------------------------
YorN searchNextSpcDDA::
moveRayWithSobokuSkip(Ray *pRay)
{
    DDAInfoClass ddainfo = pRay->getSpcDDAInfo();
    IntVec3      spcpos  = pRay->getSpcPos();
    YorN isNextSpaceInDefspc = YES;

    if(ddainfo.isDDAinited() == NO)
    {
	this->initializeDDA(&ddainfo, pRay->getPos(), pRay->getDir(),
			    spcpos);
    }

    while(1)
    {
	// ζ֤õ
	DIR_3D nextDir = this->getDirByDDA(&ddainfo); 

	// ζ֤
	isNextSpaceInDefspc = this->testAndGoIfItCan(&spcpos, nextDir);

	if(isNextSpaceInDefspc == YES)
	{
	    int idx[3];
	    spcpos.getAsArray(idx);
	    if(this->mObjInSpcMap.get(idx).isObj() == YES)
	    {
		//  && ʪΤ¸ߤ -> skip Ǥʤ
		// isNextSpaceInDefspc == YES  loop ȴ
		pRay->setSpcDDAInfo(ddainfo);
		pRay->setSpcPos(spcpos);
		return(YES);
		break;
	    }
	    else
	    {
		// ֤ && ʪΤ¸ߤʤ ->  Skip
		// skip ϿϤǵϿ
		//  		this->incSkipSpcNum();		
		//  		this->incTravSpcNum();
	    }
	}else
	{
	    // ¸ߤʤޤ֤򳰤Ƥޤä⤦ԤϤʤ
	    // isNextSpaceInDefspc == NO Ȥʤä loop ȴ
	    break;
	}
    }
    pRay->setSpcDDAInfo(ddainfo);
    pRay->setSpcPos(spcpos);
    return(isNextSpaceInDefspc);
}


//------------------------------------------------------------
// volume ư
//	֤ܶȤȤĤİư뤿ᡢvolume ư
//      ˤ϶ˤ ray  voxel ˤʤ礬롣
//------------------------------------------------------------
// ʬ֤ Direction Decision Unit ͭȤƤ뤫
YorN searchNextSpcDDA::
isValidASpcpos(const IntVec3& spcpos)
{
    if((this->mSpcIdxMin[0]    <= spcpos.get(IntVec3::X)) && 
       (this->mSpcIdxMin[1]    <= spcpos.get(IntVec3::Y)) &&
       (this->mSpcIdxMin[2]    <= spcpos.get(IntVec3::Z)) &&
       (spcpos.get(IntVec3::X) <= this->mSpcIdxMax[0]) && 
       (spcpos.get(IntVec3::Y) <= this->mSpcIdxMax[1]) &&
       (spcpos.get(IntVec3::Z) <= this->mSpcIdxMax[2]))
    {
	return(YES);
    }
    else
    {
	return(NO);	
    }
}

//------------------------------
// forceMoveRayToNextSpace
// 	֤õɬζ֤˰ưƤޤ
//------------------------------
void searchNextSpcDDA::
forceMoveRayToNextSpace(DDAInfoClass *pDinfo, 
			const Vector3& rayPos, const Vector3& rayDir,
			IntVec3      *pSpcPos)
{
    if(pDinfo->isDDAinited() == NO)
    {
	this->initializeDDA(pDinfo, rayPos, rayDir, (*pSpcPos));
    }
    DIR_3D nextDir = this->getDirByDDA(pDinfo);   
    this->goNextSpace(pSpcPos, nextDir);
}


//------------------------------
// 3DDDAΤξν (sub. of calcDDA)
//	ray  define space ˤ뤳ȤǧƤ
//	rayDir ϥ쥤οʹ٥ȥ
//	ray λ DDA info 򹹿
//------------------------------
void searchNextSpcDDA::
initializeDDA(DDAInfoClass*  pDInfo, 
	      const Vector3& rayPos, const Vector3& rayDir,
	      const IntVec3& raySpcPos)
{
    assert(pDInfo->isDDAinited() == NO);
    assert(fabs((rayDir.getNorm()) - 1.0) < D_ERROR_RES);    
    
    // access to member variable at here only
    const double CellLen	= this->mCellLength;
    assert(this->mCellLength > 0.0);
    const Vector3& partVolMin   = this->mPartVolMin;
    
    // ʹԼηȿʹԥ٥ȥset
    this->setTraverseAxisNVector(pDInfo, rayDir); 
    int shinkouJiku = pDInfo->getTravAxis(); 
    
    int OtherAxis1 = (shinkouJiku + 1) % 3; // ʹԼʳ 1
    int OtherAxis2 = (shinkouJiku + 2) % 3; // ʹԼʳ 2
    
    // ʹԼ κǾ
    const double PartMinShinkouJiku = partVolMin.get(shinkouJiku);	
    const Vector3 center(0.5, 0.5, 0.5); // 濴˰֤뤿к
    const Vector3 spcpos = iv2v(raySpcPos);
    
    // ΣŪ濴
    const Vector3 centerOfCell = (partVolMin + CellLen * (center + spcpos));
    
    //---------------------------------------------------------------
    // а = 쥤οʹԼεդΥʿ̤Ȥθ
    //  = Define Space Min + Cell Length * spcpos
    //---------------------------------------------------------------
    double minAtCell = 0.0;
    if((rayDir.get(shinkouJiku)) > 0.0)	// ʹԥ٥ȥ
    {
	minAtCell = PartMinShinkouJiku + spcpos.get(shinkouJiku) * CellLen;
    }else
    {				// Ǥϥ礭
	minAtCell = PartMinShinkouJiku 
	    + (spcpos.get(shinkouJiku) + 1.0) * CellLen;
    }
    
    // ʹԼˤĤƤλΰ֤ʹԼΥ٥ȥ˱ä 
    // minAtCell ޤǤεΥ = param_t * ʹԼΥ٥ȥʬ
    const double param_t 
	= (minAtCell - rayPos.get(shinkouJiku)) 
	    / rayDir.get(shinkouJiku);

    //  assertion  ray tracing νˤƤʤȤ
    // Τϻ֤γˤ뤳Ȥ뤫Ǥ롣 
    //     if(param_t > 0.0)
    //     {
    // 	cout << "initializeDDA param_t " << param_t << endl;
    // 	commMpi2_exit(1);
    //     }
    //     assert(param_t < 1e-5);	// (0 ΤȤΤ)
    const double relaPos1 
	= (rayPos.get(OtherAxis1) + param_t * rayDir.get(OtherAxis1)) // rayDir
	    - centerOfCell.get(OtherAxis1);		    
    
    const double relaPos2 
	= (rayPos.get(OtherAxis2) + param_t * rayDir.get(OtherAxis2)) // rayDir
	    - centerOfCell.get(OtherAxis2);
    //  rayDir ʤΤ rayDir  ray οʹñ̥٥ȥ뤫

    //----- 3DDDAͽ(ʹԼ̵̣)
    pDInfo->changeRelativePos(relaPos1, OtherAxis1, relaPos2, OtherAxis2);

    //----- äȴŤ assertionͤϼȤϸ¤ʤ(rayTr)
    // ξˤϤ asserttion ϸǤ롣֤γˤ
    // ˤа֤ cell length  1.5 ܰˤϤޤʤ
    //----- ־45٤꤮ξˤ٤üޤǤʤΤǡ+-1.5
    //assert((relaPos1 <= (1.5 * CellLen)) && ((-1.5 * CellLen) <= relaPos1));
    //assert((relaPos2 <= (1.5 * CellLen)) && ((-1.5 * CellLen) <= relaPos2));
#ifndef NDEBUG
    if(!((relaPos1 <= (1.5 * CellLen)) && ((-1.5 * CellLen) <= relaPos1)))
    {
 	cerr << "relapos1 (" << relaPos1 << "), pm 1.5 celllen = " << 
 	    (-1.5 * CellLen) << endl;
	abort();
    }
    if(!((relaPos2 <= (1.5 * CellLen)) && ((-1.5 * CellLen) <= relaPos2)))
    {
 	cerr << "relapos2 (" << relaPos2 << "), pm 1.5 celllen = " << 
 	    (-1.5 * CellLen) << endl;
	abort();
    }
#endif

    pDInfo->setDDAset();		// ׻Ȥ򵭤
}



//------------------------------------------------------------
// for test 
//------------------------------------------------------------
#ifdef TEST_DDA_UNIT
void commMpi2_exit(int i)
{
    exit(i);
}

int main()
{
    searchNextSpcDDA nssDDA;

    int min[] = {  0,  0,  0, };
    int max[] = { 10, 10, 10, };
    nssDDA.init(Vector3(0.0, 0.0, 0.0),
		2.0,
		min, max, NoSkip_rayprop);
    
}
#endif

// Local Variables:
// mode :c++
// // compile-command: "g++ -g -Wall -DTEST_DDA_UNIT searchNextSpcDDA.cc Vector3.o ray.o IntVec3.o"
// End:

