//------------------------------------------------------------
// $Id: statistics.h,v 1.1.1.1.2.1 2000/06/14 17:46:35 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 statistics ׾
//	1996/1/13
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//	statistics ȤˤϡGET_STAT ե饰򤿤Ƥƥѥ
//	롥ưȤԲķʤΤ GET_STAT αƶʤ
//	Բķʤ
//		mNumberOfGenHC
//------------------------------------------------------------
#ifndef _statistics_h
#define _statistics_h 1

#include "mpi2_funcs.h"

// for PE statistics
class StatisticsClass {
private:
    StatisticsClass(const StatisticsClass& rhs);
    const StatisticsClass& operator=(const StatisticsClass& rhs);
    
protected:
    // HemiCube 
    int    mNumberOfGenHC;
    
#ifdef GET_STAT
    // mNumOfProcRayTraces processingRayTrace  call 줿    : PE.cc
    // mNumofRayTraceProc  processingOneRayTrace  call 줿 : PE.cc
    // 餫ʿѲܤŤ ray 狼롣
    double mNumOfProcRayTraces;
    double mOneRayTraceProcs;
    double mNumOfProcRadiosities;
    double mOneRadioProcs;
    
    // recv Buffer ƱѤ줿κ
    int    mMaxRecvBuffUsingNum;
#endif
    
public:    
    StatisticsClass(void)
    {
	this->mNumberOfGenHC		=   0;
#ifdef GET_STAT
	this->mNumOfProcRayTraces 	= 0.0;
	this->mOneRayTraceProcs		= 0.0;
	this->mNumOfProcRadiosities	= 0.0;
	this->mOneRadioProcs		= 0.0;
	this->mMaxRecvBuffUsingNum	=   0;
#endif
    }
    
    // HemiCube 
    void incHCGenNum(void) 		{ this->mNumberOfGenHC++;	}
    int  getHCGenNum(void) const 	{ return(this->mNumberOfGenHC);	}
    
    // radiosity ˤư٤̿ǤĤ ray 
    void addRadioProcsAtOnce(int radioprocs)
    {
#ifdef GET_STAT
	assert(radioprocs > 0);
	this->mNumOfProcRadiosities += 1.0;
	this->mOneRadioProcs   += double(radioprocs);
#endif
	return;
	radioprocs = radioprocs;
    }
    // ray-trace ˤư٤̿ǤĤ ray 
    void addRayTraceProcsAtOnce(int rayprocs)
    {
#ifdef GET_STAT
	assert(rayprocs > 0);
	this->mNumOfProcRayTraces += 1.0;
	this->mOneRayTraceProcs   += double(rayprocs);
#endif
	return;
	rayprocs = rayprocs;	// for -Wall
    }
    
    // recv buffer ƱѤ줿ͤεϿ
    void maxRecvBuffSize(int nowUsingBufferNum)
    {
#ifdef GET_STAT
	if(this->mMaxRecvBuffUsingNum < nowUsingBufferNum)
	{
	    this->mMaxRecvBuffUsingNum = nowUsingBufferNum;
	    //cout<<"## mMaxRecvBuffUsingNum = " << this->mMaxRecvBuffUsingNum
	    // << endl;
	}
#endif
	return;
	nowUsingBufferNum = nowUsingBufferNum;
    }
    
    void print(const char *pHead, const IntVec3& PEid) const 
    {
	const char* pMes = genHd(pHead, PEid);
	// HemiCube 
	cout << pMes << "total No. gen HC " << this->getHCGenNum() << endl;
	
#ifdef GET_STAT
	// radiosity ʿѥ쥤
	cout << pMes << "stat procradios: " << this->mNumOfProcRadiosities;
	if(this->mNumOfProcRadiosities > 0)
	{
	    cout << ",\t" << 
	    (this->mOneRadioProcs/ this->mNumOfProcRadiosities);
	    cout << " oneprocs";
	}
	cout << endl;
	
	// ray trace ʿѥ쥤
	cout << pMes << "stat procrays  : " << this->mNumOfProcRayTraces;
	if(this->mNumOfProcRayTraces > 0)
	{
	    cout << ",\t" << 
	    (this->mOneRayTraceProcs / this->mNumOfProcRayTraces);
	    cout << " oneprocs";
	}
	cout << endl;
	// ХåեλѾ
	cout << pMes << ",\tmaxRecvBuffNum "<<this->mMaxRecvBuffUsingNum<<endl;
#endif
    }
};


// for host statistics
class HostStatisticsClass {
private:
    HostStatisticsClass(const HostStatisticsClass& rhs);
    const HostStatisticsClass& operator=(const HostStatisticsClass& rhs);
protected:
    // host  PEstat ο
    double mHostGetPEStats;
    
public:
    HostStatisticsClass(void)
    {
	this->init();
    }
    void init(void)
    {
	this->mHostGetPEStats = 0.0;
    }
    void incrGetPEStatsNum(void) { this->mHostGetPEStats++;	}
    void print(void) const 
    {
	// cout << "// host :: get PEstat num " << this->mHostGetPEStats << endl;
    }
};



#ifdef THIS_IS_GLOBAL_DEFINE_FILE
class StatisticsClass Statistics;
class HostStatisticsClass HostStat;
#else
extern class StatisticsClass Statistics;
extern class HostStatisticsClass HostStat;
#endif

#endif				// #define _statistics_h 1
