//------------------------------------------------------------
// $Id: triangleObject.cc,v 1.6 2000/06/14 13:27:47 yamauchi Exp $
//------------------------------------------------------------
//	triangle object 
//	1996/3/18 
//	(C) Copyright Hitoshi Yamauchi
//	ѷΥݥꥴ
//------------------------------------------------------------
#include <stdio.h>
#include "assert.h"
#include "constants.h"
#include "vector.h"
#include "triangleObject.h"

//------------------------------------------------------------
// constructors
//------------------------------------------------------------
// for array construct
//------------------------------
triangleObjectClass::
triangleObjectClass(void)
{
    // Commented objects are already initialized by their constructor.
    // Vector3 mVertex[3];

    // Vector3  mEdge[3];       
    // Vector3  mNrm;       
    // Vector3  mEdgeNrm[3];
    // Vector3  mGpoi;      
    this->mPlaneConst	= 0.0;
    this->mEdgeConst[0]	= 0.0;
    this->mEdgeConst[1]	= 0.0;
    this->mEdgeConst[2]	= 0.0;
    this->mArea		= 0.0;

    // Vector3	mRadiosity;     
    // Vector3  mNonRad;
    // double   mEnergy
    this->mIsInRadiationQ = NO;
    static const Vector3 minus(-1.0e6, -1.0e6, -1.0e6);
    int i;
    for(i = 0; i < 3; i++)
    {
	this->mIntensity[i] = minus;
	this->mAddedIntensityNum[i] = 0;
    }
}

triangleObjectClass::
triangleObjectClass(int   objectID,  
		    int   materialID,
		    const Vector3& v1,	const Vector3& v2,
		    const Vector3& v3,  const Vector3& spcpos,
		    const Vector3& nonRadiation)
{
    // objBaseClass
    this->mObjectID	= objectID;
    this->mSpcPos	= Vec3toInt3(spcpos);
    this->mMaterialID 	= materialID;

    // this class
    this->mVertex[0] = v1;
    this->mVertex[1] = v2;
    this->mVertex[2] = v3;
    
    this->calcGeometoryInfo();

    //------------------------------
    //  饸ƥ
    //------------------------------
    static const Vector3 zero(0.0, 0.0, 0.0); 
    this->mRadiosity 	= zero;
    this->mNonRad	= zero;

    this->mIsInRadiationQ = NO; // not in queue, unlocked.

    static const Vector3 minus(-1.0e6, -1.0e6, -1.0e6);
    int i;
    for(i = 0; i < 3; i++)
    {
	this->mIntensity[i] = minus;
	this->mAddedIntensityNum[i] = 0;
    }
    
    this->addUnshotRadiosity(nonRadiation); // ˤꥨͥ륮
}

triangleObjectClass::
triangleObjectClass(const triangleObjectClass& rhs)
{
    // object class (base class)
    this->mObjectID	= rhs.mObjectID;
    this->mSpcPos	= rhs.mSpcPos;
    this->mMaterialID 	= rhs.mMaterialID;

    // this class    
    int i = 0;
    for(i = 0; i < 3; i++)
    {
	this->mVertex[i]	= rhs.mVertex[i];	    
	this->mEdge[i]		= rhs.mEdge[i];      
	this->mEdgeNrm[i]	= rhs.mEdgeNrm[i]; 
	this->mEdgeConst[i]	= rhs.mEdgeConst[i];
    }
    this->mNrm		= rhs.mNrm;        
    this->mPlaneConst   = rhs.mPlaneConst; 
    this->mArea		= rhs.mArea;       
    this->mRadiosity	= rhs.mRadiosity;
    this->mNonRad	= rhs.mNonRad;  
    this->mIsInRadiationQ = rhs.mIsInRadiationQ;
    this->mIntensity[0] = rhs.mIntensity[0];
    this->mIntensity[1] = rhs.mIntensity[1];
    this->mIntensity[2] = rhs.mIntensity[2];
    this->mAddedIntensityNum[0] = rhs.mAddedIntensityNum[0];
    this->mAddedIntensityNum[1] = rhs.mAddedIntensityNum[1];
    this->mAddedIntensityNum[2] = rhs.mAddedIntensityNum[2];
}

const triangleObjectClass triangleObjectClass::
operator=(const triangleObjectClass& rhs)
{
    if(this != &rhs)
    {
	// object class (base class)
	this->mObjectID		= rhs.mObjectID;
	this->mSpcPos		= rhs.mSpcPos;
	this->mMaterialID 	= rhs.mMaterialID;

	// this class    
	int i = 0;
	for(i = 0; i < 3; i++)
	{
	    this->mVertex[i]	= rhs.mVertex[i];	    
	    this->mEdge[i]	= rhs.mEdge[i];      
	    this->mEdgeNrm[i]	= rhs.mEdgeNrm[i]; 
	    this->mEdgeConst[i]	= rhs.mEdgeConst[i];
	    this->mIntensity[i] = rhs.mIntensity[i];
	    this->mAddedIntensityNum[i] = rhs.mAddedIntensityNum[i];
	}
	this->mNrm		= rhs.mNrm;        
	this->mPlaneConst      	= rhs.mPlaneConst; 
	this->mArea		= rhs.mArea;       
	this->mRadiosity	= rhs.mRadiosity;
	this->mNonRad		= rhs.mNonRad;  
	this->mIsInRadiationQ 	= rhs.mIsInRadiationQ;
    }
    return(*this);
}

//------------------------------------------------------------
// ˴ؤ
//------------------------------------------------------------
void triangleObjectClass::
calcGeometoryInfo(void)
{
    static const Vector3 zero(0.0, 0.0, 0.0); 
    //------------------------------
    // åΥ٥ȥ(Ƥʤ)
    //------------------------------
    this->mEdge[0] = this->mVertex[1] - this->mVertex[0];
    this->mEdge[1] = this->mVertex[2] - this->mVertex[1];
    this->mEdge[2] = this->mVertex[0] - this->mVertex[2];

    //------------------------------
    // ѥåˡ٥ȥ
    //------------------------------
    this->mNrm = this->mEdge[0].VOut_prd(this->mEdge[1]);
    this->mNrm.VNormalize();

    //------------------------------
    // å鳰򸫤٥ȥ
    //------------------------------
    this->mEdgeNrm[0] = this->mNrm.VOut_prd(this->mEdge[0]);
    this->mEdgeNrm[0].VNormalize();
    
    this->mEdgeNrm[1] = this->mNrm.VOut_prd(this->mEdge[1]);
    this->mEdgeNrm[1].VNormalize();
    
    this->mEdgeNrm[2] = this->mNrm.VOut_prd(this->mEdge[2]);
    this->mEdgeNrm[2].VNormalize();
    
    //------------------------------
    // NrmP1 = - d: plane constant
    //------------------------------
    this->mPlaneConst = this->mNrm.dInn_prd(this->mVertex[0]);

    //------------------------------
    // ѥåˡ˿ľʥåޤʿ̤ Nv1 = d_e1
    //------------------------------
    this->mEdgeConst[0] = this->mEdgeNrm[0].dInn_prd(this->mVertex[0]);
    this->mEdgeConst[1] = this->mEdgeNrm[1].dInn_prd(this->mVertex[1]);
    this->mEdgeConst[2] = this->mEdgeNrm[2].dInn_prd(this->mVertex[2]);

    //------------------------------
    // ѷ ... tripatch.Area.tex 
    // S = \frac{1}{2} ab sin(\theta) 
    //   = \frac{1}{2} \sqrt{|a|^2 |b|^2 - (a \dot b)^2} (overflow )
    //------------------------------
    double aSquare = this->mEdge[0].dInn_prd(this->mEdge[0]); // 礭
    double bSquare = this->mEdge[2].dInn_prd(this->mEdge[2]); // ɤ
    double aDotb   = this->mEdge[0].dInn_prd(zero - this->mEdge[2]);
    this->mArea = 0.5 * sqrt(aSquare * bSquare - aDotb * aDotb);
}


//------------------------------
// radiosity ̤ͤä
//------------------------------
void triangleObjectClass::
addUnshotRadiosity(const Vector3& rad)
{
    this->mNonRad = this->mNonRad + rad;
}

//------------------------------
// ̤ͤ radiosity ͤ radiosity ͤ˲ä
// ĺε٤(׻λѤ)  
//   @return Ǹޤͤʤäʬͥͥ륮֤
//------------------------------
double triangleObjectClass::
flushUnshotRadiosityNInitVerInt(void)
{
    // Ǹޤͤʤäͥ륮
    const double nonRadEnergy = this->getNonRadEnergy(); 

    // ̤ͤʬ򤳤Υѥå뤵ȤƲä
    this->mRadiosity 	= this->mRadiosity + this->mNonRad;
    this->mNonRad.set(0.0, 0.0, 0.0);

    // ĺνͤ radiosity ΤΤǲä 1 
    this->mIntensity[0] = this->mRadiosity;
    this->mIntensity[1] = this->mRadiosity;
    this->mIntensity[2] = this->mRadiosity;
    this->mAddedIntensityNum[0] = 1;
    this->mAddedIntensityNum[1]= 1;
    this->mAddedIntensityNum[2] = 1;

    return(nonRadEnergy);
}

//------------------------------
//  patch  energy 1998ǯ12 9()
//   η׻ɤޤΤʤ
//   (ޤVector3(R,G,B) * Area ɤȤƤ)
//	Graphics Gems  II  Progressive Refinement ǤϤ
//	Ƥ褦 1998ǯ1211()
//------------------------------
double triangleObjectClass::
getNonRadEnergy(void) const
{
    double ret = this->mArea * (this->mNonRad.get(Vector3::X) +
				this->mNonRad.get(Vector3::Y) +
				this->mNonRad.get(Vector3::Z)); 
    return(ret);	
}

//------------------------------
// ſ (HemiCube 濴)
//   ٷ׻褦ˤ롥1998ǯ12 3()
//------------------------------
const Vector3 triangleObjectClass::
getGCenter(void) const
{
    return((this->mVertex[0] + this->mVertex[1] + this->mVertex[2]) / 3.0);
}


//------------------------------
// ѥå̤ radioosity ֤ͤ
//	饸ƥ + ̤ͥꥢ
//	ޤ atomic (ϥ塼ФȤ atomic 
//	Ͼ̤Υ롼ݤ) 
//------------------------------
const Vector3 triangleObjectClass::
getNClearNonRadAndUpdateRadiosity(void)
{
    static Vector3 retNonRad;	// static for return reference 

    this->mRadiosity = this->mRadiosity + this->mNonRad; // 饸ƥ
    retNonRad = this->mNonRad;				 // ̤¸
    this->mNonRad.set(0.0, 0.0, 0.0);			 // ̤ͥꥢ
    return(retNonRad);					 // ¸̤ return
}


//------------------------------
// ĺε٤ʿѲ
//------------------------------
void triangleObjectClass::
calcVerIntAveVal(void)
{
    int i;
    for(i = 0; i < 3; i++)
    {
    	this->mIntensity[i] = 
		this->mIntensity[i] / this->mAddedIntensityNum[i];
    }
}

//------------------------------------------------------------
// ʪΤޤǤεΥ(if ret PlusInfty =  not hit)
//------------------------------------------------------------
double triangleObjectClass::
getDistance(const Ray *const apRay, Vector3 *pHitPos)
{
    double distance = PlusInfty; // ޤǤεΥ          
    double tpDotRay = 0.0;	 // Ѥ                  
    
    // ѷݥꥴޤʿ̤Ȥθ       
    tpDotRay = (this->getNormal()).dInn_prd(apRay->getDir());
    if(tpDotRay >= -(D_ERROR_RES))
    {				// ʤ(΢򺹤ʤ)
	return(PlusInfty);
    }

    // ѷݥꥴޤʿ̤ȤθȤεΥ
    distance = (this->getPlaneConstant() - 
		(this->getNormal()).dInn_prd(apRay->getPos())) / tpDotRay;

    if(distance <= D_ERROR_RES)
    {				// ʤ(ˤ)
	return(PlusInfty);
    }
    
    // 
    (*pHitPos) = (apRay->getPos()) + (apRay->getDir()) * distance;
    
    // åθ(ѷ?)
    for(int i = 0; i < 3; i++)
    {
	double dTes = (this->getEdgeNormal(i)).dInn_prd(*pHitPos) - 
	    this->getEdgeConstant(i);
	if(dTes < 0.0)
	{			// 褿黰ѥѥåγˤ = 
	    return(PlusInfty);
	}
    }
    // Hit
    return(distance); 
}

//------------------------------------------------------------
// 
//------------------------------------------------------------
// ostream& operator<<(ostream& s, const triangleObjectClass& rhs)
// {
//     s << "f " << rhs.mObjectID << rhs.mSpcPos << 
// 	rhs.mVertex[0] << rhs.mVertex[1] << rhs.mVertex[2] << rhs.mSpcPos;
//     return (s);
// }

//------------------------------
// porigonID ĺΰ֤äƤ鵱٤ä
//------------------------------
void triangleObjectClass::
addIntensityToVertex(const VertexIntensity& vertex)
{
    if(this->getObjectID() == vertex.getPolygonID())
    {
	for(int i = 0; i < 3; i++)
	{
	    if(this->mVertex[i] == vertex.getVertex())
	    {
		this->mIntensity[i] += vertex.getIntensity();
		this->mAddedIntensityNum[i]++;
		break;		// ĺɬ㤦ΤǰĹ礨нλ
	    }
	}
    }
}

//------------------------------
// ݥꥴǰͤ Radiosity ͤĺΰ־Ф
//	Ƶ٤ФʤΤϵ٤äλ˳Ƶ٤äƤ
//	˸ߤ礦ͤˤʤʤ
//
//	dest spcpos ʤΤäƤ
//	֤ͤ src (= ĺΤ) ְ
//------------------------------
void triangleObjectClass::
getRadVer(VertexIntensity *pRadiosityVertexInfo)
{
    static IntVec3 illegalSpcPos(-1, -2, -3);
    int i;
    for(i = 0; i < 3; i++)
    {
	assert(this->mIntensity[i].get(Vector3::X) >= 0.0);
	pRadiosityVertexInfo[i].set(this->getObjectID(), illegalSpcPos,
				    this->mRadiosity,    this->mVertex[i]);
    }
}

//------------------------------
// ĺȳƵ٤Ф
//	dest spcpos ʤΤäƤ
//	֤ͤ src (= ĺΤ) ְ
//------------------------------
void triangleObjectClass::
getVerIntensity(VertexIntensity *pIntensityVertexInfo)
{
    static IntVec3 illegalSpcPos(-1, -2, -3);
    int i;
    for(i = 0; i < 3; i++)
    {
	assert(this->mIntensity[i].get(Vector3::X) >= 0.0);
	pIntensityVertexInfo[i].
	    set(this->getObjectID(),    illegalSpcPos,
		this->mIntensity[i], this->mVertex[i]);
    }
}

//------------------------------
// print out 
//------------------------------
void triangleObjectClass::
print(const char *pHead)
{
    cout << pHead << " # material id = " << this->mMaterialID << endl;    
    cout << pHead << " f " << this->getObjectID() << " ";
    cout << this->mVertex[0] << " ";
    cout << this->mVertex[1] << " ";
    cout << this->mVertex[2] << " ";
    cout << this->mSpcPos    << endl;
}

//------------------------------
// get mpi2 format strings
//------------------------------
void triangleObjectClass::
getMpi2Form(int type, char *pRes)
{
    switch(type)
    {
    case NORMAL_ObjOut_e:
	sprintf(pRes, "f %d  %.16g %.16g %.16g  %.16g %.16g %.16g  %.16g %.16g %.16g %d %d %d",
		this->getObjectID(),
		this->mVertex[0].get(Vector3::X),
		this->mVertex[0].get(Vector3::Y),
		this->mVertex[0].get(Vector3::Z),
		this->mVertex[1].get(Vector3::X),
		this->mVertex[1].get(Vector3::Y),
		this->mVertex[1].get(Vector3::Z),
		this->mVertex[2].get(Vector3::X),
		this->mVertex[2].get(Vector3::Y),
		this->mVertex[2].get(Vector3::Z),
		this->mSpcPos.get(IntVec3::X),
		this->mSpcPos.get(IntVec3::Y),
		this->mSpcPos.get(IntVec3::Z));
	break;
	
    case WITH_SHOT_RADOUT_e:
	sprintf(pRes, "F %d  %.16g %.16g %.16g  %.16g %.16g %.16g  %.16g %.16g %.16g %d %d %d  %.16g %.16g %.16g",
		this->getObjectID(),
		this->mVertex[0].get(Vector3::X),
		this->mVertex[0].get(Vector3::Y),
		this->mVertex[0].get(Vector3::Z),
		this->mVertex[1].get(Vector3::X),
		this->mVertex[1].get(Vector3::Y),
		this->mVertex[1].get(Vector3::Z),
		this->mVertex[2].get(Vector3::X),
		this->mVertex[2].get(Vector3::Y),
		this->mVertex[2].get(Vector3::Z),
		this->mSpcPos.get(IntVec3::X),
		this->mSpcPos.get(IntVec3::Y),
		this->mSpcPos.get(IntVec3::Z),
		this->mRadiosity.get(Vector3::X),
		this->mRadiosity.get(Vector3::Y),
		this->mRadiosity.get(Vector3::Z));
	break;
	
    case WITH_UNSHOT_RADOUT_e:
	sprintf(pRes, "F %d  %.16g %.16g %.16g  %.16g %.16g %.16g  %.16g %.16g %.16g %d %d %d  %.16g %.16g %.16g",
		this->getObjectID(),
		this->mVertex[0].get(Vector3::X),
		this->mVertex[0].get(Vector3::Y),
		this->mVertex[0].get(Vector3::Z),
		this->mVertex[1].get(Vector3::X),
		this->mVertex[1].get(Vector3::Y),
		this->mVertex[1].get(Vector3::Z),
		this->mVertex[2].get(Vector3::X),
		this->mVertex[2].get(Vector3::Y),
		this->mVertex[2].get(Vector3::Z),
		this->mSpcPos.get(IntVec3::X),
		this->mSpcPos.get(IntVec3::Y),
		this->mSpcPos.get(IntVec3::Z),
		this->mNonRad.get(Vector3::X),
		this->mNonRad.get(Vector3::Y),
		this->mNonRad.get(Vector3::Z));	
	break;
    default:
	cout << "Internal Error! : triangleObjectClass::getMpi2Form : "
	"Illegal Output Type." << endl;
	exit(1);
	break;
    }
}

//------------------------------
// who am i 
//------------------------------
int triangleObjectClass::
who(void) const
{
    return(TRIANGLE_OBJ_E);
}

//------------------------------
// ֤ˤ뤫
//------------------------------
YorN triangleObjectClass::
checkSpcPos(const Vector3 &partmin, const Vector3 &subSpcSize,
	    int subdivnum) const
{
    // check spcpos num
    int i;    
    for(i = 0; i < 3; i++)
    {
	if((this->mSpcPos.get(i) < 0) || (this->mSpcPos.get(i) >= subdivnum))
	{
	    cout << "Error! :f(triangle): spcpos is out of define space." 
		<< endl;
	    return(NO);
	}
    }

    // check vertex range
    double min[3];
    double max[3];
    for(i = 0; i < 3; i++)
    {
	min[i] = partmin.get(i) + 
	    (double)(this->mSpcPos.get(i))     * subSpcSize.get(i);
	max[i] = partmin.get(i) + 
	    (double)(this->mSpcPos.get(i) + 1) * subSpcSize.get(i);
    }
    const double err_tolerance = subSpcSize.get(0) * 1e-3; // 1 % ޤǤ OK 
    int ver;
    for(ver = 0; ver < 3; ver++)
    {
	for(i = 0; i < 3; i++)
	{
	    if((this->mVertex[ver].get(i) < (min[i] - err_tolerance)) ||
	       (this->mVertex[ver].get(i) > (max[i] + err_tolerance)))
	    {
		static const char *s[] = { "x", "y", "z", };
		cout << "Error! :f(triangle): vertex[" << ver << "](" << 
		    s[i] << ") is not in legal spcpos" << endl;
		cout << "It must be in [" << min[i] << ", " << max[i] <<
		    "]. (tolerance = " << err_tolerance << ")" << endl;
		cout << "spcpos = "  << this->mSpcPos 
		     << ", partmin = " << partmin << endl;
		return(NO);
	    }
	}
    }
    return(YES);
}

//------------------------------------------------------------
// for 2 dim draw funcs
//------------------------------------------------------------
#ifdef FOR_2DIM_OUT
int triangleObjectClass::
get2dimPoiNumbers(void) const
{
    return(3);
}

void triangleObjectClass::
get2dimPoint(int idx, double *x, double *y, double *z)
{
    assert((idx >= 0) && (idx < 3));
    (*x) = this->mVertex[idx].get(Vector3::X);
    (*y) = this->mVertex[idx].get(Vector3::Y);    
    (*z) = this->mVertex[idx].get(Vector3::Z);
}

Vector3 triangleObjectClass::
getFlatRadiosityColor(const Vector3& hitPos)
{
    return(hitPos);
}

Vector3 triangleObjectClass::
getShadedRadiosityColor(const Vector3& hitPos)
{
    return(hitPos);
}
#endif

#ifdef READTEST
Vector3 triangleObjectClass::
getFlatRadiosityColor(const Vector3& hitPos)
{
    return(hitPos);
}

Vector3 triangleObjectClass::
getShadedRadiosityColor(const Vector3& hitPos)
{
    return(hitPos);
}
#endif

