//------------------------------------------------------------
// $Id: voltravinfo.h,v 1.2.2.1 2000/06/14 15:00:11 yamauchi Exp $
//------------------------------------------------------------
//	volume traverse information
//	1998/4/9
//	(C) Copyright YAMAUCHI Hitoshi 
//	volume ̲
//------------------------------------------------------------
#ifndef _voltravinfo_h
#define _voltravinfo_h 1

#include <assert.h>
#include "IntVec3.h"
#include "Vector3.h"
#include "ddaInfo.h"

class volTravInfoClass {
protected:
    DDAInfoClass  mVolDinfo;	// volume ̲Τ DDA ݻ
    int 	  mVolID;	// volume ID
    IntVec3 	  mVoxelIdx;	// ޤ̲ᤷ voxel  index
    double 	  mAccumOpacity; // ޤǤ volume Ʃ٤ѻ

public:
    volTravInfoClass(void)	{	this->invalidateInit();	}
    // ~volTravInfoClass(void);
    volTravInfoClass(const volTravInfoClass& rhs)
    {
	this->mVolDinfo		= rhs.mVolDinfo;
	this->mVolID		= rhs.mVolID;
	this->mVoxelIdx		= rhs.mVoxelIdx;	
	this->mAccumOpacity	= rhs.mAccumOpacity;
    }
    const volTravInfoClass& operator=(const volTravInfoClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mVolDinfo	= rhs.mVolDinfo;
	    this->mVolID	= rhs.mVolID;
	    this->mVoxelIdx	= rhs.mVoxelIdx;
	    this->mAccumOpacity	= rhs.mAccumOpacity;
	}
	return(*this);
    }
    //----- initialize 
    void invalidateInit(void)
    {
	this->mVolDinfo.invalidateInit();
	this->mVolID		= -1;
	this->mVoxelIdx.set(-5, -6, -7);
	this->mAccumOpacity	= 0.0;
    }

    //----- volume ID
    //    volume ID Ƥ뤳ȤȡDDA 
    //   뤳ȤؤϤ뤬ƱͤǤϤʤȤաDDA 
    //   Ƥˤ volume ID ϽƤʤƤϤʤ
    //   volume ID 뤫ȸä DDA ƤȤϸ¤
    //    
    void setVolID(int vid)
    {
	assert((0 <= vid) && (vid < 1024)); // 1024 Ϥʿ
	this->mVolID = vid;
    }
    int getVolID(void) const 	{ return(this->mVolID);	}

    //----- volume DDA
    void setVolDDA(const DDAInfoClass& volumeDDA)
    {
	this->mVolDinfo = volumeDDA;
    }
    const DDAInfoClass getVolDDA(void) const 
    {
	return(this->mVolDinfo);
    }

    //----- volume index
    void setVolIdx(const IntVec3& volidx) 
    {
	this->mVoxelIdx = volidx;
    }
    IntVec3 getVolIdx(void) const 	{ return(this->mVoxelIdx);	} 

    //----- volume accumulate opacity
    void setAccumOpacity(double accumOpacity)
    {
	assert(accumOpacity >= 0.0);
	this->mAccumOpacity += accumOpacity;
    }
    double getAccumOpacity(void) const 	{ return(this->mAccumOpacity);	}
};


#endif				// #ifndef _voltravinfo_h
