//------------------------------------------------------------
// $Id: volumeReader.cc,v 1.4 2000/05/21 15:42:18 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 volume reader 
//	read volume 
//	1998/10/1
//	Copyright (C) 1998 YAMAUCHI Hitoshi  
// 
// Ĥ sub volume (slice) ɤߡξ˽äơsub volume 
// ֤ǤϰĤΥե뤴Ȥɤ֤Τǡvolume 
// θߤϾ 1 Υ饤ƱǤ롥 3 ΰ
// ʤɤϸꤵƤΤǸ 1  volume Ǥ롥
//
// PNM եĤ volume Ȥɤ߹
// 
//   YorN readOneSubSliceVolume(const myString& subSliceVolumeFileName, 
// 			        SpaceParam&	spcParam,
// 			        YorN  		isDividedVolume, 
// 			        VolumeClass*	pSliceVolume);
//------------------------------------------------------------
#include <stdio.h>
#include <iostream.h>
#include <assert.h>
 
#include "Option.h"
#include "FileInfo.h"
#include "volume.h"
#include "myString.h"
#include "pnmReader.h"
#include "lineParser.h"
#include "volumeInfile.h"
#include "volumeFuncs.h"
#include "array3d.h"
#include "objectInfoInASpace.h"
#include "SpaceParam.h"

#ifdef GENVOL			// generate a volume and subdivide the volume
void deliverOneVolume(VolumeClass *pVol)
{
    // void func : genvol Ǥ volume Ϥʤ
    pVol = NULL;
}
#else
// #  include "volumeFuncs.h"
#endif				// #ifdef GENVOL

//------------------------------
// volume slice եΥȤΥȥ꼱̻
//------------------------------
enum VolumeSliceEntry {
    GridIdx_vse,
    GridPos_vse,
    CellIdx_vse,
    Zdir_vse,
    Partvol_vse,
    Partnum_vse,
    //     Creator_vse,  lineParse ǤϤʤΤǤ
    SizeOfVolumeSliceEntry
};

//------------------------------------------------------------
// local functions
//------------------------------------------------------------
// ʬβϤ volume ؤͤΥå
//   char **pBuf			: IN  : volume Τ comment 
//   int commentlines			: IN  : volume Τ comment Կ
//   SubGridInfoClass *pSubVolInfo	: OUT : Ф subvolume 
//   int *pZdir				: OUT : bitmap  ˡθ
//   Vector3 *pPartvolMinPos		: OUT : Υ饤 partvol κǾ
//   Vector3 *pPartvolMaxPos		: OUT : Υ饤 partvol κ
//   int     *pPartnum			: OUT : partnum 
//------------------------------
static void analyzeAndSetVolumeInfo(char **pBuf,  int commentlines,
				    SubGridInfoClass *pSubVolInfo,
				    int *pZdir,
				    Vector3 *pPartvolMinPos, 
				    Vector3 *pPartvolMaxPos,
				    int     *pPartNum
				    )
{
    // line parser :: 
    LineParser lp(SizeOfVolumeSliceEntry);
    LineParserNumberElem lpNumElem[SizeOfVolumeSliceEntry];

    // line parser :: Ǥκ
    lpNumElem[GridIdx_vse].set("gridIdx", 6);
    lpNumElem[GridPos_vse].set("gridPos", 6);
    lpNumElem[CellIdx_vse].set("cellIdx", 3);
    lpNumElem[Zdir_vse].set("zdir", 1);
    lpNumElem[Partvol_vse].set("partvol", 6);
    lpNumElem[Partnum_vse].set("partnum", 1);


    // line parser :: set entries 
    int i;
    for(i = 0; i < SizeOfVolumeSliceEntry; i++)
    {
	lp.addEntry(&(lpNumElem[i]));
    }

    // cout << "DEBUG:: analyzeAndSetVolumeInfo "; lp.print();
    
    // line parser :: eval the buffer
    for(i = 0; i < commentlines; i++)
    {
	if(strncmp(pBuf[i], "creator", 6) == 0)
	{
	    continue;		// creator ιԤФ
	}
	LineParserElemIF *pLpIF = NULL;
	if(lp.evalOneLine(pBuf[i], &pLpIF) == YES) 
	{			// YES ʤ餽ιԤϿΤ˰
	    assert(pLpIF->getType() ==  LP_NUMBER_e);
	    LineParserNumberElem *pLpNum = (LineParserNumberElem *)pLpIF;
	    if(pLpNum->getIdentifier() == "gridIdx") //  ==  operator==
	    {
		assert(pLpNum->getVectorLen() == 6);
		// int iv[pLpNum->getVectorLen()];
		int j, iv[6];	// ǤʤƤϤʤ̥ѥ餬
		for(j = 0; j < pLpNum->getVectorLen(); j++)
		{
		    iv[j] = (int)(pLpNum->getVecValue(j)); 
		}
		pSubVolInfo->setMinIdx(IntVec3(iv[0], iv[1], iv[2]));
		pSubVolInfo->setMaxIdx(IntVec3(iv[3], iv[4], iv[5]));
	    }
	    else if(pLpNum->getIdentifier() == "gridPos")
	    {
		assert(pLpNum->getVectorLen() == 6);
		int j;
		double dval[6];
		for(j = 0; j < pLpNum->getVectorLen(); j++)
		{
		    dval[j] = pLpNum->getVecValue(j); 
		}
		pSubVolInfo->setMinPos(Vector3(dval[0], dval[1], dval[2]));
		pSubVolInfo->setMaxPos(Vector3(dval[3], dval[4], dval[5]));
	    }
	    else if(pLpNum->getIdentifier() == "cellIdx")
	    {
		assert(pLpNum->getVectorLen() == 3);
		int j, iv[3];
		for(j = 0; j < pLpNum->getVectorLen(); j++)
		{
		    iv[j] = (int)(pLpNum->getVecValue(j)); 
		}
		pSubVolInfo->setSpcPos(IntVec3(iv[0], iv[1], iv[2]));
	    }
	    else if(pLpNum->getIdentifier() == "zdir")
	    {
		assert(pLpNum->getVectorLen() == 1);
		(*pZdir) = (int)(pLpNum->getVecValue(0)); 
	    }
	    else if(pLpNum->getIdentifier() == "partvol")
	    {
		assert(pLpNum->getVectorLen() == 6);
		int j;
		double dval[6];
		for(j = 0; j < pLpNum->getVectorLen(); j++)
		{
		    dval[j] = pLpNum->getVecValue(j); 
		}
		pPartvolMinPos->set(dval[0], dval[1], dval[2]);
		pPartvolMaxPos->set(dval[3], dval[4], dval[5]);
	    }
	    else if(pLpNum->getIdentifier() == "partnum")
	    {
		assert(pLpNum->getVectorLen() == 1);
		(*pPartNum) = (int)(pLpNum->getVecValue(0)); 
	    }
	    else
	    {
		cout << "Internal Error!:analyzeAndSetVolumeInfo"  << endl;  
		commMpi2_exit(1);
	    }
	}else
	{
	    cerr << "Illegal line at " << pBuf[i] << endl;
	}
    }

    if(lp.getNumberofUnparsedEntries() > 0)
    {
	cout << "Warning! :: There is unparsed entry." << endl;
	lp.printUnparsedEntries();
	commMpi2_exit(1);
    }
}    

//------------------------------
// initialize sub volume for volume creation
//	global grid info ϽƤȤ
//------------------------------
void initSubVolume(PNMReader *pnmBuf, 
		   const SubGridInfoClass& subGridInfo, int zdir,
		   VolumeClass *pVol)
{
    // global grid ϽƤϤ
    assert((pVol->getGlobalGrid()).isInited() == YES);

    //  zdir ϰȤ
    if(zdir != 2)
    {
	cout << "Warning! : now implementation assumes zdir == 2" << endl;
    }

    if(pnmBuf->getDepth() != (double)(pVol->getGridRGBDepth()))
    {
	cout << "Error! : detected inconsistency between volin file and "
	     "slice file. (volin depth, slice depth) = ("
	     << pVol->getGridRGBDepth() << " != " << pnmBuf->getDepth() 
	     << ")." << endl;
	commMpi2_exit(1);
    }

    // sub info ν
    pVol->initSubGridInfo(subGridInfo);

    // grid  fill 
    pVol->addPNM(pnmBuf);
    
    // subGridInfo effective index 롥
    // effective index  Ʒ׻subgrid ˴ޤ뤳Ȥˤ褦
    // θ塤serialize, deserialize ƥȤ롥
}


//------------------------------------------------------------
// PNM ե뤫饳ȤξȴФʬϤˤ
// SubGridInfoClass  
// 	@param  pnmBuf 	 [IN]  PNMImage
//	@param  spcParam [IN]  ɤ߹ volume Ϥ spcparam ˰פ뤫
// 	@param  pSgiinfo [OUT] comment 椫Ф줿 SubGridInfo
// 	@param  pZdir    [OUT] comment 椫Ф줿 zdir
//	@return YES ʤ
//------------------------------------------------------------
static YorN getSubGridInfoFromComments(const PNMReader &pnmBuf, 
				       const SpaceParam &spcParam,
				       SubGridInfoClass *pSginfo, 
				       int  *pZdir)
{
    const char *pErrmes = "Error! : getSubGridInfoFromComments ";

    // ȤιԿʤˤʬ䤵줿 volume ե뤫路
    if(pnmBuf.getSizeOfComments() < AT_LEAST_COMMENTS_WITHSUBDIVIDED_VOL)
    {
	cout << pErrmes << "This file has too few comments. Is this a "
	    "Subdivided volume file?" << endl;
	return(NO);
    }

    // PNMREADER_MAX_COMMENTS_LINES is defined in pnmReader.h.
    int i;
    char **pBuf = new char*[pnmBuf.getSizeOfComments()];
    for(i = 0; i < pnmBuf.getSizeOfComments(); i++) 
    {
	const char *line = pnmBuf.getCommentsRef(i);
	if(line[0] != '#')
	{
	    // ȤǤǤϤʤä
	    cout << pErrmes << "illegal comment element : " << line << endl;  
	    return(NO);
	}

	// ιԤϺǽ '# ' ȲꤷƤ롥ƥԡ
	// 
	// ex. "# setnum gridIdx = 0 0 0 35 35 0"
	//      ^^ ФΤ [2] 
	//  -> "setnum gridIdx = 0 0 0 35 35 0"
	pBuf[i] = strnew(&(line[2])); 
    }

    //------------------------------
    // line parser ѤƲϤ
    //------------------------------
    // 饤˵Ƥ partvol  partnum Ӥ
    Vector3 partVolMinofTheSlice, partVolMaxofTheSlice; 
    int     partNumofTheSlice;
    analyzeAndSetVolumeInfo(pBuf, pnmBuf.getSizeOfComments(), pSginfo,
			    pZdir,
			    &partVolMinofTheSlice, &partVolMaxofTheSlice, 
			    &partNumofTheSlice);
    // 
    for(i = 0; i < pnmBuf.getSizeOfComments(); i++) 
    {
	strdel(pBuf[i]);
    }
    delete [] pBuf;

    //  volume ɤǤ뤫θĤޤꤳ slice file Ϻ
    //  space param ˰פƤ뤫?  
    if((spcParam.getPartVolumeMin() == partVolMinofTheSlice) &&
       (spcParam.getPartVolumeMax() == partVolMaxofTheSlice) && 
       (spcParam.getSubDivNum()	    == partNumofTheSlice))
    {
	return(YES);
    }else
    {
	cout << pErrmes << "volume data file is not match with space "
	"parameter." << endl;
	cout << "space parameter is below." << endl;
	spcParam.print("");
	cout << "partvol of the volume file (" << partVolMinofTheSlice << 
	")-(" << partVolMaxofTheSlice << "), partnum = " <<
	partNumofTheSlice << endl;

	return(NO);
    }
}

//------------------------------------------------------------
// 1 Ĥ volume slice file (pgm format)ɤߤ volume image ˤ
// ֤֤ưĤ volume ɤࡥ(äƤδؿ̾
// Ϥʤ롥)
// 
//   @param subSliceVolumeFileName [IN]	 volume slice filename
//   @param spcParam		   [IN]	 volume θζ־
//   @param isDividedVolume	   [IN]	 YES λʬѤߤ volume ɤǤ
//   @param pSliceVolume	   [OUT]  volume image 
//   @return YES if succeed the read else NO
// 
// isDividedVolume == YES ξˤϴ subvolume ֤
// isDividedVolume == NO  ξˤϲ sub grid info ǽ 
// 		      volume ֤ʬ slice ɤिᡥ
//		      ( slice reader ƤФ)
//------------------------------------------------------------
YorN readOneSubSliceVolume(const myString& subSliceVolumeFileName, 
			   const SpaceParam &spcParam,
			   YorN  isDividedVolume, 
			   VolumeClass *pSliceVolume)
{
    static const char *pErrmes = "Error! : readOneSubSliceVolume : ";
    
    PNMReader pnmBuf;
    if(readOnePNMFile((const char*)subSliceVolumeFileName, &pnmBuf) == 0)
    {
	// pnm եɤ߹ߤ˼Ԥ
	cout << pErrmes << "fail to read the volume slice file [" << 
	    subSliceVolumeFileName << "]" << endl;
	return(NO);
    }
    
    // ˤǤ global grid info ϽѤ
    assert((pSliceVolume->getGlobalGrid()).isInited() == YES);

    // subgrid 
    SubGridInfoClass sginfo;
    int zdir;
    if(isDividedVolume == YES)
    {
	// volume ʬѤ
	if(getSubGridInfoFromComments(pnmBuf, spcParam, &sginfo, &zdir) == NO)
	{
	    cout << pErrmes << "This may an unsubdivided volume or "
	    "wrong volume. [" << subSliceVolumeFileName << "]" << endl;
	    return(NO);
	}

	// volume (pSliceVolume) ()
	initSubVolume(&pnmBuf, sginfo, zdir, pSliceVolume);
    }
    else
    {
	// volume 򤳤줫ʬ䤹롥ޤʬ䤷Ƥʤ
	if(pnmBuf.getSizeOfComments() >= AT_LEAST_COMMENTS_WITHSUBDIVIDED_VOL)
	{
	    cout << pErrmes << "This file may already subdivided." << endl;
	    return(NO);
	}

	// z  default : 2 ˸
	zdir = 2; 

	// ʬ䤷Ƥʤ slice ηǤϤ
	if(pnmBuf.getResolSizeX() != pnmBuf.getResolSizeY())
	{
	    cout << "Error! : non divided slice must be squrt "
	        "(width["      << pnmBuf.getResolSizeX() << 
		"] != height[" << pnmBuf.getResolSizeY() << "])" << endl;
	    cout << "illegal file size : [ " << subSliceVolumeFileName
	        << "]" << endl;
	    commMpi2_exit(1);
	}

	//  sginfo  Global Grid Info  pnmBuf 
	int resolmin[3], resolmax[3];
	resolmin[0] = resolmin[1] = resolmin[2] = 0;
	resolmax[0] = pnmBuf.getResolSizeX() - 1; // Max index  
	resolmax[1] = pnmBuf.getResolSizeY() - 1; // ResolSize - 1 Ȥʤ
	resolmax[2] = 0;

	sginfo.initAll((pSliceVolume->getGlobalGrid()).getMinPos(),
		       (pSliceVolume->getGlobalGrid()).getMaxPos(),
		       IntVec3(0, 0, 0), IntVec3(resolmin), IntVec3(resolmax));
	initSubVolume(&pnmBuf, sginfo, zdir, pSliceVolume);
    }
    return(YES);
}

//------------------------------------------------------------
// check volume range (define space ˤ뤫)
// ˤ volume ޤäƤΤĴ٤
// 	@param volInfileInfo     [IN] ɤ߹ volume 
// 	@param spcParam          [IN] ɤ߹־
// 	@param pVolumeInfileName [IN] (ե̾ : 顼)
//------------------------------
static void checkVolumeRange(const volumeInfileInfoClass& volInfileInfo, 
			      const SpaceParam& spcParam,
			      const char *pVolumeInfileName)
 {
     const char *mes = "Error! : checkVolumeRange ";
     GlobalGridInfoClass ggg = volInfileInfo.getGlobalGridInfo();
     YorN isOK = YES;
     for(int i = 0; i < 3; i++)	// 0..x, 1..y, 2..z
     {
	 if((ggg.getMinPos()).get(i) > (ggg.getMaxPos()).get(i))
	 {
	     cout << mes << "illegal volume position : must be min < max."
	     << endl;
	     isOK = NO;
	 }
	 if(((ggg.getMinPos()).get(i) < (spcParam.getPartVolumeMin()).get(i))||
	    ((spcParam.getPartVolumeMax()).get(i) < (ggg.getMinPos()).get(i)))
	 {
	     cout << mes << "volume minpos is out of define space." << endl;
	     isOK = NO;
	 }
	 if(((ggg.getMaxPos()).get(i) < (spcParam.getPartVolumeMin()).get(i))||
	    ((spcParam.getPartVolumeMax()).get(i) < (ggg.getMaxPos()).get(i)))
	 {
	     cout << mes << "volume maxpos is out of define space." << endl;
	     isOK = NO;
	 }
     }
     if(isOK == NO)
     {
	 cout << "Error! : ----- space param -----" << endl;
	 spcParam.print("");
	 cout << "Error! : ----- volume grobal grid -----" << endl;
	 ggg.print();
	 cout << "Error! : in file [" << pVolumeInfileName << "], "
	 "illegal volume range with space parameter." << endl;
	 commMpi2_exit(1);
     }
 }

 //------------------------------------------------------------
 // volume data ɤ߹ߤ sub volume ɤࡥ
 //	volumeInfileListFile ... volumeInfile ΥꥹȤ񤤤Ƥ
 //	Ǥ volumeInfileListFile ɤߡvolumeInfile Ȥ 
 //	volume ɤ 
 //------------------------------
 // Ĥ volumeInfile  volume data ɤ߹ߡɤऴȤˤ
 // ꤵ줿᥽åɤϤ
 // 
 // @param pVolumeInfilenName 	[IN] Ĥ volume ϰϤκ硤Ǿ
 // 				     ٤ʤɤ񤤤ե̾  
 // @param spcParam 		[IN] ־ : volume ɤ߹ߤκݤθ
 // @param volumeID		[IN] ɤ߹Ǥ volume  ID
 // @param pObjNum3dArray	[IN] ɤ߹ volume ¸ߤʬ֤ɽ
 // @return ɤ߹ߤ YES 
 //------------------------------
 static YorN readOneVolume(const char *pVolumeInfileName, 
			   const SpaceParam& spcParam,
			   int volumeID,
			   array3dClass < objectNumInASpaceClass >
			   *pObjNum3dArray)
 {
     volumeInfileInfoClass volInfileInfo(volumeID);

     // readVolumeInfile ref. volumeInfile.h, readVolumeInfile.cc
     if(readVolumeInfile(pVolumeInfileName, &(volInfileInfo)) == NO)
     {
	 cout << "Error! : read fail [" << pVolumeInfileName << "]" << endl;
	 return(NO);
     }
     if(Option::getInstance()->getVerboseMode() == YES)
     {    
	 volInfileInfo.print(VERBOSEHEAD);
     }

     // ˤ volume ޤäƤΤĴ٤
     checkVolumeRange(volInfileInfo, spcParam, pVolumeInfileName);


     if((Option::getInstance()->getDebugMode()   == NO) && 
	(Option::getInstance()->getVerboseMode() == YES))
     {
	 // եɤ߹߾ɽ
	 cout << VERBOSEHEAD << "reading volume sequence: ";
     }

     for(int i = volInfileInfo.getSeqStart(); i <= volInfileInfo.getSeqEnd();
	 i    += volInfileInfo.getSeqInc())
     {
	 VolumeClass v;
	 const YorN  isDividedVolume = YES;
	 // global info ν
	 v.initGlobalGridInfo(volInfileInfo.getGlobalGridInfo());
	 // local info  grid ƽ
	 if(readOneSubSliceVolume(volInfileInfo.getFileName(i), 
				  spcParam, isDividedVolume, &v)
	    == YES)
	 {
	     // volume ɤ߹ߤʬۤ
	     deliverOneVolume(&v);
	     // ʪ¸ɽ򹹿롥ϿΤ volume οǤϤ
	     // 饤 
	     IntVec3 spos = (v.getSubGrid()).getSpcPos();
	     objectNumInASpaceClass onias = pObjNum3dArray->get(spos);
	     onias.mVolNum++;
	     pObjNum3dArray->set(spos, onias);
	 }else
	 {
	     cout << "Error!: fail to read volume [" << 
		 volInfileInfo.getFileName(i) << "]" << endl;
	     return(NO);
	 }

	 if(Option::getInstance()->getDebugMode() == YES)
	 {
	     cout << DEBUGHEAD << " [" << i << "] " << 
		 volInfileInfo.getFileName(i) << endl;
	 }
	 else if(Option::getInstance()->getVerboseMode() == YES)
	 {
	     cout << "[" << i << "]" << flush; // եɤ߹߾ɽ
	 }
     }
     if((Option::getInstance()->getDebugMode()   == NO) && 
	(Option::getInstance()->getVerboseMode() == YES))
     {
	 cout << endl; // եɤ߹߾ɽ
     }
     return(YES);
 }

 //------------------------------
 // @param  pVolInfileLists : volume infile (Ĥ volume ˤĤƤε
 // 	   		     ) ΥꥹȤ񤤤Ƥե
 // @param  spcParam	   : space parameter ־
 // @param  pObjNum3dArray  :  volume ɤΤ褦¸ߤ뤫ɽ
 // @return ɤ߹ volume 
 //------------------------------
 int readAllVolumeData(const char *const pVolInfileLists,
		      const SpaceParam& spcParam,
		      array3dClass < objectNumInASpaceClass > *pObjNum3dArray)
{
    int numOfVolume = 0;	// ɤ߹ volume  (volume ID)
    if(pVolInfileLists == NULL)
    {
	return(numOfVolume); // volume file λϤʤ
    }

    FILE *pfp = fopen(pVolInfileLists, "r");
    if(pfp == NULL)
    {
	cout << "Error! : can not open infile list file [" << 
	    pVolInfileLists << "]" << endl;
	commMpi2_exit(1);
    }

    //  file ɤǤ
    const int MAX_LINE = 1024;
    char  buf[MAX_LINE];
    int   line = 0;
    while(fgets(buf, MAX_LINE, pfp) != NULL)
    {
	line++;
	if((buf[0] == '#') || (buf[0] == '\n'))	// comment, Ͻ
	{
	    continue;
	}
	for(int i = 0; buf[i] != '\0'; i++) // chop
	{
	    if(buf[i] == '\n')
	    {
		buf[i] = '\0';
	    }
	}
	
	// volume ɤ
	if(readOneVolume(buf, spcParam, numOfVolume, pObjNum3dArray) == YES)
	{
	    numOfVolume++;
	}else
	{
	    cout << FileInfo::getInstance()->getVolumeInFileListName()
		<< ":" << line << ": illegal line." << endl;
	    cout << FileInfo::getInstance()->getVolumeInFileListName()
		<< ":" << line << " " << buf << endl;
	    commMpi2_exit(1);
	}
    }
    fclose(pfp);
    return(numOfVolume);
}

//------------------------------------------------------------
// Test 1:  read subvolume ʬ volume ɤ߹ߥƥ
//------------------------------------------------------------
#ifdef TEST_READ_A_SUB_VOLUME
int main(int argc, char *argv[])
{
    if(argc != 2)
    {
	cerr << "usage : svr slicevolumefile" << endl;
	commMpi2_exit(1);
    }
    
    int volumeID = 1;
    IntVec3 globalGridResSize(100, 100, 100);
    Vector3 globalGridMinPos(  0.0,   0.0,   0.0);
    Vector3 globalGridMaxPos(100.0, 100.0, 100.0);
    double  voxelEdgeLen = 2.0;
    GlobalGridInfoClass gginfo;
    gginfo.initAll(volumeID, globalGridResSize, 
		   globalGridMinPos, globalGridMaxPos, voxelEdgeLen);

    VolumeClass v;
    v.initGlobalGridInfo(gginfo);

    if(readOneSubVolume(myString(argv[1]), &v) != YES)
    {
	cout << "Error! : fail to read volume data [" << argv[1] <<
	    "]" << endl;
    }else
    {
	cout << "OK!" << endl;
    }
    cout << "DEBUG at main --------------------" << endl;
    v.print();

    cout << "DEBUG : serialize" << endl;
    int bufsize = v.getSerializedSize();
    double *pSendbuf = v.newSerializedArray();
    
    VolumeClass recvVol;
    recvVol.deserialize(pSendbuf);
    for(int i = 0; i < bufsize; i++)
    {
	pSendbuf[i] = -1.0;
    }
    delete [] pSendbuf;
    cout << "DEBUG : deserialize" << endl;
    recvVol.print();
}
#endif				// #ifdef TEST_READ_A_SUB_VOLUME
// g++ -Wall -g -DTEST_READ_A_SUB_VOLUME -I../mpi2dataReader pnmReader.cc LineParser.cc volumeReader.cc myString.cc volume.cc getvals.cc Vector3.cc IntVec3.cc -o svr 

// imake -DUseInstalled -I/usr/X11R6/lib/X11/config -f Imakefile.volreadtest


//------------------------------------------------------------
// Test 2:  volume ɤ
//------------------------------------------------------------
// test read volume infile file and construct a volume
// 	1998ǯ1030()
// 	ΥȰǯ᤯ƮƤ롥褬ʤʤ
//------------------------------------------------------------
#ifdef TEST_READ_VOLUME
#include "Option.h"
optionClass Option; 
void commMpi2_exit(int i)
{
    exit(i);
}

const char* genHd(const char *pHead, const int rank)
{
    static char buf[256];    
    sprintf(buf, "%s rank %d : ", pHead, rank);
    return(buf);    
}

int main(int argc, char *argv[])
{
    Option::getInstance()->setDebugMode();

    if(argc != 3)
    {
	cerr << "Usage : " << argv[0] << " volumeInfileFile " << 
	    "space_param_file" << endl;
	return(1);
    }

    // read space parameter
    SpaceParam spcParam;
    if(readSpcparamFile(argv[2], &spcParam) == NO)
    {
	cout << "Error! : Can't read space param file ["
	    << argv[2] << "]" << endl;
	commMpi2_exit(1);
    }
    cout << "// test ----- read space param succeeded" << endl;
    spcParam.print("//", IntVec3(0, 0, 0));

    // read one volume
    int volumeID = 68000;
    if(readOneVolume(argv[1], volumeID) == NO)
    {
	cerr << "Error! : fail to read a volume accrding to the infile [" 
	    << argv[1] << "]" << endl;
 	commMpi2_exit(1);
    }
}

#endif				// #ifdef TEST_READ_VOLUME

