//------------------------------------------------------------
// $Id: volumeSet.cc,v 1.1.1.1 1999/11/25 06:26:10 yamauchi Exp $
//------------------------------------------------------------
// 	volume set (objectSetClass ) 
//	(M\pi)^2 
//
//	volume  PE ݻݤѤ륯饹
//	˶(Ūʶ֤ǤϤʤΥ饹δ礭
//	 indexΥ饹 PE ΥȥݥʤɤΤʤ)  
//	index ͿȤζ֤°ʪΤ
// 	϶֤®٤Υȥ졼ɥդѲͽ
//	ޤ1ˤ
//	objectSet ȻƤΤ template ͤ٤ä? 
//	1998/2/9
//	Copyright (C) 1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#include "volumeSet.h"
#include "ProcObj.h"

void VolumeSetClass::
init(const IntVec3& aLocalTotalSpcNum)
{
    const int localSpcNumX = aLocalTotalSpcNum.get(IntVec3::X);
    const int localSpcNumY = aLocalTotalSpcNum.get(IntVec3::Y);
    const int localSpcNumZ = aLocalTotalSpcNum.get(IntVec3::Z);
    if((localSpcNumX <= 0) || (localSpcNumY <= 0) || (localSpcNumZ <= 0))
    {
	cerr << "Error! : illegal number of spaces VolumeSetClass::init"
	    << aLocalTotalSpcNum << endl;
	commMpi2_exit(1);
    }
    this->delElems();
    
    this->mpVolList = new SLList < VolumeClass * > [localSpcNumX * 
						    localSpcNumY * 
						    localSpcNumZ];	    
    this->mLocalSpcNum = aLocalTotalSpcNum;
}

/**------------------------------------------------------------
 *  3 dim  index ǻꤷΥꥹȤ pVol ä
 * 	@param a3dIdx  ʬְ = spcpos
 *	@param pVol    volume ؤΥݥ
 *------------------------------------------------------------*/
void VolumeSetClass::
add(const IntVec3& a3dIdx, VolumeClass* pVol)
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->localIdxOK(innerIdx) == YES);
    int idx = this->getLocalIdxFromLocalXYZ(innerIdx.get(IntVec3::X),
				innerIdx.get(IntVec3::Y),
				innerIdx.get(IntVec3::Z));
    this->mpVolList[idx].append(pVol);
}

/**------------------------------------------------------------
 *  3 dim  index ǻꤷ volume list ֤
 * 	@param a3dIdx  ʬְ spcpos
 *------------------------------------------------------------*/
SLList < VolumeClass * > *VolumeSetClass::
getList(const IntVec3& a3dIdx)
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->localIdxOK(innerIdx) == YES);
    int idx = this->getLocalIdxFromLocalXYZ(innerIdx.get(IntVec3::X),
					    innerIdx.get(IntVec3::Y),
					    innerIdx.get(IntVec3::Z));
    return(&(this->mpVolList[idx]));
}

/**------------------------------------------------------------
 *  ƤǤĤ List Ȥ֤
 *	for(int i = 0; i < aVolumeSet.getTotalLocalSpaceNum(); i++)
 *      {      aVolumeSet.getList(i);	}
 *  Τ褦ˤƤζ֤ΥꥹȤĴ٤
 *
 * 	@param idx  ɽ index
 *------------------------------------------------------------*/
void VolumeSetClass::
getAllElementAsList(SLList < VolumeClass * > * pRetList)
{
    for(int i = 0; i < this->getTotalLocalSpaceNum(); i++)
    {
	SLList < VolumeClass * > *pPtrcpy = this->getListAs1DimArray(i);
	for(Pix p = pPtrcpy->first(); p != NULL; pPtrcpy->next(p))
	{
	    pRetList->append((*pPtrcpy)(p));
	}
    } 
}


/**------------------------------------------------------------
 *  ɽ 1  index ǻꤷ volume list ֤
 *  Ϥ volumeSet ФΤ򸫤ͭ
 *  ȤС
 *	for(int i = 0; i < aVolumeSet.getTotalLocalSpaceNum(); i++)
 *      {      aVolumeSet.getList(i);	}
 *  Τ褦ˤƤζ֤ΥꥹȤĴ٤
 *
 * 	@param idx  ɽ index
 *------------------------------------------------------------*/
SLList < VolumeClass * > *VolumeSetClass::
getListAs1DimArray(int idx)
{
    assert((0 <= idx) && (idx < this->getTotalLocalSpaceNum()));
    return(&(this->mpVolList[idx]));
}


/**------------------------------------------------------------
 *  ݻֿ : ݻƤʬ֤ο
 *	 allocation ˡˤäƤô֤礭礬
 *------------------------------------------------------------*/
int VolumeSetClass::
getTotalLocalSpaceNum(void) const
{
    int axis[3];
    this->mLocalSpcNum.getAsArray(axis);

    return(axis[0] * axis[1] * axis[2]);
}


void VolumeSetClass::
print(void)
{
    for(int z = 0; z < this->mLocalSpcNum.get(IntVec3::Z); z++)
    {
	for(int y = 0; y < this->mLocalSpcNum.get(IntVec3::Y); y++)
	{
	    for(int x = 0; x < this->mLocalSpcNum.get(IntVec3::X); x++)
	    {
		int idx = getLocalIdxFromLocalXYZ(x, y, z);
		if(!(this->mpVolList[idx].empty()))
		{
		    cout << "DEBUG: spcpos " << 
			(this->mpVolList[idx].front())->getSubVolumeSpcPos()
			    << ", id = ";
		    Pix pix;
		    SLList < VolumeClass * > &vlist = this->mpVolList[idx];
		    for(pix = vlist.first(); pix != NULL; vlist.next(pix))
		    {
			cout << vlist(pix)->getID() << " ";
			vlist(pix)->print();
			// vlist(pix)->outVolumeAsPPM(); ǧ
		    }
		    cout << "." << endl;
		}
	    }
	}
    }
}
