//------------------------------------------------------------
// $Id: ElapsedTimer.h,v 1.1.1.1 1999/11/25 06:26:11 yamauchi Exp $
//------------------------------------------------------------
//	ַ¬ѤΥ饹
//	using gettimeofday() 1999ǯ4 5()
//	
//	 getrusage ȤäƤ׻ˤϸʤȤ
//	Τϡ process ̿Ԥߤ sleep äƤޤ
//	̿ overhead ¬ǤʤʤäƤޤǤ롥
//	׻ξˤɤ¬Ȥϸʤ 
//	
//	Copyright (C) 1999 YAMAUCHI Hitoshi  
//------------------------------------------------------------
/**
 * ˡ
 *	ElapsedTimerClass et;
 *      et.start();
 *      do_something();	// פꤿؿϤ
 *	et.stop();
 *	cout << "Elapsed time = " << et.getTotalTime() << " sec" << endl;
 * Ƿв֤狼롥
 */

#ifndef _ElapsedTimer_h
#define _ElapsedTimer_h 1

#include <assert.h>
#include <iostream.h>
#include <sys/time.h>

const int ElapsedTimerClass_NOT_A_TIME     = -1;

class ElapsedTimerClass {
protected:
    struct timeval mStartTimeVal; // ϻ
    struct timeval mStopTimeVal;  // stop 
    
public:
    ElapsedTimerClass(void)
    {
	struct timeval notatime_tv;	
	notatime_tv.tv_sec  = ElapsedTimerClass_NOT_A_TIME;
	notatime_tv.tv_usec = ElapsedTimerClass_NOT_A_TIME;

	this->mStartTimeVal = notatime_tv;
	this->mStopTimeVal  = notatime_tv;
    }
    ElapsedTimerClass(const ElapsedTimerClass& rhs)
    {
	this->mStartTimeVal = rhs.mStartTimeVal;
	this->mStopTimeVal  = rhs.mStopTimeVal;
    }
    const ElapsedTimerClass& operator=(const ElapsedTimerClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mStartTimeVal = rhs.mStartTimeVal;
	    this->mStopTimeVal  = rhs.mStopTimeVal;
	}
	return(*this);
    }

    // ϻ說ꥢ
    void reset(void)
    {
	this->mStartTimeVal.tv_sec  = ElapsedTimerClass_NOT_A_TIME;
	this->mStartTimeVal.tv_usec = ElapsedTimerClass_NOT_A_TIME;
    }

    // ¬곫
    void start(void)
    {
	gettimeofday(&(this->mStartTimeVal), NULL);
    }

    // ¬꽪λ : stop ϲ٤Ǥ call Ǥ롥 start 
    // λ֤ getTotalTime ǼФ
    void stop(void)
    {
	gettimeofday(&(this->mStopTimeVal), NULL);	
    }

    // פ֤
    double getTotalTime(void) const
    {
	// start  stop ϴ˸ƤФƤ
	assert((this->mStartTimeVal.tv_sec  != ElapsedTimerClass_NOT_A_TIME)&& 
	       (this->mStartTimeVal.tv_usec != ElapsedTimerClass_NOT_A_TIME));
	assert((this->mStopTimeVal.tv_sec   != ElapsedTimerClass_NOT_A_TIME)&& 
	       (this->mStopTimeVal.tv_usec  != ElapsedTimerClass_NOT_A_TIME));

	const double MICRO_SEC_FACT = 1000000.0;	

	// s ... second, us ... micro second
	long int s  = this->mStopTimeVal.tv_sec  - this->mStartTimeVal.tv_sec;
	long int us = this->mStopTimeVal.tv_usec - this->mStartTimeVal.tv_usec;

	double ret = ((double)(s)) + ((double)(us)) / MICRO_SEC_FACT;	
	return(ret);
    }

    // äΤߤ long int ֤
    long int getSecondTime(void) const 
    {
	assert((this->mStartTimeVal.tv_sec  != ElapsedTimerClass_NOT_A_TIME)&& 
	       (this->mStartTimeVal.tv_usec != ElapsedTimerClass_NOT_A_TIME));
	assert((this->mStopTimeVal.tv_sec   != ElapsedTimerClass_NOT_A_TIME)&& 
	       (this->mStopTimeVal.tv_usec  != ElapsedTimerClass_NOT_A_TIME));
	
	// s ... second, us ... micro second
	long int s  = this->mStopTimeVal.tv_sec  - this->mStartTimeVal.tv_sec;
	return(s);
    }

    // λ֤֤
    static double getNowRawTime(void) 
    {
	const double MICRO_SEC_FACT = 1000000.0;	
	struct timeval tp;
	gettimeofday(&tp, NULL);
	double ret = ((double)(tp.tv_sec)) + 
		     ((double)(tp.tv_usec)) / MICRO_SEC_FACT;
	return(ret);	
    }
    static long int getNowRawTimeAsSecond(void) 
    {
	struct timeval tp;
	gettimeofday(&tp, NULL);
	return(tp.tv_sec);	
    }
};

#endif				// #ifndef _ElapsedTimer_h
