//------------------------------------------------------------
// $Id: RecvBuffer.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// RecvBuffer
//    ĤΰĤμХåե manage 롥
//    SendBuffer ФˤʤäƤ롥
//
//    ѥХåեƤꡤ쥤ǽʾ˼ޥɤ
//    ȯԤХåեå롥塼 Obj 򥳥ԡ
//    μ롥
//   
//	Copyright (C) 1999 YAMAUCHI Hitoshi  
//
//   FIXME use testsrc/RecvRaysBuffer.cc for test 
//------------------------------------------------------------
#ifndef _RecvBuffer_h
#define _RecvBuffer_h 1

#include <assert.h>
#include <stdio.h>
#include "mpi2.h"
#include "req_handle_t.h"
#include "mySLQueue.h"
#include "mpi2communication.h"
#include "Statistics.h"
#include "ProfileMon.h"

//------------------------------------------------------------
// RecvBuffer : ĤμѥХåե
//------------------------------------------------------------
template < class T >
class RecvBuffer {
private:
    RecvBuffer(const RecvBuffer < T > & rhs);
    const RecvBuffer < T > & operator=(const RecvBuffer < T > & rhs);

protected:
    int  mBufSize;		// ѥХåեΥ
    T   *mpBuff;		// Obj μХåե
    YorN mIsLock;		// Хåե lock 椫ɤ
    int  mRecvNum;		//  ray ο
    reqHandle_st mReqHandle;	// ꥯȥϥɥ
    mySLQueue < T * > *mpObjQueue; //  Obj  queue ؤλ
    int  mSrcRank;		   // Ǹ˼Υ

public:				
    // ׾
    CommunBufStatistics mCBStat;

protected:
    void freebuf(void)
    {
	if(this->mpBuff != NULL)
	{
	    delete [] this->mpBuff;
	}
	this->mpBuff  	= NULL;
    }

public:
    RecvBuffer(void)
    {
	this->mBufSize	= -1;
	this->mpBuff	= NULL;
	this->mIsLock	= NO;
	this->mRecvNum	= -1;
	// this->mReqHandle;
	this->mSrcRank	= -1;
    }
    ~RecvBuffer(void)
    {
	this->freebuf();
    }

    //------------------------------
    // initialize : Ƥ٤
    //  @param bufferLength : ХåեĹ
    //  @param pObjQueueRef :  Objs ؤΥݥ󥿤륭塼
    //	    	ؤλȡ塼μΤϤΥ塼ΤФ
    //		˾̤˳ݤΤ̾  
    //------------------------------    
    void init(int bufferLength, mySLQueue < T * > *pObjQueueRef)
    {
	// delete buff
	if(this->mpBuff != NULL)
	{
	    this->freebuf();
	}
	
	// check arg
	if(bufferLength < 1)
	{
	    cout << "Error! : bufferLength::RecvBuffer::init must be > 0"
	    << endl;
	    exit(1);
	}
	
	if(pObjQueueRef == NULL)
	{
	    cout << "Error! : pObjQueueRef::RecvBuffer::init must be != NULL"
	    << endl;
	    exit(1);
	}
	
	// init
	this->mBufSize	= bufferLength;
	this->mpBuff 	= new T [this->mBufSize];
	this->mIsLock 	= NO;
	this->mRecvNum	= -1;
	// this->mReqHandle;
	this->mpObjQueue 	= pObjQueueRef;

	// init statistics 
	this->mCBStat.init();
    }
    
    //------------------------------
    // 椫
    //   @return ʤ YES
    //------------------------------
    YorN isLocking(void) const { return(this->mIsLock);	}
    
    //------------------------------
    // δλߤ롥
    //   椫鴰λ˰ܹԤ YES ֤
    //------------------------------
    YorN completeRecv(void)
    {
	// ˤƤФʤ
	if(this->isLocking() == NO)
	{
	    return(NO);
	}
	
	// λ?
	if(commMpi2_isRecvComplete(this->mReqHandle) == YES)
	{
	    assert(this->mRecvNum > 0); //  obj ο
	    
	    // λХåե쥤Ф
	    int i;
	    for(i = 0; i < this->mRecvNum; i++)
	    {
		// ХåեФ obj 򿷤 new  
		// newObj (newRay, newIntensity, ... etc.)! 
		T *pNewObj = new T (this->mpBuff[i]);
		
		// PE  procRaysQueue  enqueue 
		this->mpObjQueue->enq(pNewObj); 
	    }
	    // λΥե饰򥻥åȤΥХåե̤ѤȤ롥
	    this->mIsLock = NO;
	    this->mRecvNum = -1;
	    
	    return(YES);
	}
	else
	{
	    return(NO);
	}
    }

    //------------------------------
    // ׵ȯԤǤ뤫
    //  @return ׵ȯԤ
    //------------------------------
    YorN issueRecvIfItCan(void)
    {
	if(this->isLocking() == YES)
	{
	    return(NO);
	}

	int nObjsBytes;
	
	// ɤ餫Ƥ뤫
	if(commMpi2_canRecv(&(this->mSrcRank), T::getTAG(), &nObjsBytes)
	   == YES) 
	{	
	    assert(nObjsBytes % sizeof( T ) == 0);
	    int nObjs = nObjsBytes / sizeof( T );

	    // Ƥ롥׵ȯ
	    this->mReqHandle = 
	    	commMpi2_IrecvObj(this->mSrcRank, this->mpBuff, nObjs);
	    this->mIsLock    = YES; 	// ˤʤä lock
	    this->mRecvNum   = nObjs;	// ʪοϿ
	    
	    // ХåեѤפ
	    this->mCBStat.reportNSendRecvObjs(nObjs); 

	    // Profile Monitor
	    ProfileMon::getInstance()->recv(this->mSrcRank, 
					    nObjs, T::getTAG());
	    
	    return(YES);
	}
	else
	{
	    return(NO);
	}
    }

    //------------------------------
    // ХåեĹ
    //  @return ߤμХåեĹ (Ĺǽ)
    //------------------------------
    int  getFixedBufLen(void) const	{ return(this->mBufSize);	}

    //------------------------------
    // 椫
    //  @return ʤ YES
    //------------------------------
    YorN updateRecving(void)
    {
	if(this->isLocking() == YES)
	{
	    // δλߤ롥Ǽλ lock ϳ
	    // ⤷ʤʤ⤷ʤ
	    this->completeRecv();
	}

	// ܤ lock ϼλǳ줿⤷ʤ
	if(this->isLocking() == NO)
	{
	    // åäƤʤмȯԤߤ롥ǥ
	    // 뤫⤷ʤʤ⤷ʤ
	    this->issueRecvIfItCan();
	}

	// ɡ 2 ĤФƺǽŪ˥ХåեåƤм
	// Ǥ롥
	return(this->isLocking()); 
    }

    //------------------------------
    // Ǹ˼ src rank
    //------------------------------
    int getLastSrcRank(void) const 
    {
	return(this->mSrcRank);
    }

public:
    //------------------------------
    // ʰ״ؿ : ƥȤԤȯԤߤ
    //------------------------------
    void recv(void)
    {
	// λƥ
	this->completeRecv(); 
	// μȯԤǤ뤫
	this->issueRecvIfItCan();
    }

    // Τ뤫뤤ϼ椫
    YorN isRecvObj(void)
    {
	if(this->isLocking() == YES)
	{
	    return(YES);
	}
	if(this->mpObjQueue->length() > 0)
	{
	    return(YES);
	}
	return(NO);
    }
};

#endif				// _RecvBuffer_h
