//------------------------------------------------------------
// $Id: Statistics.h,v 1.1.1.1.2.1 2000/06/14 17:46:35 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 Statistics ׾
//	1999ǯ625() 
//	Copyright (C) 1996--1999 YAMAUCHI Hitoshi  
// 
//	statistics ȤˤϡUSE_STAT ե饰򤿤Ƥƥѥ
//	Ԥ
// 	(original statistics.h)
//------------------------------------------------------------
#ifndef _Statistics_h
#define _Statistics_h 1

#include "mpi2_funcs.h"

//------------------------------------------------------------
// ̿Ȥϰۤʤ statistics
//------------------------------------------------------------
class GeneralStatistics {
private:
    GeneralStatistics(const GeneralStatistics& rhs);
    const GeneralStatistics& operator=(const GeneralStatistics& rhs);
    
protected:
    // HemiCube 
    int    mNumberOfGenHC;
    
public:    
    GeneralStatistics(void)
    {
	this->mNumberOfGenHC = 0;
    }
    
    // HemiCube 
    void incHCGenNum(void) 		{ this->mNumberOfGenHC++;	}
    int  getHCGenNum(void) const 	{ return(this->mNumberOfGenHC);	}

    void print(const char* pMes)
    {
	cout << pMes << "total generated number of HCs " <<
		this->mNumberOfGenHC << endl;
    }
};


//------------------------------------------------------------
// ̿ХåեѤ statistics
//------------------------------------------------------------
//	(֥Ȥ / ) ʿѰ󤢤ꤤ
//	ĤΥ֥ȤΤ狼롥
//------------------------------
class CommunBufStatistics  {
protected:
    int mMaxQueueLen; 		// ¦Υ塼Ĺ (¦Τ)
    int mNSendRecv;		//  or 
    int mNObjs;			//  or ֥

public:
    CommunBufStatistics (void)
    {
	this->init();
    }
    ~CommunBufStatistics (void){}
    CommunBufStatistics (const CommunBufStatistics & rhs)
    {
	this->mMaxQueueLen = rhs.mMaxQueueLen;
	this->mNSendRecv   = rhs.mNSendRecv;
	this->mNObjs	   = rhs.mNObjs;
    }
    const CommunBufStatistics & operator=(const CommunBufStatistics & rhs)
    {
	if(this != &rhs)
	{
	    this->mMaxQueueLen = rhs.mMaxQueueLen;
	    this->mNSendRecv   = rhs.mNSendRecv;
	    this->mNObjs       = rhs.mNObjs;
	}
	return(*this);
    }
    void init(void)
    {
	this->mMaxQueueLen = 0;
	this->mNSendRecv   = 0;
	this->mNObjs	   = 0;
    }

    // ˸ߤΥ塼ĹΥ塼ĹϿ롥
    void reportQueLen(int quelen)
    {
#ifdef USE_STAT
	if(quelen > this->mMaxQueueLen)
	{
	    this->mMaxQueueLen = quelen;
	}
#else
	return;
	quelen = quelen;	// for -Wall, never reached
#endif
    }
    // ä(Ǽ)ʪοεϿ
    void reportNSendRecvObjs(int n_objes)
    {
#ifdef USE_STAT
	this->mNSendRecv++;
	this->mNObjs += n_objes;
#else
	return;
	n_objes = n_objes;	// for -Wall, never reached
#endif
    }

    int getMaxQueueLen(void) const 	{ return(this->mMaxQueueLen);	}
    int getNSendRecv(void) const	{ return(this->mNSendRecv);	}
    int getNObjs(void) const 		{ return(this->mNObjs);		}

    double getNObjParSend(void) const 
    {
	if(this->mNSendRecv == 0)
	{
	    return(0.0);	// Ѥʤäˤ 0.0 ֤
	}else
	{
	    return(((double)this->mNObjs) / ((double)this->mNSendRecv));
	}
    }
};


//------------------------------------------------------------
// Host  statistics
//------------------------------------------------------------
class HostStatistics {
private:
    HostStatistics(const HostStatistics& rhs);
    const HostStatistics& operator=(const HostStatistics& rhs);
protected:
    // host  PEstat ο
    double mHostGetPEStats;
    
public:
    HostStatistics(void)
    {
	this->init();
    }
    void init(void)
    {
	this->mHostGetPEStats = 0.0;
    }
    void incrGetPEStatsNum(void) { this->mHostGetPEStats++;	}
    void print(void) const 
    {
	// cout << "// host :: get PEstat num " << this->mHostGetPEStats << endl;
    }
};

#endif				// #define _Statistics_h 1
