//------------------------------------------------------------
// $Id: boundtest.cc,v 1.3 2000/05/21 15:42:18 yamauchi Exp $
//------------------------------------------------------------
//	boundTest.cc
//	test ray and vector with some box range
//	1998ǯ127()
//	(C) Copyright Hitoshi YAMAUCHI
//
//	֥٥ȥ롢ray Ȥ box ϰϤȤΥƥȡǤ box  
//	x, y, z ˱äȢΤȤ 
//------------------------------------------------------------
#include <assert.h>
#include "mpi2.h"
#include "Vector3.h"
#include "constants.h"


//#define TEST_isHitBoundingBox 1
//#ifndef TEST_isHitBoundingBox

// #ifndef ONLY_VOLREN
// // stand alone 
// #  ifdef FOR_STANDALONE
// #    include "StandAloneModeObjects.h"
// #  else
// #    include "ProcObj.h"
// #  endif			// #ifdef FOR_STANDALONE
// #endif				// #ifndef ONLY_VOLREN

//------------------------------------------------------------
// Ƚ bounding box 
//	An Introduction to Ray Tracing, Roman Kuchkuda p.p. 1039--1060
// ֤ͤ Hit ̤ non-hit  DIR_ILLEGAL ֤
// 礦üäǤ֤ξʤ hit Ȥ롣
//	Ĥޤ hit ϰϤϡ[min, max)
//------------------------------
DIR_3D isHitBoundingBox(const Vector3& minBox,    
			const Vector3& maxBox, 
			const Vector3& rayOrigin,
			const Vector3& rayDir,
			Vector3 *pHitPoint)
{
    static DIR_3D hitDirection[9] = {
	DIR_XPLUS,
	DIR_XMINUS,
	DIR_YPLUS,
	DIR_YMINUS,
	DIR_ZPLUS,
	DIR_ZMINUS,
	DIR_HERE,		
	DIR_3D_NUM,
	DIR_ILLEGAL,
    };
    
    int i;
    Vector3 boxCenter	= (maxBox + minBox) / 2.0;
    Vector3 boxHalfSize	= (maxBox - minBox) / 2.0;
    Vector3 vv = rayDir;
    vv.VNormalize();		// ɬƤΤʤάǽ improve me
    double distance = PlusInfty;
    DIR_3D hitSide  = hitDirection[DIR_ILLEGAL];
    for(i = 0; i < 3; i++)
    {
	// check each faces (֤ X,Y,Z ˱ä¸ߤ뤿ᡢ
	// ʬΤ٥ȥ뤬Τ)  
	//   1e-5 ϸкͤ 0.00001 ʬ 
	//   Test 
	if(fabs(vv.get(i)) > 1e-5)
	{			   
	    assert(boxHalfSize.get(i) > 0.0); // Box 礭ʤΤ > 0.0
		
	    // Ȣ濴 Plus ̤Ȥθ򺹻
	    // 	    double tmpDist = 
	    // 		(boxHalfSize.get(i) - boxCentToVp.get(i)) / vv.get(i);
	    double tmpDist = 
		((boxCenter.get(i) + boxHalfSize.get(i)) - rayOrigin.get(i)) 
		    / vv.get(i);
	    if((0.0 < tmpDist) && (tmpDist < distance))
	    {
		static double hitPos[3];
		hitPos[i] = boxCenter.get(i) + boxHalfSize.get(i);
		// 		hitPos[(i + 1) % 3] = 
		// 		    fabs(boxCentToVp.get((i + 1) % 3) + 
		// 			 tmpDist * vv.get((i + 1) % 3));
		// 		hitPos[(i + 2) % 3] = 
		// 		    fabs(boxCentToVp.get((i + 2) % 3) + 
		// 			 tmpDist * vv.get((i + 2) % 3));
		hitPos[(i + 1) % 3] = 
		    rayOrigin.get((i + 1) % 3) + tmpDist * vv.get((i + 1) % 3);
		hitPos[(i + 2) % 3] = 
		    rayOrigin.get((i + 2) % 3) + tmpDist * vv.get((i + 2) % 3);
		Vector3 relaPos(hitPos[0], hitPos[1], hitPos[2]);
		relaPos = relaPos - boxCenter;

		// x ΥƥȤ򤷤ƤȤơy, z ϰˤ
		// Ĵ٤롣κݡ[min, max) ϰϤˤ뤫ߤ
		// ѿ˰ŪƤΤϤ狼䤹Τᡣ
		// ѥ餵󡢺Ŭߤޤ 
		// ѿ̾ͳ  
		//	bhs[YZ] = box half Size
		//      r[YZ]   = relative position [YZ] from box center
		// ʲͤѤɤǤ [min, max) 
		// (min, max) ϰϤȤʤäˤƤޤ
		// 		if((fabs(relaPos.get((i + 1) % 3)) < 
		// 		    boxHalfSize.get((i + 1) % 3))	&& 
		// 		   (fabs(relaPos.get((i + 2) % 3)) <
		// 		    boxHalfSize.get((i + 2) % 3)))
		double bhsY  = boxHalfSize.get((i + 1) % 3);
		double bhsZ  = boxHalfSize.get((i + 2) % 3);
		double rposY = relaPos.get((i + 1) % 3);
		double rposZ = relaPos.get((i + 2) % 3);
		if((((-bhsY) <= rposY) && (rposY < bhsY)) && 
		   (((-bhsZ) <= rposZ) && (rposZ < bhsZ)))
		{
		    hitSide  = hitDirection[i * 2];
		    distance = tmpDist;
		    pHitPoint->set(hitPos[0], hitPos[1], hitPos[2]);
		}
	    }	   
	    
	    // Ȣ濴 Minus 
	    // 	    tmpDist = 
	    // 		(-boxHalfSize.get(i) - boxCentToVp.get(i)) / vv.get(i);
	    tmpDist = 
		((boxCenter.get(i) - boxHalfSize.get(i)) - rayOrigin.get(i)) 
		    / vv.get(i);
	    if((tmpDist > 0) && (tmpDist < distance))
	    {
		double hitPos[3];
		hitPos[i] = boxCenter.get(i) - boxHalfSize.get(i);
		// 		hitPos[(i + 1) % 3] = 
		// 		    fabs(boxCentToVp.get((i + 1) % 3) + 
		// 			 tmpDist * vv.get((i + 1) % 3));
		// 		hitPos[(i + 2) % 3] = 
		// 		    fabs(boxCentToVp.get((i + 2) % 3) + 
		// 			 tmpDist * vv.get((i + 2) % 3));
		hitPos[(i + 1) % 3] = 
		    rayOrigin.get((i + 1) % 3) + tmpDist * vv.get((i + 1) % 3);
		hitPos[(i + 2) % 3] = 
		    rayOrigin.get((i + 2) % 3) + tmpDist * vv.get((i + 2) % 3);
		Vector3 relaPos(hitPos[0], hitPos[1], hitPos[2]);
		relaPos = relaPos - boxCenter;

		double bhsY  = boxHalfSize.get((i + 1) % 3);
		double bhsZ  = boxHalfSize.get((i + 2) % 3);
		double rposY = relaPos.get((i + 1) % 3);
		double rposZ = relaPos.get((i + 2) % 3);
		if((((-bhsY) <= rposY) && (rposY < bhsY)) && 
		   (((-bhsZ) <= rposZ) && (rposZ < bhsZ)))
		{
		    hitSide  = hitDirection[i * 2];
		    distance = tmpDist;
		    pHitPoint->set(hitPos[0], hitPos[1], hitPos[2]);
		}
	    }	   
	}
    }	
    if(distance == PlusInfty)
    {
	return(DIR_ILLEGAL);	
    }else
    {
	return(hitSide);
    }
}

//------------------------------------------------------------
// pos  [min, max) ˤ뤫 
//	Ķ򳫶֤ˤΤϢ³Ѥͤ
//	(ΤΤ min )
// 	Ѥϼˤä¸ߤΤȽϳƼȤ˹Ԥʤɤ
//------------------------------------------------------------
// changed from isViewPointInDefineSpace
YorN isPosInBox(const Vector3& pos, 
		const Vector3& minpos, const Vector3& maxpos)
{
    int i;
    for(i = 0; i < 3; i++)
    {
	if((pos.get(i) < minpos.get(i)) || (maxpos.get(i) < pos.get(i)))
	{
	    return(NO);
	}
    }
    return(YES);
}

YorN isPosInBoxWithRes(const Vector3& pos, 
		       const Vector3& minpos, const Vector3& maxpos,
		       double err)
{
    assert(err > 0.0);
    int i;
    for(i = 0; i < 3; i++)
    {
	if(((pos.get(i) + err) < minpos.get(i)) ||
	   (maxpos.get(i) < (pos.get(i) - err)))
	{
	    return(NO);
	}
    }
    return(YES);
}
