//------------------------------------------------------------
// $Id: calcRadioIC.cc,v 1.2.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	calcRadioIC.cc
//	calculation of Intensity Calcuration unit for radiosity 
//	1996/9/8, 1997/3/25
//	(C) 1995-1998 Copyright by Yamauchi Hitoshi
//
//	radiosity εٷ׻  
//------------------------------------------------------------
#include "mpi2_funcs.h"
#include "Option.h"
#include "PE.h"

//------------------------------------------------------------
// radiosity intensity η׻
//------------------------------------------------------------
void PEClass::
calcNsetIntensityRadio(Ray *pRay, const materialClass *const pMat,
		       objBaseClass * pHitPat)
{
    assert(pHitPat != NULL);
    assert(pHitPat->who() == TRIANGLE_OBJ_E);

    double   dAj      	    = pHitPat->getArea(); // ѥå
    const Vector3 Rho_j     = pMat->getDiffRef(); // ȿΨ
    // dBi*Fie*Ai(ref.Ray.h)
    const Vector3 dBiFieAi  = pRay->getColor(); 
    
    // 饸ƥ dRad = 
    // ȿΨ * 饸ƥ * եե * ͥѥå / 
    Vector3 dRad = (Rho_j * dBiFieAi) / dAj; 

    pHitPat->addUnshotRadiosity(dRad); // 饸ƥͤ

    // HemiCube::initialize ˤƴ˥ѥåʬϰƤ
    // Ͳ && FRGΥ塼ˤʤ
    if((pHitPat->getNonRadEnergy() > this->mViewData.getMinRadEnergy()) && 
       (pHitPat->isInRadiationQueue() == NO)) 
    {
        pHitPat->setInRadiationQueue(); // lock 
	this->mRadPatchQueue.append((objBaseClass *)pHitPat);//ͥ塼

	if(Option::getInstance()->getVerboseMode() == YES)
	{
	    cout << genHd(VERBOSEHEAD, this->getMyRank()) << 
		    "enqueue radiation patch : patch non rad enetgy = " << 
		    pHitPat->getNonRadEnergy() << endl;
	}
    }
}



