//------------------------------------------------------------
// $Id: calcRayTrSRGDist.cc,v 1.2 2000/05/15 14:20:43 yamauchi Exp $
//------------------------------------------------------------
//	calcRayTrSRGDist.cc
//	calculation of Secondary Ray Generation unit for 
//	distributed ray-tracing
//	1999/3/23
//	(C) 1998-1999 Copyright TOKUNAGA Mayumi   ͳ
//	(C) 1998-1999 Copyright	YAMAUCHI Hitoshi  
//------------------------------------------------------------
#include "calcRayTrSRGgetdir.h"

//----------------------------------------------------
// 2nd Ray ʣ˻餹ˡ
//	Tokunaga and YAMAUCHI
//----------------------------------------------------
YorN PEClass::
secondRayGenWithDistrbute(Ray *pRay, const materialClass *pMat, 
			  objBaseClass * pHitObj)
{
    YorN isGenerateRay = NO;	// 쥤ȯ뤫? 
    
    //  ray ȿ͡޲ۤƤ뤫
    if(pRay->getReflectedNum() >= this->mViewData.getMaxRayRefNum())
    {				// ۤƤ롣ray ȯʤ
	return(isGenerateRay);
    }
    
    //------------------------------------------------------------
    // ȿ󼡥쥤 new PE ν塼Ͽ
    //------------------------------------------------------------
    Vector3 reflectRayDir, reflectRayCoeff;
    YorN isGenReflectRay = 
	getReflectionRayDirRayTrace(pRay, pMat, 
				    this->mViewData.getMinRayRefCoeffNorm(),
				    pHitObj, 
				    &reflectRayDir,
				    &reflectRayCoeff);
    if(isGenReflectRay == YES)	// ray ȯϲǽ٤
    {
	this->mFrustum.setTopAngleRadandRotate(pMat->getFrustumHalfTopRad(), 
					       pMat->getSpecTransCosN(),
					       reflectRayDir);
	for(int i = 0; i < this->mFrustum.getTotalSampleNum(); i++)
	{
	    Vector3 nextDir = this->mFrustum.getSamplePixelPos(i);
	    nextDir.VNormalize();
	    Vector3 newCoeff = reflectRayCoeff * this->mFrustum.getWeight(i);
	    Ray *pNewRay = 
		Ray::newForReflectionRayTracing(pRay, 	  nextDir, 
						newCoeff, pHitObj);
	    Vector3 newColor = pRay->getColor() * this->mFrustum.getWeight(i);
	    pNewRay->setColor(newColor);

	    this->setRayPtrToThisPE(pNewRay);		   
	}
	isGenerateRay = YES;
	// ȿͥ쥤ΤʤФ Hint TOKUNAGA
    }
    
    //------------------------------------------------------------
    // Ʃ󼡥쥤 new PE ν塼Ͽ
    //------------------------------------------------------------
    Vector3 refractedRayDir, refractedRayCoeff;
    YorN isGenRefractedRay = 
	getRefractionRayDirRayTrace(pRay, pMat, 
				    this->mViewData.getMinRayRefCoeffNorm(),
				    pHitObj, 
				    &refractedRayDir, 
				    &refractedRayCoeff);
    
    if(isGenRefractedRay == YES)
    {
	this->mFrustum.setTopAngleRadandRotate(pMat->getFrustumHalfTopRad(), 
					       pMat->getSpecTransCosN(),
					       reflectRayDir);

	for(int i = 0; i < this->mFrustum.getTotalSampleNum(); i++)
	{
	    Vector3 nextDir = this->mFrustum.getSamplePixelPos(i);
	    nextDir.VNormalize();
	    Vector3 newRefractCoeff = 
		pRay->getRefCoeff() * this->mFrustum.getWeight(i);
	    Ray *pNewRay = 
		Ray::newForReflectionRayTracing(pRay, nextDir, 
						newRefractCoeff, pHitObj);

	    // ray ȯ˵٤ƤΤ?
	    if(isGenerateRay == NO)
	    {			// Ƥʤ٤
		Vector3 newRefractColor = 
		    pRay->getColor() * this->mFrustum.getWeight(i);
		pNewRay->setColor(newRefractColor);
	    }
	    this->setRayPtrToThisPE(pNewRay);
	}
	isGenerateRay = YES;
	// ޥ쥤ΤʤФ Hint TOKUNAGA
    }
    return(isGenerateRay);
}
