//------------------------------------------------------------
// $Id: calcRayTrSRGgetdir.h,v 1.2 2000/06/14 13:29:37 yamauchi Exp $
//------------------------------------------------------------
//	calcRayTrSRGgetDir.cc
//	calculation of secondary ray direction
//	1999/3/24
//	(C) 1998-1999 Copyright YAMAUCHI Hitoshi  
//	(C) 1998-1999 Copyright TOKUNAGA Mayumi   ͳ
//
// inline functions for get refrection/refraction direction 
//------------------------------------------------------------
#ifndef _calcRayTrSRGgetdir_h
#define _calcRayTrSRGgetdir_h 1

#include <assert.h>
#include "PE.h"

//------------------------------
// ȿͤˤ󼡥쥤ȯ
//	߿ΤѤ ray tracing ǤϤʤ
// @param pRay 		    IN 	ͥ쥤
// @param pMat 		    IN 	ȿͤʪ(= pRay ȸ򺹤ʪ) material 
// @param minRayCoefNorm    IN  ȿͻκǾͥ륮
// @param pHitObj 	    IN	pRay Ȥθʪ
// @param pReflectRayDir    OUT	ȿͥ쥤٥ȥ
// @param pReflectRayCoeff  OUT	ȿͥ쥤εٷ
//------------------------------
static inline YorN 
getReflectionRayDirRayTrace(const  Ray* const 	  pRay,
			    const  materialClass* pMat,
			    double 		  minRayCoefNorm,
			    objBaseClass *	  pHitObj,
			    Vector3      *	  pReflectRayDir,
			    Vector3 	 *	  pReflectRayCoeff)
{
    assert(pHitObj != NULL);

    // ȿ͸그׻
    (*pReflectRayCoeff) = pRay->getRefCoeff() * (pMat->getSpecRef());

    // commented by tosho : ޤǤƼϤʤ ray Ƥ
    //   ȿ͸그ʲ ray Ϥʾ¤ʤ
    if((*pReflectRayCoeff).dInn_prd(*pReflectRayCoeff) < minRayCoefNorm)
    {
	return(NO);
    }

//     cout << "DEBUG:refcoef " << (*pReflectRayCoeff)	<< ", inprd " << 
// 	(*pReflectRayCoeff).dInn_prd(*pReflectRayCoeff) << " < min " << 
// 	    minRayCoefNorm << ", raycoeff " << pRay->getRefCoeff() << 
// 		", matspec " << (pMat->mSpecRef) << endl;

    // ȿ
    // tokunaga change: 
    // sphere ξ getNormal ֤äƤ٥ȥ뤬γ
    // Τʪ˥쥤ϡҤȤޤˡոˤ롣  
    Vector3 normal;
    switch(pHitObj->who())
    {
    case TRIANGLE_OBJ_E:
	normal = pHitObj->getNormal(pRay->getHitPos());
	break;

    case SPHERE_OBJ_E:
	if(pRay->isInside() == YES)
	{
	    normal = (-1.0) * pHitObj->getNormal(pRay->getHitPos()); 
	}else
	{
	    normal = pHitObj->getNormal(pRay->getHitPos());	    
	}
	break;
	
    case NULL_OBJ_E:
    default:
	cout << "Internal Error! : illegal object : "
	    "getReflectionRayDirRayTrace" << endl;
	break;
    }

    assert((normal.getNorm() - 1.0) < D_ERROR_RES);//ˡƤϤ
    (*pReflectRayDir) = 
	(-2.0 * ((pRay->getDir()).dInn_prd(normal)) * normal) + pRay->getDir();
    
    return(YES);
}

//------------------------------
// ޤˤ 2  ray-tracing ray ȯ
//
// @param pRay 		    IN 	ͥ쥤
// @param pMat 		    IN 	ȿͤʪ(= pRay ȸ򺹤ʪ) material 
// @param minRayCoefNorm    IN  ȿͻκǾͥ륮
// @param pHitObj 	    IN	pRay Ȥθʪ
// @param pRefractRayDir    OUT	ޥ쥤٥ȥ
// @param pRefractRayCoeff  OUT	ޥ쥤εٷ
//------------------------------
static inline YorN
getRefractionRayDirRayTrace(const  Ray* const 	  pRay,
			    const  materialClass* pMat,
			    double 		  minRayCoefNorm,
			    objBaseClass *	  pHitObj,
			    Vector3 * 		  pRefractRayDir,
			    Vector3 * 		  pRefractRayCoeff)
{
    // ray  copy  pMat Ʃ᷸ݤ
    (*pRefractRayCoeff) = (pRay->getRefCoeff()) * (pMat->getSpecTrans());

    if((*pRefractRayCoeff).dInn_prd(*pRefractRayCoeff) < minRayCoefNorm)
    {
	return(NO);
    }
    
    // Ʃ׻
    if(pMat->getIdxRefraction() != 1.0)	
    {
	// ޤ ޥ쥤
	assert(pHitObj != NULL);

	// ʪˤ϶ΨεտΨˤ
	// sphere ξȿͥ쥤Ʊˡ٥ȥո
	Vector3 normal;  // ˡƤϤ
	double  n;        // Ψ
	if(pRay->isInside() == YES)
	{
	    n = pMat->getIdxRefraction(); 
	    
	    switch(pHitObj->who())
	    {
	    case TRIANGLE_OBJ_E:
		normal = pHitObj->getNormal(pRay->getHitPos());
		break;
		
	    case SPHERE_OBJ_E:
		if(pRay->isInside() == YES)
		{
		    normal = (-1.0) * pHitObj->getNormal(pRay->getHitPos()); 
		}else
		{
		    normal = pHitObj->getNormal(pRay->getHitPos());
		}
		break;
		
	    case NULL_OBJ_E:
	    default:
		cout << "Internal Error! : illegal object : "
		    "getRefractionRayDirRayTrace" << endl;
		break;
	    }
	}
	else
	{
	    n = 1.0 / (pMat->getIdxRefraction());
	    normal = pHitObj->getNormal(pRay->getHitPos());
	}
	//ˡƤϤ
	assert((normal.getNorm() - 1.0) < D_ERROR_RES);
	
	// Υ٥ȥ T (I ͥ٥ȥ, N ʪˡ٥
	// , n жΨ >= 1.0)  
	// T = (n (-N \dot I) - \sqrt(1 - n^2(1 - (N \dot I)^2)) N) + nI
	
	const double ndi = (pRay->getDir()).dInn_prd(normal); // (N \dot I)
	const double rt_2  =  1.0 - (n * n) * (1.0 - (ndi * ndi));
	    
	// tokunaga changed:
	if(rt_2 < 0.0) // \sqrt Ȥ 0 ̤ξˤƩȯʤ
	{
	    return(NO);
	}
	else
	{
	    const double rt = sqrt(rt_2);
	    (*pRefractRayDir) = 
		(((n * (-ndi)) - rt) * normal) + (n * pRay->getDir());
	}
    }
    else
    {
	// pMat->mIdxRefraction == 1.0  : ƩΨ 1 ̵̣ʡ
	(*pRefractRayDir) = pRay->getDir();
    }

    // Ʃ쥤 newRay!
    // Υ󥹥ȥ饯Ǻ쥤ϰäʪΤˤϸ򺹤ʤ 
    //     Ray *pNewRay = 
    //     	Ray::newForReflectionRayTracing(pRay, refractedRayDir, 
    //					newRefCoef, pHitObj);

    // ޤξˤʪΤȳѴ
    // pNewRay->changeSide();
    // DELETEME
    return(YES);
}

/**
//ȿ͡ޤ򥨥ͥ륮ʬǷ ̤
// tokunaga changed
static inline double reflectEnergyAlloc(const  Ray *const pRay,
					const  materialClass*  pMat,
					objBaseClass *pHitObj)

{
    Vector3 normal = pHitObj->getNormal(pRay->getHitPos());
    double cos_in =
	((pRay->getDir()).dInn_prd(normal))
	    /((pRay->getDir()).getNorm() * normal.getNorm()); 

    double n = pMat->mIdxRefraction;
    double tmp = n * n - 1 + cos_in * cos_in;
    if (tmp <= 0)
    {
	return(1.0);
    }
    else
    {
	double r_half = (cos_in - sqrt(tmp))
	    /(cos_in + sqrt(tmp));
	double r = r_half * r_half;
	return(r);
    }
}
*/

// ʲ¤⡼ɡ
// YorN PEClass::
// newSecondaryRays(Ray *pRay, const materialClass *pMat, 
// 		 objBaseClass * pHitObj)
// {
//     YorN isGenerateRay = NO;	// 쥤ȯ? 
//     
//     //tokunaga directioanl diffuse 
//     if(pMat->mfrustrum_rad != 0.0)
//     {
// 	// 
// 	return(this->secondDistrbuteRays(pRay, pMat, pHitObj));
//     }else
//     {
// 	//  ray ȿ͡޲ۤƤ뤫
// 	if(pRay->getReflectedNum() >= this->mViewData.getMaxRayRefNum())
// 	{				// ۤƤ롣ray ȯʤ
// 	    assert(isGenerateRay == NO);
// 	    return(isGenerateRay);
// 	}
// 	
// 	//------------------------------------------------------------
// 	// ȿ󼡥쥤 new PE ν塼Ͽ
// 	//------------------------------------------------------------
// 	Ray *pNewHanshaRay = 
// 	    newReflectionRays(pRay, pMat, 
// 			      this->mViewData.getMinRayRefCoeffNorm(),
// 			      pHitObj);
// 	if(pNewHanshaRay != NULL)	// ray ȯ٤
// 	{
// 	    pNewHanshaRay->setColor(pRay->getColor());
// 	    this->setRayPtrToThisPE(pNewHanshaRay);		   
// 	    isGenerateRay = YES;
// 	    // ȿͥ쥤ΤʤФ Hint TOKUNAGA
// 	}
// 	
// 	//------------------------------------------------------------
// 	// Ʃ󼡥쥤 new PE ν塼Ͽ
// 	//------------------------------------------------------------
// 	Ray *pNewToukaRay = 
// 	    newRefractionRays(pRay, pMat, 
// 			      this->mViewData.getMinRayRefCoeffNorm(),
// 			      pHitObj);
// 	if(pNewToukaRay != NULL)
// 	{
// 	// ray ȯ˵٤ƤΤ?
// 	    if(isGenerateRay == NO)
// 	    {			// Ƥʤ٤
// 		pNewToukaRay->setColor(pRay->getColor());	    
// 	    }
// 	    this->setRayPtrToThisPE(pNewToukaRay);
// 	    isGenerateRay = YES;
// 	    // ޥ쥤ΤʤФ Hint TOKUNAGA
// 	}
// 	return(isGenerateRay);
//     }
// }

#endif				// #ifdef   _calcRayTrSRGgetdir_h
