//------------------------------------------------------------
// $Id: fileUtil.cc,v 1.1.1.1 1999/11/25 06:26:12 yamauchi Exp $
//------------------------------------------------------------
//	fileUtil.cc
//	1998ǯ1222()
//	Copyright (C) 1998  YAMAUCHI Hitoshi  
// 
// FILE *getOpenedFp(const char *pFilename)
//	̾ check  open check Ԥʤ open Ǥʤäˤ 
//	NULL ֤Ԥξ message Ϥ롥
//	@param pFilename 	
//
// FILE *getUniqueWriteFP(const char *pCandidateWriteFname, char *ResBuf,
//			  int resbufsize)
//	write  file  open 롥ꤷե뤬¸ߤ
//	ˤϡmktemp Ѥƿʥե name  write 
//	 open ߤ롥
//      @param pCandidateWriteFname write  open ե̾
//      @param pResBuf ǽŪ open ե̾򤳤 buf ˥ԡ
//             ֤NULL Ϥˤϥԡʤ
//      @param resbufsize pResBuf 礭
//      @return open  FILE *Ԥˤ NULL ֤롥
//------------------------------------------------------------
#include <stdio.h>
#include <iostream.h>
#include <unistd.h> 		// extern "C" char *mktemp(char *);
#include <stdlib.h>
#include <string.h>
#include "constants.h"
#include "strnew.h"

#ifdef MPI2
#include "mpi2exit.h"
static void fileUtil_exit(int err)
{
    commMpi2_exit(err);
}
#else
static void fileUtil_exit(int err)
{
    exit(err);
}
#endif

//------------------------------------------------------------
// return opened FILE* for read, with check filename and open test.
// 	close ɬ
//------------------------------------------------------------
FILE *getOpenedFp(const char *pFileName)
{
    if((pFileName == NULL) || (pFileName[0] == '\0'))
    {
	cout << "Error! : illegal file name  [" << pFileName << "]" << endl;
	return(NULL);
    }
    
    FILE *pfp = fopen(pFileName, "r");
    if(pfp == NULL)
    {
	cout << "Error! : can not open [" << pFileName << "]" << endl;
	return(NULL);
    }
    else 
    {
	return(pfp);
    }
}

//------------------------------------------------------------
// return opened FILE* for write, with check filename and open test
// and ensure no override file.
// 	close ɬ
//   ̾ѹ줿ˤϤ̾ pResBuf ˽񤤤֤
//   ѹ줿̾ߤʤˤ pResBuf = NULL ȤƤ
//------------------------------------------------------------
FILE *getUniqueWriteFP(const char *pCandidateWriteFname, char *pResBuf, 
		       const int resbufsize)
{
    // file ¸ߤ뤫ǧ
    FILE *pfp = fopen(pCandidateWriteFname, "r");
    if(pfp == NULL)		
    {
	// ե¸ߤʤwrite  open 
	if((pfp = fopen(pCandidateWriteFname, "w")) == NULL)
	{
	    // ǤⳫʤfail
	    cout << "Error! : there is no file [" << pCandidateWriteFname << 
	    "], but can't open the file with write mode." << endl;
	    fileUtil_exit(1);
	}else
	{
	    // normail exit
	    if(pResBuf != NULL)
	    {
		if(resbufsize <= (int)strlen(pCandidateWriteFname))
		{
		    cout << "Warning! : shortage of resbufsize. "
		    	    "truncated. at getUniqueWriteFP(). [" << 
			    pCandidateWriteFname << "]" << endl;
		}
		strncpy(pResBuf, pCandidateWriteFname, resbufsize);
	    }
	}
    }
    else
    {
	// ե뤬¸ߤΤĤ¾ΥեƥȤ
	cout << "Warning! : There is [" << pCandidateWriteFname << "]. " << 
	    "I will try to new filename by mktemp." << endl;
	fclose(pfp);
	pfp = NULL;

	// try to make temporary file
	char *pTmpfname = strnew(pTEMP_SAVE_IMAGE_FILENAME);
	strncpy(pTmpfname, pTEMP_SAVE_IMAGE_FILENAME, resbufsize);
	if(mktemp(pTmpfname) == NULL)
	{
	    cout << "Error! : I can not make unique tmpfilename " << 
		"at getUniqueWriteFP." << endl;
	    fileUtil_exit(1);
	}
	if((pfp = fopen(pTmpfname, "w")) == NULL)
	{
	    cout << "Error! : can't open " << pTmpfname << 
	    " to write at getUniqueWriteFP." << endl;
	    fileUtil_exit(1);
	}else
	{
	    cout << "Warning! : mktmp succeeded. writing filename is  [" << 
	    pTmpfname << "] instead of [" << pCandidateWriteFname <<
	    "]" << endl;
	    if(pResBuf != NULL)
	    {
		if(resbufsize <= (int)strlen(pTmpfname))
		{
		    cout << "Warning! : shortage of resbufsize. "
		    	    "truncated. at getUniqueWriteFP(). [" <<
			    pTmpfname << "]" << endl;
		}
		strncpy(pResBuf, pTmpfname, resbufsize);
	    }
	}
	strdel(pTmpfname);
    }
    return(pfp);
}
