//------------------------------------------------------------
// $Id: hemicube.cc,v 1.2 2000/05/15 14:20:43 yamauchi Exp $
//------------------------------------------------------------
//	(M)^2 System Hemi cube class
//	First Ray Generation Unit has Hemi cube.
//	(This is only use radiosity mode)
//      (C) 1993-1998 Copyright By YAMAUCHI Hitoshi  
//	ʿǯ()
//	ʿǯ()
//	ʿǯ()	(start SP2 mpi2 implementation)
//
// ߥ졼Ѥ HC ϰܤŤĥ쥤ȯ򤷤Ƥߤ뤳Ȥ
// ǤʤƤϤʤäϤɬפʤΤᤤĤ
// δñǽǤ롣
//------------------------------------------------------------
#include <math.h>
#include <assert.h>

#include "constants.h"
#include "hemicube.h"
#include "mpi2exit.h"
#include "ray.h"
#include "triangleObject.h"

//------------------------------------------------------------
// protected functions
//------------------------------------------------------------
// memory allocation
//------------------------------
void hemiCubeClass::
getMemory(void)
{
    assert((this->getHemres() > 1) || (this->getHemres() % 2 == 0)); //inited?
    
    //------------------------------
    // getting form factor values area
    // (this->mpFFcal[ɤμ][⤵][])
    //------------------------------
    this->mpFFval 		= new double **[WALL_XPLUS_e + 1]; // ŷ1
    //     ŷ
    this->mpFFval[WALL_CEILING_e] = new double  *[this->getHemres()];  
    int i;
    for(i = 0; i < this->getHemres(); i++)
    {
	this->mpFFval[WALL_CEILING_e][i] = new double[this->getHemres()];
    }
    //     ɤ1
    // ɤι⤵Ͼ̤Ⱦʬ
    this->mpFFval[WALL_XPLUS_e] = new double  *[this->getHemres() / 2];
    for(i = 0; i < (this->getHemres() / 2); i++) // ɤι⤵Ⱦʬ
    {
	// ɤƱ
	this->mpFFval[WALL_XPLUS_e][i] = new double[this->getHemres()];
    }
    
    //------------------------------
    // getting Vector3 values    
    // (this->mpFFEOrgPos[ɤμ][⤵][])
    //------------------------------
    this->mpFFEOrgPos = new Vector3 **[HEMICUBE_PLANE_MAX_e];
    this->mpFFEPos    = new Vector3 **[HEMICUBE_PLANE_MAX_e];

    int w;
    for(w = WALL_CEILING_e; w < HEMICUBE_PLANE_MAX_e; w++)
    {
	int maxHeight = 0;		// դι⤵
	if(WALL_CEILING_e == w)		// ŷ
	{
	    maxHeight = this->getHemres();
	}else
	{
	    maxHeight = this->getHemres() / 2; // ŷʳ
	}
	this->mpFFEOrgPos[w] = new Vector3*[maxHeight]; 
	this->mpFFEPos[w]    = new Vector3*[maxHeight]; 

	int h;			// h (height)  mHemres 뤤 mHemres/2
	for(h = 0; h < maxHeight; h++)  //  maxHeight ޤ
	{
	    this->mpFFEOrgPos[w][h] = new Vector3[this->getHemres()];
	    this->mpFFEPos[w][h]    = new Vector3[this->getHemres()];
	}
    }
}

//------------------------------
// setFormFactor
//	Master Hemi-Cube(ž Hemi-Cube)Υեեȳƥԥ
//	֤ 
// +--------------+ --
// |              | ^
// | Hemi-Cube    | | hight
// | Plane        | v
// +--------------+ --
// |<-- width --->|
//                  pixel  FF  mpFFval[plane][hight][width]
//------------------------------
void hemiCubeClass::
setFormFactor(void)
{
    const double dZMAX =  1.0;	// Hemi-Cube ι⤵
    const double dZMIN =  0.0;	// -1.0    1.0   
    const double dXMIN = -1.0;	//   +-------+ ---  1.0 
    const double dXMAX =  1.0;	//   | Hemi- | 		 top view
    const double dYMIN = -1.0;	//   |  Cube |
    const double dYMAX =  1.0;	//   +-------+ --- -1.0 
    const double dCEIL_EDGE	//   |<----->| dCEIL_EDGE
	= dXMAX - dXMIN;
    const double dELEM_EDGE		   // dELEM_EDGE = ǤΰĹ
	= dCEIL_EDGE / double(this->getHemres());
    const double dELEM_BIAS	           // Ǥ濴뤿bias
	= dELEM_EDGE / 2.0;

    const double dElemArea = dELEM_EDGE * dELEM_EDGE;   // Ǥ:

    double x  = 0.0;
    int    ix = 0;
    for(x =  dXMIN + dELEM_BIAS, ix = 0; // ŷʬ 
	x <  dXMAX;
	x += dELEM_EDGE,         ix++)
    {
	assert(ix < this->getHemres());
	double y  = 0.0;
	int    iy = 0;
	for(y = dYMIN + dELEM_BIAS, iy = 0;
	    y < dYMAX;
	    y += dELEM_EDGE,        iy++)
	{
	    assert(iy < this->getHemres());
	    double dR_sqr = x * x + y * y + 1.0;
	    dR_sqr *= dR_sqr;
	    
	    this->mpFFval[WALL_CEILING_e][ix][iy] = dElemArea/(M_PI * dR_sqr); 
	    this->mpFFEOrgPos[WALL_CEILING_e][ix][iy].set(x, y, dZMAX);
	}
    }
    //----------------------------------------------------------
    //  Ĥʬ xp(ulus), xm(inus), yp(ulus), ym(inus)Τ
    // Ĥ狼ФȤƱ
    //----------------------------------------------------------

    double  z = 0.0;
    int    iz = 0;
    for(z =  dZMIN + dELEM_BIAS, iz = 0;
	z <  dZMAX;
	z += dELEM_EDGE,         iz++)
    {
	assert(iz < (this->getHemres() / 2));
	double  y = 0.0;
	int    iy = 0;
	for(y = dYMIN + dELEM_BIAS, iy = 0;
	    y < dYMAX;
	    y += dELEM_EDGE,        iy++)
	{
	    assert(iy < this->getHemres());
	    double dR_sqr = 1.0 + y * y + z * z;
	    dR_sqr *= dR_sqr;
	    this->mpFFval[WALL_XPLUS_e][iz][iy] = 
		(dElemArea * z) / (M_PI * dR_sqr);
	    this->mpFFEOrgPos[WALL_XPLUS_e][iz][iy].set( dXMAX, y, z);   
	    this->mpFFEOrgPos[WALL_XMINUS_e][iz][iy].set(dXMIN, y, z);   
	}
    }
    
    for(z =  dZMIN + dELEM_BIAS, iz = 0;	// z Ϲ⤵ hight
	z <  dZMAX;
	z += dELEM_EDGE,         iz++)
    {
	assert(iz < (this->getHemres() / 2));
	for(x = dXMIN + dELEM_BIAS, ix = 0; // x  width
	    x < dXMAX;
	    x += dELEM_EDGE,               ix++)
	{
	    assert(ix < this->getHemres());
	    this->mpFFEOrgPos[WALL_YPLUS_e][iz][ix].set( x, dYMAX, z);
	    this->mpFFEOrgPos[WALL_YMINUS_e][iz][ix].set(x, dYMIN, z);
	}
    }
}

//------------------------------
// rotate hemi cube (by Eular rotation)
//	(Maybe, this code includes my oldest code in mpi2)
//------------------------------
void hemiCubeClass::
rotateHC(const Vector3& aPatchNrm)
{
    const double D_NON_DEF = -2.0; // ꤨʤ
    double a[3][3];		/* 顼Ѵޥȥꥯ  */
    double dCtheta = D_NON_DEF;	/* (x' axis)     */
    double dStheta = D_NON_DEF;
    double dCkai   = D_NON_DEF;	/* (y' axis)     */
    double dSkai   = D_NON_DEF;
    double dCphi   = 1.0;	/* (z' axis)=0.0 */
    double dSphi   = 0.0;

    double dNx = aPatchNrm.get(Vector3::X); // ѥåˡ٥ȥ
    double dNy = aPatchNrm.get(Vector3::Y); /* nrmƤ */
    double dNz = aPatchNrm.get(Vector3::Z);

    dCtheta = dNz;
    dStheta = sqrt( 1 - dNz * dNz ); /* Ȥꤢ˲ */
    if(0.0 == dStheta)
    {
	dSkai = 0.0;
	dCkai = 1.0;
    }else
    {
	dSkai   = dNx / dStheta;
	dCkai   = dNy / dStheta;
    }

    /* -1.0 < sin,cos < 1.0 */
    assert( (-1.0 <= dCtheta) && (dCtheta <= 1.0) );
    assert( (-1.0 <= dStheta) && (dStheta <= 1.0) );
    assert( (-1.0 <= dCphi)   && (dCphi <= 1.0) );
    assert( (-1.0 <= dSphi)   && (dSphi <= 1.0) );

    a[0][0] =   dCkai   * dCphi - dSkai * dCtheta * dSphi;
    a[1][0] = - dSkai   * dCphi - dCkai * dCtheta * dSphi;
    a[2][0] =   dStheta * dSphi;

    a[0][1] =   dCkai   * dSphi + dSkai * dCtheta * dCphi;
    a[1][1] = - dSkai   * dSphi + dCkai * dCtheta * dCphi;
    a[2][1] = - dStheta * dCphi;

    a[0][2] =   dSkai * dStheta;
    a[1][2] =   dCkai * dStheta;
    a[2][2] =   dCtheta;

    int hcPlane;
    int maxHeight;
    for(hcPlane = WALL_CEILING_e; hcPlane < HEMICUBE_PLANE_MAX_e; hcPlane++)
    {
	if(hcPlane == WALL_CEILING_e)
	{
	    maxHeight = this->getHemres();
	}else
	{
	    maxHeight = this->getHemres() / 2; // ŷʳϹ⤵Ⱦʬ
	}
	int height;
	for(height = 0; height < maxHeight; height++)
	{
	    int width;
	    for(width = 0; width < this->getHemres(); width++)
	    {
		assert(isHemiCubePosXYZRight((hemicube_plane_type_e)hcPlane,
					     height, width)); 
		const Vector3& orgpos = 
		    this->mpFFEOrgPos[hcPlane][height][width];
		
		double x = orgpos.get(Vector3::X);
		double y = orgpos.get(Vector3::Y);
		double z = orgpos.get(Vector3::Z);
		
		double xt = a[0][0] * x + a[0][1] * y + a[0][2] * z; 
		double yt = a[1][0] * x + a[1][1] * y + a[1][2] * z;
		double zt = a[2][0] * x + a[2][1] * y + a[2][2] * z;
		
		this->mpFFEPos[hcPlane][height][width].set(xt, yt, zt);
	    }
	}
    }
}

//------------------------------
// generation rays using by rotetaed hemi-cube
//	Ray α delta radiosity  \delta Fij * PatchArea
//------------------------------
inline Ray *hemiCubeClass::
genOneRay(int plane, int height, int width)
{
    assert(isHemiCubePosXYZRight(plane, height, width) == YES);

    Vector3   aPos(this->mGravityCenter);
    Vector3   aDir(this->mpFFEPos[plane][height][width]);
    aDir.VNormalize();            // 쥤Υ٥ȥ
    Vector3   aRadiosity(this->mLockingNotYetRad);
    
    // 쥤ˤϥեեͥѥåѤݤäƤ
    int ffvalPlane = plane;
    if(plane > WALL_XPLUS_e)
    {
	ffvalPlane = WALL_XPLUS_e; // ¦̤ FF val ƱʤΤ 1 ĤˤƤ
    }
    aRadiosity = aRadiosity * 
	(this->mpFFval[ffvalPlane][height][width] * this->mPatchArea);
    
    // 쥤 newray
    Ray *pNewRay = Ray::newForRadiosity(aPos, aDir, aRadiosity,
					this->mpPatch, this->mSpcpos
					//,  this->mPEID
					); 
    return(pNewRay);
}

//---------------
// distributed method
//	ray ̤򼡡ѲƱ(˶ᤤ)Ϣ³ ray 
//	ͤʤ褦ˤ
//	load balancing θ̤ȹͤˡ  
//---------------
void hemiCubeClass::
distributeRadiation(Ray * pRetRays[])
{
    int plane, h, w;		// plane, height, width
    int ridx = 0;		// index for return ray 
    const int halfHemres = (this->getHemres() / 2);
    for(h = 0; h < halfHemres; h++)
    {
	for(w = 0; w < this->getHemres(); w++)	    
	{
	    // ŷ2 : h * w  h + halfHemres * w  ray 
	    pRetRays[ridx] = this->genOneRay(WALL_CEILING_e, h, w);
	    ridx++;
	    pRetRays[ridx] = this->genOneRay(WALL_CEILING_e, h + halfHemres,w);
	    ridx++;
	    
	    // ŷǤʤʬ
	    for(plane = WALL_XPLUS_e; plane < HEMICUBE_PLANE_MAX_e; plane++)
	    { 
		pRetRays[ridx] = this->genOneRay(plane, h, w);
		ridx++;
	    }
	}
    }
}

//---------------
// continuous method
//	ray ̤ѲƱ(˶ᤤ)Ϣ³ ray 
//	ͤ
//	load balancing θ̤ȹͤˡ  
//---------------
void hemiCubeClass::
continuousRadiation(Ray *pRetRays[])
{
    int plane, h, w;		// plane, height, width
    int ridx = 0;		// index for return ray 
    for(plane = WALL_CEILING_e; plane < HEMICUBE_PLANE_MAX_e; plane++)
    { 
	//(plane == WALL_CEILING_e)?(this->getHemres()):(this->getHemres()/2);
	int maxHeight;
	if(plane == WALL_CEILING_e)
	{
	    maxHeight = this->getHemres();
	}else
	{
	    maxHeight = this->getHemres() / 2;
	}
	for(h = 0; h < maxHeight; h++)
	{
	    for(w = 0; w < this->getHemres(); w++)	    
	    {
		pRetRays[ridx] = this->genOneRay(plane, h, w);
		ridx++;
	    }
	}
    }
}

//------------------------------
// ɸؤƤ뤫Υƥ ˤ YES
//------------------------------
YorN hemiCubeClass::
isHemiCubePosXYZRight(const int plane, const int height, const int width) const
{
    if(plane >= HEMICUBE_PLANE_MAX_e) // plane̵ʤΤӤ̵
    {
	cout << "Error! : illegal plane = " << plane
	    << " at MHC position" << endl;
	return(NO);
    }
    
    int MaxHeight = 0;
    if(plane != WALL_CEILING_e)
    {
	MaxHeight = this->getHemres() / 2;
    }else
    {
	MaxHeight = this->getHemres();
    }
    
    if((height < 0) || (height >= MaxHeight)) // ⤵Ѳ
    {
	cout << "Error!: illegal height = " << height
	    << " at MHC position" << endl;
	return(NO);
    }
    
    if((width < 0) || (width >= this->getHemres())) // Ѳʤ
    {
	cout << "Error!: illegal hemres = " << this->getHemres() << 
	    " width = " << width << " at MHC position" << endl;
	return(NO);	
    }
    return(YES);
}

//------------------------------------------------------------
// public functions
//------------------------------------------------------------
// constructor
//------------------------------
hemiCubeClass::
hemiCubeClass(int aHemres, const IntVec3& PEID)
{
    assert(PEID.get(IntVec3::X) >= 0); // host  hemi cube ʤ

    if((aHemres < 2) || (aHemres % 2 != 0))
    {
	cout << "Error! : illegal hemres value. " << 
	    "hemres must be > 1 and % 2 == 0, hemres = " << aHemres << endl;
	commMpi2_exit(1);
    }

    this->mpFFval	= NULL;
    this->mpFFEOrgPos	= NULL;
    this->mpFFEPos	= NULL;

    this->mElemArea	= -1.0;
    this->mHemres	= aHemres;

    this->mPEID		= PEID;	
    
    this->mPatchNormal.set(0.0, 0.0, 0.0);
    this->mGravityCenter.set(PlusInfty, PlusInfty, PlusInfty);
    this->mPatchArea	= 0.0;
    this->mSpcpos.set(-1, -1, -1);
    this->mpPatch	= NULL;
    this->mLockingNotYetRad.set(0.0, 0.0, 0.0);

    // memory allocation 
    this->getMemory();

    // initialize master hemi-cube
    this->setFormFactor();
}

//------------------------------
// 
//------------------------------
hemiCubeClass::
~hemiCubeClass()
{
    int i;
    // FFͤΰ(ŷ)
    for(i = 0; i < this->getHemres(); i++)
    {
	delete [] this->mpFFval[WALL_CEILING_e][i];
    }
    // FFͤΰ()
    for(i = 0; i < (this->getHemres() / 2); i++) // ɤι⤵Ⱦʬ
    {
	delete [] this->mpFFval[WALL_XPLUS_e][i];
    }
    delete [] this->mpFFval[WALL_CEILING_e];
    delete [] this->mpFFval[WALL_XPLUS_e];
    delete [] this->mpFFval;
    this->mpFFval = NULL;	// meanless but comfortable for me
    
    // ֤ݻƤΰβ
    int w;
    for(w = WALL_CEILING_e; w < HEMICUBE_PLANE_MAX_e; w++)
    {
	int maxHeight = 0;	// դι⤵
	if(WALL_CEILING_e == w)	// ŷ
	{
	    maxHeight = this->getHemres();
	}else
	{
	    maxHeight = this->getHemres() / 2; // ŷʳ
	}
	int h;			// h (height)  mHemres 뤤 mHemres/2
	for(h = 0; h < maxHeight; h++)  //  maxHeight ޤ
	{
	    delete [] this->mpFFEOrgPos[w][h];
	    delete [] this->mpFFEPos[w][h];
	}
	delete [] this->mpFFEOrgPos[w];
	delete [] this->mpFFEPos[w];
    }
    delete [] this->mpFFEOrgPos;
    delete [] this->mpFFEPos;
    this->mpFFEOrgPos = NULL;	// meanless but comfortable for me
    this->mpFFEPos    = NULL;	// meanless but comfortable for me
}


//------------------------------
// ͥѥåξˤꡢHemi-Cube žray Ф
//	Ray Υݥ ray  new ֤
//	Ray ΥݥΰϸƤӽФ¦ǳݤ뤳
//------------------------------
void hemiCubeClass::
genRays(objBaseClass *const apPatch, 	  // ͥѥå
	const YorN isDistributedRadiation,// ray ȯ load balance 뤫
	Ray *pRetRays[])		  //  ray Υݥ
{
    // must normalized normal
    assert(fabs((apPatch->getNormal()).getNorm() - 1.0) < 1e-5); 
    assert(pRetRays != NULL);

    this->mPatchNormal		= apPatch->getNormal();
    this->mGravityCenter	= apPatch->getGCenter();
    this->mPatchArea		= apPatch->getArea();
    assert(this->mPatchArea > 0.0); // ѤϤϤ

    this->mSpcpos	= apPatch->getSpcPos();
    assert((this->mSpcpos.get(IntVec3::X) >= 0) && 
	   (this->mSpcpos.get(IntVec3::Y) >= 0) && 
	   (this->mSpcpos.get(IntVec3::Z) >= 0)); 

    // ¾ radiosityͤƤɤ褦ͤ lock 
    // ɤϽ񤤤ߡmulti thread ǤʤΤ lock ʤƤ
    // Ǥ롣Ĥɬפˤʤ뤫⤷ʤ(塼ʬ 
    // atomic ˤƤʤΤǡ MT ˤʤäϤ狼ʤ) 
    // 7 Sept. 1996 Hitoshi Yamauchi 
    // critical region begin
    this->mLockingNotYetRad = apPatch->getNClearNonRadAndUpdateRadiosity();
    apPatch->unsetInRadiationQueue(); // 줬̵ä 1998ǯ1211()
    // critical region end

    this->rotateHC(this->mPatchNormal);

    if(isDistributedRadiation == YES)
    {
	this->distributeRadiation(pRetRays);
    }else
    {  
	this->continuousRadiation(pRetRays);
    }
}


//------------------------------------------------------------
// main test
//------------------------------------------------------------
#ifdef TEST_HEMICUBE
void hemiCubeClass::
test()
{
    for(int x = 0; x < this->getHemres(); x++)
    {
	for(int y = 0; y < this->getHemres(); y++)
	{
	    cout << "[" << x << "][" << y << "]= " <<
	    this->mpFFval[WALL_CEILING_e][x][y] << endl;
	}
    }
}

void commMpi2_exit(int err_num)
{
    exit(err_num);
}

int main()
{
    IntVec3 PEID(0, 0, 0);
    const int hemres = 10;
    hemiCubeClass *pHemiCube = new hemiCubeClass(hemres, PEID);
    pHemiCube->test();
    return(0);
}
#endif				// #ifdef TEST_HEMICUBE
//
// g++ -I ../mpi2dataReader/ -D TEST_HEMICUBE hemicube.cc 
//
