//------------------------------------------------------------
// $Id: hemicube.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
//
//	Hemi cube class for (M)^2 System 
//	First Ray Generation Unit has Hemi cube.
//	(This is only use radiosity mode)
//      (C) 1993-1998 Copyright By YAMAUCHI Hitoshi
// 	ʿǯ()(start implementation)
//	ʿǯ() 	(simulation implementation finished)
//	ʿǯ()	(start SP2 mpi2 implementation)
//
// ߥ졼Ѥ HC ϰܤŤĥ쥤ȯ򤷤Ƥߤ뤳Ȥ
// ǤʤƤϤʤäϤɬפʤΤᤤĤ
// δñǽǤ롣Ȥ Master Hemi-Cube ¢Ƥޤ
// Ȥʤɡ 
//
// μǤϡ
// 	1.HemiCube 򤢤 hemres Ǻpatch  Normal Vector 
// 	  ƽ롣 
// 	2.θϡpatch  Normal vector ͿƼνԤ
//	  ȤǺѤ롣
//------------------------------------------------------------
#ifndef _hemicube_h
#define _hemicube_h 1

#include <assert.h>

#include "IntVec3.h"
#include "Vector3.h"
#include "mpi2.h"

// class declaration
class objBaseClass;
class Ray;

enum hemicube_plane_type_e {
    WALL_CEILING_e,		// ŷ(Ѥ̾줹뤿)
    WALL_XPLUS_e,		// 
    WALL_XMINUS_e,    
    WALL_YPLUS_e,
    WALL_YMINUS_e,
    HEMICUBE_PLANE_MAX_e	// xlC Τ , õͤФʤ
};

//------------------------------------------------------------------- 
// Hemi-Cube ( Hemi-cube ϳƥѥåΤưŪ˺)
//------------------------------------------------------------------- 
class hemiCubeClass {
private:
    // don't make hemicube as {default|copy} constructor and substitute
    hemiCubeClass(void);
    hemiCubeClass(const hemiCubeClass& rhs);
    const hemiCubeClass &operator=(const hemiCubeClass &rhs);

protected:
    // set in getMemory()
    double   ***mpFFval;	// FormFacter ɤΤΤ1Ĥɤ
    Vector3  ***mpFFEOrgPos;	// 줾ΥȤβžΰ
    Vector3  ***mpFFEPos;	// žΤ줾ΥȤΰ

    // hemi cube info
    double   mElemArea;		// 줾ΥȤ
    int	     mHemres;		// Hemi-cube resolution

    IntVec3  mPEID;		// ô PE ID
    
    // raiation patch informatio
    Vector3  mPatchNormal; 	// ͥѥåˡ
    Vector3  mGravityCenter;	// ͥѥåνſ
    double   mPatchArea;	// ͥѥå
    IntVec3  mSpcpos;		// ͥѥå¸ߤֻɸ
    objBaseClass *mpPatch;	// ͥѥå
    Vector3  mLockingNotYetRad;	// ̤ͤΥå

protected:
    int getHemres(void)	const 	{ return(this->mHemres);	}

protected:
    void getMemory(void);	// 
    void setFormFactor(void);	// Master Hemi-Cube ΰ֤ FF 
    void rotateHC(const Vector3& patchNorm); // HemiCubeΥ顼Ѵ

    // generation rays using by Hemi-Cube
    void distributeRadiation(Ray *pRayArea[]);
    void continuousRadiation(Ray *pRayArea[]);
    inline Ray *genOneRay(int plane, int height, int width);
    // 顼å
    YorN isHemiCubePosXYZRight(//const hemicube_plane_type_e plane, 
			       const int plane,
			       const int height, const int width) const;

public:
    hemiCubeClass(int hemres, const IntVec3& PEID);
    ~hemiCubeClass(void);    

    // ȯ ray  =  * 4 + ŷ(ɤ礭ŷȾʬ) = 3 * ŷ 
    int getGenRayNum(void) const { return(3 * this->mHemres * this->mHemres); }

    // 쵤˰Ĥ HemiCube ʬ ray ȯpRetRays ˥ݥ
    // 򥳥ԡ(ݥ󥿤 new Ƥ)֤ 
    // pRetRays ΰϸƤӽФ¦ݤϤȡ
    void genRays(objBaseClass *const apPatch, 	   // ͥѥå
		 const YorN isDistributedRadiation,// ray ȯ
		 Ray *pRetRays[]);		   // rayptr
#ifdef TEST_HEMICUBE
    void test();
#endif
};

#endif				// (#ifndef _hemicube_h)

