//------------------------------------------------------------
// $Id: objectInfoInASpace.h,v 1.2 2000/06/14 13:29:37 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 : object information in a subspace
//		    (Ĥ֤ʪΤ¸߾򼨤)  
//	1996/7/6 start as `dataCollection.h'
//	Copyright (C) 1998 YAMAUCHI Hitoshi   
//	1998ǯ827()
// 
// 	֤ʪξ̾ array3DClass ǤȤʤꡤʪΤ¸
// 	ʤɤ򼨤
//
// 	objectNumInASpaceClass:   ֤¸ߤʪ̤ο򥫥Ȥ
// 	objectExistInASpaceClass: ֤ʪΤ¸ߤͻҤ򼨤
//------------------------------------------------------------
#ifndef _objectInfoInASpace_h
#define _objectInfoInASpace_h 1

#include <iostream.h>
#include "mpi2.h"

// ʪΤ¸߾ɽη (objectExistInASpaceClass)
#define OBJINSPC_IMPLEMENT_TYPE char

//------------------------------------------------------------
// Ĥζ֤¸ߤʪΤξ
// 	(host )
//------------------------------------------------------------
class objectNumInASpaceClass {
public:    
    int mGeoNum;
    int mVolNum;		// volumeReader.cc Ǥϥ饤

public:    
    objectNumInASpaceClass(void) : mGeoNum(0), mVolNum(0){}
    objectNumInASpaceClass(const objectNumInASpaceClass& rhs)
    {
	this->mGeoNum = rhs.mGeoNum;
	this->mVolNum = rhs.mVolNum;
    }
    const objectNumInASpaceClass& operator=(const objectNumInASpaceClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mGeoNum = rhs.mGeoNum;
	    this->mVolNum = rhs.mVolNum;
	}
	return(*this);
    }
    YorN isObj(void)		// ʪΤ¸ߤ YES
    {
	if((this->mGeoNum > 0) || (this->mVolNum > 0))
	{
	    return(YES);
	}else
	{
	    return(NO);
	}
    }
    friend ostream& operator<<(ostream& s, const objectNumInASpaceClass& onis)
    {
	s << onis.mGeoNum << "\t" << onis.mVolNum;
	return s;
    }

    //------------------------------
    // pretty print ʬ֤ˤɤΤ褦ʪΤ뤫򸫤뤿Τ
    //------------------------------
    const char * getVisualOutDescription(void) const
    {
	return(" [P]olygon, [V]olume, [B]oth");
    }
    char getVisualOut(void) const
    {
	// Ǥ Polygon  P, Volume ʤ V, ξʤ B ֤
	if((this->mGeoNum > 0) && (this->mVolNum > 0))
	{
	    return('B');
	}
	else if(this->mGeoNum > 0)
	{
	    return('P');
	}
	else if(this->mVolNum > 0)
	{
	    return('V');	    
	}
	else
	{
	    return(' ');	    	    
	}
    }

    //----------------------------------------
    // SerializableIF : double ɽƱ׻ǤʤȾ꤯ʤ    
    //----------------------------------------
    int getSerializedSize(void) const
    {
	return(2);
    }
    double *newSerializedArray(void)
    {
	double *r = new double[this->getSerializedSize()];
	r[0] = this->mGeoNum;
	r[1] = this->mVolNum;
	return(r);
    }
    void deserialize(double *pBuf)
    {
	this->mGeoNum = (int)(pBuf[0]);
	this->mVolNum = (int)(pBuf[1]);
    }

    // operator ==
    friend int operator==(const objectNumInASpaceClass &a,
			  const objectNumInASpaceClass &b)
    {
	return((a.mGeoNum == b.mGeoNum) && (a.mVolNum == a.mVolNum));
    }
    friend int operator!=(const objectNumInASpaceClass &a,
			  const objectNumInASpaceClass &b)
    {
	return(!((a.mGeoNum == b.mGeoNum) && (a.mVolNum == a.mVolNum)));
    }
};


//------------------------------------------------------------
// ֤ʪΤ¸ߤͻҤ򼨤
// 	Geometry 뤫 Volume 뤫
//	ʤ #include "serializable.h"
//------------------------------------------------------------
class objectExistInASpaceClass {  
protected:    
    OBJINSPC_IMPLEMENT_TYPE mObjInfo;

public:    
    enum {
	IS_GEO = 1,		// = 01b : geometry (polygon ʤ) 
	IS_VOL = 2		// = 10b : volume 
    };

public:    
    objectExistInASpaceClass(void) : mObjInfo(0){}
    objectExistInASpaceClass(const objectExistInASpaceClass& rhs)
    {
	this->mObjInfo = rhs.mObjInfo;
    }
    objectExistInASpaceClass(const OBJINSPC_IMPLEMENT_TYPE& rhs)
    {
	this->mObjInfo = rhs;
    }
    const objectExistInASpaceClass operator=(const
					     objectExistInASpaceClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mObjInfo = rhs.mObjInfo;
	}
	return(*this);
    }

    void set(int aGeoNum, int aVolNum) // set Τ߾äʤ
    {
	if(aGeoNum > 0)
	{
	    this->mObjInfo |= objectExistInASpaceClass::IS_GEO;
	}
	if(aVolNum > 0)
	{
	    this->mObjInfo |= objectExistInASpaceClass::IS_VOL;
	}
    }
    void clear(void)
    {
	this->mObjInfo = 0;
    }

    YorN isObj(void) const	// ʪΤ¸ߤ YES
    {
	return(((this->mObjInfo > 0)) ? YES : NO);
    }
    YorN isGeo(void) const	// geometry ¸ߤ YES
    {
	if((this->mObjInfo & objectExistInASpaceClass::IS_GEO) > 0)
	{
	    return(YES);
	}else
	{
	    return(NO);
	}
    }
    YorN isVol(void) const	// volume ¸ߤ YES
    {
	if((this->mObjInfo & objectExistInASpaceClass::IS_VOL) > 0)
	{
	    return(YES);
	}else
	{
	    return(NO);
	}
    }

    // for serialize (Τ OBJINSPC_IMPLEMENT_TYPE ǼФ)
    OBJINSPC_IMPLEMENT_TYPE getObjInfo(void) const
    {
	return(this->mObjInfo);
    }
    
    friend ostream& operator<<(ostream& s, objectExistInASpaceClass& onis)
    {
	s << onis.mObjInfo;
	return s;
    }

    // for pretty print
    const char * getVisualOutDescription(void) const
    {
	return(" [P]olygon, [V]olume, [B]oth");
    }
    char getVisualOut(void) const
    {
	// Polygon  P, Volume ʤ V, ξʤ B ֤
	if(this->mObjInfo == (objectExistInASpaceClass::IS_GEO | 
			      objectExistInASpaceClass::IS_VOL))
	{
	    return('B');
	}
	else if(this->mObjInfo == objectExistInASpaceClass::IS_GEO)
	{
	    return('P');
	}
	else if(this->mObjInfo == objectExistInASpaceClass::IS_VOL)	
	{
	    return('V');
	}
	else
	{
	    return(' ');	    	    
	}
    }
    
    //----------------------------------------
    // SerializableIF : double ɽƱ׻ǤʤȾ꤯ʤ    
    //----------------------------------------
    int getSerializedSize(void) const
    {
	// OBJINSPC_IMPLEMENT_TYPE mObjInfo;  char 
	return(1);
    }
    double *newSerializedArray(void)
    {
	double *r = new double[this->getSerializedSize()];
	r[0] = (double)(this->mObjInfo);
	return(r);
    }
    void deserialize(double *pBuf)
    {
	this->mObjInfo = (char)(pBuf[0]);
    }


    // operator ==
    friend int operator==(const objectExistInASpaceClass &a,
			  const objectExistInASpaceClass &b)
    {
	return(a.mObjInfo == b.mObjInfo);
    }
    friend int operator!=(const objectExistInASpaceClass &a,
			  const objectExistInASpaceClass &b)
    {
	return(a.mObjInfo != b.mObjInfo);
    }
};

#endif				// #define _objectInfoInASpace_h 1





