//------------------------------------------------------------
// $Id: objectSet.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// 	object set implementation
//	(M\pi)^2 
//
//	object  PE ݻݤѤ륯饹
//	 sub ֤ΰ֤ͿȤζ object ο 
//	object Ф롣
// 	϶֤®٤Υȥ졼ɥդѲͽ
//	1996/7/16 
//		ޤ3Ĺĩ
//		֥ȶʬ䷿׻˴ŤôʬΤߤ
//		־  
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#include <assert.h>

// #include <stdlib.h>
// #include "constants.h"

#include "PE.h"
#include "ProcObj.h"
#include "mpi2exit.h"
#include "objectSet.h"
#include "Option.h"

//------------------------------------------------------------
// protected functions
//------------------------------------------------------------
void objectSetClass::
delElems(void)
{
    if(this->mpppObjArray != NULL)
    {
	const int SpcNumX = this->mTotalSpcNum.get(IntVec3::X);
	const int SpcNumY = this->mTotalSpcNum.get(IntVec3::Y);
	const int SpcNumZ = this->mTotalSpcNum.get(IntVec3::Z);
	if((SpcNumX <= 0) || (SpcNumY <= 0) || (SpcNumZ <= 0))
	{
	    cerr << "Error! : illegal number of spaces at delElems." << 
		this->mTotalSpcNum << endl;
	    commMpi2_exit(1);
	}
	int x, y;
	for(x = 0; x < SpcNumX; x++)
	{
	    for(y = 0; y < SpcNumY; y++)	    
	    {
		delete [] this->mpppObjArray[x][y];
	    }
	    delete [] this->mpppObjArray[x];	    
	}
	this->mpppObjArray = NULL;	    	
	this->mTotalSpcNum = IllegalPEID;	// set(-2, -2, -2);	
    }
}

//------------------------------
// index ϰϤå
//------------------------------
YorN objectSetClass::
idxOK(const IntVec3& a3dIdx) const
{
    if((0 <= a3dIdx.get(IntVec3::X)) &&
       (0 <= a3dIdx.get(IntVec3::Y)) &&
       (0 <= a3dIdx.get(IntVec3::Z)) &&
       (a3dIdx.get(IntVec3::X) < this->mTotalSpcNum.get(IntVec3::X)) &&
       (a3dIdx.get(IntVec3::Y) < this->mTotalSpcNum.get(IntVec3::Y)) &&
       (a3dIdx.get(IntVec3::Z) < this->mTotalSpcNum.get(IntVec3::Z)))
    {
	return(YES);
    }else
    {
	if(Option::getInstance()->getDebugMode() == YES)
	{
	    cout << DEBUGHEAD << "debug :: objectSetClass::idxOK idx = "
	    << a3dIdx << ", total space num = " << this->mTotalSpcNum << endl;
	}
	return(NO);
    }
}

//------------------------------------------------------------
// public functions
//------------------------------------------------------------
objectSetClass::
~objectSetClass(void)
{
    this->delElems();
}

//------------------------------
// ֿƽ
//------------------------------
void objectSetClass ::
init(const IntVec3& aTotalSpcNum)
{
    const int localSpcNumX = aTotalSpcNum.get(IntVec3::X);
    const int localSpcNumY = aTotalSpcNum.get(IntVec3::Y);
    const int localSpcNumZ = aTotalSpcNum.get(IntVec3::Z);
    if((localSpcNumX < 0) || (localSpcNumY < 0) || (localSpcNumZ < 0))
    {
	cerr << "Error! : illegal number of spaces objectSetClass::init"
	    << aTotalSpcNum << endl;
	commMpi2_exit(1);
    }
    this->delElems();

    int x, y;
    this->mpppObjArray = new objectsArrayClass** [localSpcNumX];	    
    for(x = 0; x < localSpcNumX; x++)
    {
	this->mpppObjArray[x] = new objectsArrayClass* [localSpcNumY];	    
	for(y = 0; y < localSpcNumY; y++)	    
	{
	    this->mpppObjArray[x][y] = new objectsArrayClass [localSpcNumZ];
	}
    }
    this->mTotalSpcNum = aTotalSpcNum;
}

//------------------------------
// ǤĹ ֹ֤򤽤ΤޤѤǤ
//------------------------------
void objectSetClass::
setLength(const IntVec3& a3dIdx, int aLen)
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->idxOK(innerIdx) == YES);    
    this->mpppObjArray[innerIdx.get(IntVec3::X)]
	[innerIdx.get(IntVec3::Y)][innerIdx.get(IntVec3::Z)].setLength(aLen);
}

//------------------------------
// ǤĹ ֹѤ Ǥ뤬
// ̤򸺤餻 
//------------------------------
void objectSetClass::
setLengthWithLocalIdx(const IntVec3& innerIdx, int aLen)
{
    assert(this->idxOK(innerIdx) == YES);    
    this->mpppObjArray[innerIdx.get(IntVec3::X)]
	[innerIdx.get(IntVec3::Y)][innerIdx.get(IntVec3::Z)].setLength(aLen);
}

//------------------------------
// ꤵ줿 index Ĺ֤
//------------------------------
int objectSetClass::
getLength(const IntVec3& a3dIdx) const
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->idxOK(innerIdx) == YES);
    return(this->mpppObjArray[innerIdx.get(IntVec3::X)]
	   [innerIdx.get(IntVec3::Y)][innerIdx.get(IntVec3::Z)].getLength());
}

//------------------------------
// object ꤵ줿κǸղä
//------------------------------
void objectSetClass::
add(const IntVec3& a3dIdx, objBaseClass* pObj)
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->idxOK(innerIdx) == YES);
    int x = innerIdx.get(IntVec3::X);
    int y = innerIdx.get(IntVec3::Y);
    int z = innerIdx.get(IntVec3::Z);
    this->mpppObjArray[x][y][z].add(pObj);
}

//------------------------------
// ꤵ줿 object ؤλȤФ
//------------------------------
objectsArrayClass *objectSetClass::
get(const IntVec3& a3dIdx)
{
    IntVec3 innerIdx = GpPE->getLocalIdxFromSpcPos(a3dIdx);
    assert(this->idxOK(innerIdx) == YES);
    return(&(this->mpppObjArray[innerIdx.get(IntVec3::X)]
	     [innerIdx.get(IntVec3::Y)][innerIdx.get(IntVec3::Z)]));
}

//------------------------------------------------------------
//  object set ׾
//------------------------------------------------------------
// ôֿ
//------------------------------
void objectSetClass::
getStat(int    *pNumberOfTotalSpace, // ôֿ
	double *pAverage,	     // ʪοʿ
	double *pVariance,	     // ʪοʬ
	int    *pNoObjectSpaces,     // ʪΤ¸ߤʤֿ
	double *pNoObjSpaceAverage, // ʪΤ¸ߤʤ֤ʪοʿ
	double *pNoObjSpaceVariance // ʪΤ¸ߤʤ֤ʪοʬ
	)
{
    // ֿ
    const int numOfTotalSpc = 
	this->mTotalSpcNum.get(IntVec3::X) *
	    this->mTotalSpcNum.get(IntVec3::Y) * 
		this->mTotalSpcNum.get(IntVec3::Z);
    (*pNumberOfTotalSpace) = numOfTotalSpc;
    
    int *pNumObjInSpc = new int [numOfTotalSpc];
    int i, x, y, z;
    for(i = 0; i < numOfTotalSpc; i++)
    {
	pNumObjInSpc[i] = 0;
    }
    
    // 3 Ū˻äƤʪοξ켡ѴƷ׻ưפˤ
    i = 0;
    for(z = 0; z < this->mTotalSpcNum.get(IntVec3::Z); z++)
    {
	for(y = 0; y < this->mTotalSpcNum.get(IntVec3::Y); y++)
	{
	    for(x = 0; x < this->mTotalSpcNum.get(IntVec3::X); x++)
	    {
		pNumObjInSpc[i] = this->mpppObjArray[x][y][z].getLength();
		i++;
	    }
	}
    }

    // ʪοʿѡʬ
    double sum 	   = 0.0;
    double sqrdSum = 0.0;
    const double spacenum = double(numOfTotalSpc);
    for(i = 0; i < numOfTotalSpc; i++)
    {
	sum 	+= double(pNumObjInSpc[i]);
	// double ѴƤ褺Τ overflow Ǥ򤱤뤿
	sqrdSum	+= double(pNumObjInSpc[i]) * double(pNumObjInSpc[i]);
    }

    (*pAverage)	= sum / spacenum;
    (*pVariance)= (sqrdSum / spacenum) - ((sum / spacenum) * (sum / spacenum));
    
    // ʪΤ¸ߤӡʪοʿѡʬ
    sum		= 0.0;
    sqrdSum 	= 0.0;
    int spacenumWithObjs = 0;
    for(i = 0; i < numOfTotalSpc; i++)
    {
	if((pNumObjInSpc[i]) != 0)
	{
	    sum 	+= double(pNumObjInSpc[i]);
	    sqrdSum	+= double(pNumObjInSpc[i]) * double(pNumObjInSpc[i]);
	    spacenumWithObjs++;
	}
    }
    (*pNoObjectSpaces) = numOfTotalSpc - spacenumWithObjs;

    if(spacenumWithObjs == 0)
    {
	//  PE ʪΤݻƤʤ
	(*pNoObjSpaceAverage)	= 0.0;
	(*pNoObjSpaceVariance) 	= 0.0;
    }else
    {
	(*pNoObjSpaceAverage)	= sum / spacenumWithObjs;
	(*pNoObjSpaceVariance)	= 
	    (sqrdSum / spacenumWithObjs) - 
		((sum / spacenumWithObjs) * (sum / spacenumWithObjs));
    }
    delete [] pNumObjInSpc;
}

