//------------------------------------------------------------
// $Id: prepareShading.cc,v 1.10.2.1 2000/06/14 17:46:35 yamauchi Exp $
//------------------------------------------------------------
//	prepare shading
//	1996/9/11
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//
//	shading Τĺٸ򴹤Ƚ(ʿѲʤ)
//------------------------------------------------------------
#include "PE.h"
#include "Option.h"
#include "mpi2communication.h"
#include "adjdir.h"
#include "mpi2_funcs.h"
#include "PEpmarray.h"

// stand alone 
#ifdef FOR_STANDALONE
// #include "StandAloneModeObjects.h"
#else

#endif

// IntVec3 -> Vector3(using in calcRayTrDD.cc, prepareShading.cc)
static inline Vector3 iv2v(const IntVec3& iv)
{
    return(Vector3(double(iv.get(IntVec3::X)),
		   double(iv.get(IntVec3::Y)),	   
		   double(iv.get(IntVec3::Z))));
}

#ifdef FOR_STANDALONE
//------------------------------
// for stand alone mode 
// stand alone ǤϤδؿƤλ(Ĥޤ⽪λ
// Ƥ)˸ƤФΤǾ YES
// 	isPrepareStageOver()
//------------------------------
YorN PEClass::
isPrepareShadingStageOver(void)
{
    this->mIsPrepareShadingOver = YES;
    return(YES);		
}
#endif
//------------------------------
// initPrepareStage
//	Shading stage 
//------------------------------
void PEClass::
initPrepareShadingStage(void) 
{
    // ΥơϤ줫(λƤʤ)
    this->mIsPrepareShadingOver = NO;
    this->initBusyIdleStat();

    // ĺХåե
    this->mNIUnit.initVerIntBuff(this->mSysInfo.getSendVerIntAtOnce(), 
				 &(this->mVerIntPtrQueue));
}

//------------------------------
// ζֻɸ⤫
//------------------------------
inline YorN PEClass::
checkInSpc(const IntVec3 &spcpos)
{
    for(int i = 0; i < 3; i++)
    {
	if((spcpos.get(i) < (this->mSpcParam.getMinDefSpcIdx()).get(i)) ||
	   (spcpos.get(i) > (this->mSpcParam.getMaxDefSpcIdx()).get(i)))
	{
	    return(NO);
	}
    }
    return(YES);
}

/*
 * ƶ֤ȤƱĺε٤
 * 	줾ζΤ
 */
class PolygonIDNObjAryIdx {
public:
    int mPolygonID;
    int mObjAryIdx;    
public:
    PolygonIDNObjAryIdx()
    {
	this->mPolygonID = -1;
	this->mObjAryIdx = -1;    
    }
    ~PolygonIDNObjAryIdx(){}
    PolygonIDNObjAryIdx(const PolygonIDNObjAryIdx& rhs)
    {
	this->mPolygonID = rhs.mPolygonID;
	this->mObjAryIdx = rhs.mObjAryIdx;
    }
    const PolygonIDNObjAryIdx& operator=(const PolygonIDNObjAryIdx& rhs)
    {
	if(this != &rhs)
	{
	    this->mPolygonID = rhs.mPolygonID;
	    this->mObjAryIdx = rhs.mObjAryIdx;
	}
	return(*this);
    }
    void print()
    {
	cout << "PolyID " << this->mPolygonID << ", objary index " 
	     << this->mObjAryIdx << endl;
    }
};

static int comp(const void *pAa, const void *pBb)
{
    PolygonIDNObjAryIdx *pA = (PolygonIDNObjAryIdx *)pAa;
    PolygonIDNObjAryIdx *pB = (PolygonIDNObjAryIdx *)pBb;
    
    if(pA->mPolygonID < pB->mPolygonID)
    {
	return(-1);
    }
    else if(pA->mPolygonID == pB->mPolygonID)
    {
	return(0);
    }else
    {
	return(1);	
    }
}

/*
 * ҤȤĤ Polygon ʬ
 *	IMPROVEME ߺѤη˽񤱤ФΤߤƼ
 *  @param pObjArray 	 :  PE ݻƤ object array
 *  @param pPIDnOAidxTab : polygonIDsortѤߤ PolygonIDNObjAryIdx 
 *  @param startTabIdx   : PolygonIDNObjAryIdx Ϣ³Ʊ
 *			   polygonIDϤޤ table  index
 *  @param endTabIdx 	 : Ϣ³νindex 
 *			   Ϣ³ϰϤ [startTabIdx, endTabIdx]
 */
static void aveVerIntOnePolygon(objectsArrayClass   *pObjArray,
				PolygonIDNObjAryIdx *pPIDnOAidxTab,
				const int startTabIdx, 
				const int endTabIdx)
{
    VertexIntensity senderIvc[3];
    for(int i = startTabIdx; i <= endTabIdx; i++)
    {
	const int sendOAidx = pPIDnOAidxTab[i].mObjAryIdx;
	objBaseClass *pSenderObj = pObjArray->get(sendOAidx); // 긵
	if(pSenderObj->who() == TRIANGLE_OBJ_E)	      // ѷΤ߽
	{
	    pSenderObj->getRadVer(senderIvc);
	    for(int j = startTabIdx; j <= endTabIdx; j++)
	    {
		if(i != j)	// ʬȤǤʤԤ
		{
		    assert(pPIDnOAidxTab[i].mPolygonID == 
			   pPIDnOAidxTab[j].mPolygonID);

		    const int recvOAidx = pPIDnOAidxTab[j].mObjAryIdx;

		    // ټ¦
		    objBaseClass *pGetterObj = pObjArray->get(recvOAidx);
		    if(pGetterObj->who() == TRIANGLE_OBJ_E)
		    {
			// sv ... sender vertex idx
			for(int sv = 0; sv < 3; sv++)
			{
			    // addIntensityToVertex  porigonID ĺ
			    // ΰ֤Ʊʤ鵱٤ä  
			    pGetterObj->addIntensityToVertex(senderIvc[sv]);
			}
		    }
		}
	    }
	}
    }
}

/*
 * ҤȤĤζ֤ʬ
 */
static void aveVerIntOneSpcLocal(objectsArrayClass *pObjArray)
{
    const int len = pObjArray->getLength();
    int i;

    /*
     * make { polygonID, objarray idx } array
     *	The last element is the guard. ǸϤФڤ
     */
    // cerr << "DEBUG : sorting " << len << "\t"; cerr.flush();

    PolygonIDNObjAryIdx *pPIDnOAidxTab = new PolygonIDNObjAryIdx[len + 1];
    for(i = 0; i < len; i++) 
    {
	objBaseClass *pSenderObj = pObjArray->get(i);
	pPIDnOAidxTab[i].mPolygonID = pSenderObj->getObjectID();
	pPIDnOAidxTab[i].mObjAryIdx = i;
    }
    qsort(pPIDnOAidxTab, len, sizeof(PolygonIDNObjAryIdx), comp);
    
    /*
     * search same polygon ID
     */
    // cerr << "DEBUG : update ";cerr.flush();
    for(i = 0; i < len; i++)
    {
	if(pPIDnOAidxTab[i].mPolygonID == pPIDnOAidxTab[i + 1].mPolygonID)
	{
	    // found, counting same polygonID polygon
	    int samepidnum = 1;	// I already know [i] and [i+1] is the same.
	    while(pPIDnOAidxTab[i].mPolygonID == 
		  pPIDnOAidxTab[i + samepidnum + 1].mPolygonID)
	    {
		samepidnum++;
	    }
	    
	    // Ĥ polygon ʬ
	    aveVerIntOnePolygon(pObjArray, pPIDnOAidxTab, i, i + samepidnum);

	    // for  i++ ƤΤǰĸ餷ʬä
	    // ФƤɤʼϰͤʤΤǺǸ
	    // ƱΤ³ˤפʤ褦ˤ롥
	    i += (samepidnum - 1); 
	}
    }
    delete [] pPIDnOAidxTab;
    // cerr << "DEBUG : done" << endl;    
}

//------------------------------------------------------------
// prepare Gouroud shading
//	shading Τĺε٤򴹤
//------------------------------------------------------------
void PEClass::
prepareGouroudShading(void)
{
    pm_change_area(PA_prepshade_e);
    pm_change_stat(PC_prec_intensity_e);

    // Cell Ĺĺΰ֤εƸ
    const double cellLen   = this->mSpcParam.getCellLen();
    const double tolerance = cellLen / 64.0; // Ƚ

    // PE λʪξ֤Ȥ˥󤹤
    int spx, spy, spz;
    IntVec3 peid, spcpos;
    Vector3 partVolMinPos = this->mSpcParam.getPartVolumeMin();
    if(partVolMinPos != Vector3(0.0, 0.0, 0.0))
    {
	// ¿ʬϤʤʤäȻפäΤ˰ٹ𤹤
	// 2000ǯ521()
	cerr << "Warning! : constraint as partvol min is " 
	     << "(0.0, 0.0, 0.0) may deleted. but notice." << endl;
    }
    
    for(spz = 0; spz < this->mSpcParam.getSubDivNum(); spz++)
    {
	for(spy = 0; spy < this->mSpcParam.getSubDivNum(); spy++)
	{
	    for(spx = 0; spx < this->mSpcParam.getSubDivNum(); spx++)
	    {
		//  PE ô֤
		spcpos.set(spx, spy, spz);
		peid = this->mNIUnit.mpSpc2PE->getPEIDfromSpcPos(spcpos);
		if(this->mID == peid)
		{
		    // ʪο 0 ʤ餳ζ֤ԤɬפϤʤ
		    if(this->mObjectSet.getLength(spcpos) > 0) 
		    {
			// 1.ζεͤʿѤ 
			//  1 ĤʪΤʤнɬפϤʤ
			if(this->mObjectSet.getLength(spcpos) > 1)
			{
			    aveVerIntOneSpcLocal(this->mObjectSet.get(spcpos));
			}
			
			// 2.ζε٤¾ζ֤ؤ¤
			//   ζ֤ min, max 
			const Vector3 spmin = 
			    partVolMinPos + cellLen * iv2v(spcpos);
			const Vector3 spmax = 
			    spmin + Vector3(cellLen, cellLen, cellLen);
			
			//   ʪΤФ
			objectsArrayClass *pOAry =this->mObjectSet.get(spcpos);
			this->sendVerIntOfThisSpc(pOAry, spcpos, 
						  spmin, spmax, tolerance);
		    }
		}
	    }
	}
	if(Option::getInstance()->getVerboseMode() == YES)
	{
	    cout << genHd(VERBOSEHEAD, this->getMyRank()) 
		 << " z = " << spz << endl;
	}
    }
#ifndef REDUCE_VERBOSE_INFO
    if(Option::getInstance()->getVerboseMode() == YES)
    {
	cout << genHd(VERBOSEHEAD, this->getMyRank()) << 
		"send Intensity-Vertex.. done." << endl;
    }
#endif
    //  PE ôʪΤĺ٤ϤȤꤢ塼ˤ줿
    // ȤδλȼδλƥơνλԤ 
    while(this->isPrepareShadingStageOver() == NO)
    {
	// Хåե flush
	this->mNIUnit.flushVerIntSendBuff();

	// 
	this->mNIUnit.recvVerInt();
    
	if((this->mNIUnit.isSendingVerInt() == YES) ||
	   (this->mNIUnit.isRecvingVerInt() == YES))
	{
	    // 椢뤤ϼ
	    this->toBusy(); // host ưã	    
	    this->mNIUnit.recvVerInt();
	}
	else
	{
	    // Ȥˤʤʤä
	    this->toIdle(); // host ؽλã
	}
	this->probNgetHostCommand(); // host ϢԤ
	pollingSleep();
    }

#ifndef REDUCE_VERBOSE_INFO
    if(Option::getInstance()->getVerboseMode() == YES)
    {
	cout << genHd(VERBOSEHEAD, this->getMyRank()) << 
		"get all Intensity-Vertex.. done." << endl;
    }
#endif
}

//------------------------------
// Ĥζεپ¾롣1Ĥζ֤ʪξ 
// pOAry ؤƤ롣
//------------------------------
void PEClass::
sendVerIntOfThisSpc(objectsArrayClass *pOAry, const IntVec3& srcspc, 
		    const Vector3& spmin,     const Vector3& spmax,
		    const double tolerance)
{
    const int objnum = pOAry->getLength();
    int i, ver;			
    VertexIntensity retVerInts3[3];
    for(i = 0; i < objnum; i++)
    {
	objBaseClass *pObj = pOAry->get(i);

	// ˤʤΤ radiosity Ѥ뤳Ȥǽ primitive
	// (ߤϡѥѥåΤ)
	if(pObj->who() == TRIANGLE_OBJ_E)
	{
	    // ͤФ
	    pObj->getRadVer(retVerInts3);
	    for(ver = 0; ver < 3; ver++) // ѷĺ3
	    {
		// ʪΤΰĤεͤ٤ΤɤȽ
		// 롣nonblocking Ԥ
		this->testOneIntNsendVerInt(retVerInts3[ver], srcspc, 
					    spmin, spmax, tolerance);
	    }
	}
    }
}

//------------------------------
// εپ٤ΤɤȽꤷ
//------------------------------
void PEClass::
testOneIntNsendVerInt(const VertexIntensity& v, const IntVec3& srcspc, 
		      const Vector3& spmin,   const Vector3& spmax,
		      const double   tolerance)
{
    VertexIntensity verint(v);	// verint ѹβǽ

    assert(tolerance > 0.0);
    int i;
    for(i = 0; i < 3; i++) // vector i  (x, y, z)
    {
	// ĺ϶
#ifndef NDEBUG
	if((spmax.get(i) - (verint.getVertex()).get(i)) < (-tolerance))
	{
	    cout << "Error! : vertex is out of range:Large"	<< endl;
	    cout << "min	" << spmin 		     	<< endl;
	    cout << "ver	" << (verint.getVertex())	<< endl;
	    cout << "max	" << spmax		     	<< endl;
	    cout << "out axis is [" << i << "], val = " 	<< 
		(spmax.get(i) - (verint.getVertex()).get(i))	<< endl;
	    cout << "tolerance " << (-tolerance) 		<< endl;
	    exit(1);
	}
	if(((verint.getVertex()).get(i) - spmin.get(i)) < (-tolerance))
	{
	    cout << "Error! : vertex is out of range:Small"	<< endl;
	    cout << "min	" << spmin 		     	<< endl;
	    cout << "ver	" << verint.getVertex()	<< endl;
	    cout << "max	" << spmax		     	<< endl;
	    cout << "out axis is [" << i << "], val = " 	<< 
	    	((verint.getVertex()).get(i) - spmin.get(i)) 	<< endl;
	    cout << "tolerance " << (-tolerance) 		<< endl;
	    exit(1);
	}
#endif
	// ޤϳ X,Y,Z  +- 
	if((spmax.get(i) - (verint.getVertex()).get(i)) < tolerance)
	{
	    // plus Ȥɲ(ˤʤ)
	    verint.setDestSpcPos(srcspc + AdjDir.get(i * 2));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if((verint.getVertex().get(i) - spmin.get(i)) < tolerance)
	{
	    // minus Ȥɲ(ˤʤ)
	    verint.setDestSpcPos(srcspc + AdjDir.get(i * 2 + 1));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else
	{
	    // θˤϤʤʤ
	}
    }
    // ʣ (X+Y+, X+Y-, X-Y+, X-Y- : XZ Ʊ)
    Vector3 vertexpos = verint.getVertex();
    double xp = spmax.get(Vector3::X) - vertexpos.get(Vector3::X); 
    double xm = vertexpos.get(Vector3::X) - spmax.get(Vector3::X); 
    double yp = spmax.get(Vector3::Y) - vertexpos.get(Vector3::Y);
    double ym = vertexpos.get(Vector3::Y) - spmax.get(Vector3::Y);
    double zp = spmax.get(Vector3::Z) - vertexpos.get(Vector3::Z);
    double zm = vertexpos.get(Vector3::Z) - spmax.get(Vector3::Z);
    // XY, XZ
    if(xp < tolerance) 
    {
	//----- XPlus
	if(yp < tolerance)
	{			// Y+
	    verint.setDestSpcPos(srcspc + 
				   AdjDir.get(DIR_XPLUS) + 
				   AdjDir.get(DIR_YPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// ޤ X+ θ Y+ (ߤϻȤʤ)
		// Ū Mesh η׻ǤϤΤ褦Ū2
		// ɤߤ MPI  rank ä
		//  (IMPROVEME)
		// verint.mRestDir = DIR_YPLUS; // X+ -> Y+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(ym < tolerance)
	{			// Y-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XPLUS) + 
				   AdjDir.get(DIR_YMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_YMINUS; // X+ -> Y-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
	if(zp < tolerance)
	{			// Z+
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XPLUS) + 
				   AdjDir.get(DIR_ZPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZPLUS; // X+ -> Z+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(zm < tolerance)
	{			// Z-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XPLUS) + 
				   AdjDir.get(DIR_ZMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZMINUS; // X+ -> Z-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
    }else if(xm < tolerance)
    {
	//----- X Minus
	if(yp < tolerance)
	{			// Y+
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XMINUS) + 
				   AdjDir.get(DIR_YPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_YPLUS; // X- -> Y+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(ym < tolerance)
	{			// Y-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XMINUS) + 
				   AdjDir.get(DIR_YMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_YMINUS; // X- -> Y-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
	if(zp < tolerance)
	{			// Z+
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XMINUS) +
				   AdjDir.get(DIR_ZPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZPLUS; // X- -> Z+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(zm < tolerance)
	{			// Z-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_XMINUS) + 
				   AdjDir.get(DIR_ZMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZMINUS; // X- -> Z-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
    }
    //-------------------- YZ
    if(yp < tolerance) 
    {
	//----- YPlus
	if(zp < tolerance)
	{			// Z+
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_YPLUS) + 
				   AdjDir.get(DIR_ZPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZPLUS; // Y+ -> Z+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(zm < tolerance)
	{			// Z-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_YPLUS) + 
				   AdjDir.get(DIR_ZMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZMINUS; // Y+ -> Z-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
    }else if(ym < tolerance)
    {
	//----- Y Minus
	if(zp < tolerance)
	{			// Z+
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_YMINUS) + 
				   AdjDir.get(DIR_ZPLUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZPLUS; // Y- -> Z+
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}else if(zm < tolerance)
	{			// Z-
	    verint.setDestSpcPos(srcspc + AdjDir.get(DIR_YMINUS) + 
				   AdjDir.get(DIR_ZMINUS));
	    if(this->checkInSpc(verint.getDestSpcPos()) == YES)
	    {
		// verint.mRestDir = DIR_ZMINUS; // Y- -> Z-
		this->sendVerIntToOtherSpcNrecv(verint);
	    }
	}
    }
}

//------------------------------
// پ
//------------------------------
void PEClass::
sendVerIntToOtherSpcNrecv(const VertexIntensity& verint)
{
    const IntVec3 destPEId = 
    	this->mNIUnit.mpSpc2PE->getPEIDfromSpcPos(verint.getDestSpcPos());
    if(destPEId != this->mID)
    {
 	// ֤ϼʬôΤǤϤʤä -> 

	// PEID -> rank
	int destRank = this->getRank(destPEId);

	// Τϰ new 
	VertexIntensity *pSendVerInt = new VertexIntensity(verint);

	// rank	ΤΤ
	this->mNIUnit.sendVerInt(pSendVerInt, destRank);

	// ƥ
	this->mNIUnit.recvVerInt();
	
	// λƤ塼ƤФ
	while(this->mVerIntPtrQueue.length() > 0)
	{
	    assert(this->mVerIntPtrQueue.length() > 0);
	    VertexIntensity *pV = this->mVerIntPtrQueue.deq();
	    this->addIntensity(*pV);
	    delete pV;		// Τ new Ƥ
	}
    }else
    {
 	// ֤ϼʬôΤä
 	this->addIntensity(verint);
    }
}


//------------------------------
// addIntensity
//	٤ä뤫Ĵ١ǽʤä
//	äĺοФƤ
//------------------------------
void PEClass::
addIntensity(const VertexIntensity& verint)
{
    const int destObjNum = this->mObjectSet.getLength(verint.getDestSpcPos());
    if(destObjNum > 0)
    {
	objectsArrayClass *pObjArray = 
		this->mObjectSet.get(verint.getDestSpcPos());
	int i;
	for(i = 0; i < destObjNum; i++)
	{
	    objBaseClass *pObj = pObjArray->get(i);
	    // ٲäƤɤ(ĤΥݥꥴ󤬽ޤäĺβǽ)
	    if(pObj->who() == TRIANGLE_OBJ_E) // ϸߥѥåΤ
	    {
		// ݥꥴ ID  vertex ֹӤƱʤвä
		pObj->addIntensityToVertex(verint);
	    }
	}
    }
}

//------------------------------
// finalizePrepareShadingStage
//	̿Ʋû٤ʿѤ
//------------------------------
void PEClass::
finalizePrepareShadingStage(void)
{
    Pix pidx;
    for(pidx = this->mObjList.first(); pidx != NULL; this->mObjList.next(pidx))
    {
	if(this->mObjList(pidx)->who() == TRIANGLE_OBJ_E)
	{
	    this->mObjList(pidx)->calcVerIntAveVal();
	}
    }
}


