//------------------------------------------------------------
// $Id: rayTrFRGUnit.h,v 1.2 2000/05/19 20:35:51 yamauchi Exp $
//------------------------------------------------------------
//	calcRayTrFRG.h
//
//	calculation of First Ray Generation unit for ray tracing 
//	ray-tracing ˡˤ ray 쵤ȯΤǤϤʤ
//	ĤȯƤ׻̿Ԥɤޤ ray ȯ
//	ʤɤݻɬפ롣ΤΥ饹Ǥ롣 
//
//	(C) Copyright 1996--1998 YAMAUCHI Hitoshi  
//
//	쥤ȯ
//------------------------------------------------------------
#ifndef _calcRayTrFRG_h
#define _calcRayTrFRG_h 1

#include "viewdata.h"
#include "SpaceParam.h"

class Ray;
class scrPtrIF;

//------------------------------------------------------------
// First Ray Generation Unit 
//------------------------------------------------------------
class rayTrFRGUnitClass {
private:
    rayTrFRGUnitClass(const rayTrFRGUnitClass& rhs);
    const rayTrFRGUnitClass operator=(const rayTrFRGUnitClass& rhs);
    
protected:
    int     mScanMethodOnScreen; // first ray generation method
    
    IntVec3 mPEid;
    Vector3 mViewPoint;		
    scrPtrIF *mpScreenPtr;	// screen pointer: screen  pixel ȯ
    
    Vector3 mScreenLeftUpFromVp; // ̺ؤ vector
    Vector3 mDeltaXscr;		 // screen ˤ 1 pixel ʬΥ٥ȥ X
    Vector3 mDeltaYscr;		 // 					 Y
    int     mMaxRaysInAPixel;	 // 1 pixel ȯä ray ܿ
    int     mGenRayParPixel;	 // ߤ pixel ФƲ ray ȯä
    YorN    mCanGenerateNextRay; //  ray ȯǽ
 
    // [־]
    Vector3 mDefSpcMin;		// [־] 
    Vector3 mDefSpcMax;
    Vector3 mPartVolMinPos;	// Partition volume κǾ
    double  mSubDivNum;		// ʬֿ
    double  mPartVolOneSize;	// ֤ΰդĹ
      
    // 
    IntVec3 mVpSpcPos;		 // ¸߶ְ(λ)
    YorN    mIsVpInDefSpc;	 // ˤ뤫
    int     mNumOfTotalGenRays;	 // ߤޤǤ ray ȯ
    double  mDistRaysFactor;	 // ray1ĤβǤؤδͿγ ʬ 
    // 				 // raytrace  4/pixel ʤ 1/4 

    // screen 
    int	    mScrX;
    int	    mScrY;

protected:
    // screen pointer(ʬ쥤ʤɤɤΤ褦ȯ뤫 Strategy) 
    // νȤȼ member νȤСmVpSpcPos ʤ
    // ϻ֤򼨤ϽʬԤ
    // ɤ˿äƤΤǤǽ롥
    void initForScreenPointer(int scrSizeX, int scrSizeY,  
			      int myRank,   int totalPEnum);
    void initForAllScanMethod(int scrSizeX, int scrSizeY);
    void initForScanlineScanMethod(int scrSizeX, int scrSizeY,  
				   int myRank,   int totalPEnum);
    void initForDistributedScanMethod(int scrSizeX, int scrSizeY,
				      int myRank,   int totalPEnum);

    void moveOnScreen(void);	//  pixel ذư

    // ֤λɸ֤
    IntVec3 getSpcposOfaPoint(const Vector3& pos) const; 

    // view vector generator
    inline Vector3 genViewVec(void) const;
 
    // ray generator
    Ray *newOneRayVpInDefineSpc(void) const; // ˤ
    Ray *newOneRayVpOutOfDefSpc(void) const; // ֳˤ
	
public:
    rayTrFRGUnitClass(void);
    //------------------------------
    // init 
    //	@param rayGenerationMethod : ʬ ray ˡ(Allscan  ScanlineScan)
    //  @param viewDat	: ΰ֡ʤɤλ
    //  @param spcDat	: ־
    //  @param PEid	: νȯ˥åȤ° PE  ID
    //  @param totalPEnum : ƥ PE  (ʬɬ)
    //  @param myRank 	: ʬ rank (0 Ϥޤ)
    void init(int	     	     rayGenerationMethod,
	      const ViewDataClass&   viewDat, 
 	      const SpaceParam&      spcDat, 
 	      const IntVec3& 	     PEid,
	      int   	 	     totalPEnum,
	      int 		     myRank);
    
    YorN canGenerateNextRay(void) const { return(this->mCanGenerateNextRay); }
    Ray *newNextRay(void);
    int       getTotalGenRays(void) const { return(this->mNumOfTotalGenRays); }
    int  getScanMethodOnScreen(void) const{ return(this->mScanMethodOnScreen);}
};

#endif				// #ifndef _calcRayTrFRG_h
