#!/bin/sh -x
#
#
rm save.out

if [ $# != 1 ] ; then 
	echo "Usage: ./tes.sh [num]"
	exit;
fi

starttime=`date`
#------------------------------
# data dir
#------------------------------
datadir=../../../data/testMpi2Data
# datadir=../../mpi2data/my_soda

#------------------------------
# machine file
#------------------------------
mpirunoption='-machinefile /usr/local/mpich/util/machines/machines.freebsd'
# mpirunoption='-machinefile /usr/local/mpich/util/machines/machines.solaris'

#------------------------------
# mpi2 option
#------------------------------
mpi2option=-dv
# mpi2option=-vs

#------------------------------
# data file basename
#------------------------------
file=4tri.mpi2
# file=room16.mpi2
# file=my_soda.mpi2
# file=head

#------------------------------
# volume and geometry ξ
#------------------------------
# mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/$file.spc -fmat $datadir/$file.mat -fgeo $datadir/$file.geo -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fvinl ../../../data/volumedata/sampledat/4tri.volinlist -fsaveppm save.out

#------------------------------
# geometry only
#------------------------------
# mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/$file.spc -fmat $datadir/$file.mat -fgeo $datadir/$file.geo -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fsaveppm save.out

#------------------------------
# volume only
#------------------------------
# mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/$file.spc -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fvinl ../../test/dividedvol/sample.volin.list -fsaveppm save.out

#-----------------------------
# test for new version
#-----------------------------
# mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/$file.spc -fmat $datadir/$file.mat -fgeo $datadir/$file.geo -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fsaveppm save.out

#-----------------------------
# test for volume head data 
#-----------------------------
# mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/head.spc -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/head.view -fvinl $datadir/head.volin.list -fsaveppm save.out

datadir=../../../data/volumedata/3Dhead_pgm

mpirun $mpirunoption -np $1 ./mpi2 $mpi2option -fspc $datadir/head.spc -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/head.view -fvinl $datadir/head.volin.list2 -fsaveppm save.out

echo "start time = $starttime"
echo "end   time = `date`"

