//------------------------------------------------------------
// $Id: volume.h,v 1.2.2.1 2000/06/14 15:00:10 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 define volume class
// 	Volume Rendeing 
// 1998ǯ120()
// 1998ǯ216() volume ɽ grid äȤ˵Ĥ
// ľϤ롣Lovoy ʸ 
// @Article{Levoy1988,
//   author = 	 "Marc Levoy",
//   title = 	 "Display of Surfaces from Volume Data",
//   journal =	 "IEEE Computer Graphics and Applications",
//   year =	 1988,
//   volume =	 8,
//   number =	 5,
//   pages =	 "29--37",
//   month =	 "May",
// }
// ɤǤʤ (Figure 2) ѤɽȤƽ񤤤Ƥޤä
// ץ뤹ˤ grid ȤƷ׻Ȥǥΰݤʤ
// ץ񤤤Ƥޤäᡢ쥤㥹ƥ󥰻˼ʤХ
// äƤޤä 
//
// ʸ Figure 2 ˹פ褦˼롣
// 
//     |   |   |   |   |   slice  = 5
// 
//     +---+---+---+---+   grid point 5
//     |   |   |   |   |   volume   4 (դ)
//     +---+---+---+---+    grid ǻ
//     |<------------->|   äʬʬ䤵üϥԡ
// volume,grid min    volume,grid max
//
// ϰϤ [cellmin_i, cellmax_i) Ǥ뤳Ȥդ뤳
//
// 1998ǯ412() 
//	grid ϥץ󥰥ݥȤǤꡢ饤ʤɤ grid °롣
//	volume ϤΥץ󥰥ݥȤ鹽ΤǤäơ
//	grid ȤбȤΤϾˤ롣򲼤˼
//
// *** volume μΤ grid Ǥ롣
//     -> ¤ grid ռʤˤ volume Ȥ̾ǥ
//
// 1.  g---g
//     |   | voxel(voxel ͤϤ֤ͤ롣lower left ɽ
//     g---g       ͤˤʤɤͤ)
//     |<->|
// 	voxel length
//   g  grid 
// 
//	Copyright (C) 1997--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _volume_h
#define _volume_h 1

#include <stdio.h>
#include <iostream.h>
#include "GridColor.h"
#include "IntVec3.h"
#include "Vector3.h"
#include "YorN.h"
#include "array3d.h"
#include "pnmReader.h"
#include "ray.h"
#include "volumeGridInfo.h"

//------------------------------------------------------------
// ʬ䤵줿ܥ塼ޤեˤϺ 5 ԤΥȤ롥
// οʬܥ塼फɤȽǤ뤳Ȥˤ롥
//------------------------------------------------------------
const int AT_LEAST_COMMENTS_WITHSUBDIVIDED_VOL = 5;


class VolDistClass;
//------------------------------------------------------------
// volume 򼨤 class 
// 	volume  global volume  sub volume ͤ
// 	global volume Ȥʬ volume ΤȤ global volume ʬ
// 	䤵줿줾줬 sub volume Ǥ롣Ʊ global volume 
// 	ʬ䤵줿 volume Ʊ ID ġΤ褦ˤ뤳Ȥʬ
// 	줿 volume 礬ñˤʤ롣
//	
//	 : global volume Ȥƥ
//------------------------------------------------------------
// Υ饹ν
//	1.initGlobalGridInfo   
//	2.initSubGridInfo	: grid  array Ƥ alloc Ԥ
// 	3.grid ΤΤν
//	4.calcEffectiveGridRange	
// Ǵˤʤ롥ʬˤ 4  2 ΰ(ְ, subgrid ϰ)
// ɤʤȤʤɤʬΥƤ롥꤯񤱤Τ
//------------------------------
class VolumeClass { //  : public DividableIF, public SerializableIF{ 
protected:
    array3dClass < GridColorClass > mGrid; // grid data
    GlobalGridInfoClass    mGlobalGrid;	   // ʬ global  volume ξ
    SubGridInfoClass       mSubGrid;	   // ʬʬ volume ξ
    EffectiveGridInfoClass mEffiGrid;	   // ζ֤ͭ Grid ϰ
    
protected:
    YorN checkCanAddPNM(PNMReader *pPNMBuf) const;
    void keepConsistentWithPNM(PNMReader *pPNMBuf);
    YorN checkCanAddVolume(VolumeClass *pAddVolume) const;

public:
    // constructors (ͤƤ)
    VolumeClass(void);
    VolumeClass(const VolumeClass& rhs);
    const VolumeClass& operator=(const VolumeClass& rhs);
    ~VolumeClass(void);

    friend int operator == (const VolumeClass& a, const VolumeClass& b);
    
    // null volume ȤƤν 
    void initAsNullVolume(void);
    YorN isNullVolume(void) const { return(this->mGlobalGrid.isNullVolume());}

    // initializer 
    void initSize(const int *pGridMinIdx, const int *pGridMaxIdx);
    YorN calcEffectiveGridRange(const Vector3& cellMinPos, 
  				const Vector3& cellMaxPos);
    YorN isInited(void) const;	// already initialized or not 

    //------------------------------
    //  global volume Ȥƥ 
    // GridColorClass ο [0.0, 1.0] 
    // grid          index  [gridmin index, gridmax index] ϰ
    // effectiveGrid index  [effectiveMin, effectiveMax]   ϰ
    //------------------------------
    void setGlobalGridIdxColor(int globalIdx[], const GridColorClass& aCol)
    {
 	this->mGrid.set(globalIdx, aCol);
    }
    GridColorClass getGlobalGridIdxColor(int globalIdx[]) const
    {
 	return(this->mGrid.get(globalIdx));
    }
    GridColorClass getGlobalEffiGridIdxColor(int volumeGlobalIdx[]) const;
    int getGridResSize(int dim) const 	{ return(this->mGrid.getSize(dim));}
    int getGridMinIdx(int dim)  const 	{ return(this->mGrid.getMinIdx(dim));}
    int getGridMaxIdx(int dim)  const 	{ return(this->mGrid.getMaxIdx(dim));}
    int getTotalGridNum(void)   const	{ return(this->mGrid.getTotalSize());}
    int getGlobalGridResSize(int dim) const
    {
 	return((this->mGlobalGrid.getResolSize()).get(dim));
    }

    //------------------------------
    // global grid info
    //------------------------------
    // ID (set ʤȽ줿Ȥˤʤʤ)
    int  getID(void) const		{ return(this->mGlobalGrid.getID());}
    void initGlobalGridInfo(const GlobalGridInfoClass &gginfo);	// init gginfo
    const GlobalGridInfoClass &getGlobalGrid(void) const 
    {
	return(this->mGlobalGrid);
    }
    double getVoxelEdgeLen(void) const
    {
 	return(this->mGlobalGrid.getVoxelEdgeLen()); 
    }
    int getGridRGBDepth(void) const { return(this->mGlobalGrid.getRGBDepth());}

    //------------------------------
    // sub grid info manipulation
    //------------------------------
    void initSubGridInfo(const SubGridInfoClass &sginfo);// subinfoˤ
    const SubGridInfoClass &getSubGrid(void) const 
    {
	return(this->mSubGrid);
    }
    IntVec3 getSubVolumeSpcPos(void) const
    {
 	return(this->mSubGrid.getSpcPos());	
    }

    //------------------------------
    // effective grid info manipulation
    //------------------------------
    void initEffiGridInfo(const EffectiveGridInfoClass& eginfo);
    const EffectiveGridInfoClass& getEffiGrid(void) const
    {
	return(this->mEffiGrid);
    }
    void invalidateEffiGridInfo(void);

    //------------------------------
    // subvolume manipulation
    //------------------------------
    // add subvolume to this volume 
    void addPNM(PNMReader *pPNMBuf);
    PNMReader *getNewPNM(int zpos);
    PNMReader *getNewPNM(void);
    void addSubVolume(VolumeClass *pGrid);

    // get physical position from volume index
    YorN    checkGridIdxRangeForDEBUG(int idx[]) const;
    YorN    checkGridIdxRangeForDEBUG(const IntVec3& idx) const;
    Vector3 getGlobalGridPosFromIdx(int idx[]) const; //with check
    Vector3 getGlobalGridPosFromIdxNoRangeCheck(int idx[]) const;

    // global grid info  sub grid info ֤ΰ check 
    YorN isConsistentGlobalAndSubGridInfo(void) const;
     
    void print(void) const;	// print this volume property
    YorN isAllFill(void);	// check not initialized voxel

public:				
    //------------------------------------------------------------
    // interface DividableIF Ȥʤͽ
    //------------------------------------------------------------
    VolumeClass *newSubVolume(int minGridIdx[], int maxGridIdx[], 
 			      const IntVec3& spcpos) const;

public:				
    //------------------------------------------------------------
    // casting a ray to this volume supporting methods 
    // ref. volumeRayCast.cc
    //------------------------------------------------------------
    IntVec3 getGlobalVolumeIndexFromPos(const Vector3& pos);
    YorN castRay(Ray *pRay, const VolDistClass* const pVolDist, 
		 Vector3 *pRetColor);

public:				
    //------------------------------------------------------------
    // SerializableIF : double ɽƱ׻ǤʤȾ꤯ʤ    
    // ref. volumeSerializable.cc
    //------------------------------------------------------------
    int getSerializedSize(void) const;
    double *newSerializedArray(void);
    void deserialize(double *pBuf);
};

#endif				// #ifndef _volume_h 
