//------------------------------------------------------------
// $Id: volumeSet.h,v 1.1.1.1 1999/11/25 06:26:10 yamauchi Exp $
//------------------------------------------------------------
// 	volume set (objectSetClass ) 
//	(M\pi)^2 
//
//	volume  PE ݻݤѤ륯饹
//	˶(Ūʶ֤ǤϤʤΥ饹δ礭
//	 indexΥ饹 PE ΥȥݥʤɤΤʤ)  
//	index ͿȤζ֤°ʪΤ
// 	϶֤®٤Υȥ졼ɥդѲͽ
//	ޤ1ˤ
//	objectSet ȻƤΤ template ͤ٤ä? 
//	1998/2/9
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _volumeSet_h
#define _volumeSet_h 1

#include "SLList.h"
// #include "mpi2.h"
#include "volume.h"
#include "mpi2exit.h"

class VolumeSetClass {
protected:
    IntVec3 	mLocalSpcNum;	//  volume åȤô֤ο
    // 				// ʬ (1 / PE )
    SLList < VolumeClass * > *mpVolList; // volume ؤΥݥ󥿤ΥꥹȤ
    
protected:
    void delElems(void)
    {
	if(this->mpVolList != NULL)
	{
	    delete [] this->mpVolList;	    
	}
	this->mpVolList = NULL;	    	
	this->mLocalSpcNum = IllegalPEID;	// set(-2, -2, -2);	
    }
    YorN localIdxOK(const IntVec3& localIdx) const
    {
	if((0 <= localIdx.get(IntVec3::X)) &&
	   (0 <= localIdx.get(IntVec3::Y)) &&
	   (0 <= localIdx.get(IntVec3::Z)) &&
	   (localIdx.get(IntVec3::X) < this->mLocalSpcNum.get(IntVec3::X)) &&
	   (localIdx.get(IntVec3::Y) < this->mLocalSpcNum.get(IntVec3::Y)) &&
	   (localIdx.get(IntVec3::Z) < this->mLocalSpcNum.get(IntVec3::Z)))
	{
	    return(YES);
	}else
	{
	    cout << "Error! :: VolumeSetClass::idxOK idx = " << localIdx << 
		", total space num = " << this->mLocalSpcNum << endl;
	    abort();
	    commMpi2_exit(1);
	    return(NO);
	}
    }
    int  getLocalIdxFromLocalXYZ(int x, int y, int z) const
    {
	return(z * this->mLocalSpcNum.get(IntVec3::Y) * 
	       this->mLocalSpcNum.get(IntVec3::X) +
	       y * this->mLocalSpcNum.get(IntVec3::X) +
	       x);
    }
public:
    VolumeSetClass(void) : mpVolList(NULL) {}
    ~VolumeSetClass(void){ this->delElems();	}
    void init(const IntVec3& aLocalTotalSpcNum);
    void add(const IntVec3& a3dIdx, VolumeClass* pVol);
    SLList < VolumeClass * > *getList(const IntVec3& a3dIdx);
    SLList < VolumeClass * > *getListAs1DimArray(int innerIndex); // Ĵ
    void getAllElementAsList(SLList < VolumeClass * > * pRetList);
    IntVec3 getTotalLocalSpaceIntVec3(void)const{ return(this->mLocalSpcNum); }
    int getTotalLocalSpaceNum(void) const;
    void print(void);
    
};


#endif				// #ifdef _volumeSet_h
