//------------------------------------------------------------
// $Id: mpi2ReaderClass.cc,v 1.5.2.1 2000/06/14 15:00:11 yamauchi Exp $
//------------------------------------------------------------
//	mpi2ReaderClass.cc
//	read (M\pi)^2 data file implementation 
//	(this data format is delived mgf data format)
//
//	1996/9/25
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//	refer readfile.doc
// 
// 1997-3-21 ɤ߹ߤʤʤɤνǤʤƤϺȤ
// ȤȽΤǽľɬפȤʤä 
//
// 1997ǯ831() ʶ֤򥹥åפ롣omega net Τ
// ˤɤǤ̿ǤꤷƤ
//------------------------------------------------------------
#include "mpi2exit.h"
#include "mpi2ReaderClass.h"
#include "constants.h"
#include "SpaceParam.h"

extern YorN readSpcparamFile(const char *spcpmFile,  SpaceParam *pSpcPrm);

//------------------------------------------------------------
// protected functions
//------------------------------
// ɤ߹ߡƬ򸫤ƲȽ̤
//------------------------------
int mpi2ReaderClass::
getFirstTokenOfLine(void)
{
    static char ftokenbuff[MAX_LINE]; // ǽ token ֤Хåե
    char *retptr = fgets(this->mReadBuff, MAX_LINE, this->mpFp);
    this->mReadLine++;			// ɤ߹Կ
    if(retptr == NULL)
    {
	return(EOF_tkn);
    }

    // ƬζʸˤϷٹȯäƥȤȤߤʤ
    if((this->mReadBuff[0] == ' ') && (this->mReadBuff[0] == '\t')) 
    {
	cout << "host:: Warning! : There is white space at top of "
	    "line at " << this->mReadLine << endl;
	return(COMMENT_tkn);
    }

    // Ƭ \n λˤ϶ԤǤꡢȤƱ
    if((this->mReadBuff[0] == '\n') || (this->mReadBuff[0] == '#'))
    {
	return(COMMENT_tkn);
    }

    // ʸǤʤʬ򥳥ԡ
    for(this->mIdx = 0; 
	(this->mReadBuff[this->mIdx] != ' ')  && 
	(this->mReadBuff[this->mIdx] != '\t') && 
	(this->mReadBuff[this->mIdx] != '\n') &&
	(this->mReadBuff[this->mIdx] != '\0');
	this->mIdx++)
    {
	ftokenbuff[this->mIdx] = this->mReadBuff[this->mIdx];
    }
    // Ǹ \0 ƶڤȤ 
    // 	   -> mIdx ϸbuffκǽζؤƤ
    ftokenbuff[this->mIdx] = '\0';
    int i;
    for(i = 0; FirstToken[i].name != NULL; i++)
    {
	if(strcmp(ftokenbuff, FirstToken[i].name) == 0)
	{
	    return(FirstToken[i].tokenID);
	}
    }
    cout << "Error! : command not found. mpi2ReaderClass::"
    	"getFirstTokenOfLine() at line " << this->getReadLineNum() << 
	" of [" << this->mFilename << "]" << endl;
    return(FIRST_TOKEN_ELSE_tkn);    
}

//------------------------------
// ԤλĤοʬβ
//	οʬ double ֤ͤ
// 	ǰʤ餳Ƥ餽Τ getNextString Ƥ֤ȤϤǤʤ
//	饹Υݥ mIdx 򹹿Ƥʤ
//------------------------------
YorN mpi2ReaderClass::
getRestDoublePart(int numberOfArgs, double retvals[])
{
    int i;
    char *ptr = NULL;
    char *pNumStartPtr = &(this->mReadBuff[this->mIdx]);
    for(i = 0; i < numberOfArgs; i++)
    {
	ptr = NULL;
	// strtod  arg οʬβŬѤ
	retvals[i] = strtod(pNumStartPtr, &ptr);
	if(pNumStartPtr == ptr)	
	{
	    // no conversion äˤ ptr ʤǤʤ
	    cout << "Error! : number of argment must be " <<
		numberOfArgs << " at line " << this->mReadLine << endl;
	    return(NO);
	}
	pNumStartPtr = ptr;
    }
    return(YES);
}

//------------------------------
// ɤ߹ʸκǽ token Ƭζʸ
// ԡ֤ pRetStr ϸƤӽФ¦ǳݤ뤳
// θƤӽФưĤʸ֤饹βϥݥ󥿤ʤ
//------------------------------
void mpi2ReaderClass::
getNextString(char *pRetStr)
{
    // ƬζɤФ
    while((this->mReadBuff[this->mIdx] == ' ') || 
	  (this->mReadBuff[this->mIdx] == '\t'))
    {
	this->mIdx++;
    }

    // ޤޤʤʸνޤǥԡ
    int i;
    for(i = 0; 
	(this->mReadBuff[this->mIdx] != ' ')  && 
	(this->mReadBuff[this->mIdx] != '\t') &&
	(this->mReadBuff[this->mIdx] != '\n') && 
	(this->mReadBuff[this->mIdx] != '\0');
	this->mIdx++, i++)
    {
	pRetStr[i] = this->mReadBuff[this->mIdx];
    }
    pRetStr[i] = '\0'; 
}

//------------------------------------------------------------
// public functions
//------------------------------------------------------------
// destructor
//------------------------------
mpi2ReaderClass::
~mpi2ReaderClass(void)
{
    if(this->mpFp != NULL)
    {
	fclose(this->mpFp);
    }
};

//------------------------------
//  get 벿ʤΤǡϲƤɤ褦˽
//	token ֤ token ˤߤäֵѤ롣
//	ƤӽФΰϼΤݤΤϤ
//------------------------------
int mpi2ReaderClass::
getOneLine(int *pNumOfToken, double retval[], char *pRetStr)
{
    int  tkn = this->getFirstTokenOfLine();
    YorN isOK = YES;		// οä?
    switch(tkn)
    {
    case TRIANGLE_POLY_tkn:	case TRIANGLE_POLY_WITH_RADIO_tkn:
    case SPHERE_tkn:		case CYLINDER_tkn:
    case CONE_tkn:		case RING_tkn:
    case TORUS_tkn:
	(*pNumOfToken) = FirstToken[tkn].numberOfToken;
	isOK = this->getRestDoublePart((FirstToken[tkn].numberOfToken - 1),
				       retval);
	// ޥ̾ʬ arg οʤΤ - 1
	pRetStr[0] = '\0';
	break;

    case DIFF_REF_tkn:		case DIFF_TRANS_tkn:
    case DIFF_EMIT_tkn:		case SPEC_REF_tkn:
    case SPEC_TRANS_tkn:	case INDEX_REF_tkn:
    case IES_tkn:		case FRUSTUM_HALFTOPRAD_tkn:
	(*pNumOfToken) = FirstToken[tkn].numberOfToken;
	// material ̾
	this->getNextString(pRetStr);
	// Ĥΰ (ޥ̾ + ̾) ʬ 2 
	isOK = this->getRestDoublePart(FirstToken[tkn].numberOfToken - 2,
				       retval);
	break;

    case MATERIAL_NAME_tkn:
	(*pNumOfToken) = FirstToken[tkn].numberOfToken;
	this->getNextString(pRetStr);
	break;

    case EOF_tkn:
    case COMMENT_tkn:
	break;

    case FIRST_TOKEN_ELSE_tkn:
    default:
	cerr << "Error! : parse error. Is this file mpi2 format file?"
	    << endl;
	commMpi2_exit(1);
	break;
    }

    if(isOK == YES)
    {
	return(tkn);
    }else
    {
	return(ERROR_tkn);
    }
}

//------------------------------
// YorN open(const char *pFilename);
//	ɤ߹եλ( YES:  NO)
//------------------------------
YorN mpi2ReaderClass::
open(const char *pFilename)
{
    // already open ?
    if(this->mpFp != NULL)
    {
	cout << "Error! : can't open " << pFilename << ". because of " << 
	    this->mFilename << " is already opened at mpi2ReaderClass::open." 
		<< "(only one file can be opened at once.) " << endl;
	return(NO);
    }

    // filename is OK?
    if((pFilename == NULL) || (pFilename[0] == '\0'))
    {
	cout << "Error! : illegal filename (null or 0) at "
	    "mpi2ReaderClass::open" << endl;
	return(NO);
    }

    // can open file?
    if(strncmp(pFilename, "(stdin)", strlen("(stdin)")) == 0)
    {
	this->mpFp = stdin;
    }
    else if((this->mpFp = fopen(pFilename, "r")) == NULL)
    {
	cout << "Error! : can't open " << pFilename << " mpi2ReaderClass::open"
	    << endl;
	return(NO);
    }

    // all correct
    this->mFilename = myString(pFilename);
    this->mReadLine = 0;
    this->mIdx = 0;
    return(YES);
}

//------------------------------
// YorN close(void);
// 	եΥ
//------------------------------
YorN mpi2ReaderClass::
close(void)
{
    if(strncmp(this->mFilename, "(stdin)", strlen("(stdin)")) == 0)
    {
	// nothing to do
	return(YES);
    }
    else if(this->mpFp != NULL)
    {
	fclose(this->mpFp);
	return(YES);
    }else
    {
	cout << "Warning! : called close but no file is opened at " << 
	    "mpi2ReaderClass::close" << endl;
	return(NO);
    }
};

//------------------------------------------------------------
// material ɤ߲ material ΥꥹȤ롣
//------------------------------------------------------------
// material θԤ
//	¸ߤˤϥꥹȤ椫 current material ֤
//	¸ߤʤˤϥꥹȤɲä current material Ȥ
//	֤
//------------------------------
materialClass *searchAndNewAdd(const char *pMatName, 
			       SLList < materialClass * > *pMatList)
{
    YorN isFind = NO;
    Pix pidx;
    materialClass *pMat = NULL;
    for(pidx = pMatList->first(); pidx != NULL; pMatList->next(pidx))
    {
	pMat = (*pMatList)(pidx);
	if(strncmp(pMatName, pMat->getName(), MAX_MATERIAL_NAME_LEN) == 0)
	{
	    isFind = YES;
	    break;
	}
    }
    if(isFind == YES)
    {
	return(pMat);
    }else
    {
	materialClass *pm = new materialClass;	
	pm->setName(pMatName);
	pMatList->append(pm);
	return(pm);
    }
}

//------------------------------
// material reader
//	pMatList λؤ material μΤ new ƤΤ
//	pMatList Ѥ delete 뤳
//------------------------------
YorN readMatInfo(const char *pMatFname, SLList < materialClass * > *pMatList)
{
    assert(pMatFname != NULL);
    assert(pMatList  != NULL);
    static const Vector3 zero(0.0, 0.0, 0.0);

    mpi2ReaderClass matReader;
    if(matReader.open(pMatFname) == NO)
    {
	cout << NORMALHEAD << " host : Error! : can't open mat file ["
	     <<  pMatFname  <<  "]"  <<  endl;
	commMpi2_exit(1);
    }
    int 	tkn;
    double 	retval[MAX_MPI2_ARGNUM];
    char 	retStr[MAX_LINE];
    int 	numOfTkn;
    materialClass *pCurMat = NULL; // ܤƤޥƥꥢ
    char matname[MAX_MATERIAL_NAME_LEN];
    const char *pMsg = " host : Warnig ! redefined ";

    do {
	tkn = matReader.getOneLine(&numOfTkn, retval, retStr);
	switch(tkn)
	{
	case COMMENT_tkn:	// Ȥʤ鲿⤷ʤ
	case EOF_tkn:		// EOF ʤ while ξȴ
	    break;
	    
	case MATERIAL_NAME_tkn:
	    if(strlen(retStr) >= MAX_MATERIAL_NAME_LEN)
	    {
		cout << NORMALHEAD << " host : Warning! too long material name"
		  "[" << retStr << "]. material name is changed. at line " <<
		  matReader.getReadLineNum() << endl;
	    }else
	    {
		// ̾򥳥ԡƥꥹȤõ̵ХꥹȤɲä
		// ܤ material ֤
		strncpy(matname, retStr, MAX_MATERIAL_NAME_LEN);
		pCurMat = searchAndNewAdd(matname, pMatList);
	    }
	    break;

	case DIFF_REF_tkn:
	    if(pCurMat->getDiffRef() != zero)
	    {
		cout << NORMALHEAD << pMsg << (pCurMat->getName()) << 
		" of rd" << endl;
	    }
	    pCurMat->setDiffRef(Vector3(retval[0], retval[1], retval[2]));
	    break;

	case DIFF_TRANS_tkn:
	    if(pCurMat->getDiffTrans() != zero)
	    {
		cout << pMsg << (pCurMat->getName()) << " of td" << endl;
	    }
	    pCurMat->setDiffTrans(Vector3(retval[0], retval[1], retval[2]));
	    break;

	case DIFF_EMIT_tkn:
	    if(pCurMat->getDiffEmit() != zero)
	    {
		cout << pMsg << (pCurMat->getName()) << " of ed" << endl;
	    }
	    pCurMat->setDiffEmit(Vector3(retval[0], retval[1], retval[2]));
	    break;

	case SPEC_REF_tkn:
	    if(pCurMat->getSpecRefCosN() != 0.0)
	    {
		cout << pMsg << (pCurMat->getName()) << " of rs" << endl;
	    }
	    pCurMat->setSpecRefCosN(retval[0]);
	    pCurMat->setSpecRef(Vector3(retval[1], retval[2], retval[3]));
	    break;

	case SPEC_TRANS_tkn:
	    if(pCurMat->getSpecTransCosN() != 0.0)
	    {
		cout << pMsg << (pCurMat->getName()) << " of ts" << endl;
	    }
	    pCurMat->setSpecTransCosN(retval[0]);
	    pCurMat->setSpecTrans(Vector3(retval[1], retval[2], retval[3]));
	    break;

	case INDEX_REF_tkn:
	    //tokunaga change:
	    //ɤ߹ߤޤҤȤޤʣǿ̵롣
	    pCurMat->setIdxRefraction(retval[0]);
	    break;

	case FRUSTUM_HALFTOPRAD_tkn:
	    pCurMat->setFrustumHalfTopRad(retval[0]);   
	    break;
    
	case IES_tkn:
	    cout << "Error! : unsupported ies." << endl;	    
	    commMpi2_exit(1);
	    break;

	case ERROR_tkn:
	default:
	    cout << "Error! : Illegal token in mat file [" <<
		pMatFname << "] at line " << matReader.getReadLineNum()
		    << endl;
	    commMpi2_exit(1);
	}
    }while(tkn != EOF_tkn);

    if(pMatList->length() > 0)
    {
	return(YES);	
    }else
    {
	cout << "Error! : no material data. in [" << pMatFname << "]" << endl;
	commMpi2_exit(1);
	return(NO);
    }
}

//------------------------------------------------------------
// geometry ɤ߲ : geoReaderClass implementation
//	geometry ɤˤ object ֤褦 open  get 
//	ʬΥ
//------------------------------------------------------------
// getIdxOfmatTable : 2 ʬõ
//	material  table ̾򸡺
//	¸ߤʤˤ -1 ֤
//------------------------------
int geoReaderClass::
getIdxOfmatTable(const char *pMatName)
{
    assert(this->mpMatArray != NULL);
    int min = 0;
    int max = this->mTableSize;
    int middle  = (min + max) / 2;
    int comp;
    while(min != max)
    {
	comp = strncmp(this->mppMatNameTable[middle], pMatName,
		       MAX_MATERIAL_NAME_LEN);
	if(comp > 0)
	{			// ߤΰ֤ϸ夹ΤϰϤθ˰ư
	    max = middle;
	}else if(comp < 0)
	{			// ߤΰ֤ΤϰϤ˰ư
	    if(min == middle)
	    {
		// ⤦middleϰưʤ(min+max)/2ɬmin
		// max꾮ʤƤϤʤڼΤƤΤᡤ
		// minƱˤʤ礬뤽κݤˤõ
		// ΥХ2000ǯ516()ޤȯʤä
		return(-1);	
				// 
	    }
	    min = middle;
	}else			// comp == 0 -> match
	{
	    return(middle);
	}
	middle = (min + max) / 2;
    }
    // (min == max) ȤʤäΤõλ -> match ʤä
    return(-1);
}

//------------------------------
// open : filename  material name table Ϥ
//	  material name table μΤϸƤӽФ¦Ѱդ
//	  Ƥ check ƻѤ롣
//	  material table ϸΤ sort ΤϤñ 
//	  check Ԥ 
//------------------------------
YorN geoReaderClass::
open(const char *pGeoFName, int tableSize, char **appMatNameTab, 
     materialClass *pMatArray)
{
    if(this->mpGeoReader != NULL)
    {
	cerr << "Error! : geometry file is already opened, not open [" 
	    << pGeoFName << "]" << endl;
	commMpi2_exit(1);
    }
    if((tableSize <= 0) || (appMatNameTab == NULL))
    {
	cerr << "Error! : no material name table. "
	    "at geoReaderClass::open" << endl;
	commMpi2_exit(1);	
    }
    if(pMatArray == NULL)
    {
	cerr << "Error! : no material array. at geoReaderClass::open" << endl;
	commMpi2_exit(1);	
    }

    this->mpGeoReader = new mpi2ReaderClass;
    if(this->mpGeoReader->open(pGeoFName) == NO)
    {
	return(NO);
    }
    // check material table contents
    int  i;
    for(i = 0; i < tableSize; i++) 
    {
	// ۾ʤΤ¸ߤƤʤǧ
	if((appMatNameTab[i] == NULL) || (appMatNameTab[i][0] == '\0'))
	{
	    cerr << "Error! : material table has illegal entry at " 
		"geoReaderClass::open" << endl;
	    commMpi2_exit(1);	
	}
    }
    for(i = 0; i < (tableSize - 1); i++)
    {
	// sort Ѥߤǧ
	if(strncmp(appMatNameTab[i], 
		   appMatNameTab[i + 1], MAX_MATERIAL_NAME_LEN) > 0)
	{
	    cerr << "Error! : material table is not sorted." << endl;
	    cerr << "[" << i << "] = " << appMatNameTab[i]      << endl;
	    cerr << "[" << i << "] = " << appMatNameTab[i + 1]  << endl;
	    commMpi2_exit(1);		    
	}
    }

    // ǧѤߤ table 
    this->mppMatNameTable = appMatNameTab;
    this->mTableSize	  = tableSize;
    this->mCurMatIdx = -1;
    this->mpMatArray	  = pMatArray;
    return(YES);
}

// close
YorN geoReaderClass::
close(void)
{
    if(this->mpGeoReader == NULL)
    {
	cout << NORMALHEAD << 
	     " hosts : Error! : not opened geometry file. ignred." << endl;
	return(NO);
    }else
    {
	this->mppMatNameTable   = NULL;
	this->mTableSize	= -1;
	this->mCurMatIdx 	= -1;
	YorN closeStat = this->mpGeoReader->close();
	this->mpGeoReader = NULL;
	return(closeStat);
    }
}

// get : ɤ߹Ԥ token Ȱ֤
int geoReaderClass::
getOneGeoData(objBaseClass **ppObject)
{
    int tkn;
    int numOfTkn;
    double retvals[MAX_MPI2_ARGNUM];
    static char retStr[MAX_LINE];
    
    // comment ɤФ
    // material name ξˤϵϿɤФ
    while(1)
    {
	tkn = this->mpGeoReader->getOneLine(&numOfTkn, retvals, retStr);
	if(tkn == MATERIAL_NAME_tkn)
	{			// material name ʤ current ȤƵϿ
	    this->mCurMatIdx = this->getIdxOfmatTable(retStr);
	    if(this->mCurMatIdx < 0)
	    {
		cerr << "Error! : " << retStr << " is not in material table. "
		    "at line " << this->mpGeoReader->getReadLineNum() 
			<< endl;
		commMpi2_exit(2);
	    }
	}else if(tkn != COMMENT_tkn)
	{			// ȤǤʤ loop ȴ
	    break;
	}
    }
    // COMMENT_tkn Ǥ material name Ǥʤ token ɤ᤿
    static Vector3 v1, v2, v3, nonRadColor; // triangle
    static Vector3 center;		    // sphere
    double radius = 0.0;
    static Vector3 spcpos;
    int	   objnum = -1;

    if((this->mCurMatIdx < 0) ||
       (this->mTableSize <= this->mCurMatIdx))
    {
	// geomtry data  current material Ǥʤgeometry
	// file Ƭǻ˺줿ΤǤϤʤ? 
	cerr << "Error! : can not specify current material. at line " 
	    << this->mpGeoReader->getReadLineNum() << endl;
	cerr << "Did you specify material name before geometry data in "
	    "geometry file?" << endl;
	commMpi2_exit(2);
    }
    
    switch(tkn)
    {
    case TRIANGLE_POLY_tkn:
	objnum	= int(retvals[0]);
	v1.set(retvals[1], retvals[2], retvals[3]);
	v2.set(retvals[4], retvals[5], retvals[6]);
	v3.set(retvals[7], retvals[8], retvals[9]);
	spcpos.set(retvals[10], retvals[11], retvals[12]);
	if((v1 == v2) || (v1 == v3) || (v2 == v3))
	{
	    cout << "Error! : illegal triangle (There are same points) at " 
		<< this->getReadLineNum() << endl;
	    commMpi2_exit(2);
	}
	(*ppObject) 	= 
	    new triangleObjectClass(objnum, this->mCurMatIdx, 
				    v1, v2, v3, spcpos, 
				    this->mpMatArray[this->mCurMatIdx].
				    getDiffEmit());
	break;

    case TRIANGLE_POLY_WITH_RADIO_tkn:
	objnum	= int(retvals[0]);
	v1.set(retvals[1], retvals[2], retvals[3]);
	v2.set(retvals[4], retvals[5], retvals[6]);
	v3.set(retvals[7], retvals[8], retvals[9]);
	spcpos.set(retvals[10], retvals[11], retvals[12]);
	nonRadColor.set(retvals[13], retvals[14], retvals[15]);
	if((v1 == v2) || (v1 == v3) || (v2 == v3))
	{
	    cout << "Error! : illegal triangle (There are same points.) at " 
		<< this->mpGeoReader->getReadLineNum() << endl;
	    commMpi2_exit(2);
	}
	(*ppObject) 	= 
	    new triangleObjectClass(objnum, this->mCurMatIdx, 
				    v1, v2, v3, spcpos, 
				    nonRadColor);
	break;

    case SPHERE_tkn:
	objnum	= int(retvals[0]);
	center.set(retvals[1], retvals[2], retvals[3]);
	radius 	= retvals[4];
	spcpos.set(retvals[5], retvals[6], retvals[7]);	
	(*ppObject)     = 
	    new sphereObjectClass(objnum, this->mCurMatIdx, 
				  center, radius, spcpos);
	break;

    case CYLINDER_tkn:
	// 	objNum	= int(getDouble(words[1]));
	// 	center1 = getVector(words[2],  words[3],  words[4]);
	// 	center2 = getVector(words[5],  words[6],  words[7]);
	// 	radius 	= getDouble(words[8]);
	// 	spcpos 	= getVector(words[9], words[10], words[11]);	
	// 	(*ppObject) 	= new cylinderObjectClass(objNum, center1, center2, radius, spcpos);
	break;

    case CONE_tkn:
// 	int	objNum	= int(getDouble(words[1]));
// 	Vector3 center1 = getVector(words[2],  words[3],  words[4]);
// 	double  radius1 = getDouble(words[5]);
// 	Vector3 center2 = getVector(words[6],  words[7],  words[8]);
// 	double  radius2	= getDouble(words[9]);
// 	Vector3 spcpos 	= getVector(words[10], words[11], words[12]);	
// 	(*ppObject) 	= new coneObjectClass(objNum,  
// 				center1, radius1, 
// 				center2, radius2, spcpos);
	break;

    case RING_tkn:
// 	int	objNum	= int(getDouble(words[1]));
// 	Vector3 center 	= getVector(words[2],  words[3],  words[4]);
// 	Vector3 normal	= getVector(words[5],  words[6],  words[7]);
// 	double  inRadius	= getDouble(words[8]);
// 	double  outRadius	= getDouble(words[9]);
// 	Vector3 spcpos 	= getVector(words[10], words[11], words[12]);	
// 	(*ppObject)	= new ringObjectClass(objNum,   center,    normal, 
// 				inRadius, outRadius, spcpos);
	break;

    case TORUS_tkn:
// 	int	objNum	= int(getDouble(words[1]));
// 	Vector3 center 	= getVector(words[2],  words[3],  words[4]);
// 	Vector3 normal	= getVector(words[5],  words[6],  words[7]);
// 	double  inRadius	= getDouble(words[8]);
// 	double  outRadius	= getDouble(words[9]);
// 	Vector3 spcpos 	= getVector(words[10], words[11], words[12]);	
// 	(*ppObject)	= new torusObjectClass(objNum,   center,    normal, 
// 				 inRadius, outRadius, spcpos);
	break;

    case EOF_tkn:		// EOF ϵƤ token Ǥ
#ifndef NULL
	(*ppObject) = NULL;
#endif
	break;

    case ERROR_tkn:		// ERROR token ξϰ­ʤɤȯ
    default:			// ʪΰʳ tkn(comment matname)ϼ
	cerr << "Error! : illegal line in geometry file at line " 
	    << this->mpGeoReader->getReadLineNum() << endl;
	cerr << "Error! : Is this geometry file? token = " << tkn << endl;
	commMpi2_exit(1);
	break;
    }
    return(tkn);
}
