//------------------------------------------------------------
// $Id: mpi2ReaderClass.h,v 1.1.1.1 1999/11/25 06:26:12 yamauchi Exp $
//------------------------------------------------------------
// 	mpi2ReaderClass.h
//	for read (M\pi)^2 data file file headder
//	(M\pi)^2 data file is derived mgf data format
//
//	mpi2 data file ɤिΥ饹
//	1996/6/10
//	21 March 1997 ɤ߹ߤʤȹ®
//	(C) Copyright Hitoshi YAMAUCHI
//	refer readfile.doc
//------------------------------------------------------------
#ifndef _mpi2ReaderClass_h
#define _mpi2ReaderClass_h 1

#include <stdio.h>
// #include <String.h> ... do not work on SP2
#include "myString.h"
#include "SLList.h"
#include "mpi2.h"
#include "constants.h"
#include "material.h"
#include "triangleObject.h"
#include "sphereObject.h"
#include "mpi2dataToken.h"

//------------------------------------------------------------
// mpi2ReaderClass 
//    mpi2 Υեɤ߹
// Υ饹ŵŪˡ:
//	mpi2ReaderClass mpi2reader;	// 饹
//	mpi2reader.open("filename");	// file open
//	do {
//	    tkn = mpi2reader.getOneLine(&tknum, str, retval);// Ԥξ
//	    // ԾѤ
//	} while(tkn != EOF_tkn);
//	mpi2reader.close();		// ե close
// ºݤˤ define space ɤ߲material ɤ߲geometry ɤ߲
//------------------------------------------------------------
const int MAX_LINE = 4096;

class mpi2ReaderClass {
private:
    mpi2ReaderClass(const mpi2ReaderClass& rhs);
    const mpi2ReaderClass& operator=(const mpi2ReaderClass& rhs);    

protected:
    FILE        *mpFp;
    myString 	mFilename;
    int		mReadLine;
    char 	mReadBuff[MAX_LINE]; // ɤ߹ѤΥХåե
    int		mIdx;		     // buffer ν
    
protected:
    int  getFirstTokenOfLine(void);
    YorN getRestDoublePart(int numberOfArgs, double retvals[]);
    void getNextString(char *pRetStr);
    
public:
    mpi2ReaderClass(void) : mpFp(NULL){};
    ~mpi2ReaderClass(void);

    // ɤ߹ line ֤
    int getReadLineNum(void) const { return(this->mReadLine); }
    // ɤ߹ߡtoken Ȱ֤
    int getOneLine(int *pNumOfToken, double retval[], char *pRetStr);
    
    // ɤ߹եλ( YES:  NO)
    YorN open(const char *pFilename);
    
    // եΥ(destruct ˤϸƤФ)
    YorN close(void);
};

//------------------------------------------------------------
// geometry file ɤ߹िΥ饹
//------------------------------------------------------------
class geoReaderClass {
private:
    geoReaderClass(const geoReaderClass& rhs);
    const geoReaderClass& operator=(const geoReaderClass& rhs);

protected:
    mpi2ReaderClass *mpGeoReader; // ɤ߹ߥ饹
    char **mppMatNameTable;	       // material table
    int	   mTableSize;		       // material table size
    int    mCurMatIdx;		       // ߤΥƥȤ material ֹ
    materialClass *mpMatArray;	       // material μΤ򻲾Ȥ뤿 ptr

protected:
    int getIdxOfmatTable(const char *pMatName);

public:
    geoReaderClass(void) : mpGeoReader(NULL), mppMatNameTable(NULL),
    mTableSize(-1), mCurMatIdx(-1), mpMatArray(NULL) {}

    YorN open(const char *pGeoFName, int tableSize, char **appMatNameTab,
	      materialClass *pMatArray);
    YorN close(void);
    int  getOneGeoData(objBaseClass **ppObject);
    int  getReadLineNum(void) const 
    { 
	return(this->mpGeoReader->getReadLineNum());
    }
};


//------------------------------------------------------------
// function for reading space information
//------------------------------------------------------------
YorN readDefSpcInfo(const char *pSpcFname,
		    Vector3 *pDefspcMin,  Vector3 *pDefspcMax, 
		    Vector3 *pPartVolMin, Vector3 *pPartVolMax, 
		    int     *pSpcDivNum);

//------------------------------------------------------------
// function for reading material information
//------------------------------------------------------------
YorN readMatInfo(const char *pMatFname, 
		 SLList < materialClass * > *pMatList);

#endif				// #ifndef _mpi2ReaderClass_h
