/*
 * $Id: ObjExistanceInASpc.java,v 1.4 1999/09/22 19:35:09 yamauchi Exp $
 *     (M\pi)^2 : object existance in a space
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source objectInfoInASpace.h
 *
 *	֤ʪΤ¸ߤ򼨤geometry  volume ʬΥƤ
 * 	פ⤷ʤ
 * 
 * 1999ǯ8 9()
 */

package jp.ac.tohoku.is.archi.mpi2.dda;

import java.io.Serializable;

/**
 * ֤ʪΤ¸ߤͻҤ򼨤
 * 	Geometry 뤫 Volume 뤫
 */
public final class ObjExistanceInASpc 
implements ObjInASpc 
, Serializable
{  
    public static final byte IS_GEO = 1; // = 01b :geometry(polygonʤ)
    public static final byte IS_VOL = 2; // = 10b :volume 

    private byte mObjInfo;

    /**
     * constructor
     */
    public ObjExistanceInASpc()
    {
	this.mObjInfo = 0;
    }
    /**
     * copy constructor
     */
    public ObjExistanceInASpc(ObjExistanceInASpc rhs)
    {
	this.mObjInfo = rhs.mObjInfo;
    }

    /**
     * set
     */
    public void set(int aGeoNum, int aVolNum) // set Τ߾äʤ
    {
	if(aGeoNum > 0)
	{
	    this.mObjInfo |= (ObjExistanceInASpc.IS_GEO);
	}
	if(aVolNum > 0)
	{
	    this.mObjInfo |= ObjExistanceInASpc.IS_VOL;
	}
    }

    /**
     * clear : this space has no object.
     */
    public void clear()
    {
	this.mObjInfo = 0;
    }

    public boolean isObj() 	// ʪΤ¸ߤ true
    {
	return((this.mObjInfo > 0) ? true : false);
    }

    public boolean isGeo() 	// geometry ¸ߤ true
    {
	if((this.mObjInfo & ObjExistanceInASpc.IS_GEO) > 0)
	{
	    return(true);
	}else
	{
	    return(false);
	}
    }
    public boolean isVol() 	// volume ¸ߤ true
    {
	if((this.mObjInfo & ObjExistanceInASpc.IS_VOL) > 0)
	{
	    return(true);
	}else
	{
	    return(false);
	}
    }

//      * for serialize (Τ OBJINSPC_IMPLEMENT_TYPE ǼФ)
//     OBJINSPC_IMPLEMENT_TYPE getObjInfo() 
//     {
// 	return(this.mObjInfo);
//     }
    

    // for pretty print
    public String getVisualOutDescription() 
    {
	return(" [P]olygon, [V]olume, [B]oth");
    }

    public String toVisualString() 
    {
	// Polygon  P, Volume ʤ V, ξʤ B ֤
	if(this.mObjInfo == (ObjExistanceInASpc.IS_GEO | 
			     ObjExistanceInASpc.IS_VOL))
	{
	    return("B");
	}
	else if(this.mObjInfo == ObjExistanceInASpc.IS_GEO)
	{
	    return("P");
	}
	else if(this.mObjInfo == ObjExistanceInASpc.IS_VOL)	
	{
	    return("V");
	}
	else
	{
	    return(" ");	    	    
	}
    }
    
//      *----------------------------------------
//      * SerializableIF : double ɽƱ׻ǤʤȾ꤯ʤ    
//      *----------------------------------------
//     int getSerializedSize() 
//     {
// 	// OBJINSPC_IMPLEMENT_TYPE mObjInfo;  char 
// 	return(1);
//     }
//     double *newSerializedArray()
//     {
// 	double *r = new double[this.getSerializedSize()];
// 	r[0] = (double)(this.mObjInfo);
// 	return(r);
//     }
//     void deserialize(double *pBuf)
//     {
// 	this.mObjInfo = (char)(pBuf[0]);
//     }

    /**
     * equals
     */
    public boolean equals(Object obj)
    {
	if(obj instanceof ObjExistanceInASpc)
	{
	    ObjExistanceInASpc rhs = (ObjExistanceInASpc)obj;
	    return(this.mObjInfo == rhs.mObjInfo);
	}else
	{
	    return(false);
	}
    }
}
