/*
 * $Id: SearchNextSpcDDA.java,v 1.6 2000/06/15 13:55:50 yamauchi Exp $
 *     (M\pi)^2 : Search next Space by 3DDDA 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source searchNextSpcDDA.h searchNextSpcDDA.cc
 *
 *	õ 3DDDA μ : Ǽ르ꥺबɤ
 *	櫓ǤϤʤ褦
 * 
 *    boolean moveRayToNextCalcSubspace(RayClass *pRay);
 *	pRay Ϥδؿλˤϼ˸ȽԤ֤ˤ롣
 *	֤ : θȽֳ֤Ǥ NO
 *		 Ǥ true ֤
 *
 * 1999ǯ8 8()
 */

package jp.ac.tohoku.is.archi.mpi2.dda;

import  jp.ac.tohoku.is.archi.mpi2.util.*;
import  jp.ac.tohoku.is.archi.mpi2.obj.Ray;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;

/**
 * ֤Τ interface ʤɤͤƤ̤Υ饹
 *     C++  virtual ʤΤˤ constructor  destructor 
 *     ΰ˻롣
 *------------------------------------------------------------
 * 3DDDA ˡѤõ
 */
public class SearchNextSpcDDA implements Mpi2Enum{
    // 3DDDA η׻ɬפȤʤǡ
    private Vector3  mDefSpcMin;  // DDA ŬѤ֤κǾ
    private double   mCellLength; // DDA  traverse 륻礭
    private int	[]   mSpcIdxMin;  // cell κǾ index (subvolume 
    private int	[]   mSpcIdxMax;  // Ʊ index:      Τ0ǾǤϤʤ)
    private int      mRayPropSkipMethod;// Skip ˡ(Skip 뤷ʤ)
    private int      mNetworkType;	 // ͥåȥη
    
    // ʪΤ¸߾
    private Array3D  mObjInSpcMap; 

    // derived values
    private double   mCellHalf; // cell ĹȾʬ

    /**
     * local functions
     *------------------------------------------------------------
     * 쥤οʹ XPLUS, XMINUS,.. η(sub. calcDDA)
     * ˹Ԥ뤫ɤ(⤫ɤΥƥȤϹԤʤ)
     */
    private static int getDirection(DDAInfo dInfo, int goingDirection)  
    {
	int dir;
	switch(goingDirection)
	{
	case Vector3.X:
	    if(dInfo.peekDDAVec().get(Vector3.X) < 0.0)
	    {
		dir = DIR_3D.XMINUS;
	    }else
	    {
		dir = DIR_3D.XPLUS;
	    }
	    break;
	    
	case Vector3.Y:	
	    if(dInfo.peekDDAVec().get(Vector3.Y) < 0.0)
	    {
		dir = DIR_3D.YMINUS;
	    }else
	    {
		dir = DIR_3D.YPLUS;
	    }
	    break;
	    
	case Vector3.Z:
	    if(dInfo.peekDDAVec().get(Vector3.Z) < 0.0)
	    {
		dir = DIR_3D.ZMINUS;
	    }else
	    {
		dir = DIR_3D.ZPLUS;
	    }
	    break;
	    
	default:
	    throw new RuntimeException("Error!: at getOnlyDirection illegal "+
				       "goingdir( = " + goingDirection + ")");
	    // commMpi2_exit(1);
	    // break;
	}
	return(dir);
    }

    /**
     * double double ֤ (sub. of calcDDA)
     */
    private static double dSignD(double x) 
    {
	if(x < 0.0)
	{
	    return(-1.0);
	}else if(x > 0.0)
	{
	    return(1.0);
	}else 
	{
	    return(0.0);
	}
    }

    /**
     * check initialize parameter
     */
    private static void exitIfIllegalParam(double cellLength, 
					   int []spcIdxMin,  int []spcIdxMax, 
					   int rayPropSkipMethod, 
					   int networkType)
    {
	String s = "Error! : SearchNextSpcDDA.exitIfIllegalParam : ";
	if(cellLength <= 0.0)
	{
	    throw new RuntimeException(s + "illegal cellLength (" + 
				       cellLength + ")");
	    // commMpi2_exit(1);
	}
	for(int i = 0; i < 3; i++)
	{
	    if((spcIdxMin[i] < 0) || (spcIdxMax[i] <= 0) ||
	       (spcIdxMin[i] >= spcIdxMax[i]))
	    {
		throw new RuntimeException(s + "illegal spc index. spcMin[" + 
					   i + "] = "  + spcIdxMin[i]  + 
					   ", spcMax[" + spcIdxMax[i] + "]");
		// commMpi2_exit(1);		
	    }
	}
	if((rayPropSkipMethod == NoSkip_rayprop)	||
	   (rayPropSkipMethod == SobokuSkip_rayprop) 	||
	   (rayPropSkipMethod == ProximityClouds_rayprop))
	{
	    // OK! : no skip  Ѥ skip ϥݡ
	}else
	{
	    throw new RuntimeException(s + "illegal skip method.(" + 
				       rayPropSkipMethod + ")");
	    // commMpi2_exit(1);		
	}
	
	if(networkType == Torus_network)
	{
	    throw new RuntimeException(s + "NIN : Not implemented for " + 
				       "Torus net.");
	    // commMpi2_exit(1);		
	}
	else if(networkType == MultiStage_network)
	{    
	    // OK! : multistage ϥݡ
	}else
	{
	    throw new RuntimeException(s + "illegal network type = " + 
				       networkType);
	    // commMpi2_exit(1);		
	}
    }

    /**
     * õԤ
     *	õԤ֤֤
     *	֤ޤɤ
     */
    private int getDirByDDA(DDAInfo dInfo)
    {
	// δؿƥȤ뤿 member ؤΥϤˤ
	// optimizer of compiler will be delete this code
	double CellLen	= this.mCellLength;
	double CellHalf = this.mCellHalf;
	
	// DDA info is already initialized
	Assert.out(dInfo.isDDAinited() == true, "Error!:dinfo already inited");
	
	int travAxis = dInfo.getTravAxis(); // ȥС    
	
	int OtherAxis1 = (travAxis + 1) % 3; // ʹԼʳ 1
	int OtherAxis2 = (travAxis + 2) % 3; // ʹԼʳ 2
	
	// ʹԼʳμˤʤफ а֤ưƤߤ
	Vector3 relaPos = new Vector3(dInfo.peekRelativePos());
	Vector3 DDAVec  = new Vector3(dInfo.peekDDAVec());
	
	// аַ׻
	double t1 = relaPos.get(OtherAxis1) + DDAVec.get(OtherAxis1); 
	double t2 = relaPos.get(OtherAxis2) + DDAVec.get(OtherAxis2); 
	
	// ưа֤
	double absT1 = Math.abs(t1);
	double absT2 = Math.abs(t2);
	
	if((absT1 <= CellHalf) && (absT2 <= CellHalf)) // ɤˤʤޤʤ
	{
	    dInfo.changeRelativePos(t1, OtherAxis1, t2, OtherAxis2);
	    int dir = getDirection(dInfo, travAxis);
	    dInfo.setGoingDir(dir);
	    return(dir);		//----- ʹԼ;
	}
	
	// ʹʳΥ٥ȥ
	double axis1_sign = dSignD((dInfo.peekDDAVec()).get(OtherAxis1));
	double axis2_sign = dSignD((dInfo.peekDDAVec()).get(OtherAxis2));
	
	if((absT1 > CellHalf) && (absT2 <= CellHalf)) // 1˿ʤ
	{
	    double rpos = relaPos.get(OtherAxis1) - axis1_sign * CellLen;
	    dInfo.changeRelativePos(rpos,                    OtherAxis1, 
				    relaPos.get(OtherAxis2), OtherAxis2);
	    int dir = getDirection(dInfo, OtherAxis1);	
	    dInfo.setGoingDir(dir);
	    return(dir);		//----- 1;
	}
	
	if((absT1 <= CellHalf) && (absT2 > CellHalf)) // 2˿ʤ
	{
	    double rpos = relaPos.get(OtherAxis2) - axis2_sign * CellLen;
	    dInfo.changeRelativePos(relaPos.get(OtherAxis1), OtherAxis1,
				    rpos,                    OtherAxis2);
	    int dir = getDirection(dInfo, OtherAxis2);
	    dInfo.setGoingDir(dir);
	    return(dir);		//----- 2;
	}
	
	//--------------------------------------------------
	// ʳ(1,21,2ɤ餫ؿʤ) 
	//--------------------------------------------------
	double param_s1
	    = (axis2_sign * (dInfo.peekDDAVec()).get(OtherAxis2))
            * (CellHalf - (axis1_sign * relaPos.get(OtherAxis1)));
	double param_s2
	    = (axis1_sign * (dInfo.peekDDAVec()).get(OtherAxis1))
            * (CellHalf - (axis2_sign * relaPos.get(OtherAxis2)));
	
	if(param_s1 < param_s2)
	{
	    double rpos = relaPos.get(OtherAxis1) - axis1_sign * CellLen;
	    dInfo.changeRelativePos(rpos,                    OtherAxis1,
				    relaPos.get(OtherAxis2), OtherAxis2);
	    int dir = getDirection(dInfo, OtherAxis1);
	    dInfo.setGoingDir(dir);
	    return(dir);		//----- 1;
	}else
	{
	    double rpos = relaPos.get(OtherAxis2) - axis2_sign * CellLen;
	    dInfo.changeRelativePos(relaPos.get(OtherAxis1), OtherAxis1,
				    rpos,                    OtherAxis2);
	    int dir = getDirection(dInfo, OtherAxis2);
	    dInfo.setGoingDir(dir);
	    return(dir);		//----- 2;
	}
	
    }

    /**
     * ʹԼDDAVectordInfo˥å(sub. of initializeDDA)
     */
    private void setTraverseAxisNVector(DDAInfo dInfo, Vector3 rayDir)
    {
	// access to member variable at here only
	double cellLen = this.mCellLength;
	
	// ٥ȥͺǤ
	// 	٥ȥ礭(x)
	double dAbsmax = Math.abs(rayDir.get(Vector3.X));
	double dy      = Math.abs(rayDir.get(Vector3.Y)); // ٥ȥ礭
	double dz      = Math.abs(rayDir.get(Vector3.Z)); 
	int SinkouJiku = Vector3.X;	// ȥС
	
	if(dAbsmax < dy)
	{
	    dAbsmax    = dy;
	    SinkouJiku = Vector3.Y;
	}
	
	if(dAbsmax < dz)
	{
	    dAbsmax = dz;
	    SinkouJiku = Vector3.Z;
	}
	dInfo.setTravAxis(SinkouJiku); // ʹԼ򥻥åȤ
    
	//----- DDAѤΥ٥ȥ򥻥åȤ
	dInfo.setDDAVec(rayDir.mulScalerNew(cellLen / dAbsmax));
    }

    /**
     * ֤ذưǤ뤫ƥȤ롣ʤ yes 
     * 	IN : pSpcPos ˸ΰ֤ƤؿƤ֡
     *	IN : dir ư
     * ƥȤΤѤʤ
     */
    private boolean testCanGo(IntVec3 spcPos, int dir) 
    {
	switch(dir)
	{
	case DIR_3D.XPLUS:
	    if((spcPos.get(IntVec3.X) + 1) >= this.mSpcIdxMax[0])
	    {
		return(false);
	    }
	    break;
	case DIR_3D.XMINUS:
	    if((spcPos.get(IntVec3.X) - 1) <  this.mSpcIdxMin[0])
	    {
		return(false);
	    }
	    break;
	case DIR_3D.YPLUS:
	    if((spcPos.get(IntVec3.Y) + 1) >= this.mSpcIdxMax[1])
	    {
		return(false);
	    }
	    break;
	case DIR_3D.YMINUS:
	    if((spcPos.get(IntVec3.Y) - 1) <  this.mSpcIdxMin[1])
	    {
		return(false);
	    }
	    break;
	case DIR_3D.ZPLUS:
	    if((spcPos.get(IntVec3.Z) + 1) >= this.mSpcIdxMax[2])
	    {
		return(false);
	    }
	    break;
	case DIR_3D.ZMINUS:
	    if((spcPos.get(IntVec3.Z) - 1) <  this.mSpcIdxMin[2])
	    {
		return(false);
	    }
	    break;
	default:
	    throw new RuntimeException("Error! : at testCanGo Illegal dir.");
	    // commMpi2_exit(1);
	    // break;
	}
	return(true);
    }

    /**
     * ֤ذư롣
     * 	IN OUT: spcPos ˸ΰ֤ƴؿƤ֡
     *	IN    : dir ư
     * ֤ư
     */
    private void goNextSpace(IntVec3 spcPos, int dir) 
    {
	// forceMove Ѥ礬ΤǤ assert ̵
	// Assert.out(this.testCanGo(spcPos, dir) == true, "Error!:");
	
	int x = spcPos.get(IntVec3.X);
	int y = spcPos.get(IntVec3.Y);
	int z = spcPos.get(IntVec3.Z);
	switch(dir)
	{
	case DIR_3D.XPLUS:
	    x++;
	    break;
	case DIR_3D.XMINUS:
	    x--;
	    break;
	case DIR_3D.YPLUS:
	    y++;
	    break;
	case DIR_3D.YMINUS:
	    y--;
	    break;
	case DIR_3D.ZPLUS:
	    z++;
	    break;
	case DIR_3D.ZMINUS:
	    z--;
	    break;
	default:
	    throw new RuntimeException("Error!:goNextSpace() : Illegal dir.");
	    // commMpi2_exit(1);
	    // break;
	}
	spcPos.set(x, y, z);
    }
    
    /**
     * ⤷ưǤΤʤ餽˰ưtrue ֤
     * Ǥʤˤϰư false ֤
     */
    private boolean testAndGoIfItCan(IntVec3 spcPos, int dir) 
    {
	if(this.testCanGo(spcPos, dir) == true)
	{
	    this.goNextSpace(spcPos, dir);
	    return(true);
	}else
	{
	    return(false);
	}
    } 
    
    /**
     * ֤õ
     * 	calculate next subspace and set the subspace to ray
     *	dInfo, spcPos ѹ
     *  skip ̵
     *
     * volume ʬȶͭ뤿μõ method
     * ddainfo ˤ뤳Ȥ volume Ǥ subspace Ǥ OK!
     */
    private boolean moveRayToNextSubspaceNoSkip(DDAInfo dInfo, 
						Vector3 rayPos,// 
						Vector3 rayDir,//٥ȥ
						IntVec3 spcPos)
    {
	/**
	 * 1.쥤˹Ԥζ֤
	 * δؿϸߤζְ֤ DDA ξ󤫤鿷ְ֤
	 * 
	 */
	if(dInfo.isDDAinited() == false)
	{
	    this.initializeDDA(dInfo, rayPos, rayDir, spcPos);
	}
	
	int nextDir = this.getDirByDDA(dInfo);
	
	// 2.ζ֤⤫Ĵ٤
	boolean isNextSpaceInDefspc = this.testAndGoIfItCan(spcPos, nextDir);
	return(isNextSpaceInDefspc);
    }

    /**-----------------------------------------------------------
     * public functions
     *------------------------------------------------------------
     * constructor
     */
    public SearchNextSpcDDA()
    {
	this.mDefSpcMin		= null;
	this.mCellLength	= -1.0;
	this.mSpcIdxMin		= null;
	this.mSpcIdxMax		= null;
	this.mRayPropSkipMethod	= ELSE_rayprop;
	this.mNetworkType	= ELSE_network;

	// derived variables
	this.mCellHalf	= -1.0;
    }

    public Array3D peekObjInSpcMap()
    {
	return(this.mObjInSpcMap);
    }
    
    /**
     * initialize
     *	defSpcMin  DDA ŬѤ֤κǾ֤Ǥ뤬 
     *	subspace ζ֤ǤϤʤʬ䤵뤤 subvolume 
     *	ʬ䤵 defspc min Ǥ롣 
     *	ȤminIdx, maxIdx ϰϤʬ֤¸ߤ
     *	(äʬ֤ʬ䤷κǾ֤Хʤʤľ
     *	 ʤä1998ǯ4 3() ¿ĸβָǤä
     *	 3/30 Ӹ󤬷뺧餷)
     *
     * ͭϰϤ [SpcIdxMin, SpcIdxMax) Ǥ롥 interface
     * ɤ뤫
     * 	@param defSpcMin	DDA ŬѤ֤κǾ֡global 
     *  @param cellLength	DDA traverse 륻礭
     *  @param spcIdxMin	cell κǾindex, 
     * 				subvolume Τ 0 ǾǤϤʤ
     *  @param spcIdxMax, 	cell κindex
     *  @param rayPropSkipMetod	skip ˡ
     *  @param networkType	ͥåȥ
     */
    public void initWithoutObjInSpcMap(Vector3 	defSpcMin, 
				       double 	celllen, 
				       int [] 	spcIdxMin, 
				       int []	spcIdxMax,
				       int  	skipMethod,
				       int      systemNetworkType)
    {
	SearchNextSpcDDA.exitIfIllegalParam(celllen, spcIdxMin, spcIdxMax, 
					    skipMethod, systemNetworkType);
	this.mDefSpcMin	= defSpcMin; 	 
	this.mCellLength= celllen;
	this.mSpcIdxMin = new int[3];
	this.mSpcIdxMax	= new int[3];
	for(int i = 0; i < 3; i++)
	{
	    this.mSpcIdxMin[i] 	= spcIdxMin[i];
	    this.mSpcIdxMax[i]	= spcIdxMax[i];
	}
	this.mRayPropSkipMethod = skipMethod;
	this.mNetworkType 	= systemNetworkType;    

	// derived variables
	this.mCellHalf = this.mCellLength / 2.0;
    }

    /**
     * ʪΤ¸߾
     */
    public void initObjInSpcMap(Array3D objMap)
    {
	String s = "Error! : SearchNextSpcDDA.initObjInSpcMap : ";
	if((objMap == null) || (objMap.getTotalSize() <= 0))
	{
	    throw new RuntimeException(s + "illegal object in space map.");
	    // commMpi2_exit(1);		
	}
	this.mObjInSpcMap = objMap;
    }

    /**
     * ʪΤ¸߾ν
     */
        /**
     * ־ν϶̥롼
     */
    public static void printObjInSpcMapCommon(String head, Array3D spcmap)
    {
	int [] idx = new int[3];
	final int xmaxIdx = spcmap.getMaxIdx(0);
	final int ymaxIdx = spcmap.getMaxIdx(1);
	final int zmaxIdx = spcmap.getMaxIdx(2); 
	idx[0] = idx[1] = idx[2] = 0;
	
	ObjInASpc oias = (ObjInASpc)spcmap.get(idx);
	System.out.println(head + oias.getVisualOutDescription());
	for(idx[0] = 0; idx[0] <= xmaxIdx; idx[0]++)
	{
	    for(idx[1] = 0; idx[1] <= ymaxIdx; idx[1]++)
	    {
		System.out.print(head + " obj in subspace [" +
				 idx[0] + "][" + idx[1] + "]: ");
		for(idx[2] = 0; idx[2] <= zmaxIdx; idx[2]++)
		{
		    oias = (ObjInASpc)spcmap.get(idx);
		    System.out.print(oias.toVisualString());
		}
		System.out.println("");
	    }
	}
    }	

    /**
     * ζְ֤ʪΤ¸ߤ뤫
     */
    public boolean isObject(IntVec3 spcpos)
    {
	return(((ObjExistanceInASpc)(this.mObjInSpcMap.get(spcpos))).isObj());
    }
    
    /**
     * 3DDDAΤξ(DDAInfo)ν (sub. of calcDDA)
     *	ray  define space ˤ뤳ȤǧƤ
     *	rayDir ϥ쥤οʹ٥ȥ
     *	ray λ DDA info 򹹿
     */
    public void initializeDDA(DDAInfo dInfo, 
			      Vector3 rayPos, Vector3 rayDir,
			      IntVec3 raySpcPos)
    {
	Assert.out(dInfo.isDDAinited() == false, 
		   "Error!: ddainfo is already initialized: initializeDDA");
	Assert.out(Math.abs((rayDir.getNorm()) - 1.0) < 
		   Mpi2Constants.D_ERROR_RES,
		   "Error!: rayDir is not normalized : initializeDDA");
    
	// access to member variable at here only
	double CellLen		= this.mCellLength;
	Assert.out(this.mCellLength > 0.0, "Error!: celllen must be > 0.0");
	Vector3 defSpcMin 	= this.mDefSpcMin;
    
	// ʹԼηȿʹԥ٥ȥset
	this.setTraverseAxisNVector(dInfo, rayDir); 
	int shinkouJiku = dInfo.getTravAxis(); 
	
	int OtherAxis1 = (shinkouJiku + 1) % 3; // ʹԼʳ 1
	int OtherAxis2 = (shinkouJiku + 2) % 3; // ʹԼʳ 2
    
	// ʹԼ κǾ
	double DefSpcMinShinkouJiku =	defSpcMin.get(shinkouJiku);	
	// (0.5, 0.5, 0.5) 濴˰֤뤿к
	Vector3 center = new Vector3(0.5, 0.5, 0.5); 
	Vector3 spcpos = new Vector3(raySpcPos);
	
	// ΣŪ濴
	// Vector3 centerOfCell = (defSpcMin + CellLen * (center + spcpos));
	center.plusHere(spcpos);
	center.mulScalerHere(CellLen);
	Vector3 centerOfCell = new Vector3(defSpcMin);
	centerOfCell.plusHere(center);
		
	/**-------------------------------------------------------------
	 * а = 쥤οʹԼεդΥʿ̤Ȥθ
	 *  = Define Space Min + Cell Length * spcpos
	 */
	double minAtCell = 0.0;
	if((rayDir.get(shinkouJiku)) > 0.0)	// ʹԥ٥ȥ
	{
	    minAtCell = 
		DefSpcMinShinkouJiku + spcpos.get(shinkouJiku) * CellLen;
	}else
	{				// Ǥϥ礭
	    minAtCell = DefSpcMinShinkouJiku 
		+ (spcpos.get(shinkouJiku) + 1.0) * CellLen;
	}
    
	/**
	 * ʹԼˤĤƤλΰ֤ʹԼΥ٥ȥ˱ä 
	 * minAtCell ޤǤεΥ = param_t * ʹԼΥ٥ȥʬ
	 */
	double param_t = (minAtCell - rayPos.get(shinkouJiku)) 
	    / rayDir.get(shinkouJiku);

	/**
	 *  assertion  ray tracing νˤƤʤȤ
	 * Τϻ֤γˤ뤳Ȥ뤫Ǥ롣 
	 *     if(param_t > 0.0)
	 *     {
	 * 	System.out.println("initializeDDA param_t " + param_t);
	 * 	 // commMpi2_exit(1);
	 *     }
	 *     Assert.out(param_t < 1e-5, // (0 ΤȤΤ, 
	 * 	"Error!:")
	 */
	double relaPos1 
	    = (rayPos.get(OtherAxis1) + param_t * rayDir.get(OtherAxis1)) //rayDir
	    - centerOfCell.get(OtherAxis1);		    
    
	double relaPos2 
	    = (rayPos.get(OtherAxis2) + param_t * rayDir.get(OtherAxis2)) // rayDir
	    - centerOfCell.get(OtherAxis2);
	//  rayDir ʤΤ rayDir  ray οʹñ̥٥ȥ뤫
	
	//----- 3DDDAͽ(ʹԼ̵̣)
	dInfo.changeRelativePos(relaPos1, OtherAxis1, relaPos2, OtherAxis2);
	
	/*----- Ť assertionͤϼȤϸ¤ʤ(rayTr)
	 * ξˤϤ asserttion ϸǤ롣֤γˤ
	 * ˤа֤ cell length  1.5 ܰˤϤޤʤ
	 *----- ־45٤꤮ξˤ٤üޤǤʤΤǡ+-1.5
	 * Assert.out((relaPos1 <= (1.5 * CellLen)) && 
	 * ((-1.5 * CellLen) <= relaPos1), "Error!:", );
	 * Assert.out((relaPos2 <= (1.5 * CellLen)) && 
	 * ((-1.5 * CellLen) <= relaPos2), "Error!:");
	 */
	Assert.out((relaPos1 <= (1.5 * CellLen)) && 
		   ((-1.5 * CellLen) <= relaPos1),
		   "Error! : relapos1 (" + relaPos1 + "), \\pm 1.5x celllen = "
		   + (1.5 * CellLen));
	Assert.out((relaPos2 <= (1.5 * CellLen)) && 
		   ((-1.5 * CellLen) <= relaPos2),
		   "Error! : relapos2 (" + relaPos2 + "), \\pm 1.5x celllen = "
		   + (1.5 * CellLen));
	dInfo.setDDAset();		// ׻Ȥ򵭤
    }

    //  subclass 뤫 interface ˤ٤
    // ϸ
    // ray ΰ֤򼡶֤ѹ : Skip ̵
    /**
     * ֤õ
     * 	calculate next subspace and set the subspace to ray
     *	ray  (volume Ǥʤ)  ddainfo, space pos Ϲ
     * skip ̵
     */
    public boolean moveRayToNextSubspaceNoSkip(Ray ray)
    {
	DDAInfo ddainfo = ray.peekSpcDDAInfo();
	if(ddainfo == null)
	{
	    ddainfo = new DDAInfo();
	    ray.setSpcDDAInfo(ddainfo);
	}
	    
	IntVec3 spcpos  = ray.peekSpcPos();
	boolean isSendRay = 
	    this.moveRayToNextSubspaceNoSkip(ddainfo, 
					     ray.peekPos(), ray.peekDir(),
					     spcpos);
	ray.setSpcPos(spcpos);
	return(isSendRay);
    }    

    /**
     * ֤õ
     * 	Ѥ skip (⤦ ray.getSpcPos() ѤϤʤɬ٤ذư
     * 	ߤ)
     */
    public boolean moveRayWithSobokuSkip(Ray ray)
    {
	DDAInfo ddainfo = ray.peekSpcDDAInfo();
	IntVec3 spcpos  = ray.peekSpcPos();
	boolean isNextSpaceInDefspc = true;
	
	if(ddainfo == null)
	{
	    ddainfo = new DDAInfo();
	}
	if(ddainfo.isDDAinited() == false)
	{
	    this.initializeDDA(ddainfo, ray.peekPos(), ray.peekDir(), spcpos);
	}
	
	while(true)
	{
	    // ζ֤õ
	    int nextDir = this.getDirByDDA(ddainfo); 
	    
	    // ζ֤
	    isNextSpaceInDefspc = this.testAndGoIfItCan(spcpos, nextDir);
	    
	    if(isNextSpaceInDefspc == true)
	    {
		if(((ObjExistanceInASpc)(this.mObjInSpcMap.get(spcpos))).
		   isObj() == true)
		{
		    //  && ʪΤ¸ߤ . skip Ǥʤ
		    // isNextSpaceInDefspc == true  loop ȴ
		    
		    ray.setSpcDDAInfo(ddainfo);
		    ray.setSpcPos(spcpos);
		    return(true);
		}
		else
		{
		    // ֤ && ʪΤ¸ߤʤ .  Skip
		    // skip ϿϤǵϿ
		    //  		this.incSkipSpcNum();		
		    //  		this.incTravSpcNum();
		}
	    }else
	    {
		//¸ߤʤޤ֤򳰤ƤޤäԤϤʤ
		// isNextSpaceInDefspc == false Ȥʤä loop ȴ
		break;
	    }
	}
	ray.setSpcDDAInfo(ddainfo);
	ray.setSpcPos(spcpos);
	return(isNextSpaceInDefspc);
    }
    
    /*
     *------------------------------------------------------------
     * volume ư
     *	֤ܶȤȤĤİư뤿ᡢvolume ư
     *      ˤ϶ˤ ray  voxel ˤʤ礬롣
     *------------------------------------------------------------
     * ʬ֤ Direction Decision Unit ͭȤƤ뤫
     boolean SearchNextSpcDDA.
     isValidASpcpos(IntVec3 spcpos)
     {
     if((this.mSpcIdxMin[0]    <= spcpos.get(IntVec3.X)) && 
     (this.mSpcIdxMin[1]    <= spcpos.get(IntVec3.Y)) &&
     (this.mSpcIdxMin[2]    <= spcpos.get(IntVec3.Z)) &&
     (spcpos.get(IntVec3.X) < this.mSpcIdxMax[0]) && 
     (spcpos.get(IntVec3.Y) < this.mSpcIdxMax[1]) &&
     (spcpos.get(IntVec3.Z) < this.mSpcIdxMax[2]))
     {
     return(true);
     }
     else
     {
     return(false);	
     }
     }
     */

    /**
     * forceMoveRayToNextSpace
     * 	֤õɬζ֤˰ưƤޤ
     */
    void forceMoveRayToNextSpace(DDAInfo dInfo, 
				 Vector3 rayPos, Vector3 rayDir,
				 IntVec3 spcPos)
    {
	if(dInfo.isDDAinited() == false)
	{
	    this.initializeDDA(dInfo, rayPos, rayDir, spcPos);
	}
	int nextDir = this.getDirByDDA(dInfo);   
	this.goNextSpace(spcPos, nextDir);
    }


    /**
     * for test 
     */
    public static void main(String [] args)
    {
	SearchNextSpcDDA nssDDA = new SearchNextSpcDDA();
	
	int min[] = {  0,  0,  0, };
	int max[] = { 10, 10, 10, };
	nssDDA.initWithoutObjInSpcMap(new Vector3(0.0, 0.0, 0.0),
				      2.0, // celllen
				      min, max, 
				      NoSkip_rayprop,
				      MultiStage_network);
    }
}
