/*
 * $Id: Mpi21PE.java,v 1.11.4.2 2000/06/18 18:54:36 yamauchi Exp $
 *     (M\pi)^2 : Mpi2 for 1PE 
 *	Copyright (C) 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source main.cc
 *
 * 1999ǯ8 9()
 */

package jp.ac.tohoku.is.archi.mpi2.host;

import java.io.*;

import  jp.ac.tohoku.is.archi.mpi2.util.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import  jp.ac.tohoku.is.archi.mpi2.net.*;
import  jp.ac.tohoku.is.archi.mpi2.common.*;


/**
 * for 1PE main
 */
public final class Mpi21PE 
implements Mpi2Constants, Mpi2Enum 
{
    /**
     * main
     * 	host computer 
     */
    private static void do_host(int hostrank)
    {
	(Host.getInstance()).init(hostrank);
	(Host.getInstance()).readAndDeliverAllData();
    }    

    /**
     * main
     *  PE : Processing Element
     */
    private static void do_PE()
    {
	PE pe = PE.getInstance();

	// GpPE.initBeforeRendeirng();
	if(Mpi2Option.getInstance().getShowDataMode() == true)
	{
	    pe.printSysInfo(NORMALHEAD);
	    pe.printMaterials(NORMALHEAD);
	    pe.printObjects(NORMALHEAD);
	}
	
	if(Mpi2Option.getInstance().getShowNumobjInSpace() == true)
	{
	    pe.printObjInSpcMap(NORMALHEAD);
	}

	// ϡhost (material, object)λ command 
	// ġäƤˤϥޥɤ dispatch routine 

	/*
	 * radiosity stage 
	 */
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("start radiosity stage.");
	}
	ElapsedTimer etimer = new ElapsedTimer();
	etimer.start();
	pe.doRadiosity();
	etimer.stop();		
	ElapsedTimer.outPEEtime("done radiosity stage.", etimer);
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("done radiosity stage.");
	}
	if(pe.peekSysInfo().isRadiosityCalc())
	{
	    pe.printStatInfo("Radiosity"); // ׾ν
	}

	/*
	 * prepare shading stage 
	 */
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("start prepare shading.");
	}
	etimer.reset();
	etimer.start();
	pe.doPrepareShading();
	etimer.stop();		
	ElapsedTimer.outPEEtime("done prepare shading.", etimer);
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("done prepare shading.");
	}
	
	/*
	 * ray-tracing stage 
	 */
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("start ray-tracing stage.");
	}
	etimer.reset();
	etimer.start();
	pe.doRayTracing();
	etimer.stop();		
	ElapsedTimer.outPEEtime("done ray-tracing stage.", etimer);
	if(Mpi2Option.getInstance().getVerboseMode())
	{
	    ElapsedTimer.outPERawTime("done ray-tracing stage.");
	}
	if(pe.peekSysInfo().isRayTracingCalc())
	{
	    pe.printStatInfo("Ray-Tracing"); // ׾ν
	}
	//System.out.println(NORMALHEAD + " PE skip/traverse spaces of rays " +
	//	   pe.getSkipSpcOfRays() + "/"+ pe.getTravSpcOfRays());
    }

    /**
     * initialize communicator of stand alone mode 
     */ 
    public static void initCommunicator(String [] args)
    {
	Mpi2CommFactory.initCommunicator(Mpi2Enum.MPI2COMM_OnePE);
	
	Mpi2CommFactory.getInstance().init(args);
    }
	
    /**
     * analize command line option
     */ 
    public static void analyzeCommandLine(String [] args)
    {
	// file info by command line option 
	FileInfo optionFIF = null;
	try {
	    optionFIF = Mpi2Option.getopt_newfileinfo(args);
	}catch(IllegalArgumentException e)
	{
	    System.out.println(e);
	    Mpi2Option.usage();
	    Mpi2CommFactory.getInstance().exit(1);
	}
	
	// real file information
	FileInfo fif = FileInfo.getInstance();
	if(!((optionFIF.getConfigFileName()).equals(FileInfo.INIT_FILENAME)))
	{
	    // Option  conf file ꤵƤʤɤ
	    fif.setConfigFileName(optionFIF.getConfigFileName());
	    try {
		fif.readConfigFile();
	    }catch(IOException e)
	    {
		System.out.println(e);
	    }
	}

	// ޥɥ饤󥪥ץեɤ߹Τ˾񤭤롥
	fif.overrideFileInfoWithOption(optionFIF);
	(SysStat.getInstance()).setHostRank(1); // stand alone
    }


    /**
     * stand alone (M\pi)^2 main
     */ 
    public static void main(String [] args) 
    {
	initCommunicator(args);

	analyzeCommandLine(args);

	// PrifileMonitor init
	ProfileMon.
	    getInstance().init(SysStat.getInstance().getMyRank(), 
			       FileInfo.getInstance().getTraceFileBaseName());

	if((Mpi2Option.getInstance()).getDebugMode())
	{
	    System.out.println((Mpi2Option.getInstance()).
			       toStringWithHead("//"));
	    System.out.println(FileInfo.getInstance().toStringWithHead("//"));
	}

	String s = 
	    "//-----------------------------------------------------\n" +
	    "// Stand Alone mode can not skip the radiosity stage.  \n" +
	    "// if you want to skip the radiosity stage. Please set \n" +
	    "// a minRadiationEnergy Huge val(like 1e20) in a view  \n" +
	    "// file data. and never off Rendering  = Radiosity     \n" +
	    "// in a sysinfo file.    Hitoshi Yamauchi              \n" +
// 	    "// Stand Alone mode Ǥϥ饸ƥơ򥹥å \n" +
// 	    "// Ǥޤ󡣤minRadiationEnergy 礭ͤ \n" +
// 	    "// 뤳ȤƱ̤ޤsysinfo ե\n" +
// 	    "// Ǥ Rendering  = Radiosity ɬꤷƲ\n" +
// 	    "//                       			      \n" +
	    "//-----------------------------------------------------";
	System.out.println(s);

	Mpi21PE.do_host(1);
	Mpi21PE.do_PE();
	
	Mpi2CommFactory.getInstance().finalizecommun();

	(Host.getInstance()).outResult();
	// λ̽(뤤 
	// ray-tracing ǤϾ˽)
    }
}
