/*
 * $Id: Mpi2Communicator.java,v 1.8 1999/10/05 14:25:19 yamauchi Exp $
 *     (M\pi)^2 : Interface of Mpi2 Communicator 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 * original source mpi2communStandAlone.h mpi2communStandAlone.cc
 *
 * MPI μʬ¿ΤǡȤꤢɬפʤΤ񤤤
 * 
 *
 * 1999ǯ8 9() */

package jp.ac.tohoku.is.archi.mpi2.net;

import  mpi.*;
import  jp.ac.tohoku.is.archi.mpi2.common.*;
import  jp.ac.tohoku.is.archi.mpi2.obj.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import  jp.ac.tohoku.is.archi.mpi2.util.*;

/**
 * (M\pi)^2 Ѥ̿ؿ interface
 */
public interface Mpi2Communicator {
    /**
     * get name : ɤʼ̿
     */
    public String getName();

    /**
     * initialize commun (M\pi)^2
     */
    public String [] init(String [] args);


    public void finalizecommun(); // finalize() Ϥ褯Τ̾Ѥ
    public void barrier();
    public void exit(int err_num);

    /**
     * get type
     */
    public int getCommunicatorType();

    /**
     * get identification
     */
    public String getDescription();

    /**
     * sysinfo (Broadcast)
     *  PE ѤǤ object, material, sysinfo  receive Ϥʤ
     *  send Ʊ receive 
     *
     *	ƥѥ᡼ IN(root)/OUT(others) ʤΤǼФ褦Ĺ 
     *  1 Ȥ
     */
    public void broadSysinfo(SysInfo 	[] sys, 
			     ViewData 	[] view, 
			     SpaceParam [] spcparam);

    /**
     * ƶ֤ʪΤ¸ߤ뤫ɽ
     */
    public void broadObjectInSpaceMap(Array3D [] objectInSpaceMap);

    /**
     * ʪΤεΥɽ
     */
    // public void broadPRCSkipMap(int bytes, OBJINSPC_IMPLEMENT_TYPE * pDatArray)

    /*
     * send, recv objects
     */
    /**
     * send objects
     * 	@param destRank 	ʪΥץߥƥ rank
     * 	@param objprim 		դʪΥץߥƥ
     */
    public void sendObject(int destRank, ObjectPrimitive objprim);
    
    /**
     * recv objects
     * 	@param destRank 	ʪΥץߥƥո rank Ĺ 1 
     * 	@param objprim 		ʪΥץߥƥ֤
     */
    public void recvObject(int [] srcRank,  ObjectPrimitive [] objprim);
    

    /**
     * Isend objects
     *	non blocking send
     *	
     *	@param destRank	
     *	@param buff	ʪΤ
     *	@param sendnum  ϸˤȤ뤳Ȥ¿Τᡤ
     *			ΤĤޤǤ٤Τ򼨤Ƥ
     */
    public Request IsendObj(int destRank, EncodedData lockedSendBuf, 
			    int sendObjTag);


    /**
     * Irecv objects
     *	non blocking recv
     *	
     *	@param srcRank	  
     *	@param buff	  ʪΤ
     *	@param recvObjnum 
     */
    public Request IrecvObj(int srcRank, EncodedData encodedBuf, int recvTags);

    /*
     * send complete? 
     * (waiting completion of non blocking send)
     */
    public boolean isSendComplete(Request req_handle);

    /*
     * recv complete? 
     * (waiting completion of non blocking recv)
     */
    public boolean isRecvComplete(Request req_handle);

    /**
     * send, recv volume (䤬 object Ȥ줹٤?)
     *	ĹΤΤ serialize ϤʤΤǸĹΤ
     *	ϤΤޤޡserialize ٤Τ serialize Ū
     *	褦  
     *------------------------------------------------------------
     * send subvolume
     */
    // public void commMpi2_sendVolume(int dstRank, VolumeClass *pVol);

    /**
     * recv subvolume
     */
    // public void commMpi2_recvVolume(int srcRank, int dstRank, 
    // 				       VolumeClass **ppVol);

    /**
     * material
     */
    public void broadMaterial(Material [] aMaterial);


    /*------------------------------------------------------------
     * probe 
     *-----------------------------------------------------------*/
    /**
     * can recv 
     * 	@param srcRank_and_recvDatNum[] : ֤
     *		srcRank_and_recvDatNum[0] : 
     *		srcRank_and_recvDatNum[1] : ʪο
     *	@param recvStaffTAG 		: Τ TAG
     *	@return recv ȯԲǽʤ true 
     */
    public boolean canRecv(int [] srcRank_and_recvDatNum, 
			   int    recvStaffTAG,
			   Datatype dat_t);
    
    /**
     * ray
     */
    // public reqHandle_st commMpi2_sendRays(int destRank, Ray* pRay, int numOfRays);

    // public reqHandle_st commMpi2_recvRays(int srcRank, Ray *pRay, int numOfRays)


    /**
     * send intensity to Frame Buffer
     */
    // public void commMpi2_sendIntensity2FB(IntensityClass *pIntensity, int numOfInt);

    // public void commMpi2_recvIntensity2FB(IntensityClass *pIntensity, int numOfIntensity);


    /**
     * send, recv PEStatus
     */
    // public void commMpi2_sendPEstat2Host(PEStatClass *pPEstat);
    // public void commMpi2_recvPEstat(PEStatClass *pPEstat);

    /**
     * send, recv Intensity value and vertex position
     */
    // public reqHandle_st commMpi2_sendIntVer(int destRank, intVerClass *pIntver);
    // public void commMpi2_recvIntVer(int srcRank,  intVerClass *pIntver);

    /**
     * send, recv object
     *	1 PE ξ,ºݤˤ̿ʤΤǤδؿľܰ(̾ 
     *	host)˽񤤤Ƥޤ  
     */
    // public void sendIntensityStandAlone(IntensityClass *pObj, int numOfObj);
}
