/*
 * $Id: NetIntUnit.java,v 1.15.4.1 2000/06/15 20:41:23 yamauchi Exp $
 *     (M\pi)^2 : Network Interface Unit
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source NetIntUnit.h NetIntUnit.cc
 *
 *	Network Interface Unit μ
 * 
 * 1999ǯ8 9()
 *
 *-- 1999ǯ928() 轵ζˤ˥Хåž֤ƤƤ
 *-- 顤褿Х 2 ȤΤĤˤäȻ夲줿Ȥä
 *-- ˥ХåĤɤƨ줿ʢΩĤȤǤ롥
 *-- ꤪӤΰܤǤޤʤäΤǰǤʤ̡
 *--
 *-- äƱȺ򷫤֤Ƥ餷ޤäƤʤ
 *-- Ƥ;ɵڤ٤ä⤷ʤҲͤ̾ϽФ
 *-- ĤعȤ̾Ϥʤä
 */

package jp.ac.tohoku.is.archi.mpi2.net;

import  java.util.*;

import  jp.ac.tohoku.is.archi.mpi2.common.*;
import  jp.ac.tohoku.is.archi.mpi2.obj.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import  jp.ac.tohoku.is.archi.mpi2.util.*;

// import  jp.ac.tohoku.is.archi.mpi2.raytrace.RayTrFRGUnit;

/**
 * NetIntUnit : Network Interface Unit μ
 */
public final class NetIntUnit 
implements Mpi2Enum, Mpi2Constants 
{
    /*
     *  PE 
     */
    private int mTotalPENum;		 
    /* 
     * 塼Ĺۤ ray 
     */
    private int mSendRayThreshold;	 

    /* 
     * 塼ĹĹۤ
     */
    private int	mSendIntensityThreshold; 

    /*
     *  NetworkInterface μʬ rank (check)
     */
    private int mThisRank;		 

    /*
     * host  rank
     */
    private int mHostRank;		 

    /*
     * ֤ PE бμ
     */
    private Space2PE 	mSpc2PE;

    /**
     * ray ѥХåե (塼󥰤): i ܤѥХåե 
     *  rank == i  
     */
    public SendBuffer [] mSendRaysBuf; //  buffer : ¹Ի˿ꤹ
    public RecvBuffer [] mRecvRaysBuf; //  buffer : ϸ

    /**
     * ۥȤؤε buf (ѤĤΤߡ host Τ)
     */
    public SendBuffer mSendIntensitiesBuf;

    /**
     * ǥ󥰻ĺѥХåե
     */
    public SendBuffer [] mSendVerIntBuf; // [i]  destrank == i 
    public RecvBuffer mRecvVerIntBuf;

    /**
     * ۥȤؤξ֤ѥХåե
     */
    public SendBuffer mSendPEStatBuf;

    /**
     * ۥȤ̿μХåե
     */
    public RecvBuffer mRecvHostCommBuf;
    
    /** 
     * constructor
     */
    public NetIntUnit()
    {
	this.mTotalPENum 		= -1;
	this.mSendRayThreshold 		= -1;
	this.mSendIntensityThreshold  	= -1;
	this.mThisRank			= -1;
	this.mHostRank			= -1;
	this.mSpc2PE 			= null;
	this.mSendRaysBuf		= null;
	this.mSendIntensitiesBuf	= null;
	this.mSendVerIntBuf		= null;
	this.mRecvVerIntBuf		= null;
	this.mSendPEStatBuf		= null;
	this.mRecvHostCommBuf		= null;
    }


    /**
     * Ray SendRecv Buffer
     * 	initialize ray buffer :  call Ƥ
     *	@param totalPENum		 PE 
     *	@param raySendThreshold 	ray  
     *	@param intensitySendThreshold  	پ FB ؤΤޤȤ
     *	@param thisRank			 PE  rank (ºݤ:å)
     *	@param hostRank			host Υ : Pixel 
     *	@param procRaysQueue		PEǽrayݻ륭塼λ
     *	@param hostCommRaysQueue	Host Υޥɤ륭塼λ
     */
    public void initRayBuff(int 	totalPENum, 	  
			    int 	raySendThreshold,    
			    int 	intensitySendThreshold,
			    int 	thisRank,	  
			    int 	hostRank,	  
			    Queue 	procRaysQueue,
			    Queue	hostCommRaysQueue)
    {
	// check args
	if((totalPENum <= 0) 	     	 || (raySendThreshold <= 0) || 
	   (intensitySendThreshold <= 0) || (thisRank < 0)  	    ||
	   (thisRank >= totalPENum)	 || (hostRank < 0))
	{
	    String s = "Error! : illegal args at NetIntUnit.initRayBuff" +
		"(totalPENum, raySendThreshold, intensitySendThreshold, " + 
		"thisRank, hostRank) = (" + totalPENum + ", " + 
		raySendThreshold + ", "   + intensitySendThreshold + ", " + 
		thisRank + ", " + hostRank + ")";
	    throw new RuntimeException(s);
	}
	if((procRaysQueue == null) || (hostCommRaysQueue == null))
	{
	    throw new RuntimeException("Error! : illegal queue (null) at " +
				       "NetIntUnit.initRayBuff");
	}
	if((procRaysQueue.length() != 0) || (hostCommRaysQueue.length() != 0))
	{
	    throw new RuntimeException("Error! : illegal queue (there is " + 
				       "contents) NetIntUnit.initRayBuff");
	}
	
	// init PE num and threshold
	this.mTotalPENum 	      	= totalPENum;	
	this.mSendRayThreshold  	= raySendThreshold;
	this.mSendIntensityThreshold	= intensitySendThreshold;
	this.mThisRank 			= thisRank;
	this.mHostRank 			= hostRank;
    
	// ray Хåեν 
	this.mSendRaysBuf = new SendBuffer[this.mTotalPENum];
	for(int peRank = 0; peRank < this.mTotalPENum; peRank++)
	{
	    this.mSendRaysBuf[peRank] = new SendBuffer();
	    this.mSendRaysBuf[peRank].initBuff(this.mSendRayThreshold,
					       Ray.getTAG());
	}

	// ray Хåեν
	this.mRecvRaysBuf = new RecvBuffer[MAX_RECV_BUFFNUM];
	for(int i = 0; i < MAX_RECV_BUFFNUM; i++)
	{
	    // ΥХåեȼΥХåեΰ礭Ʊ
	    // (礭(this.mSendRayThreshold)̤rayΤȤ꤬롥)
	    this.mRecvRaysBuf[i] = new RecvBuffer();
	    this.mRecvRaysBuf[i].init(this.mSendRayThreshold, procRaysQueue,
				      Ray.getTAG(), Ray.getObjectDecoder());
	}

	// host ؤεѥХåե
	this.mSendIntensitiesBuf = new SendBuffer();
	this.mSendIntensitiesBuf.initBuff(this.mSendIntensityThreshold,
					  Intensity.getTAG());

	// host ؤξѥХåե : 
	this.mSendPEStatBuf	= new SendBuffer();
	this.mSendPEStatBuf.initBuff(1, // 塼󥰤Ϥʤ
				     PEStat.getTAG());
	

	// host ̿Хåե
	this.mRecvHostCommBuf	= new RecvBuffer();
	this.mRecvHostCommBuf.init(this.mSendRayThreshold, hostCommRaysQueue,
				   HostCommand.getTAG(),   
				   HostCommand.getObjectDecoder());
    }


    /**
     * initSpc2PE
     *	 ֤ PE Υޥåԥ󥰴طν
     *	child of initInternalUnits()
     *  @ref Host.java private void mapSpacePE()
     */
    // public void initSpc2PE(SysInfo sys, SpaceParam spcparam, IntVec3 PEID)
    public void initSpc2PE(int allocationScheme, IntVec3 PEdim, 
			   int subdivNum, 	 IntVec3 PEID)
    {
	switch(allocationScheme)
	{
	case Block_Alloc:
	{
	    Space2PEBlock s2p = new Space2PEBlock();
	    s2p.init(PEdim, subdivNum, PEID);
	    this.mSpc2PE = s2p;
	    Mpi2Option.getInstance().verboseOut("PE : " + PEID + " init " + 
						"BlockAlloc");
	}
        break;
	
	case Distributed_Alloc:
	{
	    Space2PEDistributed s2p = new Space2PEDistributed();
	    s2p.init(PEdim, subdivNum, PEID);
	    this.mSpc2PE = s2p;
	    Mpi2Option.getInstance().verboseOut("PE : " + PEID + " init " + 
						"DistributedAlloc");
	}
	break;
	
	case Skewed_Alloc:
	{
	    Space2PESkewedDistributed s2p = new Space2PESkewedDistributed();
	    s2p.init(PEdim, subdivNum, PEID);
	    this.mSpc2PE = s2p;
	    Mpi2Option.getInstance().verboseOut("PE : " + PEID + " init " + 
						"SkewedDistributedAlloc");
	}
	break;
	
	case Random_Alloc:
	{
	    Space2PERandom s2p = new Space2PERandom();
	    s2p.init(PEdim, subdivNum, PEID);
	    this.mSpc2PE = s2p;
	    Mpi2Option.getInstance().verboseOut("PE : " + PEID + " init " + 
						"RandomAlloc");
	}
	break;
	
	default:
	    this.mSpc2PE = null;
	    throw new RuntimeException("Error! : no such allocation scheme " + 
				       "NetIntUnit.initSpc2PE");
	}
    }


    /*------------------------------
     * send
     * 	塼졤Υ塼ʬĹˤ
     */
    public boolean sendRays(Ray r, int destRank)
    {
	return(this.mSendRaysBuf[destRank].enqNewedObjwithMaySend(r, 
								  destRank));
    }

    /*
    // Ƥ򸫤ƤΥ塼ʬĹˤ
    boolean sendRaysIfExceedQueueLen();
    */

    /**
     * 塼 1 ܤǤ ray ¸ߤȯԤߡbuffer  lock 
     * Ƥʤ¤׵ȯԤ롥 
     *   @return ׵ȯԤ true
     */
    public boolean flushSendRaysBuffer() 
    {
	// 
	boolean isIssueSend = false;
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    if(this.mSendRaysBuf[i].flushdone(i) == true)
	    {
		// ʬȤˤ̿ϩȤʤľ
		Assert.out(this.mThisRank != i, 
			   "Error!: no send to myself with communication.");
		isIssueSend = true; // ׵ȯԤ
	    }
	}
	return(isIssueSend);
    }

    /*
    // ׵̤ΤΤλΤå
    void completeSendRaysRequest();
    */

    /**
     * Ray ˤĤΤΤ̵ true ֤
     */
    public boolean isNoSendRay()
    {
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    // ΤΤ¸ߤȤˤ¨ false
	    if(this.mSendRaysBuf[i].isLockRealBuffer() == true)
	    {
		this.mSendRaysBuf[i].flushdone(i);
		return(false);
	    }
	}
	return(true);
    }

    /**
     * ƤХåե empty ʤ true
     */
    public boolean isSendRayBufAllEmpty()
    {
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    if(this.mSendRaysBuf[i].getSizeOfQueue() > 0)
	    {
		return(false);
	    }
	}
	return(true);
    }

    
    /*------------------------------------------------------------
     * 
     *-----------------------------------------------------------*/
    /**
     * ޥȯ
     */
    public boolean recvRays()
    {
	// λ
	// ΥХåե򸡺λʤ餽νԤ
	for(int recvBuffNum = 0; recvBuffNum < MAX_RECV_BUFFNUM; recvBuffNum++)
	{
	    // λƥȤλʤ⤷λʤ 
	    // unlock 뤬Ͼˤ롥
	    this.mRecvRaysBuf[recvBuffNum].completeRecv(); 
	}

	// ׵ȯ
	boolean issueRecvReq = false;
	for(int i = 0; i < MAX_RECV_BUFFNUM; i++)
	{
	    if(this.mRecvRaysBuf[i].issueRecvIfItCan(Ray.getTAG()) == true)
	    {
		issueRecvReq = true;
	    }else
	    {	
		// ⤦ ray ¸ߤʤΤ loop ȴ
		break;		
	    }
	}
	return(issueRecvReq);
    }

    /**
     * Ray ΥХåե 1 ĤǤ⤢ false ֤
     * ΤΤʤ true
     */
     public boolean isNoRecvRay()
    {
	for(int i = 0; i < MAX_RECV_BUFFNUM; i++)
	{
	    // ΤΤ¸ߤȤˤ¨ false
	    if(this.mRecvRaysBuf[i].isLocking() == true)
	    {
		this.mRecvRaysBuf[i].recv(Ray.getTAG());
		return(false);	// 
	    }
	}
	return(true);
    }

    /*
    int  getNRecvs();	// ΥХåե֤
     */

    /*------------------------------------------------------------
     * Intenisity : pixel Τ (host )
     *-----------------------------------------------------------*/
    /**
     * 塼ꤷͤۤݻ줿硤׵᤬ȯԲǽ
     * ȯ 
     */
    public void sendIntensity(Intensity intensity)
    {
	this.mSendIntensitiesBuf.enqNewedObjwithMaySend(intensity, 
							this.mHostRank);
    }

    /**
     * flush queue
     */
    public void flushIntensitySendBuf()
    {
	this.mSendIntensitiesBuf.flushdone(this.mHostRank);
    }

    /**
     * 椫
     */
    public boolean isSendingIntensity()
    {
	return(!this.mSendIntensitiesBuf.isNoMoreWork());
    }
    
    /*------------------------------------------------------------
     * ĺХåե
     *-----------------------------------------------------------*/
    /**
     * initialize intensity vertex sendrecv buffer :  call Ƥ
     *
     *    @param verIntSendThreshold 	ĺ 
     *    @param verIntRecvQueue    	Shading ˼ĺΥ塼
     */
    public void initVerIntBuff(int verIntSendThreshold, Queue verIntRecvQueue)
    {
	// check internal status 
	// (rayη׻ǽƤʤƤϤʤ)
	if((this.mTotalPENum < 0) || (this.mThisRank < 0))
	{
	    throw new RuntimeException("Error! : not init yet. " + 
				       "NetIntUnit.initVerInttexBuff");
	}

	// check args 
	if(verIntSendThreshold <= 0)
	{
	    String s = "Error! : illegal args at NetIntUnit.initVerInttexBuff "
		+ "initVerInttexBuff = " + verIntSendThreshold;
	    throw new RuntimeException(s);
	}
	if((verIntRecvQueue == null) || (verIntRecvQueue.length() != 0))
	{
	    String s ="Error! : illegal queue at NetIntUnit.initVerInttexBuff";
	    throw new RuntimeException(s);	
	}

	/*
	 * ĺХåեν
	 */
	this.mSendVerIntBuf = new SendBuffer[this.mTotalPENum];
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    this.mSendVerIntBuf[i] = new SendBuffer();	    
	    this.mSendVerIntBuf[i].initBuff(verIntSendThreshold, 
					    VertexIntensity.getTAG());
	}
	this.mRecvVerIntBuf = new RecvBuffer();
	this.mRecvVerIntBuf.init(verIntSendThreshold, verIntRecvQueue,
				 VertexIntensity.getTAG(),
				 VertexIntensity.getObjectDecoder());
    }

    public void sendVerInt(VertexIntensity verint, int destrank)
    {
	Assert.out(destrank != this.mThisRank, 
		   "Error! : not use sendbuff for sending myself:sendVerInt");
	this.mSendVerIntBuf[destrank].enqNewedObjwithMaySend(verint, destrank);
    }

    public void flushVerIntSendBuff()
    {
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    this.mSendVerIntBuf[i].flushdone(i);
	}
    }

    // ΤΤ¸ߤ
    public boolean isSendingVerInt()
    {
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    // ΤΤ¸ߤȤˤ true
	    if(this.mSendVerIntBuf[i].isLockRealBuffer() == true)
	    {
		return(true);
	    }
	}
	return(false);
    }

    public void recvVerInt()
    {
	this.mRecvVerIntBuf.recv(VertexIntensity.getTAG());
    }

    // ΤΤ¸ߤ
    public boolean isRecvingVerInt()
    {
	// lock ʤ
	return(this.mRecvVerIntBuf.isLocking());
    }


    /*------------------------------------------------------------
     * PE ۥȤ
     *-----------------------------------------------------------*/
    /*
    void initPEStatHostCommBuff(Vector hostCommRecvQueue);
    */
    public void sendPEStatToHost(PEStat pestat)
    {
	int hostRank = SysStat.getInstance().getHostRank();
 	if(this.mSendPEStatBuf.enqNewedObjwithMaySend(pestat, hostRank)
	   == true)
	{
	    // System.out.println("SendPEStat");
	}
    }
    /**
     * ĤǤĤäƤȯԤߤ.
     */
    public void flushPEStatSendBuff()
    {
	// ϸ Host ˸
	this.mSendPEStatBuf.flushdone(this.mHostRank);	
    }
    /**
     * PEStat ΤΤ¸ߤ
     */
    public boolean isSendingPEStat()
    {
	// !ŻϤʤ ==  : ŻȤΤ SendBuffer Ǥ
	return(!(this.mSendPEStatBuf.isNoMoreWork()));
    }

    /**
     * host ˤ PE ξ֤
     *	IsThisPEBusy == true  λˤϤ PE ϲƯ򳫻Ϥ
     *	IsThisPEBusy == false λˤϤ PE  idle ˤʤä
     */
    public void sendHostToThisPEIsBusy(boolean isThisPEBusy, int peRank)
    {
	PEStat pestat = new PEStat();
	if(isThisPEBusy == true)
	{
	    pestat.setBusy(peRank);
	}else
	{
	    pestat.setIdle(peRank);	
	}
	this.sendPEStatToHost(pestat);
    }

    /**
     * ۥȤΥޥɤ
     */
    public void recvHostComm()
    {
	this.mRecvHostCommBuf.recv(HostCommand.getTAG());
    }

    /*
    boolean isRecvingHostComm(); // ΤΤ¸ߤ
     */

    /**
     * ׾ν
     *	stage  skip ˤ׾ϤȤȤʤΤǽϤʤ 
     */
    public void printStat(String mes, String stageName)
    {
	// radiosity ʿѥ쥤 FIXME ɬפ?
	// System.out.println(pMes + "stat procradios: " + 
	// 			   this.mNumOfProcRadiosities);

	/*
	 *  buffer 
	 * 祭塼Ĺν :  rank ˤĤƤȺǸ˺ĹʿĹ
	 */
	System.out.print(mes + stageName + " SendBuff.MaxQueueLength ");
	int maxqueuetotal = 0; 

	for(int i = 0; i < this.mTotalPENum; i++)	
	{
	    CommunBufStatistics sendstat = 
		this.mSendRaysBuf[i].peekCBStatistics();
	    System.out.print(sendstat.getMaxQueueLen() + " ");
	    maxqueuetotal += sendstat.getMaxQueueLen();
	}
	double ave = ((double)maxqueuetotal) / ((double)this.mTotalPENum);
	System.out.println(" : ave " + ave);
						    
	// 󤢤ǤĤ obj 줿
	System.out.print(mes + stageName + " SendBuff.NumberOfObjParSend ");
	double opstotal = 0.0;
	for(int i = 0; i < this.mTotalPENum; i++)
	{
	    CommunBufStatistics sendstat = 
		this.mSendRaysBuf[i].peekCBStatistics();

	    double n_objsend = sendstat.getNObjParSend();
	    opstotal += n_objsend;
	    
	    if(n_objsend == 0.0)
	    {
		System.out.print("(NotUsed) "); // Ѥʤä
	    }else
	    {
		System.out.print(n_objsend + " ");
	    }
	}
	System.out.println(" : ave " + 
			   (((double)opstotal) / ((double)this.mTotalPENum)));
	
	/*
	 *  buffer 
	 * 󤢤μǤĤ obj 줿
	 * MPI ݾڤΤ餳פ FIXME
	 */
	System.out.print(mes + stageName + " RecvBuff.NumberOfObjParSend ");
	opstotal = 0.0;
	for(int i = 0; i < MAX_RECV_BUFFNUM; i++)
	{
	    double n_objrecv = 
		this.mRecvRaysBuf[i].peekCBStatistics().getNObjParSend();
	    opstotal += n_objrecv;
	    
	    if(n_objrecv == 0.0)
	    {
		System.out.print("(NotUsed) "); // Ѥʤä
	    }else
	    {
		System.out.print(n_objrecv + " ");
	    }
	}
	System.out.println(" : ave " + 
			   (((double)opstotal) / ((double)MAX_RECV_BUFFNUM)));
    }

    /**
     * getPEID from spcpos
     */ 
    public IntVec3 getNewPEIDFromSpcPos(IntVec3 spcpos)
    {
	return(this.mSpc2PE.getNewPEIDfromSpcPos(spcpos));
    }
}

