/*
 * $Id: RecvBuffer.java,v 1.6.4.1 2000/06/15 20:41:23 yamauchi Exp $
 *
 *     (M\pi)^2 : SendBuffer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * RecvBuffer
 *    ĤΰĤμХåե manage 롥
 *    SendBuffer ФˤʤäƤ롥
 *
 *    ѥХåեƤꡤ쥤ǽʾ˼ޥɤ
 *    ȯԤХåեå롥塼 Obj 򥳥ԡ
 *    μ롥
 *   
 * original source RecvBuffer.h
 *
 * 1999ǯ819()
 *
 * EncodedData Ѥѹ 1999ǯ922()
 */

package jp.ac.tohoku.is.archi.mpi2.net;

import mpi.*;
import jp.ac.tohoku.is.archi.mpi2.util.*;
import jp.ac.tohoku.is.archi.mpi2.common.*;
import jp.ac.tohoku.is.archi.mpi2.sysparam.Mpi2Option;

/**
 * RecvBuffer : ĤμѥХåե
 */
public final class RecvBuffer {
    private int       	mBufRecvObjsPerOnce; // ٤˼ Obj 
    private int       	mRecvObjTag; 	     //  Buf ʪΤ TAG
    private EncodedData mEncodedRecvBuf;     // Хåե
    private ObjectDecoder mObjDec; 	     // ʪΤ Decorder
    private boolean   	mIsLock;	     // Хåե lock 椫ɤ
    private int      	mRecvObjNum; 	     //  Object ο
    private int      	mSizeOfObj; 	     // ʪΤ encode 
    private Request   	mReqHandle;	     // ꥯȥϥɥ
    private Queue     	mObjQueueRef; 	     //Objqueueؤλ
    private int       	mSrcRank;	     //Ǹ˼Υ
    private CommunBufStatistics mCBStat;     // ׾


    /**
     * constructor
     */
    public RecvBuffer()
    {
	this.mBufRecvObjsPerOnce	= -1;
	this.mEncodedRecvBuf		= null;
	this.mObjDec			= null;
	this.mIsLock			= false;
	this.mRecvObjNum		= -1; 
	this.mSizeOfObj			= -1;
	// this.mReqHandle;
	// this.mObjQueueRef;
	this.mSrcRank	= -1;
	this.mCBStat	= new CommunBufStatistics();
    }

    /**
     * initialize : Ƥ٤
     *  @param maxrecvObjsParOnce : ٤˼ʪοκ
     *  @param objQueueRef : 
     *		 Objs ؤΥݥ󥿤륭塼ؤλȡ塼
     *		μΤϤΥ塼ΤФ˾̤˳ݤ
     *		Τ̾   
     *  @param recvObjTAG : 
     *		 RecvBuffer ʪΤμ TAG TAG 
     *		ʪΤΤߤ򤳤 Buffer ϼ롥  
     *  @param objdec : 
     *		Serialize 줿ʪΤǥɤ뤿Υǥ
     */
    public synchronized 
    void init(int maxrecvObjesParOnce, Queue 	objQueueRef, 
	      int recvObjTAG,	       ObjectDecoder objdec)
    {
	if(maxrecvObjesParOnce < 1)
	{
	    throw new RuntimeException("Error! : bufferLength.RecvBuffer.init"+
				       "must be > 0");
	}
	
	// init
	this.mBufRecvObjsPerOnce	= maxrecvObjesParOnce;
	this.mRecvObjTag		= recvObjTAG;
	// this.mEncodedRecvBuf
	this.mObjDec			= objdec;
	this.mIsLock 			= false;
	this.mRecvObjNum		= -1;
	this.mSizeOfObj			= objdec.sizeInDouble();
	this.mReqHandle			= null;
	this.mObjQueueRef 		= objQueueRef;
	this.mSrcRank	  		= -1;
	
	// init statistics 
	this.mCBStat.init();
    }
    
    /**
     * 椫
     *   @return ʤ true
     */
    public boolean isLocking() 
    { 
	return(this.mIsLock);	
    }
    
    /**
     * δλߤ롥
     *   椫鴰λ˰ܹԤ true ֤
     */
    public synchronized boolean completeRecv()
    {
	// ˤƤФʤ
	if(this.isLocking() == false)
	{
	    return(false);
	}
	
	// λ?
	Assert.out(this.mReqHandle != null, 
		   "Error! : no recv is issued : completeRecv");
	if((Mpi2CommFactory.getInstance()).isRecvComplete(this.mReqHandle)
	   == true)
	{
	    //  obj ο
	    Assert.out(this.mRecvObjNum > 0, 
		       "Error! : recv objnum must be > 0. completeRecv");
	    
	    Assert.out(this.mEncodedRecvBuf != null,
		       "Error! : mEncodedRecvBuf is null");

	    // λХåե쥤Ф
	    Decoder dec = this.mEncodedRecvBuf.getDecoder();

	    for(int i = 0; i < this.mRecvObjNum; i++)
	    {
		// ХåեФ obj 򿷤 new  
		// newObj (newRay, newIntensity, ... etc.)! 
		// T *pNewObj = new T (this.mBuff[i]); 
		// Java ξˤϴ new ƤϤ
		
		// PE  procRaysQueue  enqueue 
		this.mObjQueueRef.enq(dec.decode(this.mObjDec)); 
	    }

	    // λΥե饰򥻥åȤΥХåե̤ѤȤ롥
	    this.mIsLock = false;
	    this.mRecvObjNum = -1;
	    return(true);
	}
	else
	{
	    return(false);
	}
    }

    /**
     * ׵ȯԤǤ뤫
     *  @return ׵ȯԤ
     */
    public synchronized boolean issueRecvIfItCan(int recvTags)
    {
	if(this.isLocking() == true)
	{
	    return(false);
	}

	Mpi2Communicator comm  = Mpi2CommFactory.getInstance();
	// DataNum  MPI.BYTE  MPI.DOUBLE ǿ 
	int [] srcRankNDataNums = new int[2]; 
	
	// ɤ餫Ƥ뤫
	if(comm.canRecv(srcRankNDataNums, recvTags, MPI.DOUBLE)  == true) 
	{	
	    // Ƥ롥׵ȯ
	    this.mSrcRank    = srcRankNDataNums[0];
	    this.mRecvObjNum = srcRankNDataNums[1] / this.mSizeOfObj;

	    if(srcRankNDataNums[1] % this.mSizeOfObj != 0)
	    {
		Mpi2Option.getInstance().
		    debugOut("DEBUG : RecvBuffer: can recv srcrank = " + 
			     this.mSrcRank + 
			     ", datnum " + srcRankNDataNums[1] + 
			     ", sizeof Obj " + this.mSizeOfObj + 
			     ", objnum " + this.mRecvObjNum    +
			     ", tag = " + recvTags);
	    }

	    Assert.out(srcRankNDataNums[1] % this.mSizeOfObj == 0,
		       "Error! : datanums % sizeof(obj) must be 0");
	    
	    this.mEncodedRecvBuf = 
		Marshal.createEncodedData(this.mObjDec, this.mRecvObjNum);

	    Assert.out(this.mEncodedRecvBuf.type() == MPI.DOUBLE,
		       "Error ! : Data Type is fixed to MPI.DOUBLE here.");
	    
	    this.mReqHandle = comm.IrecvObj(this.mSrcRank,
					    this.mEncodedRecvBuf, 
					    recvTags);

	    this.mIsLock    = true; 	// ˤʤä lock
	    
	    // ХåեѤפ 
	    this.mCBStat.reportNSendRecvObjs(this.mRecvObjNum); 
	    
	    // Profile Monitor
	    ProfileMon.getInstance().recv(this.mSrcRank, 
					  this.mRecvObjNum, recvTags);

	    return(true);
	}
	else
	{
	    return(false);
	}
    }

    /**
     * ХåեĹ
     *  @return ߤμХåեĹ (Ĺǽ)
     */
    /*
    public int  getFixedBufLen() 	
    { 
	return(this.mBufSize);	
    }
    */

    /**
     * 椫
     *  @return ʤ true
     */
    public synchronized boolean updateRecving(int recvobjTags)
    {
	if(this.isLocking() == true)
	{
	    // δλߤ롥Ǽλ lock ϳ
	    // ⤷ʤʤ⤷ʤ
	    this.completeRecv();
	}

	// ܤ lock ϼλǳ줿⤷ʤ
	if(this.isLocking() == false)
	{
	    // åäƤʤмȯԤߤ롥ǥ
	    // 뤫⤷ʤʤ⤷ʤ
	    this.issueRecvIfItCan(recvobjTags);
	}

	// ɡ 2 ĤФƺǽŪ˥ХåեåƤм
	// Ǥ롥
	return(this.isLocking()); 
    }

    /**
     * Ǹ˼ src rank
     */
    public int getLastSrcRank() 
    {
	return(this.mSrcRank);
    }

    /**
     * ƥȤԤȯԤߤ (ʰ״ؿ)
     */
    public synchronized void recv(int recvobjTags)
    {
	// λƥ
	this.completeRecv(); 
	// μȯԤǤ뤫
	this.issueRecvIfItCan(recvobjTags);
    }

    /**
     * Τ뤫뤤ϼ椫 (ʰ״ؿ)
     */
    public synchronized boolean isRecvObj()
    {
	if(this.isLocking() == true)
	{
	    return(true);
	}
	if(this.mObjQueueRef.length() > 0)
	{
	    return(true);
	}
	return(false);
    }

    /**
     * ׾μ
     */
    public CommunBufStatistics peekCBStatistics()
    {
	return(this.mCBStat);
    }
}
