/*
 * $Id: SendBuffer.java,v 1.7.4.1 2000/06/15 20:41:23 yamauchi Exp $
 *
 *     (M\pi)^2 : SendBuffer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * SendBuffer
 *     (rank) ФХåե
 *    Ȥ object (ray) ݤˤϰʲΤȤԤ
 *	1. object pointer Υ塼 object Υݥ󥿤򤿤Ƥ
 *	2. ٤ޤä object μΤѤΥХåե˥ԡ
 *	   ƤΥХåե̿饤֥Ϥ롥
 *	   ǼͤƼΤΥХåեΥϸȤ롥
 *	   (Ǥ mRealBufSize ޤ) ˤϥХåե lock 롥 
 *	3. ̿饤֥꤬ΤλΤΥХåե unlock 
 *	   롥 
 *
 * original source SendBuffer.h
 *
 * 1999ǯ819()
 *
 * EncodedData Ѥѹ 1999ǯ922()
 */

package jp.ac.tohoku.is.archi.mpi2.net;

import  mpi.*;
import  jp.ac.tohoku.is.archi.mpi2.util.*;
import  jp.ac.tohoku.is.archi.mpi2.common.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;

/**
 * SendBuffer : ĤѤΥХåե
 */
public final class SendBuffer {
    private Queue       mQueue;		   // ΤΥ塼
    private boolean     mIsLockRealBuffer; // Bufferlockʤtrue = 
    private int	        mMaxSendNumParOnce;// ٤祪֥ȿ
    private EncodedData	mEncodedBuf;	   // SerializeΤΥХåե
    private Request     mReqHandle;	   // ꥯȥϥɥ
    private int         mObjectTag;	   // SendBufferObjTAG

    private CommunBufStatistics mCBStat;   // ׾
    
    //  lock 򤫤
    private synchronized void lockRealbuffer()
    {  
	Assert.out(this.mIsLockRealBuffer == false, 
		   "Error!: already locked. lockRealbuffer");
	this.mIsLockRealBuffer = true;	
    }

    // Ƥѹ unlock.
    //   λbuffer ϺѤΤ delete ɬפϤʤ
    private synchronized void unLockRealbuffer()	
    {  
	Assert.out(this.mIsLockRealBuffer == true, 
		   "Error!: already unlocked. unLockRealbuffer");
	this.mIsLockRealBuffer = false;
    }    

    /**
     * ׵ȯԤ
     *   ݥ󥿥塼ˤĤʤǤΤμΤΥХåե˥ԡ 
     *   饤֥롥
     *   ˥Хåե lock Ƥˤϥ顼
     *     @param destRank 	 rank
     *	   @return		 object 
     */
    private synchronized int issueSendObjs(int destRank)
    {
	if(this.isLockRealBuffer() == true)
	{
	    String s = 
		"Error! : Now locking sendbuffer.\n" + 
		"         call unlock before call. destrank = " +
		destRank + ", SendBuffer.issueSendObjs.";
	    throw new RuntimeException(s);
	}
	
	// ԡ mMaxSendNumParOnce ʲ 
	// 	=  mMaxSendNumParOnce 
	int copyObjNum = -1;
	if(this.mQueue.length() < this.mMaxSendNumParOnce) 
	{
	    copyObjNum = this.mQueue.length();
	}
	else
	{
	    copyObjNum = this.mMaxSendNumParOnce;
	}

	// ԡǽʬԡ
	int i = 0;
	Encodable [] sendarray = new Encodable[copyObjNum];
	for(i = 0; i < copyObjNum; i++)
	{
	    Assert.out(this.mQueue.hasElements(), 
		       "Error!: No more objects. SendBuffer.issueSendObjs");
	    sendarray[i] = (Encodable)this.mQueue.deq();
	}
	
	// Хåեˤ
	this.lockRealbuffer();

	// Serialize Хåե줬 lock 
	this.mEncodedBuf = Marshal.createEncodedData(sendarray);
	

	// ׵ȯ 
	Mpi2Communicator comm = Mpi2CommFactory.getInstance();
	this.mReqHandle = 
	    comm.IsendObj(destRank, this.mEncodedBuf, this.mObjectTag);

	// object ĿϿ
	this.mCBStat.reportNSendRecvObjs(copyObjNum);

	// Profile Monitor
	ProfileMon.getInstance().send(destRank, copyObjNum, this.mObjectTag);

	return(copyObjNum);
    }

    /**
     * ׵ϴλλˤ lock 򳰤
     * 	@return ̤鴰λѲ true ֤
     */
    private synchronized boolean isCompleteSend()
    {
	// åƤʤΤǡ׵δλϤʤ(֤ѲϤʤ)
	if(this.isLockRealBuffer() == false)
	{
	    return(false);
	}
	else
	{
	    // å . λƥȤ
	    Mpi2Communicator comm = Mpi2CommFactory.getInstance();
	    if(comm.isSendComplete(this.mReqHandle) == true)
	    {
		this.unLockRealbuffer();
		return(true);	
	    }
	    else
	    {
		return(false);	    
	    }
	}
    }

    /**
     * 塼¸ߤʪο threshold ۤߤ
     */
    private synchronized boolean 
    tryToIssueSendObjsIfExceedQueueLen(int destRank)
    {
	if((this.isExceedQueueLen() == true) && 
	   (this.isLockRealBuffer() == false))
	{
	    this.issueSendObjs(destRank);
	    return(true);
	}else
	{
	    return(false);
	}
    }

    /**
     * 塼¸ߤǽʾˤߤ
     *   @return 
     */
    private synchronized boolean tryToIssueSendObjs(int destRank)
    {
	if((this.mQueue.length() > 0) && 
	   (this.isLockRealBuffer() == false))
	{
	    this.issueSendObjs(destRank);
	    return(true);
	}else
	{
	    return(false);
	}
    }

    /**
     * enqueue 
     *   real buffer 򸫤׵ȯԤƤɤ
     *  ϡ׵ȯԤŪ˹ԤȤˤ1999ǯ529()
     *	  @param  pObj : 塼κǸɲ
     *    @return ߤΥ塼Υ
     */
    private synchronized int enqueue(Object obj)
    {
	this.mQueue.enq(obj);
	this.mCBStat.reportQueLen(this.mQueue.length()); // 塼ĹεϿ
	return(this.getSizeOfQueue()); // ߤΥ塼Υ֤
    }

    /*------------------------------------------------------------
     * public functions
     *-----------------------------------------------------------*/
    public SendBuffer()
    {
	// PROF this.mQueue		= new VectorQueue();
	this.mQueue		= new RingBufferQueue();
	this.mIsLockRealBuffer	= false;
	this.mMaxSendNumParOnce	= -1;
	this.mEncodedBuf	= null;
	this.mReqHandle		= null;
	this.mObjectTag		= Mpi2Enum.TAG_ELSE;
	this.mCBStat		= new CommunBufStatistics();
    }

    /**
     * initialize
     * ٤ call ǽ
     *	@param sendBufferSize : 塼ν
     */
    public synchronized void initBuff(int sendThreshold, int objectTAG) 
    {
	//  queue ˲ĤäƤˤϽǤʤ
	if((this.mQueue != null) && (this.mQueue.length() != 0))
	{
	    throw new RuntimeException("Error! : queue has some elements, " + 
				       "can not initialize.");
	}

	// arg check
	if(sendThreshold < 1)
	{
	    System.out.println("Warning! : sendThreshold must be > 0 at " +
			       "SendBuffer.initBuff, set sendThreshold = 1.");
	    sendThreshold = 1;
	}

	this.mIsLockRealBuffer	= false; // ǤϤʤ
	this.mMaxSendNumParOnce	= sendThreshold;
	// this.mEncodedBuf	= null;
	// this.mReqHandle	= null;
	this.mObjectTag		= objectTAG;
	
	// init statistics 
	this.mCBStat.init();
    }

    /**
     * queue Ĺ٤ͤۤ?
     * 	 @return ٤ͤۤˤ Yes
     */
    public synchronized boolean isExceedQueueLen() 
    {
	return(this.mQueue.length() >= this.mMaxSendNumParOnce);
    }

    /**
     * ΤΥХåե lock 椫
     *   @return ߼ˤĤ lock 椫
     */
    public boolean isLockRealBuffer() 	
    { 
	return(this.mIsLockRealBuffer); 
    }

    /**
     * ΤΥХåեΥ : lock ʤ֤
     *   @return Υ 
     */
    public int  getSendBufSize() 	
    {
	return(this.mMaxSendNumParOnce);	
    }

    /**
     *  queue äƤΤο
     * 	 @return 塼Υ
     */
    public synchronized int getSizeOfQueue() 		
    {
	return(this.mQueue.length());
    }

    /**
     *  sendbuffer ˤϻŻʤ (== (塼Ĺ == 0) && (unlocking))
     * 	@return ʾΤλŻʤ true
     */
    public synchronized boolean isNoMoreWork()
    {
	return((this.getSizeOfQueue()   == 0) && 
	       (this.isLockRealBuffer() == false));
    }


    /*------------------------------------------------------------
     * convenient functions : 褯ѤؿޤȤ᤿
     *-----------------------------------------------------------*/
    /**
     * ʪΤ塼 enqueue 塼Ĺͤۤ
     *   @param enqueueAndSendObj  : Ĥ object 
     *   @param destrank	   :   rank
     *	 @return		   : ȯԻˤ true ֤
     */
    public synchronized boolean 
    enqNewedObjwithMaySend(Object enqueueAndSendObj, int destrank)
    {
	// enqueue
	this.enqueue(enqueueAndSendObj);

	// ׵δλƥ
	this.isCompleteSend();

	// try to send
	return(this.tryToIssueSendObjsIfExceedQueueLen(destrank));
    }

    /**
     * Хåե flush
     * 	 @destrank 	:   rank
     * 	 @return	: ʤ true 
     */
    public synchronized boolean flushdone(int destrank)
    {
	// ׵δλƥ
	this.isCompleteSend();
	
	// try to send 
	return(this.tryToIssueSendObjs(destrank));
    }

    /**
     * ׾μ
     */
    public CommunBufStatistics peekCBStatistics()
    {
	return(this.mCBStat);
    }
}
