/*
 * $Id: TriangleObject.java,v 1.15 1999/12/08 16:40:56 yamauchi Exp $
 *     (M\pi)^2 : Triangle Object
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source triangleObject.h, triangleObject.cc
 * 
 * 1999ǯ729() Primitive 񤤤ˤ Interface Τʤä
 * ΤǡʹˤʤäƤ롥󥯥饹ιѹmpi2doc 
 * 򻲾
 *
 * ϥѥå primitive ʤɤˤư㤦ǥ쥯ȥ٤
 * ǤȤˤ Java ؤΤΤޤޤѴ׻뤹롥
*/

package jp.ac.tohoku.is.archi.mpi2.obj;

import java.lang.String;
import java.lang.Math;
import java.io.Serializable;
import jp.ac.tohoku.is.archi.mpi2.util.Vector3;
import jp.ac.tohoku.is.archi.mpi2.util.IntVec3;
import jp.ac.tohoku.is.archi.mpi2.util.Assert;
import jp.ac.tohoku.is.archi.mpi2.util.Encodable;
import jp.ac.tohoku.is.archi.mpi2.util.ObjectDecoder;
import jp.ac.tohoku.is.archi.mpi2.sysparam.Mpi2Constants;
import jp.ac.tohoku.is.archi.mpi2.sysparam.Mpi2Enum;
import jp.ac.tohoku.is.archi.mpi2.sysparam.Config;


public final class TriangleObject extends ObjectPrimitive 
implements Mpi2Constants, Mpi2Enum, Config, Encodable
, Serializable
{
    // there is super class info

    // geometry info.
    private Vector3 [] mVertexPos;	// ĺ [3]
    // (must be calculate)
    private Vector3 [] mEdge;		// åΥ٥ȥ(ʤ) [3]
    private Vector3    mNrm;		// ѥåˡ٥ȥ
    private Vector3 [] mEdgeNrm; 	// å򸫤٥ȥ [3]
    private double     mPlaneConst; 	// ʿ̤
    private double  [] mEdgeConst; 	// ѥå˿ľʥåʿ [3]
    private double     mArea;		// ѥå
    
    // radiosity value
    private Vector3    mNonRad; 	// ̤ͥ饸ƥ    
    private Vector3    mRadiosity;	// 饸ƥ
    private boolean    mIsInRadiationQ; // for lock (in radiation queue or not)

    // for shading 
    private Vector3 [] mIntensity;	// ĺε [3]
    private int	    [] mAddedIntensityNum; // ٤­ [3]


    private double  getPlaneConstant() 
    {
	return(this.mPlaneConst);
    }
    private Vector3 peekEdgeNormal(int i)
    {
	return(this.mEdgeNrm[i]);
    }
    private double  getEdgeConstant(int i) 
    {
	return(this.mEdgeConst[i]);
    }

    /** 
     * initialize inner object
     * ˴ؤ
     */
    private void calcGeometoryInfo()
    {
	//------------------------------
	// åΥ٥ȥ(Ƥʤ)
	//------------------------------
	this.mEdge = new Vector3[3];
	this.mEdge[0] = (this.mVertexPos[1]).minusNew(this.mVertexPos[0]);
	this.mEdge[1] = (this.mVertexPos[2]).minusNew(this.mVertexPos[1]);
	this.mEdge[2] = (this.mVertexPos[0]).minusNew(this.mVertexPos[2]);

	//------------------------------
	// ѥåˡ٥ȥ
	//------------------------------
	this.mNrm = this.mEdge[0].outPrdNew(this.mEdge[1]);
	this.mNrm.normalize();

	//------------------------------
	// å鳰򸫤٥ȥ
	//------------------------------
	this.mEdgeNrm = new Vector3[3];
	this.mEdgeNrm[0] = (this.mNrm).outPrdNew(this.mEdge[0]);
	this.mEdgeNrm[0].normalize();
    
	this.mEdgeNrm[1] = this.mNrm.outPrdNew(this.mEdge[1]);
	this.mEdgeNrm[1].normalize();
	
	this.mEdgeNrm[2] = this.mNrm.outPrdNew(this.mEdge[2]);
	this.mEdgeNrm[2].normalize();
	
	//------------------------------
	// NrmP1 = - d: plane constant
	//------------------------------
	this.mPlaneConst = (this.mNrm).innPrd(this.mVertexPos[0]);
	
	//------------------------------
	// ѥåˡ˿ľʥåޤʿ̤ Nv1 = d_e1
	//------------------------------
	this.mEdgeConst    = new double[3];
	this.mEdgeConst[0] = (this.mEdgeNrm[0]).innPrd(this.mVertexPos[0]);
	this.mEdgeConst[1] = (this.mEdgeNrm[1]).innPrd(this.mVertexPos[1]);
	this.mEdgeConst[2] = (this.mEdgeNrm[2]).innPrd(this.mVertexPos[2]);
	
	//------------------------------
	// ѷ ... tripatch.Area.tex 
	// S = \frac{1}{2} ab sin(\theta) 
	//   = \frac{1}{2} \sqrt{|a|^2 |b|^2 - (a \dot b)^2} 
	// (overflow )
	//------------------------------
	double aSquare = (this.mEdge[0]).innPrd(this.mEdge[0]); // 礭
	double bSquare = (this.mEdge[2]).innPrd(this.mEdge[2]); // ɤ
	double aDotb   = 
	    (this.mEdge[0]).innPrd((Vector3.ZERO).minusNew(this.mEdge[2]));
	this.mArea = 0.5 * Math.sqrt(aSquare * bSquare - aDotb * aDotb);
    }
    
    /**
     * Constructor
     */
    public TriangleObject(int objectID, int materialID, IntVec3 spcpos,
			  Vector3 v1, Vector3 v2, Vector3 v3,// geometry
			  Vector3 nonRad) 		     // radiosity
    {
	// super class
	// 	this.mObjectID  = rhs.mObjectID;	
	// 	this.mMaterial  = material;
	// 	this.mSpcPos    = spcpos;
	super(objectID, materialID, spcpos);
	
	// geometry
	this.mVertexPos    = new Vector3[3];
	this.mVertexPos[0] = v1;
	this.mVertexPos[1] = v2;	
	this.mVertexPos[2] = v3;
	this.calcGeometoryInfo();

	// radiosity
	this.mNonRad	= new Vector3(Vector3.ZERO);
	this.mRadiosity	= new Vector3(Vector3.ZERO);
	this.mIsInRadiationQ = false;
	this.addUnshotRadiosity(nonRad); // ˤꥨͥ륮

	// shading 
	this.mIntensity = new Vector3[3];     // ĺε [3]
	this.mAddedIntensityNum = new int[3]; // ٤­ [3]
	for(int i = 0; i < 3; i++)
	{
	    this.mIntensity[i] = new Vector3();
	    this.mAddedIntensityNum[i] = 0;
	}
    }

    /**
     * copy constructor 
     */
    public TriangleObject(TriangleObject rhs)
    {
	// super class
	// 	this.mObjectID  = rhs.mObjectID;	
	// 	this.mMaterial  = rhs.mMaterial;	// material ϶ͭ
	//	this.mSpcPos    = new Vector3(rhs.mSpcPos);
	super(rhs.getObjectID(), rhs.getMaterialID(), rhs.peekSpcPos());
	
	// geometry
	this.mVertexPos = new Vector3[3];
	this.mEdge     	= new Vector3[3];
	this.mEdgeNrm  	= new Vector3[3];
	this.mEdgeConst	= new double[3];
	int i;
	for(i = 0; i < 3; i++)
	{
	    this.mVertexPos[i]   	= new Vector3(rhs.mVertexPos[i]);
	    this.mEdge[i]     	= new Vector3(rhs.mEdge[i]);
	    this.mEdgeNrm[i]  	= new Vector3(rhs.mEdgeNrm[i]);
	    this.mEdgeConst[i]	= rhs.mEdgeConst[i];
	}

	this.mNrm		= new Vector3(rhs.mNrm);
	this.mPlaneConst	= rhs.mPlaneConst;
	this.mArea		= rhs.mArea;

	// radiosity value
	this.mNonRad		= new Vector3(rhs.mNonRad); 
	this.mRadiosity		= new Vector3(rhs.mRadiosity);
	this.mIsInRadiationQ	= rhs.mIsInRadiationQ;

	// for shading 
	this.mIntensity		= new Vector3[3];
	this.mAddedIntensityNum	= new int[3];
	for(i = 0; i < 3; i++)
	{
	    this.mIntensity[i]		= new Vector3(rhs.mIntensity[i]);
	    this.mAddedIntensityNum[i]	= rhs.mAddedIntensityNum[i];
	}
    }
    
    //------------------------------------------------------------
    // radiosity
    //------------------------------------------------------------
    /**
     * rad ˤϴ˥եեݤäƤ
     * radiosity ̤ͤä
     */
    public void addUnshotRadiosity(Vector3 rad)
    {
	this.mNonRad.plusHere(rad);
    }
    
    /**
     * ̤ͤ radiosity ͤ radiosity ͤ˲äĺε٤
     * (׻λѤ)   
     * ׻λ radiosity ͤ update  (λ̤ͤΥͥ
     * ֤) 
     *   @return Ǹޤͤʤäʬͥͥ륮֤
     */
    public double flushUnshotRadiosityNInitVerInt()
    {
	// Ǹޤͤʤäͥ륮
	double nonRadEnergy = this.getNonRadEnergy(); 

	// ̤ͤʬ򤳤Υѥå뤵ȤƲä
	(this.mRadiosity).plusHere(this.mNonRad);
	this.mNonRad.set(Vector3.ZERO);

	// ĺνͤ radiosity ΤΤǲä 1 
	this.mIntensity[0].set(this.mRadiosity);
	this.mIntensity[1].set(this.mRadiosity);
	this.mIntensity[2].set(this.mRadiosity);
	this.mAddedIntensityNum[0] = 1;
	this.mAddedIntensityNum[1] = 1;
	this.mAddedIntensityNum[2] = 1;

	return(nonRadEnergy);
    }

    /**
     *  patch  energy 1998ǯ12 9()
     *   η׻ɤޤΤʤ
     *   (ޤVector3(R,G,B) * Area ɤȤƤ)
     *	Graphics Gems  II  Progressive Refinement ǤϤ
     *	Ƥ褦 1998ǯ1211()
     */
    public double getNonRadEnergy()
    {
	double ret = this.mArea * (this.mNonRad.get(Vector3.X) +
				   this.mNonRad.get(Vector3.Y) +
				   this.mNonRad.get(Vector3.Z)); 
	return(ret);	
    }
    
    /**
     * radiation queue ˲٤ʤ褦(lock & unlock)
     */
    public void setInRadiationQueue() 
    {	
	Assert.out(this.mIsInRadiationQ == false, "setInradiationQueue");
	this.mIsInRadiationQ = true; // lock
    }
    /**
     * unlock
     */
    public void unsetInRadiationQueue()
    {
	Assert.out(this.mIsInRadiationQ == true, 
		   "not in queue: unsetInRadiationQueue");
	this.mIsInRadiationQ = false; // unlock
    }
    /**
     * is locking now?
     */
    public boolean isInRadiationQueue()
    { 
	return(this.mIsInRadiationQ);
    }
    /**
     * Ѥ֤
     */
    public double getArea() 
    { 
	return(this.mArea);     
    }
    
    /**
     * ſ (HemiCube 濴֤֤ٷ׻褦ˤ롥
     */
    public Vector3 getNewGCenter()
    {
	// ([0] + [1] + [2]) / 3.0
	Vector3 g = (this.mVertexPos[0]).plusNew(this.mVertexPos[1]);
	g.plusHere(this.mVertexPos[2]);
	g.divScalerHere(3.0);
	return(g);
    }

    /** 
     *  ѥå̤ radioosity ֤ͤ
     *	饸ƥ + ̤ͥꥢ
     *	ޤ atomic (ϥ塼ФȤ atomic 
     *	Ͼ̤Υ롼ݤ) 
     */
    public Vector3 getNewClearNonRadAndUpdateRadiosity()
    {
	this.mRadiosity.plusHere(this.mNonRad); // 饸ƥ
	Vector3 retNonRad = new Vector3(this.mNonRad);	// ̤¸
	this.mNonRad.set(0.0, 0.0, 0.0); // ̤ͥꥢ
	return(retNonRad);			
    }

    // const Vector3 getNonRad()  { return(this.mNonRad);	}

    /**
     * ĺε٤ʿѲ
     */
    public void calcVerIntAveVal()
    {
	for(int i = 0; i < 3; i++)
	{
	    // mIntensity[i] /= (double)(this.mAddedIntensityNum[i]);
	    this.mIntensity[i].
		divScalerHere((double)(this.mAddedIntensityNum[i]));
	}
    }	
    
    //------------------------------------------------------------
    // ObjectPrimitive abstract methods
    //------------------------------------------------------------
    /**
     * ʪΤޤǤεΥ(if ret PlusInfty =  not hit)
     */
    public double getDistance(Ray aRay, Vector3 hitposRef)
    {
	double distance = Double.MAX_VALUE; // ޤǤεΥ          
	double tpDotRay = 0.0;	 // Ѥ                  
    
	// ѷݥꥴޤʿ̤Ȥθ       
	tpDotRay = (this.peekNormal(null)).innPrd(aRay.peekDir());
	if(tpDotRay >= -(D_ERROR_RES))
	{				// ʤ(΢򺹤ʤ)
	    return(Double.MAX_VALUE);
	}

	// ѷݥꥴޤʿ̤ȤθȤεΥ
	distance = (this.getPlaneConstant() - 
		    (this.peekNormal(null)).innPrd(aRay.peekPos())) / tpDotRay;
	
	if(distance <= Mpi2Constants.D_ERROR_RES)
	{				// ʤ(ˤ)
	    return(Double.MAX_VALUE);
	}
    
	// 
	// hitpos = (apRay.getDir()) * distance + (apRay.getPos());
	hitposRef.set(aRay.peekDir());
	hitposRef.mulScalerHere(distance);
	hitposRef.plusHere(aRay.peekPos());
    
	// åθ(ѷ?)
	for(int i = 0; i < 3; i++)
	{
	    double dTes = (this.peekEdgeNormal(i)).innPrd(hitposRef) - 
		this.getEdgeConstant(i);
	    if(dTes < 0.0)
	    {			// 褿黰ѥѥåγˤ = 
		return(Double.MAX_VALUE);
	    }
	}
	// Hit
	return(distance); 
    }

    public Vector3 peekNormal(Vector3 hitpos) 
    {
	return(this.mNrm);	    
    }

    /**
     *  porigonID ĺΰ֤äƤ鵱٤ä
     */
    public void addIntensityToVertex(VertexIntensity vint)
    {
	if(this.getObjectID() == vint.getPolygonID())
	{
	    for(int i = 0; i < 3; i++)
	    {
		if(this.mVertexPos[i].equals(vint.peekVertexPos()))
		{
		    this.mIntensity[i].plusHere(vint.peekIntensity());
		    this.mAddedIntensityNum[i]++;
		    break;		// ĺɬ㤦ΤǰĹ礨нλ
		}
	    }
	}	
    }
    
    /**
     * ݥꥴǰͤ Radiosity ͤĺΰ־Ф
     *	Ƶ٤ФʤΤϵ٤äλ˳Ƶ٤äƤ
     *	˸ߤ礦ͤˤʤʤ
     *
     *	dest spcpos ʤΤäƤ
     *	֤ͤ src (= ĺΤ) ְ
     */
    public void getRadVer(VertexIntensity [] radiosityVertexInfo3)
    {
	final IntVec3 illegalSpcPos = new IntVec3(-1, -2, -3);

	for(int i = 0; i < 3; i++)
	{
	    Assert.out(this.mIntensity[i].get(Vector3.X) >= 0.0, "getRadVer");
	    radiosityVertexInfo3[i].set(this.getObjectID(),  
					new IntVec3(illegalSpcPos),
					this.mRadiosity, 
					this.mVertexPos[i]);
	}	
    }

    /**
     * ĺȳƵ٤Ф
     *	dest spcpos ʤΤäƤ
     *	֤ͤ src (= ĺΤ) ְ
     */
    private final static IntVec3 IllegalSpcPos = new IntVec3(-1, -2, -3);
    public void getVerIntensity(VertexIntensity [] intensityVertexInfo3)
    {
	for(int i = 0; i < 3; i++)
	{
	    Assert.out(this.mIntensity[i].get(Vector3.X) >= 0.0,
		       "getVerIntensity");
	    intensityVertexInfo3[i].set(this.getObjectID(),    
					new IntVec3(IllegalSpcPos),
					this.mIntensity[i], 
					this.mVertexPos[i]);
	}
    }

    /**
     * flat shading 
     */
    public Vector3 newFlatRadiosityColor(Vector3 hitPos)
    {
	return(new Vector3(this.mRadiosity));
    }
    
    /*------------------------------------------------------------
     * Gouroud shading 
     *-----------------------------------------------------------*/
    /**
     * ˤ륨顼ȯͤν
     */
    private void showvers(Vector3 hitpos, Vector3 hvec, Vector3 evec,
			  Vector3 top,    Vector3 side, Vector3 other,
			  int asX, int asY, double oeh, double t, double s)
    {
	String str = 
	    "hitpos        " + hitpos + "\n" + 
	    "to hitpos vec " + hvec   + "\n" + 
	    "edge vector   " + evec   + "\n" + 
	    "vertex top    " + top    + "\n" + 
	    "vertex side   " + side   + "\n" + 
	    "vertex other  " + other  + "\n" + 
	    "asX           " + asX    + "\n" + 
	    "asY           " + asY    + "\n" + 
	    "oeh           " + oeh    + "\n" + 
	    "t             " + t      + "\n" + 
	    "s             " + s;
	System.out.println(str);
    }


    /**
     * Gouroud shading calculation
     *
     * hit point ΰ֤ε٤֤
     * 	Gouroud shading
     *
     * äˤϻѷǤäƤĻѷ˸ǡ
     *  top ĺ˰פʤʤФη׻ɬϤȤ
     * ȤǤ롣(0 ǳ褦ʾ֤Ǥʤ)
     * (⤽פǤʤΤǤǤʤˤб褦˽
     * )   
     *
     */
    public Vector3 newShadedRadiosityColor(Vector3 hitPos)
    {
	final double ERRTOL = 1.0e-20; // error tolerance 
	
	int sidever, otherver, topver, asX, asY; 
	otherver = sidever = asX = asY = -1; // פjavacʸ

	// find (asX, asY) plane
	for(topver = 0; topver < 3; topver++)
	{
	    sidever  = (topver + 1) % 3;
	    otherver = (topver + 2) % 3;
	    asX = asY = -1;
	    for(int i = 0; i < 3; i++)
	    {
		//// ۤʤ˸褦 X,Y 򤹤
		if(Math.abs(this.mVertexPos[topver  ].get(i) - 
			    this.mVertexPos[sidever ].get(i)) > 1e-6)
		{			//// top, side ΰۤʤ뼴Ǥꡢ
		    for(int j = 0; j < 3; j++)
		    {
			if(i != j)	// i ϷꤷƤ
			{
			    if(Math.abs(this.mVertexPos[topver  ].get(j) -
					this.mVertexPos[otherver].get(j)) 
			       > 1e-6)
			    {
				asX = i;
				asY = j;
				i = 3; // 롼æ : goto ǽФ٤
				break;
			    }
			}
		    }
		}
	    }
	    if(asX >= 0)
	    {
		break;
	    }
	}
	if(asX < 0)
	{
	    if(SHADE_ERR_OUT)
	    {
		System.out.println("Warning! : can't solve this triangle. asX("
				   + asX + ") < 0) but ignored and average " +
				   "intensity.");
	    }
	    // Vector3 aveInt = (this.mIntensity[0] + this.mIntensity[1] +
	    //		      this.mIntensity[2]) / 3.0;  
	    Vector3 aveInt = this.mIntensity[0].plusNew(this.mIntensity[1]);
	    aveInt.plusHere(this.mIntensity[2]);
	    aveInt.divScalerHere(3.0);  

	    return(aveInt);
	}
    
	if((Math.abs(this.mVertexPos[topver].get(Vector3.X) - 
		     hitPos.get(Vector3.X)) < ERRTOL) && 
	   (Math.abs(this.mVertexPos[topver].get(Vector3.Y) - 
		     hitPos.get(Vector3.Y)) < ERRTOL) && 
	   (Math.abs(this.mVertexPos[topver].get(Vector3.Z) - 
		     hitPos.get(Vector3.Z)) < ERRTOL))
	{
	    // top ĺפλˤϤΤޤ
	    return(this.mIntensity[topver]); 
	}
    
	// Vector3 hvec = hitPos - this.mVertexPos[topver];
	Vector3 hvec = hitPos.minusNew(this.mVertexPos[topver]);
	// Vector3 evec = this.mVertexPos[otherver] - this.mVertexPos[sidever];
	Vector3 evec = 
	    this.mVertexPos[otherver].minusNew(this.mVertexPos[sidever]);
	double ex    = evec.get(asX);
	double ey    = evec.get(asY);
	double hx    = hvec.get(asX);
	double hy    = hvec.get(asY);
	double Tx    = this.mVertexPos[topver].get(asX);  // P0x (top vertex)
	double Ty    = this.mVertexPos[topver].get(asY);  // P0y
	double Sx    = this.mVertexPos[sidever].get(asX); // P1x (side vertex)
	double Sy    = this.mVertexPos[sidever].get(asY); // P1y
	double oeh   = ex * hy - ey * hx; // t ʬ
	
	if(Math.abs(oeh) < ERRTOL)		
	{				// ǤϤʤʤϤ
	    if(SHADE_ERR_OUT)
	    {
		String s = "Error! : can't solve this triangle. oeh near 0\n" +
		    "ignored and average intensity (t, s is not calced)";
		System.out.println(s);
	    }
	    if(InDEBUG)
	    {
		this.showvers(hitPos, hvec, evec, 
			      this.mVertexPos[topver],
			      this.mVertexPos[sidever],
			      this.mVertexPos[otherver], 
			      asX, asY, oeh, -1.0, -1.0);
	    }
	    // Vector3 aveInt = (this.mIntensity[0] + this.mIntensity[1] +
	    //		      this.mIntensity[2]) / 3.0;  
	    Vector3 aveInt = this.mIntensity[0].plusNew(this.mIntensity[1]);
	    aveInt.plusHere(this.mIntensity[2]);
	    aveInt.divScalerHere(3.0);  

	    return(aveInt);
	    // commMpi2_exit(1);
	}
	double t = (Tx * hy - Ty * hx - Sx * hy + Sy * hx) / oeh;
	double s;
	if(Math.abs(hx) > Math.abs(hy))
	{
	    s = (Sx - Tx + t * ex) / hx;
	}else
	{
	    s = (Sy - Ty + t * ey) / hy; // hx ˤ hy Ƿ׻
	}
	// Vector3 intensityP = (1.0 - t) * this.mIntensity[sidever]
	// 	    + t * this.mIntensity[otherver];
	Vector3 intensityP = this.mIntensity[sidever].mulScalerNew(1.0 - t);
	intensityP.plusHere(this.mIntensity[otherver].mulScalerNew(t));

	// Vector3 intensityH =  (1.0 - (1.0 / s)) * this.mIntensity[topver]
	//    + (1.0 / s) * intensityP;
	Vector3 intensityH = 
	    this.mIntensity[topver].mulScalerNew(1.0 - (1.0 / s));
	intensityH.plusHere(intensityP.mulScalerNew(1.0 / s));
	
	if(InDEBUG)
	{
	    if((t < -0.0001) || (s < -0.0001))
	    {
		System.out.println("Error! : illegal t or s");
		this.showvers(hitPos, hvec, evec, 
			      this.mVertexPos[topver], 
			      this.mVertexPos[sidever],
			      this.mVertexPos[otherver], 
			      asX, asY, oeh, t, s);
	    }
	}

	// ٷ׻˼Ԥˤϳĺʿͤ٤Ȥ롣
	if((intensityH.get(Vector3.X) < 0.0) || 
	   (intensityH.get(Vector3.Y) < 0.0) || 
	   (intensityH.get(Vector3.Z) < 0.0))
	{
	    if(SHADE_ERR_OUT)
	    {
		System.out.println("Warning! : calcRayTrIC.intensity " + 
				   intensityH + ": < 0.0");
	    }
	    // intensityH = (this.mIntensity[0] + this.mIntensity[1] +
	    // 		  this.mIntensity[2]) / 3.0;
	    intensityH = this.mIntensity[0].plusNew(this.mIntensity[1]);
	    intensityH.plusHere(this.mIntensity[2]);
	    intensityH.divScalerHere(3.0);

	    if(InDEBUG)
	    {
		this.showvers(hitPos, hvec, evec, 
			      this.mVertexPos[topver],
			      this.mVertexPos[sidever],  
			      this.mVertexPos[otherver], 
			      asX, asY, oeh, t, s);
	    }
	}
	return(intensityH);
    }

    
    /**
     * toString 
     */
    public String toString()
    {
	String s = 
	    " f " + this.getObjectID() + " " + this.mVertexPos[0] + " " 
	    +   this.mVertexPos[1] + " " + this.mVertexPos[2] + " "
	    +   this.peekSpcPos();
	return(s);
    }

    /**
     * toString 
     */
    public String toStringWithHead(String head)
    {
	String s = head + " # materialID = " + this.getMaterialID() + "\n"
	    + head + " f " + this.getObjectID() + " " + this.mVertexPos[0] +
	    " " + this.mVertexPos[1] + " " + this.mVertexPos[2] + " "  +
	    this.peekSpcPos();
	return(s);
    }

    /**
     * to String with type 
     */
    public String getMgfForm(int outputType)
    {
	String s;
	switch(outputType)
	{
	case NORMAL_ObjOut:
	    s = "f " + this.getObjectID() + " " + 
		this.mVertexPos[0] + " " + this.mVertexPos[1] + " " + 
		this.mVertexPos[2] + this.peekSpcPos();
	    return(s);
	
	case WITH_SHOT_RADOUT:
	    s = "F " + this.getObjectID() + " " + 
		this.mVertexPos[0] + " " + this.mVertexPos[1] + " " + 
		this.mVertexPos[2] + " " +
		this.peekSpcPos()    + " " + this.mRadiosity;
	    return(s);
	
	case WITH_UNSHOT_RADOUT:
	    s = "F " + this.getObjectID() + " " + 
		this.mVertexPos[0] + " " + this.mVertexPos[1] + " " + 
		this.mVertexPos[2] + " " +
		this.peekSpcPos()    + " " + this.mNonRad;
	    return(s);

	default:
	    throw new RuntimeException("Internal Error! : " +
				       "TriangleObject::getMgfForm : " +
				       "Illegal Output Type.");
	    // break;
	}	
    }

    public int who() 
    {
	return(OBJ_TRIANGLE);
    }

    /**
     * ֤¸ߤƤ뤫Ĵ٤
     */
    public boolean isAtValidSpcPos(Vector3 partmin, Vector3 subSpcSize, 
				   int subdivnum)
    {
	// check spcpos num
	for(int i = 0; i < 3; i++)
	{
	    if((this.peekSpcPos().get(i) < 0) || 
	       (this.peekSpcPos().get(i) >= subdivnum))
	    {
		throw new RuntimeException("Error! :f(Triangle): " +
					   "spcpos is out of define space.");
		// return(false);
	    }
	}

	// check vertex range
	double [] min = new double[3];
	double [] max = new double[3];
	for(int i = 0; i < 3; i++)
	{
	    min[i] = partmin.get(i) + 
		(double)(this.peekSpcPos().get(i))  * subSpcSize.get(i);
	    max[i] = partmin.get(i) + 
		(double)(this.peekSpcPos().get(i) + 1) * subSpcSize.get(i);
	}
	final double err_tolerance = subSpcSize.get(0) * 1e-3; // 1 % ޤǤ OK
	
	for(int ver = 0; ver < 3; ver++)
	{
	    for(int i = 0; i < 3; i++)
	    {
		if((this.mVertexPos[ver].get(i) < (min[i] - err_tolerance)) ||
		   (this.mVertexPos[ver].get(i) > (max[i] + err_tolerance)))
		{
		    final String [] s = { "x", "y", "z", };
		    System.out.println("Error! :f(triangle): vertex["
				       + ver + "](" + s[i] + ") is not "
				       + "in legal spcpos");
		    System.out.println("It must be in [" + min[i] + 
				       ", " + max[i] + "]. (tolerance= "
				       + err_tolerance + ")");
		    return(false);
		}
	    }
	}
	return(true);
    }

    /*
     * ̿ѤΥ֤
     */
    public static int getTAG() 
    { 
	return(Mpi2Enum.TAG_TRIANGLE_OBJ);	
    }

    /**
     * For Encodable interface (and ObjectDecoder object).
     */
    final static int vectorSize = Vector3.ZERO.sizeInDouble();
    final static int intvecSize = IntVec3.ZERO.sizeInDouble();
    final static int doubleSize =
    1 				// material ID
    + intvecSize		// spcpos size
    + 3 * vectorSize 		// 3 ĺ
    + vectorSize		// non Rad
    + 1; 			// Object ID
    public int sizeInDouble() 
    {
	return doubleSize;
    }
    public void encodeInDouble(double[] array, int offset) 
    {
	// TriangleObject  construct ΤɬפʬΤ
	array[offset] = (double)this.getObjectID();
	offset++;

	array[offset] = (double)(this.getMaterialID());     
	offset++;
	
	(this.peekSpcPos()).encodeInDouble(array, offset);
	offset += intvecSize;
    
	this.mVertexPos[0].encodeInDouble(array, offset);
	offset += vectorSize;
	this.mVertexPos[1].encodeInDouble(array, offset);
	offset += vectorSize;
	this.mVertexPos[2].encodeInDouble(array, offset);
	offset += vectorSize;

	this.mNonRad.encodeInDouble(array, offset);
	offset += vectorSize;

  }
  static class TriangleObjectDecoder implements ObjectDecoder {
    public int sizeInDouble() {
	return doubleSize;
    }
    public Object decodeFromDouble(double[] array, int offset) {

// 	for(int i = 0; i < array.length; i++)
// 	{
// 	    System.out.println("DEBUG Decode " + array[i]);
// 	}

	ObjectDecoder vec3  = Vector3.getObjectDecoder();
	ObjectDecoder ivec3 = IntVec3.getObjectDecoder();

	int objectID =   (int)(array[offset]); 
	offset++;

	int materialID = (int)(array[offset]);
	offset++;

	IntVec3 spcpos = (IntVec3)(ivec3.decodeFromDouble(array, offset));
	offset += intvecSize;
    
	Vector3 v1 = (Vector3)(vec3.decodeFromDouble(array, offset));
	offset += vectorSize;
    
	Vector3 v2 = (Vector3)(vec3.decodeFromDouble(array, offset));
	offset += vectorSize;
    
	Vector3 v3 = (Vector3)(vec3.decodeFromDouble(array, offset));
	offset += vectorSize;

	Vector3 nonrad = (Vector3)(vec3.decodeFromDouble(array, offset));
	offset += vectorSize;

// 	System.out.println("TriObj::decode mID = " + materialID + 
// 			   ", spcpos " + spcpos + "\nv1 " + v1 + 
// 			   ", v2 " + v2 + ", v3 " + v3 + 
// 			   "\nnonrad " + nonrad + ", objID " + objectID);

	return(new TriangleObject(objectID, materialID, spcpos, 
				  v1, v2, v3, nonrad));
    }
  }
  private final static ObjectDecoder odInstance
    = new TriangleObjectDecoder();
  public static ObjectDecoder getObjectDecoder() {
    return odInstance;
  }
}

