/*
 * $Id: CalcRayTrIC.java,v 1.3 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : Intensity Calcurator of Ray-Tracer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source calcRayTrIC.cc
 *
 *	쥤ȥ졼ˡǤεٷ׻
 * 
 *-- Mapping μϤɤǤ
 *
 * 1999ǯ827()
 */


package jp.ac.tohoku.is.archi.mpi2.raytrace;

import	java.util.*;

import	jp.ac.tohoku.is.archi.mpi2.common.*;
import	jp.ac.tohoku.is.archi.mpi2.dda.*;
import	jp.ac.tohoku.is.archi.mpi2.net.*;
import	jp.ac.tohoku.is.archi.mpi2.obj.*;
import	jp.ac.tohoku.is.archi.mpi2.host.*;
import	jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import	jp.ac.tohoku.is.archi.mpi2.util.*;


/*
 * NO_OUT_SHADE_ERROR Ƥʤˤ shading η׻˼
 * ȥ顼åϤ 
 */

public final class CalcRayTrIC implements Mpi2Enum {

    /**
     * calculate Intensity 
     * 	٤׻ ray ˲äƤ
     */
    public static void calcNsetIntensityRayTr(Ray ray, ObjectPrimitive hitobj,
					      int shadingScheme)
    {
	Assert.out(hitobj != null, "Error!: no ojbect calcNsetIntensityRayTr");

	// ٷ׻ ׻ѤߤʪΤγȻ٤ 
	// ȻȿͤϷ׻ƤȤǤʪΤγȻȿͷϳݤʤ
	Vector3 intensity = new Vector3(ray.peekColor());
	Vector3 rayCoeff  = new Vector3(ray.peekRefCoeff());	
	Vector3 shadedColor = new Vector3();
	
	// swich in most deep location, can I improve? IMPROVEME
	switch(shadingScheme)
	{
	case FlatShading:
	    // intensity += (ray.getRefCoeff()) * 
	    //		    (hitobj.getFlatRadiosityColor(ray.getHitPos()))
	    shadedColor.set(hitobj.newFlatRadiosityColor(ray.peekHitPos()));
	    break;
	case GouroudShading:
	    // intensity = intensity + (ray.getRefCoeff()) * 
	    //             (hitobj.getShadedRadiosityColor(ray.getHitPos()));
	    shadedColor.set(hitobj.newShadedRadiosityColor(ray.peekHitPos()));
	    break;
	default:
	    String s = "Internal Error!:illegal shading scheme"
		+ " in CalcRayTrIC.calcNsetIntensityRayTr";
	    throw new RuntimeException(s);
	}

	rayCoeff.mulVecHere(shadedColor);
	intensity.plusHere(rayCoeff);

	ray.setColor(intensity);

	//-- ray.incReflectedNum();	// ää
	//--  new 뤳ȤäΤǤϤʤ FIXME

	//-- ̤ȿͤ˸그Ѳ뤬󼡸ȯ
	//-- ʬǹԤ 
    }
}
