/*
 * $Id: CalcRayTrSRG.java,v 1.5.4.1 2000/06/15 20:41:23 yamauchi Exp $
 *     (M\pi)^2 : 󼡸ȯ
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source calcRayTrSRG.cc
 *
 * 쥤ȥ졼ˡ󼡸ȯ
 *	ray-tracing ˡ radiosity ˡǤȿͥ쥤˰㤤ꡥ
 *	󼡥쥤ȯ for RayTracing
 * 
 * 1999ǯ9 1()
 * 
 *-- ⤦ 9 ɥĤֻ accept Ǵ򤷤
 *-- ĶѲΤ԰¤Ҥɤ꤬Ȥϻפʤ
 *-- ڤ椬ǤȤʤ
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;

import	jp.ac.tohoku.is.archi.mpi2.common.*;
import	jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import	jp.ac.tohoku.is.archi.mpi2.obj.*;
import	jp.ac.tohoku.is.archi.mpi2.util.*;

/**
 * 2 ray-tracing ray 
 *     	ٷ׻ IC ǺѤǤ
 *	(ʸ˽񤤤Ƥ߷פȤϰ㤤ΤȤ IC.SRG ³򼨤
 *	 Ƥ롥ʸǤȿ FrameBuffer ؤƤ뤬
 *	 ˤ ray Ǥκݤˤ FrameBuffer ؤιʤ
 *		(see mpi2doc_implementation)
 */
public final class CalcRayTrSRG 
{
    /**
     * ȿͤˤ󼡥쥤ȯ
     *	߿ΤѤ ray tracing ǤϤʤ
     * @param ray 		IN 	ͥ쥤
     * @param minRayCoefNorm    IN  	ȿͻκǾͥ륮
     * @param hitobj 	    	IN	pRay Ȥθʪ
     * @param reflectRayDir    	OUT	ȿͥ쥤٥ȥ
     * @param reflectRayCoeff  	OUT	ȿͥ쥤εٷ
     * @return 				
     */
    public static boolean 
    getReflectionRayDirRayTrace(Ray 		ray,
				double		minRayCoefNorm,
				ObjectPrimitive hitobj,
				Vector3      	reflectRayDir,
				Vector3		reflectRayCoeff,
				Material []	matArray)
    {
	Assert.out(hitobj != null, 
		   "Error!:nohitobj CalcRayTrSRG.getReflectionRayDirRayTrace");

	/*
	 * ȿ͸그׻
	 */
	final Material mat = matArray[hitobj.getMaterialID()];
	Vector3 ref = (ray.peekRefCoeff()).mulVecNew(mat.peekSpecRef());
	reflectRayCoeff.set(ref);

	/*
	 * commented by tosho : ޤǤƼϤʤ ray Ƥ
	 *   ȿ͸그ʲ ray Ϥʾ¤ʤ
	 */
	if((reflectRayCoeff).innPrd(reflectRayCoeff) < minRayCoefNorm)
	{
	    return(false);
	}

	/*
	System.out.println("DEBUG:refcoef " + reflectRayCoeff + ", inprd " + 
			   (reflectRayCoeff).innPrd(reflectRayCoeff) + 
			   " < min " +  minRayCoefNorm + ", raycoeff "
			   + ray.peekRefCoeff() + ", matspec " + 
			   (mat.peekSpecRef()));
			   */
	/*
	 * ȿ
	 * tokunaga change: 
	 * sphere ξ getNormal ֤äƤ٥ȥ뤬γ
	 * ƤΤʪ˥쥤ϡҤȤޤˡո
	 * ˤ롣  
	 */
	Vector3 normal = null;
	switch(hitobj.who())
	{
	case ObjectPrimitive.OBJ_TRIANGLE:
	    normal = new Vector3(((TriangleObject)hitobj).peekNormal(null));
	    break;
	    
	case ObjectPrimitive.OBJ_SPHERE:
	    // normal = hitobj.peekNormal(ray.peekHitPos()); 
	    normal = new Vector3((((SphereObject)hitobj).
				  peekNormal(ray.peekHitPos())));
	    if(ray.isInSideObject())
	    {
		normal.mulScalerHere(-1.0); // ˤΤˡȿž
	    }
	    break;
	
	case ObjectPrimitive.OBJ_NULL:
	default:
	    throw new RuntimeException("Internal Error! : illegal object : " +
				       "getReflectionRayDirRayTrace");
	}

	// ˡƤϤ
	Assert.out(Math.abs(normal.getNorm() - 1.0) < 
		   Mpi2Constants.D_ERROR_RES, 
		   "Error!: normal vector must be normalized. reflect"); 
	/*
	 * ȿͥ쥤η׻ 
	 *  ȿͥ쥤 =
	 *  (-2.0 * ((ray.peekDir()).innPrd(normal)) * normal) + ray.peekDir();
	 */
	Vector3 rdir = 
	    normal.mulScalerNew(-2.0 * ((ray.peekDir()).innPrd(normal)));
	rdir.plusHere(ray.peekDir());
	reflectRayDir.set(rdir);

	return(true);
    }

    /**
     * ޤˤ 2  ray-tracing ray ȯ
     *
     * @param ray 		IN 	ͥ쥤
     * @param minRayCoefNorm    IN  	ȿͻκǾͥ륮
     * @param hitobj 	      	IN	ray Ȥθʪ
     * @param refractRayDir    	OUT	ޥ쥤٥ȥ
     * @param refractRayCoeff  	OUT	ޥ쥤εٷ
     */
     public static boolean
     getRefractionRayDirRayTrace(Ray 	  		ray,
				 double 		minRayCoefNorm,
				 ObjectPrimitive	hitobj,
				 Vector3 		refractRayDir,
				 Vector3  	      	refractRayCoeff,
				 Material [] 		matArray)
    {
	// ray  copy  mat Ʃ᷸ݤ
	final Material mat = matArray[hitobj.getMaterialID()];
	Vector3 refract = 
	    (ray.peekRefCoeff()).mulVecNew(mat.peekSpecTrans());
	refractRayCoeff.set(refract);

	if((refractRayCoeff).innPrd(refractRayCoeff) < minRayCoefNorm)
	{
	    return(false);
	}
    
	// Ʃ׻
	if(mat.getIdxRefraction() != 1.0)	
	{
	    // ޤ ޥ쥤
	    Assert.out(hitobj != null, 
		       "Error!: hitobj must be. getRefractionRayDirRayTrace");
	    /*
	     * ʪˤ϶ΨεտΨˤ
	     * sphere ξȿͥ쥤Ʊˡ٥ȥո
	     */
	    Vector3 normal = null; // ˡƤϤ
	    double  n;		// Ψ
	    if(ray.isInSideObject())
	    {
		n = mat.getIdxRefraction(); 
	    
		switch(hitobj.who())
		{
		case ObjectPrimitive.OBJ_TRIANGLE:
		    normal = 
			new Vector3(((TriangleObject)hitobj).peekNormal(null));
		    break;
		
		case ObjectPrimitive.OBJ_SPHERE:
		    normal = new Vector3((((SphereObject)hitobj).
					  peekNormal(ray.peekHitPos())));
		    if(ray.isInSideObject())
		    {
			normal.mulScalerHere(-1.0); // λˤȿž
		    }
		    break;
		
		case ObjectPrimitive.OBJ_NULL:
		default:
		    throw new RuntimeException("Internal Error! : illegal " +
					       "object : " + 
					       "getRefractionRayDirRayTrace");
		}
	    }
	    else
	    {
		n = 1.0 / (mat.getIdxRefraction());

		switch(hitobj.who())
		{
		case ObjectPrimitive.OBJ_TRIANGLE:
		    normal = 
			new Vector3(((TriangleObject)hitobj).peekNormal(null));
		    break;
		
		case ObjectPrimitive.OBJ_SPHERE:
		    normal = new Vector3(((SphereObject)hitobj).
					 peekNormal(ray.peekHitPos())); 
		    if(ray.isInSideObject())
		    {
			normal.mulScalerHere(-1.0); // λˤȿž
		    }
		    break;
		
		case ObjectPrimitive.OBJ_NULL:
		default:
		    throw new RuntimeException("Internal Error! : illegal " +
					       "object : " + 
					       "getRefractionRayDirRayTrace");
		}
	    }

	    // ˡƤϤ
	    Assert.out(Math.abs(normal.getNorm() - 1.0) < 
		       Mpi2Constants.D_ERROR_RES, 
		       "Error!: normal vector must be normalized. refract");
	
	    /*
	     * Υ٥ȥ T (I ͥ٥ȥ, N ʪˡ٥
	     * , n жΨ >= 1.0)  
	     * T = (n (-N \dot I) - \sqrt(1 - n^2(1 - (N \dot I)^2)) N) + nI
	     */
	    double ndi = (ray.peekDir()).innPrd(normal); // (N \dot I)
	    double rt_2  =  1.0 - (n * n) * (1.0 - (ndi * ndi));
	    
	    // tokunaga changed:
	    if(rt_2 < 0.0) // \sqrt Ȥ 0 ̤ξˤƩȯʤ
	    {
		return(false);
	    }
	    else
	    {
		double rt = Math.sqrt(rt_2);
		// (((n * (-ndi)) - rt) * normal) + (n * ray.getDir());
		normal.mulScalerHere((n * (-ndi)) - rt);
		Vector3 t = (ray.peekDir()).mulScalerNew(n);
		normal.plusHere(t);
		refractRayDir.set(t);
	    }
	}
	else
	{
	    // mat.mIdxRefraction == 1.0  : ƩΨ 1 ̵̣ʡ
	    refractRayDir.set(new Vector3(ray.peekDir()));
	}

	// ºݤ ray ȯ ray ʪѴϤξδؿǹԤ
	return(true);
    }

    /**
     * secondRayGenWithoutDistribute
     * ʬ̵󼡸
     * 
     * 	@param 	ray 		ȿΥ쥤
     * 	@param 	hitobj 		ʪ
     *	@param	viewdat		
     */
    public static boolean 
    secondRayGenWithoutDistribute(Ray 		  	ray, 
				  ObjectPrimitive 	hitobj,
				  ViewData 		viewdat,
				  PE 			pe)
    {
	boolean isGenerateRay = false;	// 쥤ȯ? 

	//  ray ȿ͡޲ۤƤ뤫
	if(ray.getReflectedNum() >= viewdat.getMaxRayRefNum())
	{				// ۤƤ롣ray ȯʤ
	    Assert.out(isGenerateRay == false, 
		       "Error!: This ray already excesses reflected number.");
	    return(isGenerateRay);
	}
	
	/*
	 * ȿ 2  ray-tracing ray  new PE ν塼Ͽ
	 */
	Vector3 reflectedRayDir 	= new Vector3();
	Vector3 reflectedRayCoeff	= new Vector3();
	boolean isGenReflectRay = 
	    getReflectionRayDirRayTrace(ray, 
					viewdat.getMinRayRefCoeffNorm(),
					hitobj, 
					reflectedRayDir,
					reflectedRayCoeff, pe.peekMatArray());
	if(isGenReflectRay == true)	// ray ȯ
	{
	    // ȿͥ쥤 newRay! 
	    // Υ󥹥ȥ饯Ǻ쥤ϰäʪΤˤϸ򺹤ʤ 
	    Ray newHanshaRay = 
		Ray.newForReflectionRayTracing(ray, 
					       reflectedRayDir, 
					       reflectedRayCoeff,
					       hitobj);
	
	    // IC Ƿ׻٤
	    newHanshaRay.setColor(new Vector3(ray.peekColor()));
	    pe.setRayToThisPE(newHanshaRay);		   
	    isGenerateRay = true;
	    // ȿ ray-tracing 쥤ΤʤФ Hint TOKUNAGA
	}

	/**
	 * Ʃ 2  refraction 쥤 new PE ν塼Ͽ
	 */
	Vector3 refractedRayDir 	= new Vector3();
	Vector3 refractedRayCoeff	= new Vector3();
	boolean isGenRefractedRay = 
	    getRefractionRayDirRayTrace(ray, 
					viewdat.getMinRayRefCoeffNorm(),
					hitobj, 
					refractedRayDir,
					refractedRayCoeff, pe.peekMatArray());
	if(isGenRefractedRay == true)
	{
	    Ray newToukaRay = Ray.newForReflectionRayTracing(ray, 
							     refractedRayDir, 
							     refractedRayCoeff,
							     hitobj);
	    newToukaRay.changeInOut();// ޤξˤʪΤȳξ֤Ѵ
	
	    // ray ȯ˵٤ƤΤ?
	    if(isGenerateRay == false)
	    {			// Ƥʤ٤
		newToukaRay.setColor(new Vector3(ray.peekColor()));  
	    }
	    pe.setRayToThisPE(newToukaRay);
	    isGenerateRay = true;
	    //  ray-tracing ray ΤʤФ Hint TOKUNAGA
	}
	return(isGenerateRay);
    }

    /**
     * 󼡸ͤʬ뤫ʤ
     */
    public static boolean newSecondaryRayTracingRays(Ray 	     ray, 
						     ObjectPrimitive hitobj, 
						     ViewData	     viewdat,
						     PE  	     pe)
    {
	final Material mat = (pe.peekMatArray())[hitobj.getMaterialID()];
	if(mat.getFrustumHalfTopRad() > 0.0)
	{
	    // ʬ󼡸 
	    Mpi2Option.getInstance().
		verboseOut("NIN secondRayGenWithDistrbute");
	    // return(this.secondRayGenWithDistrbute(ray, mat, hitobj));
	    return(false);
	}
	else
	{
	    // 󼡸ͤʬ̵
	    return(CalcRayTrSRG.
		   secondRayGenWithoutDistribute(ray, hitobj, viewdat, pe));
	}
    }
}
