/*
 * $Id: PixelPtrAllScan.java,v 1.1 1999/08/06 15:07:54 yamauchi Exp $
 *     (M\pi)^2 : PixelPointer : AllScan 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	RayTracing ǤνʬΤ pixel pointer
 *	
 * original source screenPointer.h
 *
 *	pixel pointer class 
 *	    allscan    ̤˥󤹤
 *	
 * 1999ǯ8 6()
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;

import  jp.ac.tohoku.is.archi.mpi2.util.Assert;

/**
 * All scan on a screen 
 *    screen  ֤ increment Ƥ
 *   (ޤ X  scan 롥)
 */
public final class PixelPtrAllScan extends PixelPointer {
    public PixelPtrAllScan(int maxX, int maxY)
    {
	this.initMax(maxX, maxY);
    }
    
    /**
     * scan ֤̾
     */
    public String getScreenPointerType()
    {
	return("ScanType : AllScan (not distributed ray generation)");
    }
    
    /**
     * ꡼κͤ򥻥åȤ
     */
    private void initMax(int maxX, int maxY)
    {
	Assert.out(maxX >  0, "Illegal maxX PixelPtrAllScan.initMax");
	Assert.out(maxY >  0, "Illegal maxY PixelPtrAllScan.initMax");
	this.mMaxX = maxX;
	this.mMaxY = maxY; 
	this.mX = -1;	// ǽ x = 0 ֤
	this.mY =  0;	
    }

    /**
     *  screen ֤Ф
     *------------------------------
     * ʲΥɤ 1 ƥåפŤļ¹Ԥ
     * for(int y = 0; y < maxY; y++)
     * {
     *    for(int x = 0; x < maxX; x++)
     *    {
     *    }
     * }
     */
    public boolean next()
    {
	this.mX++;
	if(this.mX >= this.mMaxX)
	{
	    this.mX = 0;
	    this.mY++;
	    if(this.mY >= this.mMaxY)	    
	    {
		return(false);	// ʾ ray ϤǤʤ
	    }
	}
	return(true);
    }

    /**
     * test
     */
    public static void main(String [] args)
    {
	PixelPtrAllScan ppAllScan = new PixelPtrAllScan(32, 16);
	System.out.println("Test : PixelPtrAllScan");
	while(ppAllScan.next())
	{
	    System.out.println(ppAllScan.getPixelPosX() + ", " +
			       ppAllScan.getPixelPosY());
	}
    }
}
