/*
 * $Id: PixelPtrDistributedScan.java,v 1.1 1999/08/06 15:07:54 yamauchi Exp $
 *     (M\pi)^2 : PixelPointer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	RayTracing ǤνʬΤ pixel pointer
 *	
 * original source screenPointer.h
 *
 *	pixel pointer class 
 *		distributedscan	distributed  PE سƤ
 *	쥤ȯ screen  pixel ʬǥ󤹤
 *
 * 1999ǯ8 6()
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;

import  jp.ac.tohoku.is.archi.mpi2.util.Assert;

/**
 * distributed pixel by pixel
 *	Ĥ pixel ؤ
 */
public final class PixelPtrDistributedScan extends PixelPointer {
    private int mBlockSizeX;            // block 
    private int mBlockSizeY;
    private int mTotalPEs;
    private int mPEID;
    private int mCurrentBlock;          // ߲ܤ block 򸫤Ƥ뤫
    private int mBlockStartX;           //  block κ X 
    private int mBlockStartY;           //  block κ Y 
    private int mInnerBlockX;           // block κɸ
    private int mInnerBlockY;           
    

    /**
     * constructor
     *	@param maxX, maxY             : screen 礭
     * 	@param blocksiezX, blocksiezY : Ϣ³ô block 礭
     * 	@param numberOfPEs            :  PE  (PE  1 ŪˤȤ館)
     *  @param myPEID                 : ʬ PE  ID (rank)
     */
    public PixelPtrDistributedScan(int maxX, 	   int maxY, 
				   int blocksizeX,  int blocksizeY, 
				   int numberOfPEs, int myPEID)
    {
        // screen 礭 total PE Num  myRank (PE id  
        // distributedX,Y  startX,Y ׻롥)
        this.initMax(maxX, maxY, blocksizeX, blocksizeY, numberOfPEs, myPEID);
    }

    /**
     * scan ֤̾
     */
    public String getScreenPointerType() 
    {
        return("ScanType : Distributed (distributed first ray generation)");
    }

    /**
     * initialize 
     */
    public void initMax(int maxX, 	 int maxY,
			int blocksizeX,  int blocksizeY, 
			int numberOfPEs, int myPEID)
    {
        Assert.out(maxX > 0, "Illegal maxX PixelPtrScanlineScan.initMax");
        Assert.out(maxY > 0, "Illegal maxY PixelPtrScanlineScan.initMax");
        this.mMaxX = maxX;
        this.mMaxY = maxY; 

        Assert.out((0 < blocksizeX) && (blocksizeX < maxX),
		   "Illegal blocksizeX PixelPtrScanlineScan.initMax");
        Assert.out((0 < blocksizeY) && (blocksizeY < maxY),
		   "Illegal blocksizeY PixelPtrScanlineScan.initMax");
        this.mBlockSizeX = blocksizeX;
        this.mBlockSizeY = blocksizeY;

        Assert.out(numberOfPEs > 0, 
		   "Illegal numberofPES PixelPtrScanlineScan.initMax");
        Assert.out((0 <= myPEID) && (myPEID < numberOfPEs),
		   "Illegal myPEID PixelPtrScanlineScan.initMax");
        this.mTotalPEs = numberOfPEs;
        this.mPEID     = myPEID;

        this.mCurrentBlock = 0;

	this.mBlockStartX = this.getBlockStartX(this.mCurrentBlock);
	this.mBlockStartY = this.getBlockStartY(this.mCurrentBlock);

        this.mInnerBlockX = 0;
        this.mInnerBlockY = 0; 
    }


    /*
     * block_num ܤ block ϲ̤äȲĹȤ 0 餤Ĥ
     * ֤
     * 	@param block_num : ܤ Block 
     */
    private int getDistFromZero(int block_num)
    {
        int macrowidth = block_num * (this.mBlockSizeX * this.mTotalPEs);

        // PE  rank ˤ뼡 block ƬޤǤ
        int biasForThisPE = (this.mBlockSizeX * this.mPEID);
        
        // ̤äȲĹȤ 0 ΰ
        int distFromZero = macrowidth + biasForThisPE;

	return(distFromZero);
    }

    /**
     * X 
     *	block size X * totalPEs =  PE ĤŤ block ô
     * 	СǤ
     * ̤ X  mod ȤФ PE  block ΤϤޤ
     */
    private int getBlockStartX(int block_num)
    {
        int startBlockX = this.getDistFromZero(block_num) % this.mMaxX;
	return(startBlockX);
    }

    /**
     * Y
     * 	ޤ֤ * Y 
     */
    public int getBlockStartY(int block_num)
    {
        int startBlockY = 
	    ((int)Math.floor(((double)(this.getDistFromZero(block_num))
			      / (double)this.mMaxX))) * this.mBlockSizeY;
	return(startBlockY);
    }

    /**
     *  screen ֤Ф
     *------------------------------
     * ʲΥɤ 1 ƥåפŤļ¹Ԥ
     * 
     * curblock = 0;
     * getBlockStart(curblock);
     * while(this.mIsAllOver == NO)
     * {
     *   for(int innerBlockY = 0; innerBlockY < blockSizeY; innerBlockY++)
     *   {
     *      for(int innerBlockX = 0; innerBlockX < blockSizeX; innerBlockX++)
     *      {
     *          this.mX = blockStartX + innerBlockX;
     *          this.mY = blockStartY + innerBlockY;
     *          if(this.mY > this.mMaxY)
     *          {
     *              this.mIsAllOver = YES;
     *          }
     *      }
     *   }
     *   curblock++;
     *   getBlockStart(curblock);
     * }
     */
    public boolean next()
    {
        // inner block loop
        this.mInnerBlockX++;
        if(this.mInnerBlockX >= this.mBlockSizeX)
        {
            this.mInnerBlockX = 0;         
            this.mInnerBlockY++;
            if(this.mInnerBlockY >= this.mBlockSizeY)
            {
                this.mInnerBlockY = 0;
                this.mCurrentBlock++;
                this.mBlockStartX = this.getBlockStartX(this.mCurrentBlock);
		this.mBlockStartY = this.getBlockStartY(this.mCurrentBlock);
            }
        }

        // set next position
        this.mX = this.mBlockStartX + this.mInnerBlockX;
        this.mY = this.mBlockStartY + this.mInnerBlockY;     
        if(this.mY >= this.mMaxY)         
        {
            return(false); // ʾ ray ϤǤʤ
        }
        return(true);
    }

    /**
     * test
     */
    public static void main(String [] args)
    {
	int screensizeX = 32;
	int screensizeY = 16;
	int blocksizeX  = 8;
	int blocksizeY  = 2;	
	int numberofPES = 6;	
	int myPEID      = 0;	

	PixelPtrDistributedScan ppDist = 
	    new PixelPtrDistributedScan(screensizeX, screensizeY, 
					blocksizeX,  blocksizeY,
					numberofPES, myPEID);
	System.out.println("Test : " + ppDist.getScreenPointerType());
	while(ppDist.next())
	{
	    System.out.println(ppDist.getPixelPosX() + ", " +
			       ppDist.getPixelPosY());
	}
    }
}
