/*
 * $Id: PixelPtrScanlineScan.java,v 1.1 1999/08/06 15:07:55 yamauchi Exp $
 *     (M\pi)^2 : PixelPointer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	RayTracing ǤνʬΤ pixel pointer
 *	
 * original source screenPointer.h
 *
 *	pixel pointer class 
 *		scanlinescan 	scanline  PE ˳Ƥ
 * 1999ǯ8 6()
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;

import  jp.ac.tohoku.is.archi.mpi2.util.Assert;


/**
 * distributed with scanline
 *	PE  scanline ʬƳƤ
 *	scanline Ӥ screen ư
 */
public final class PixelPtrScanlineScan extends PixelPointer {
    private int mSkipYLines;
    
    /**
     * constructor
     */
    public PixelPtrScanlineScan(int maxX, int maxY, int skipYLines, int startY)
    {
	this.initMax(maxX, maxY, skipYLines, startY);
    }
    
    /**
     * scan ֤̾
     */
    public String getScreenPointerType() 
    {
	return("ScanType : Scanline (distributed first ray generation)");
    }
    
    /**
     * initialize 
     */
    public void initMax(int maxX, int maxY, int skipYLines, int startY)
    {
	Assert.out(maxX >  0, "Illegal maxX PixelPtrScanlineScan.initMax");
	Assert.out(maxY >  0, "Illegal maxY PixelPtrScanlineScan.initMax");
	this.mMaxX = maxX;
	this.mMaxY = maxY; 
	this.mX = -1;	// ǽ x = 0 ֤
	
	Assert.out(skipYLines > 0, 
		   "Illegal skipYLines PixelPtrScanlineScan.initMax");
	this.mSkipYLines = skipYLines;

	Assert.out(startY >= 0, 
		   "Illegal startY PixelPtrScanlineScan.initMax");
	this.mY = startY;	// ǽ scanline
    }

    /**
     *  screen ֤Ф
     *------------------------------
     * ʲΥɤ 1 ƥåפŤļ¹Ԥ
     * for(int y = startY; y < maxY; y+= skipYLines)
     * {
     *    for(int x = 0; x < maxX; x++)
     *    {
     *    }
     * }
     */
    public boolean next()
    {
	this.mX++;
	if(this.mX >= this.mMaxX)
	{
	    this.mX = 0;
	    this.mY += this.mSkipYLines;
	    if(this.mY >= this.mMaxY)	    
	    {
		return(false);	// ʾ ray ϤǤʤ
	    }
	}
	return(true);
    }

    /**
     * test
     */
    public static void main(String [] args)
    {
	PixelPtrScanlineScan ppScanline = 
	    new PixelPtrScanlineScan(32, 16, 3, 1);
	System.out.println("Test : " + ppScanline.getScreenPointerType());
	while(ppScanline.next())
	{
	    System.out.println(ppScanline.getPixelPosX() + ", " +
			       ppScanline.getPixelPosY());
	}
    }
}

