/*
 * $Id: RayTrFRGUnit.java,v 1.5.4.1 2000/06/15 20:41:23 yamauchi Exp $
 *     (M\pi)^2 : RayTrFRGUnit (RayTracing : First Rays Generation Unit)
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	calculation of First Ray Generation unit for ray tracing 
 *	ray-tracing ˡˤ ray 쵤ȯΤǤϤʤ
 *	ĤȯƤ׻̿Ԥɤޤ ray ȯ
 *	ʤɤݻɬפ롣ΤΥ饹Ǥ롣 
 *	
 * original source rayTrFRGUnit.h 
 *
 *	쥤ȯ : FRGUnit for RayTracing μ
 * 
 * 1999ǯ8 6()
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;


import  java.lang.Math;

import  jp.ac.tohoku.is.archi.mpi2.common.*;
import  jp.ac.tohoku.is.archi.mpi2.dda.*;
import  jp.ac.tohoku.is.archi.mpi2.obj.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import  jp.ac.tohoku.is.archi.mpi2.util.*;

/**
 * First Ray Generation Unit : for raytracing method
 */
public final class RayTrFRGUnit implements Mpi2Enum, Mpi2Constants {
    private int      mScanMethodOnScreen; // first ray generation method
    
    private IntVec3  mPEid;
    private Vector3  mViewPoint;		
    
    private PixelPointer mPixelPointer;  // screen  pixel ȯ

    private Vector3 mScreenLeftUpFromVp; // ̺ؤ vector
    private Vector3 mDeltaXscr;		 // screenˤ1 pixelʬΥ٥ȥ X
    private Vector3 mDeltaYscr;		 // 			              Y
    private int     mMaxRaysInAPixel;	 // 1 pixel ȯä ray ܿ
    private int     mGenRayParPixel;	 // ߤpixelФrayȯ
    private boolean mCanGenerateNextRay; //  ray ȯǽ
 
    // [־]
    //     private Vector3 mDefSpcMin;		// [־] 
    //     private Vector3 mDefSpcMax;
    //     private Vector3 mPartVolMinPos;	// Partition volume κǾ
    private double  	mSubDivNum;			// ʬֿ
    private SpaceParam 	mSpcParamRef;
    private double     	mPartVolOneSize;	// ֤ΰդĹ
      
    // 
    private IntVec3 mVpSpcPos;		// ¸߶ְ()
    private boolean mIsVpInDefSpc;	// ˤ뤫
    private int     mNumOfTotalGenRays;	// ߤޤǤ ray ȯ
    private double  mDistRaysFactor;   	// ray1ĤβǤؤδͿγ ʬ 
    // 				 	// raytrace  4/pixel ʤ 1/4 

    // screen 
    private int	    mScrX;
    private int	    mScrY;

    private static double getDRandom()
    {
	return(Math.random());
    }
    
    private static void initRandom()
    {
	Mpi2Option.getInstance().
	    verboseOut("NIN : initRandom");
    }

    /**
     * screen pointer(ʬ쥤ʤɤɤΤ褦ȯ뤫 Strategy) 
     * νȤȼ member νȤСmVpSpcPos ʤ
     * ϻ֤򼨤ϽʬԤ
     * ɤ˿äƤΤǤǽ롥
     */
    private void initForScreenPointer(int scrSizeX, int scrSizeY,  
				      int myRank,   int totalPENum)
    {
	// ΰ֤֤ȽǤ
	if(BoundTester.isPosInBox(this.mViewPoint, 
				  this.mSpcParamRef.peekDefSpaceMin(), 
				  this.mSpcParamRef.peekDefSpaceMax()))
	{
	    // ¸ߤ: ¸ߤְ֤Τ
	    this.mIsVpInDefSpc	= true;
	    this.mVpSpcPos 	= this.getNewSpcposOfaPoint(this.mViewPoint);
	}else
	{
	    Assert.out(this.mIsVpInDefSpc == false, 
		       "Error!: initForScreenPointer");
	}
	
	// ɤνȯ method Ȥˤ screen pointer 
	switch(this.mScanMethodOnScreen)
	{
	case AllScan_frgm:		// ΤΥ (ʬϤʤ)
	    this.initForAllScanMethod(scrSizeX, scrSizeY);
	    break;
	    
	case ScanlineScan_frgm:	// 饤󤴤Ȥʬ
	    this.initForScanlineScanMethod(scrSizeX, scrSizeY, 
					   myRank, totalPENum);
	    break;
	case DistributedScan_frgm:	// distributed ʬ 
	    this.initForDistributedScanMethod(scrSizeX, scrSizeY,
					      myRank, totalPENum);
	    break;
	default:
	    throw new RuntimeException("Internal Error! : illegal ray " + 
				       "generation method in ray-tracing.");
	    // commMpi2_exit(1);
	}
    }

    /**
     * AllScan ˤƽ
     */
    private void initForAllScanMethod(int scrSizeX, int scrSizeY)
    {
	Assert.out(this.mScanMethodOnScreen == AllScan_frgm, 
		   "Error!: initForAllScanMethod");
	this.mPixelPointer = new PixelPtrAllScan(scrSizeX, scrSizeY);
	
	// AllScan ξˤϻ֤ˤȯ ray ô PE 
	// 롥 
	if(this.mIsVpInDefSpc == true)
	{
	    Assert.out(BoundTester.
		       isPosInBox(this.mViewPoint, 
				  this.mSpcParamRef.peekDefSpaceMin(),
				  this.mSpcParamRef.peekDefSpaceMax()) == true,
		       "Error!: initForAllScanMethod this.mIsVpInDefSpc");
	    //  PE ϻ¸ߤ֤ôƤ뤫? 
	    if(PE.getInstance().isDealSpace(this.mVpSpcPos) == false)
	    {
		// ˤ뤬¸ߤʬ֤򤳤 
		// PE ôƤʤΤ ray ȯɬפʤ 
		this.mCanGenerateNextRay = false; // ray ȯλȤ
		if(Mpi2Option.getInstance().getDebugMode() == true)
		{
		    String s = Mpi2Option.toHead(DEBUGHEAD, this.mPEid) +
			"generate 0 rays\n" +
			"Because view point is in a define space and this PE "+
			"does not deal subspace within a view point";
		    System.out.println(s);
		}	    
	    }else
	    {
		if(Mpi2Option.getInstance().getDebugMode() == true)
		{
		    String s = Mpi2Option.toHead(DEBUGHEAD, this.mPEid) +
			"AllScan : view point is in defined space " + 
			"and this PE generate rays.";
		    System.out.println(s);			
		}
	    }
	}else
	{
	    Assert.out(BoundTester.
		       isPosInBox(this.mViewPoint, 
				  this.mSpcParamRef.peekDefSpaceMin(),
				  this.mSpcParamRef.peekDefSpaceMax())
		       == false,
		       "Error! : initForAllScanMethod");
	}
    }

    /**
     * ScanlineScan ˤƽ
     */
    private void initForScanlineScanMethod(int scrSizeX, int scrSizeY,  
					   int myRank,   int totalPEnum)
    {
        // myRank  PE 0  PE n-1 ȤʤäƤϤ
	Assert.out(myRank < totalPEnum, "Error! : initForScanlineScanMethod");
	Assert.out(myRank >= 0, 	"Error! : initForScanlineScanMethod");
	this.mPixelPointer = new PixelPtrScanlineScan(scrSizeX, scrSizeY, 
						      totalPEnum, myRank); 
	System.out.println("DEBUG: GenScreen ScanLine Pointer : myRank is " +
			   myRank + ", skip = " + totalPEnum);
	
    }

    private void initForDistributedScanMethod(int scrSizeX, int scrSizeY,
					      int myRank,   int totalPEnum)
    {
	// NIN
	Mpi2Option.getInstance().verboseOut("NIN");
	System.exit(1);
    }
    
    /** 
     * ꡼ pixel ñ̤ΰư pixel ذư
     * pixel Ǥλ ray ȯ鼡 pixel ذư
     * ޤ ray ȯǤΤʤФΤޤ
     */
    private void moveOnScreen()
    {
	this.mGenRayParPixel++;
	// 1 pixel ˤȯۤ? loop δϤ
	if(this.mGenRayParPixel >= this.mMaxRaysInAPixel)
	{
	    this.mGenRayParPixel = 0;
	    // this.mPixelPointer.next ˤäưư롥
	    // ʾưǤʤˤϤ򵭤
	    this.mCanGenerateNextRay = this.mPixelPointer.next();
	    this.mScrX = this.mPixelPointer.getPixelPosX();
	    this.mScrY = this.mPixelPointer.getPixelPosY();
	}else
	{
	    // ޤ pixel  ray ȯǽ
	}	
    }
    
    /**
     * , point ¸ߤʬ֤λɸΰ֤
     *
     * cp = cell periad, p = point, min, max = define space min, max
     * k  sub space pos Ȥ
     * min + k \frac{max - min}{cp} <= p < min + (k + 1)\frac{max - min}{cp}
     *   
     * \frac{cp (p - min)}{max - min} - 1 < k <= \frac{cp (p - min)}{max - min}
     *  Ȥʤ
     * \frac{cp}{max - min} = partVolOneSize
     *  (partVolOneSize * (p - min)) - 1 
     */
    private IntVec3 getNewSpcposOfaPoint(Vector3 pos) 
    {
	Vector3 relativePos = 
	    pos.minusNew(this.mSpcParamRef.peekPartVolumeMin());
	int [] spos = new int[3]; // space position
	for(int i = 0; i < 3; i++)
	{
	    // ֤֤礭ǳꡢشݤ
	    spos[i] = 
		(int)(Math.floor(relativePos.get(i) / this.mPartVolOneSize));
	    Assert.out(spos[i] >= 0, "Error!: spos must be >= 0");
	    
	    /*
	     * ̾ floor ɤǽΥ쥤 define space ɤ
	     * 礭ʬä㳰Ǥ롣
	     * ʤʤ顢ʬ [min, max) ϰϤǤ뤬ֳ
	     * ϳ򺹤ƤΤǡλ [min, max] Ȥ
	     * ׻ɬפΤǤ롣̤λء狼뤫? ⷯ 
	     * ʤƤ (󥿥åθʤĤäƤޤä)
	     */
	    if(spos[i] == this.mSpcParamRef.getSubDivNum())
	    {
		if((double)((int)(relativePos.get(i) / this.mPartVolOneSize))
		   == (relativePos.get(i) / this.mPartVolOneSize))
		{
		    // ֤礭ü point  
		    spos[i]--;
		}else
		{
		    System.out.println("Internal Error! : Is this pos in " + 
				       "define space?");
		}
	    }
	}
	return(new IntVec3(spos[0], spos[1], spos[2]));
    }

    /**
     * view vector generator
     */
    private Vector3 genNewViewVec()
    {
	/*
	 * AllScan ξˤϳʻҾΥꥢͤȯ뤬
	 * ưΤߤǤꡤ1PE ˤư롥
	 * ͤ AllScan mode ư˼ˤ pixel ô
	 *  PE ֤Ƕͭ뤢 pixel ˤƱΥץ󥰤Ԥ
	 * ʤƤϤʤʤͭˤ 1 Ĥ PE ץ󥰤ơ
	 * ô PE ؤ ray Ȥʤɤ뤬 AllScan 
	 * mode ͭ̿Υɤ줿ʤΤ AllScan ư
	 * ԹϤΤޤ޻ĤƤ 
	 */
	double scrX = (double)(this.mScrX);
	double scrY = (double)(this.mScrY);

	// this.mScrX + drand() 
	Vector3 deltaXdir = this.mDeltaXscr.mulScalerNew(scrX + getDRandom());
	// this.mScrY + drand() 
	Vector3 deltaYdir = this.mDeltaYscr.mulScalerNew(scrY + getDRandom());
	
	// viewvec = screen left up + deltaXdir + deltaYdir
	Vector3 viewVec = this.mScreenLeftUpFromVp.plusNew(deltaXdir);
	viewVec.plusHere(deltaYdir);

	viewVec.normalize();
	return(viewVec);	
    }
    
    /** 
     * ray generator
     *------------------------------
     * ˤ ray ȯ 
     * 1  ray ȯ index ʤƤ
     * ƽλ餽Υե饰ΩƤ롣
     *      ݻƤȯ쥤ΰ֤ϰưʤ
     */
    private Ray newOneRayVpInDefineSpc() // ˤ
    {
	Assert.out(this.mCanGenerateNextRay == true, 
		   "Error!: newOneRayVpInDefineSpc : no more gen ray.");
	Assert.out(this.mIsVpInDefSpc == true, 
		   "Error!: mIsVpInDefSpc == false");

	// ľ genNewViewVec() 񤤤ƤɤȻפä԰¤롥
	Vector3 distPixelVec = this.genNewViewVec();

	Assert.out(Math.abs((distPixelVec.getNorm()) - 1.0) < D_ERROR_RES, 
		   "Error!: not normalized.");    

	// ˤΤɬ ray ˤ롥
	Ray ray = Ray.newForRayTrace(this.mScrX, this.mScrY,
				     this.mViewPoint, 
				     distPixelVec, // ľ genNewViewVec()?
				     this.mVpSpcPos,
				     this.mDistRaysFactor); //, PEid;
	return(ray);
    }

    /**
     * ֤γˤ ray ȯ
     */
    private Ray newOneRayVpOutOfDefSpc() // ֳˤ
    {
	Assert.out(this.mCanGenerateNextRay == true, 
		   "Error!: newOneRayVpOutOfDefSpc : no more rays");
	Assert.out(this.mIsVpInDefSpc == false, 
		   "Error!: newOneRayVpOutOfDefSpc : in defspc");

	Vector3 viewVec = this.genNewViewVec();

	Assert.out(Math.abs((viewVec.getNorm()) - 1.0) < D_ERROR_RES,
		   "Error!: not normalzied");    

	/*
	 * ֤ȤθȽ 
	 * äˤϤɤʬ֤ˤä׻
	 */
	Vector3 hitpos = new Vector3();
	int hitSide = 
	    BoundTester.isHitBoundingBox(this.mSpcParamRef.peekDefSpaceMin(),
					 this.mSpcParamRef.peekDefSpaceMax(),
					 this.mViewPoint, viewVec,
					 hitpos);
	if(hitSide != DIR_3D.ILLEGAL)
	{
	    // ray ֤ hit 
	    IntVec3 hitSubSpcPos = this.getNewSpcposOfaPoint(hitpos);

	    switch(this.getScanMethodOnScreen())
	    {
	    case AllScan_frgm:
		// AllScan ʬԤʤ
		// ray  PE ô֤ˤʤˤϵѲ
		// ƻ:ädirty
		if(PE.getInstance().isDealSpace(hitSubSpcPos) == true) 
		{
		    Ray ray = Ray.newForRayTrace(this.mScrX, this.mScrY, 
						 this.mViewPoint, viewVec,
						 hitSubSpcPos, 
						 this.mDistRaysFactor); 
		    return(ray);
		}else 
		{ 
		    return(null); //֤ˤhitô֤ǤʤѲ
		}
		
	    case ScanlineScan_frgm:
	    case DistributedScan_frgm:
		{
		    /* 
		     * ʬ
		     * ꡼ʬ䤵졤ƥ꡼󤬥Ρɤʬۤ
		     * ΤǡɬƥΡɤ ray ȯ
		     *  ray Ϥζ֤ˤȤϸ¤ʤ
		     */
		    Ray ray = Ray.newForRayTrace(this.mScrX, this.mScrY, 
						 this.mViewPoint, viewVec,
						 hitSubSpcPos, 
						 this.mDistRaysFactor); //,PEid
		    return(ray);		
		}
	    default:
		throw new RuntimeException("Internal Error! : No such screen "
					   + "scan method.");
		// commMpi2_exit(1);
		// return(null);
	    }
	}else
	{
	    // ֤ hit ʤΤȯɬפϤʤ
	    return(null);
	}
	//cout + "never reach. rayTrFRGUnitClass.newOneRayVpOutOfDefSpc()" 
	//commMpi2_exit(1);
	//return(null);
    }

    public RayTrFRGUnit()
    {
	this.mScanMethodOnScreen   = ELSE_frgm;
    
	this.mPEid 		= null;
	this.mViewPoint		= null;
	this.mPixelPointer	= null;

	this.mScreenLeftUpFromVp= null;
	this.mDeltaXscr		= null;
	this.mDeltaYscr		= null;

	this.mMaxRaysInAPixel 	= -1;
	this.mGenRayParPixel	= -1;

	this.mCanGenerateNextRay= false; // ޤǤ next rays Ϥʤ


	// this.mSpcParamRef.peekDefSpaceMin()	= null;		
	// this.mDefSpcMax	= null;
	// this.mPartVolMinPos	= null;	
	// this.mSubDivNum	= 0.0;	
	// this.mPartVolOneSize	= -1.0;	
	this.mSpcParamRef	= null;

	this.mVpSpcPos   	= null;		
	this.mIsVpInDefSpc	= false;
	this.mNumOfTotalGenRays	= -1;
	this.mDistRaysFactor	= 0.0;

	this.mScrX = -10;
	this.mScrY = -11;
    }
    /**
     * init 
     *	@param rayGenerationMethod : ʬ ray ˡ(Allscan  ScanlineScan)
     *  @param viewDat	: ΰ֡ʤɤλ
     *  @param spcDat	: ־
     *  @param PEid	: νȯ˥åȤ° PE  ID
     *  @param totalPEnum : ƥ PE  (ʬɬ)
     *  @param myRank 	: ʬ rank (0 Ϥޤ)
     */
    public void init(int	 rayGenerationMethod,
		     ViewData    viewDat, 
		     SpaceParam  spcDat, 
		     IntVec3 	 PEid,
		     int   	 totalPEnum,
		     int 	 myRank)
    {
	// ˴ؤѥ᡼
	final Vector3 vp  = viewDat.peekViewPoint();   //٥ȥ
	final Vector3 vv  = viewDat.peekViewVector();  //٥ȥ
	final Vector3 vup = viewDat.peekViewUpVector();//꡼٥ȥ
	final double vFovRad = viewDat.getV_FOV();
	final double vHovRad = viewDat.getH_FOV();

	final int screenSizeX = viewDat.getScreenSizeX();
	final int screenSizeY = viewDat.getScreenSizeY();
	
	// ꡼ľñ̥٥ȥ (ñ̥٥ȥΤϤǰΤ)
	vup.normalize();			     
	vv.normalize();			     
    
	// ꡼ʿñ̥٥ȥ(vSh) $vSh = vv  \times vup$
	Vector3 vScreenHoriz = vv.outPrdNew(vup); 
	if(vScreenHoriz.getNorm() <= 1e-4)
	{
	    System.out.println(NORMALHEAD + " Warning!:maybe view up vector is"
			       +" illegal.Generated image will not be right.");
	}

	vScreenHoriz.normalize(); // $vSh = \frac{vSh}{|vSh|}$
	double  halfX  = Math.tan(vHovRad);
	double  halfY  = Math.tan(vFovRad);
	// = vp + .... - vp ʲμ˲äƤ,Ȼ vec
	// screenLeftUpFromVp = vv - (halfX * vScreenHoriz) + (halfY * vup);
	Vector3 t1 = vScreenHoriz.mulScalerNew(halfX);
	Vector3 t2 = vup.mulScalerNew(halfY);
	Vector3 screenLeftUpFromVp = vv.minusNew(t1);
	screenLeftUpFromVp.plusHere(t2);

	// deltaX = ((2.0 * halfX) / double(screenSizeX)) * vScreenHoriz;
	Vector3 deltaX = 
	    vScreenHoriz.mulScalerNew((2.0 * halfX) / (double)(screenSizeX));
	    
	// deltaY = ((-2.0 * halfY) / double(screenSizeY)) * vup;	
	Vector3 deltaY = 
	    vup.mulScalerNew((-2.0 * halfY) / (double)(screenSizeY));
	
	initRandom();		// distributed ray-tracing Τ

	// initialize member
	this.mScanMethodOnScreen = rayGenerationMethod;
	this.mPEid	 	 = PEid;
	this.mViewPoint		 = vp;
	this.mPixelPointer	 = null; //  initForScreenPointer ˤ
	this.mScreenLeftUpFromVp = screenLeftUpFromVp;
	this.mDeltaXscr		 = deltaX;
	this.mDeltaYscr		 = deltaY;
	this.mMaxRaysInAPixel	 = viewDat.getDistributedRayNum();
	Assert.out(this.mMaxRaysInAPixel > 0, 
		   "Error!: mMaxRaysInAPixel must be > 0");
	this.mGenRayParPixel	 = 0;
	
	this.mCanGenerateNextRay = true; // ޤ ray ȯƤʤ

	// [־] ְ֤뤿ν 
	// ־λȽ
	this.mSpcParamRef = spcDat;

	// this.mDefSpcMin = spcDat.getDefSpaceMin(); // ֤Ȥ
	// 	this.mDefSpcMax       = spcDat.getDefSpaceMax();
	// 	this.mPartVolMinPos   = spcDat.getPartVolumeMin();
	final Vector3 partVolMaxPos = this.mSpcParamRef.peekPartVolumeMax();
	
	// partition volume ν
	// partition volume ΩΤǤΤǰդ狼ɤ 
	this.mSubDivNum	  = (double)(this.mSpcParamRef.getSubDivNum());

	this.mPartVolOneSize = 
	    (partVolMaxPos.get(Vector3.X)
	     - (this.mSpcParamRef.peekPartVolumeMin()).get(Vector3.X))
	    / this.mSubDivNum;
	
	// initialize parameter for distributed ray-trace 
	this.mNumOfTotalGenRays	= 0;	//  ray ȯ
	
	/**
	 * mDistRaysFactor :  ray ε٤ distributed Υ쥤οʬ 1  
	 * νŤߤġΤ coefficient value ˤͤݤƤ
	 * 4 ܤ distributed ʤг ray  1 Ĥ pixel ؤδͿ 1/4 
	 */
	this.mDistRaysFactor = 1.0 / (double)(this.mMaxRaysInAPixel);
	
	this.mScrX = 0;
	this.mScrY = 0;
	
	/**
	 * screen pointer ν
	 * 	this.mIsVpInDefSpc, this.mVpSpcPos ν
	 */
	this.initForScreenPointer(screenSizeX, screenSizeY, 
				  myRank, totalPEnum);
    }

    /**
     * 
     */
    public boolean canGenerateNextRay()  
    {
	return(this.mCanGenerateNextRay); 
    }

    /**
     * ray ȯ
     * 	ʬˡŬѻˤϡȯ ray ʬֹ椬ȯ
     * 	 PE ôǤʤ礬롥
     */
    public Ray newNextRay()
    {
	// δؿƤ˰ܤȯǽǤ뤳ȤĴ٤ƤϤ
	Assert.out(this.canGenerateNextRay() == true, 
		   "Error!: no more rays can generate : newNextRay.");
	Ray ray = null;
	if(this.mIsVpInDefSpc == true)
	{
	    // ֤Τɤˤ뤫طΤϽʬʤ All
	    // scan λΤ
	    Assert.out(this.getScanMethodOnScreen() == AllScan_frgm, 
		       "Error!: Here mustbe AllScan_frgm");

	    /**
	     * ¸ߤ
	     * ξˤϤ pixel ֤ ray ȯǤʤȤ
	     * ϤʤΤǡʬˤ餺ɬ1ܤ ray ȯ
	     */
	    ray = this.newOneRayVpInDefineSpc();
	    this.moveOnScreen();	// ȯ֤ذư
	    Assert.out(ray != null, "Error!: ray must be new");
	    this.mNumOfTotalGenRays++; // ȯ ray 򥫥Ȥ
	}else
	{				
	    /**
	     * ˤϤʤ
	     * ȯǽ֤ǤäƤ⸽ߤ screen ֤Ǥ PE  ray ȯ
	     * ô뤫ɤʤΤǡ1 ȯޤ screen 
	     *  pixel ưƤߤ롣
	     * Ĥޤޤ꡼ǽ(canGenerateNextRay() == true) 
	     * Ǥĸߤ pixel  PE ôǤʤˤϼȥ꡼
	     * Ƥߤ 
	     */
	    while(this.canGenerateNextRay() == true)
	    {
		//  pixel ȯǽ? 
		ray = this.newOneRayVpOutOfDefSpc();
		this.moveOnScreen();	// ȯ֤ذư
		if(ray != null)
		{   
		    this.mNumOfTotalGenRays++; // ȯ ray 򥫥Ȥ
		    break;		// ray ȯ
		}
	    }
	}
	/**
	 * ʬˤ ray  spcpos ºݤôƤ 
	 * PE ν ray ¸ߤʤǽ롥
	 */
	return(ray);
    }

    /**
     * get total number of generated rays
     */
    public int getTotalGenRays()
    {
	return(this.mNumOfTotalGenRays); 
    }

    /**
     * get screen scan method on screen
     */
    public int getScanMethodOnScreen() 
    { 
	return(this.mScanMethodOnScreen);
    }

    /**
     * test 
     public static void main(String [] args)
     {
     
     }
     */
}
