/*
 * $Id: Mpi2Constants.java,v 1.9 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : global constants for (M\pi)^2
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 * 	Mpi2Constants  : global constants
 *
 *-- 1999ǯ8 3()
 *-- ꡤĴޤǻ䤬äƤ⤤Τ
 *-- ǤۤɽʤΤϤʤȸäƤʤ顤Ŭ
 *-- ˤȤSϤɤޤǤäƤ롥
 *-- T̤ब귯ޤȤˤʤ뤫Ƚ
 *-- ǤȤȤޤǹͤƤȤϻפ󤬡
 */

package jp.ac.tohoku.is.archi.mpi2.sysparam;

import jp.ac.tohoku.is.archi.mpi2.util.IntVec3;

/**
 * Mpi2Constants : global constants for (M\pi)^2
 */
public interface Mpi2Constants 
{
    /**
     * Version
     */
    public final static String VERSION = 
	"2000/1/4 (M\\pi)^2 initial version ";

    /**
     * Copyright
     */
    public final static String COPYRIGHT = 
	"Copyright (C) 1999-2000 YAMAUCHI Hitoshi, MAEDA Atusi";

    /**
     * ü PE (Host)  ID 
     */
    public final static IntVec3 HostID      = new IntVec3(-1, -1, -1);
    public final static IntVec3 IllegalPEID = new IntVec3(-2, -2, -2);

    /**
     * ϤκݤιƬ
     */
    public final static String NORMALHEAD  = "//";
    public final static String VERBOSEHEAD = "##";
    public final static String DEBUGHEAD   = "<<";
    public final static String OUTDATAHEAD = ";;";
    public final static String TRACE_STDOUT_HEAD = "TR: ";

    // material ̾κĹ
    // const int MAX_MATERIAL_NAME_LEN = 64;

    // image  save 뤿 tmp file name Υƥץ졼
    public final static String TEMP_SAVEIMAGE_FILEPREFIX = "tempMpi2image";

    // material name ν(̾ material ̾ȤƻȤʤ)
    // #define NULLMaterialName "This is NULL material, can not use."

    // ٤ϰ 0 餤ĤޤǤ
    public final static double MAX_INTENSITY	= 1.0;

    // ϰϤȤߤʤ
    public final static double D_ERROR_RES	= 1e-5;

    // 饸ƥͥ륮ΥǥեȺǾ
    public final static double DEFAULT_MIN_RAD_ENERGY		= 0.01; 

    // إߥ塼֤ξ̤ΰդβ
    public final static int    DEFAULT_HEMRES			= 10; 

    // 쥤ΥǥեȺȿͲ
    public final static int   DEFAULT_MAX_REFLECTION_RAY_NUM	= 3; 

    // 쥤ȿ͸ΨκǾ^2
    public final static double 	DEFAULT_MIN_REFLECTION_COEFF_NORM2 = 0.00001; 

    // ʬ쥤ȥ졼ˡΥ쥤ν(쥤Τ)
    public final static int    	DEFAULT_DIST_RAY_NUM		= 1; 

    // 쥤ȥ졼ˡˤ쥤ȯ (̤̿βܤ)
    public final static int 	GEN_FRAYS_FACTOR_BY_COMMUN	= 2;

    // ѿβ
    public final static int 	DEFAULT_FRUSTUM_RES		= 2;

    // Хåե
    public final static int	MAX_RECV_BUFFNUM		= 8;

    // ̿ٱθretry 롣βȥȥ饤ֳ()
    // SP2  HPS γߤ 400 msec 餷 = 400*1e3 = 4e5 micro sec.
    public final static int 	MAX_RETRY_NUM_WAIT_BARRIER	= 36;
    public final static int 	MAX_RETRY_NUM_CALC		= 16;
    // TCP/IP  : millisec
    public final static int 	RETRY_WAIT_TIME			= 500;
    // HPC 
    // public final static int 	RETRY_WAIT_TIME			= 100;

    // ƻεٻ߻(̿ٱθ:)()
    // SP2  High Performance Switch γߤ 400 msec 餷ΤǤ
    // θ ϥ顼Τδֳ֤ǼºݤϤäȾ
    //public final static int 	POLLING_SLEEP_TIME		= 200000; 
    public final static int 	POLLING_SLEEP_TIME		= 1; 

    // پ礤ĤޤȤ뤫 FIXHERE
    public final static int 	MAX_INTVER_NUM_AT_ONCE		= 64;

    // ͥβܤΥΥХåեѰդ뤫
    public final static int BUFSIZE_FACTOR_BY_THREASH = 3;
    
    // time display precision for gettimeofday
    public final static int TIMEOFDAYPREC = 16;

    public final static boolean REDUCE_VERBOSE_INFO		= false;
}
