/*
 * $Id: ElapsedTimer.java,v 1.4 1999/11/29 18:38:06 yamauchi Exp $
 *     (M\pi)^2 : Elapsed Timer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	ַ¬ѤΥ饹
 *	 getrusage ȤäƤ׻ˤϸʤȤ
 *	Τϡ process ̿Ԥߤ sleep äƤޤ
 *	̿ overhead ¬ǤʤʤäƤޤǤ롥
 *	׻ξˤɤ¬Ȥϸʤ 
 *
 * class StopWatch (getrusage ѤƤ)  Java ȼѻ
 *
 * original source ElapsedTimer.h
 *
 * 1999ǯ817()
 */

package jp.ac.tohoku.is.archi.mpi2.util;

import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;

/**
 * ElapsedTimer : ַ¬ΤΥ饹
 */
public final class ElapsedTimer {
    public final int ElapsedTimer_NOT_A_TIME     = -1;

    private long mStartTimeVal; // ϻ
    private long mStopTimeVal;  // ߤ
    
    
    public ElapsedTimer()
    {
	this.mStartTimeVal = ElapsedTimer_NOT_A_TIME;
	this.mStopTimeVal  = ElapsedTimer_NOT_A_TIME;
    }

    public ElapsedTimer(ElapsedTimer rhs)
    {
	this.mStartTimeVal = rhs.mStartTimeVal;
	this.mStopTimeVal  = rhs.mStopTimeVal;
    }

    /**
     * ϻ說ꥢ : clear time
     */ 
    public void reset()
    {
	this.mStartTimeVal = ElapsedTimer_NOT_A_TIME;
	this.mStartTimeVal = ElapsedTimer_NOT_A_TIME;
    }

    /**
     * ¬곫 : set start time
     */
    public void start()
    {
	this.mStartTimeVal = System.currentTimeMillis();
    }

    /**
     * ¬꽪λ : stop ϲ٤Ǥ call Ǥ롥 start 
     * λ֤ getTotalTime ǼФ
     */
    public void stop()
    {
	this.mStopTimeVal = System.currentTimeMillis();
    }

    /**
     * ¬ǽʾ֤? : start  stop ϸƤФƤ뤫
     */
    private void isOK()
    {
	// start  stop ϴ˸ƤФƤ
	if(this.mStartTimeVal == ElapsedTimer_NOT_A_TIME)
	{
	    throw new RuntimeException("Error! : ElapsedTimer.getTotalTime " +
				       "must call after start() call.");
	}	    
	if(this.mStopTimeVal  == ElapsedTimer_NOT_A_TIME)
	{
	    throw new RuntimeException("Error! : ElapsedTimer.getTotalTime " +
				       "must call after stop() call.");
	}	    
    }

    // פ֤
    public long getTotalTime() 
    {
	this.isOK();
	return(this.mStopTimeVal - this.mStartTimeVal);
    }

    // äΤߤ long int ֤
    public long getSecondTime() 
    {
	this.isOK();
	long s = (this.mStopTimeVal - this.mStartTimeVal) / 1000;
	return(s);
    }

    /**
     *  milisec ֤֤
     */
    public static long getNowRawTime() 
    {
	return(System.currentTimeMillis());
    }

    /**
     *  sec ֤֤
     */
    public static long getNowRawTimeAsSecond() 
    {
	return(System.currentTimeMillis() / 1000);
    }

    /**
     * output elapsed time of PE
     */
    public static void outPEEtime(String mes, ElapsedTimer etimer)
    {
	String s = Mpi2Constants.NORMALHEAD + " PE:: elapsed time " + 
	    etimer.getTotalTime() + " (msec) " + mes;
	System.out.println(s);
    }

    /**
     * output nowtime value of PE 
     */
    public static void outPERawTime(String mes)
    {
	String s = Mpi2Constants.NORMALHEAD + " PE:: raw time " + 
	    ElapsedTimer.getNowRawTime() + " (msec) " + mes;
	System.out.println(s);
    }

    /**
     * Host Ǥηв֤ν
     */
    public static void outHostEtime(String mes, ElapsedTimer etimer)
    {
	String s = Mpi2Constants.NORMALHEAD + " host:: elapsed time " + 
	    etimer.getTotalTime() + " (msec) " + mes;
	System.out.println(s);
    }

    /**
     * Host θ߻åդǽϤ
     */
    public static void outHostRawTime(String mes)
    {
	String s = Mpi2Constants.NORMALHEAD + " host:: raw time " + 
	    ElapsedTimer.getNowRawTime() + " (msec) " + mes;
	System.out.println(s);	
    }

    /**
     * test 
     */
    public static void main(String [] args)
    {
	ElapsedTimer et = new ElapsedTimer();
	et.start();
	// פꤿؿϤ
	System.out.println("Now time = " + ElapsedTimer.getNowRawTime());
	et.stop();
	System.out.println("Elapsed time = " + et.getTotalTime() + " msec");
    }
}
