#! /bin/sh
#
# $Id: proc_r2mark.sh,v 1.1 2000/07/02 13:50:34 yamauchi Exp $
# R^2mark : 
# 	run benchmarks for the C++ parallel mpi2
#	Copyright (C) 2000 YAMAUCHI Hitoshi  
#
R2MARKURL="http://www.mpi-sb.mpg.de/~hitoshi/research/r2mark/index.shtml"

isexit="no"
if [ ! $# -eq 2 ]; then
    isexit="yes"
else
    if [ $1 != "office"  -a  $1 != "soda"  -a  $1 != "conf" ] ; then
	isexit="yes"
    else
	SIMNAME=$1;
    fi

    if [ $2 != "test" -a $2 != "inaccurate" -a $2 != "accurate" ] ; then
	isexit="yes"
    else
	ACCURACY=$2
    fi
fi

if [ ${isexit} = "yes" ]; then
    echo "Usage: proc_r2mark.sh [office|soda|conf] [test|accurate|inaccurate]"
    echo "	[office|soda|conf] is a scene name."
    echo "	[test|accurate|inaccurate] is rendering option."	
    echo "	accurate takes much time than inaccurate."	
    echo "	Some results are in the next URL."	
    echo "	${R2MARKURL}"
    echo "R^2mark 1.0 : Copyright (C) 2000 YAMAUCHI Hitoshi"
    exit;
fi
	
#
# variables
#
MPI2=../mpi2
SIMBASE="${SIMNAME}.${ACCURACY}"
MPI2CONFIG="${SIMBASE}.conf"
MPI2VIEW="${SIMBASE}.view"
MACHINEFILE='machinefile'
MACHINEOPT="-machinefile ${MACHINEFILE}"
MPIRUN='mpirun'
LOGBASE=log.r2mparallel.cpp.${SIMBASE}

#
# create machine files
#
if [ ! -f ${MACHINEFILE} ]; then
    echo "There is no machinefile for mpich, try to generate."
    echo "hostname > ${MACHINEFILE}"
    hostname > ${MACHINEFILE}
    for i in 1 2 3 4 5 6 7
    do
	echo "hostname >> ${MACHINEFILE}"
	hostname >> ${MACHINEFILE}
    done
fi

#
# check environment
#
for needfile in ${MPI2} ${MACHINEFILE}
do
    if [ ! -f ${needfile} ]; then
	echo "Error!: I can not find ${needfile}. Please put it. Exit."
	exit 1;
    fi
done


date > log.time.$$
#
# running
#
for pe in 001 002 004 008 
do
    LOGNAME=${LOGBASE}.${pe}
    CONFNAME=${MPI2CONFIG}.${pe}
    PENUM=`expr ${pe} + 1`
    PENUMOPT="-np $PENUM"
    if [ ! -f ${LOGNAME} ]; then
	echo "running ${MPIRUN} ${PENUMOPT} ${MACHINEOPT} ${MPI2} --conf ${CONFNAME} > ${LOGNAME} 2>&1"
	${MPIRUN} ${PENUMOPT} ${MACHINEOPT} ${MPI2} --conf ${CONFNAME} > ${LOGNAME} 2>&1
	date >> log.time.$$
    else
	echo "There is ${LOGNAME}. Skip."
    fi
    # ɽ
done
