#! /bin/sh
#
# $Id: proc_r2mark.sh,v 1.2 2000/07/01 20:04:14 yamauchi Exp $
# R^2mark : 
# 	run benchmarks for serial version
#	Copyright (C) 2000 YAMAUCHI Hitoshi  
#
#
MPI2=./mpi21PE
MPI2CONFIG="${SIMNAME}.conf"
MPI2VIEW=${SIMNAME}.view
MACHINEFILE='machinefile'
MPIRUN='mpirun -np'
LOGBASE=log.r2mserial.cpp

#
# check environment
#
# ${MACHINEFILE}
for needfile in ${MPI2} 
do
    if [ ! -f ${needfile} ]; then
	echo "Error!: I can not find ${needfile}. Please put it. Exit."
	exit 1;
    fi
done

date > log.time.$$
#
# running
#
for i in test inaccurate accurate
    do
    for sim in office soda conf 
    do
	confname=${sim}.${i}.conf
	logname=${LOGBASE}.${sim}.${i}
	if [ ! -f ${logname} ]; then
	    echo "running ${MPI2} --conf ${confname} > ${logname}"
	    ${MPI2} --conf ${confname} > ${logname} 2>&1
	else
	    echo "There is ${logname}. Skip."	
	fi
    done
    # ɽ
done
