#! /bin/sh
#
# $Id: proc_r2mark.sh,v 1.3 2000/07/01 20:04:14 yamauchi Exp $
# R^2mark : 
# 	run benchmarks for serial Java version
#	Copyright (C) 2000 YAMAUCHI Hitoshi  
#
#
MPI2=jp.ac.tohoku.is.archi.mpi2.host.Mpi21PE
MPI2CONFIG="${SIMNAME}.conf"
MPI2VIEW=${SIMNAME}.view
# MACHINEFILE='machinefile'
# MPIRUN='mpirun -np'
LOGBASE=log.r2mserial.java
JAVA=java

#
# In the case of serial version, communicaton functions will never
# called, however, I think maybe class loader needs some symbols...
#
MPIJAVALIB=../../../mpiJava-1.2/lib

CLASSPATH=.:../../../Java/:${MPIJAVALIB}/classes
export CLASSPATH

LD_LIBRARY_PATH=${MPIJAVALIB}:${LD_LIBRARY_PATH}
export LD_LIBRARY_PATH

#----- expand maximum heap size 
JAVAOPTION="-Xmx512m"
# export JAVAOPTION

#
# start simulations
#
date > log.time.$$
for i in test inaccurate accurate
    do
    for sim in office soda conf 
    do
	logname=${LOGBASE}.${sim}.${i}
	confname=${sim}.${i}.conf
	if [ ! -f ${logname} ]; then
	    echo "running ${JAVA} ${JAVAOPTION} ${MPI2} --conf ${confname} > ${logname}, exported JAVAOPTION=${JAVAOPTION}"
	    ${JAVA} ${JAVAOPTION} ${MPI2} --conf ${confname} > ${logname} 2>&1
	else
	    echo "There is ${logname}. Skip."	
	fi
    done
    # ɽ
done





